<?php

namespace App\Http\Controllers\Scheduler;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Validator;
use App\Customers;
use App\Saloons;
use App\SaloonServices;
use App\Services;
use App\Barbers;
use App\Bookings;
use App\BookingItems;
use App\Ratings;
use App\BarberSchedule;
use App\BarberBreak;
use App\ApiRequest;
use App\Notification;
use DB;

class ReminderonehourController extends Controller
{
    public function __construct()
    {
        // header('Access-Control-Allow-Origin: *');
        // header('Access-Control-Allow-Methods: GET, PUT, POST, DELETE, OPTIONS');
        // header("Content-Type: application/json");
    }

    public function index()
    {
        // DB::enableQueryLog();
        $bookings = DB::table("bookings");
        $bookings = $bookings->select("bookings.id", "bookings.customer_id", "bookings.saloon_id", "bookings.barber_id", "bookings.book_number", "bookings.book_date", "bookings.from_time", "bookings.to_time", "bookings.status", "customers.id", "customers.notification_1_hour, saloons.saloon_name")
        ->join("customers", "customers.id", "=", "bookings.customer_id")
        ->join("saloons", "saloons.id", "=", "bookings.saloon_id")
        ->where("bookings.status", "!=", "cancelled")
        ->where("bookings.book_date", "=", date("Y-m-d"))
        ->where("customers.notification_1_hour", "=", "Y")
        ->where(DB::raw("bookings.from_time - interval 1 Hour"), date("H:i"))
        ->get();
        // dd(DB::getQueryLog());
        // echo "<pre>";
        // print_r($bookings);
        // echo "</pre>";
        // exit;
        if(!(empty($bookings)))
        {
            foreach ($bookings as $key => $value)
            {
                $message = "You have booking at '".$value->saloon_name."' at '".date('d-m-Y', strtotime($value->book_date))."' at '".date("H:i", strtotime($value->from_time))."'-'".date("H:i", strtotime($value->end_time))."'";
                //
                $notificationIsread = new Notification();
                $notificationcount = $notificationIsread->select("count(notification.id) as ncount")
                ->where("notification.toid", $value->customer_id)
                ->where("notification.isread", "N")
                ->get();
                $notification_unread = $notificationcount[0]->ncount;
                //
                $arr_email = array();
                $arr_sms = array();
                $arr_push = array();
                $android_recepient = array();
                $android_recepient[] = $value->devicetoken;         
                $additionalData = array(
                    'notificationType' => 'appointment_reminder',
                    'customerid' => $value->customer_id,
                    'unread' => $notification_unread,
                );
                $arr_push = array(
                    "devicetype" => $value->devicetype, 
                    "registatoin_ids" => $android_recepient,
                    "message" => $message,
                    "additionalData" => $additionalData
                );
                // echo "<br/>Push<pre>";
                // print_r($arr_push);
                // echo "</pre>";
                // exit;
                $notification = new Notification();
                $notification->sendAllNotification($arr_email, $arr_sms, $arr_push);
                //
                $notificationsave = new Notification();
                $notificationsave->fromid = $value->saloon_id;
                $notificationsave->toid = $value->customer_id;
                $notificationsave->referenceid = $value->id;
                $notificationsave->notification_type = "Appointment Reminder";
                $notificationsave->message = $message;
                $notificationsave->isread = "N";
                $notificationsave->created_at = date("Y-m-d H:i:s");
                $notificationsave->save();
                $notificationId = $notificationsave->id;
                // echo "<br/>Id = ".$notificationId;
            }
        }
    }
}