<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Support\Str;
use Carbon\Carbon;

use Illuminate\Foundation\Auth\User as Authenticatable;

class Barbers extends Authenticatable
{
  	protected $table = 'barbers';
  //	use SoftDeletes;
  	
  	public function Saloon()
    {
        return $this->belongsTo('App\Saloons','saloon_id');
    }
    public function Services()
    {
        return $this->hasMany('App\BarbersServices','barber_id');
    }

    public function generateToken()
    { 
      
        $this->api_token = Str::random(60);
        $this->last_login = Carbon::now()->toDateTimeString();
        $this->save();

        return $this->api_token;
    }

    public function Country()
    {
        return $this->belongsTo('App\Countries','country_id');
    }

    public function State()
    {
        return $this->belongsTo('App\States','state_id');
    }

    public function City()
    {
        return $this->belongsTo('App\Cities','city_id');
    }

    public function Ratings(){
        return $this->hasMany('App\Ratings','barber_id');   
    }
}
