<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Validator;
use View;

use App\DefaultServices;

class DefaultservicesController extends Controller
{
    public function __construct()
    {
        $this->middleware('auth');
    }
    public function list(){
    	$viewData['pageTitle'] = 'Default Services';
        // $viewData['records'] = Barbers::whereHas('Saloon')->orderBy('id','desc')->paginate();
        $viewData['records'] = DefaultServices::where("is_deleted", 0)->orderBy('id','desc')->paginate();
        return view('default_services.list',$viewData);
    }
    
    public function addNew(){
        $viewData['pageTitle'] = 'Add Default Service';
        $viewData['timestamp'] = time();
        return view('default_services.add',$viewData);
    }

    public function save(Request $request){
        $validator = Validator::make($request->all(), [
            'name' => 'required',
            'description' => 'required',
            'duration' => 'required',
            'price' => 'required',
        ]);

        if ($validator->fails()) {
            return redirect()->back()->withErrors($validator)->withInput();
        }
        
        $object = new DefaultServices();
        $object->name = $request->input("name");
        $object->description = $request->input("description");
        $object->duration = $request->input("duration");
        $object->price = $request->input("price");
        if($request->input("status")){
            $object->is_active = 1;    
        }else{
            $object->is_active = 0;    
        }
        $object->save();

        return redirect('/admin/defaultservices')->with("success","Record added successfully");
    }

    public function edit($id){
        $viewData['pageTitle'] = 'Edit Default Service';
        $record = DefaultServices::find($id);
        $viewData['record'] = $record;
        return view('default_services.edit',$viewData);
    }

    public function update($id,Request $request){
    	$user = DefaultServices::find($id);
        $validator = Validator::make($request->all(), [
            'name' => 'required',
            'description' => 'required',
            'duration' => 'required',
            'price' => 'required',
        ]);
        
        if ($validator->fails()) {
            return redirect()->back()->withErrors($validator)->withInput();
        }

        $object = DefaultServices::find($id);
        $object->name = $request->input("name");
        $object->description = $request->input("description");
        $object->duration = $request->input("duration");
        $object->price = $request->input("price");
        if($request->input("status")){
            $object->is_active = 1;    
        }else{
            $object->is_active = 0;    
        }
        $object->save();

        return redirect('/admin/defaultservices')->with("success","Record updated successfully");
    }
    
    public function deleteRecord($id){
        DefaultServices::where("id",$id)->update(['is_deleted'=>1,'updated_at'=>date('Y-m-d H:i:s')]);
    	return redirect('/admin/defaultservices')->with("success","Record deleted successfully");
    }
}
