<?php



namespace App\Http\Controllers\Scheduler;



use App\Http\Controllers\Controller;

use Illuminate\Http\Request;

use Validator;

use App\Customers;

use App\Saloons;

use App\SaloonServices;

use App\Services;

use App\Barbers;

use App\Bookings;

use App\BookingItems;

use App\Ratings;

use App\BarberSchedule;

use App\BarberBreak;

use App\ApiRequest;

use App\Notification;

use App\Services\CommonService;

use DB;



class ReminderbookingController extends Controller

{

    public function __construct()

    {

        // header('Access-Control-Allow-Origin: *');

        // header('Access-Control-Allow-Methods: GET, PUT, POST, DELETE, OPTIONS');

        // header("Content-Type: application/json");

    }



    public function index()
    {

        // DB::enableQueryLog();

        $bookings = DB::table("bookings");

        $bookings = $bookings->select("bookings.id", "bookings.customer_id", "bookings.saloon_id", "bookings.customer_id", "bookings.book_number", "bookings.book_date", "bookings.from_time", "bookings.to_time", "bookings.status", "customers.booking_remainder_notification_minute", "saloons.saloon_name", "customers.devicetype", "customers.devicetoken")

        ->join("customers", "customers.id", "=", "bookings.customer_id")

        ->join("saloons", "saloons.id", "=", "bookings.saloon_id")

        ->where("bookings.status", "!=", "cancelled")

        ->whereDate("bookings.book_date",date("Y-m-d"))

        ->where("customers.booking_remainder_notification", "=", "Y")

        ->where(DB::Raw("date_format(bookings.from_time - INTERVAL customers.booking_remainder_notification_minute Minute,'%H:%i')"), date("H:i"))
        
        //////////////////->where("bookings.id", "=", "33")//for testing

        ->get();

        print_r($bookings);
        echo "<br/><br/>";
        // exit;
        if(!(empty($bookings)))

        {

            foreach ($bookings as $key => $value)

            {

                $booking_services = BookingItems::with('Service')->with('SaloonService')->where("booking_id",$value->id)->get();
                $servicesname = array();
                foreach($booking_services as $serv)
                {
                    $servicesname[] = ((!empty($serv->SaloonService->service_name))?$serv->SaloonService->service_name:'');
                }

                $date = $value->book_date;
                $startTime = date('h:i A',strtotime($value->from_time));
                $endTime = $value->to_time;
                $serviceName = implode(",", $servicesname);
                if($value->book_date == date('Y-m-d'))
                {
                    $date = "Today";
                }
                else if($value->book_date == date('Y-m-d',strtotime('+1 day')))
                {
                    $date = 'Tomorrow';
                }
                else{
                    $date = date('jS M l',strtotime($value->book_date));
                }

                $message = "You have a booking for ".$serviceName." at ".$startTime." ".$date." at ".$value->saloon_name;

                //

                // Get read unread notifiction count

                $notificationReadInfo = Notification::select('id','fromid','toid','referenceid', 'notification_type', 'message', 'isread', 'created_at')

                ->where("notification.toid", $value->customer_id)

                ->where("notification.notification_for", "C")

                ->where("notification.isread", "Y")

                ->where("notification.is_deleted", 0)

                ->get();

                $readCount = $notificationReadInfo->count();

                $notificationUnreadInfo = Notification::select('id','fromid','toid','referenceid', 'notification_type', 'message', 'isread', 'created_at')

                ->where("notification.toid", $value->customer_id)

                ->where("notification.notification_for", "C")

                ->where("notification.isread", "N")

                ->where("notification.is_deleted", 0)

                ->get();

                $unreadCount = $notificationUnreadInfo->count();

                //

                $arr_email = array();

                $arr_sms = array();

                $arr_push = array();

                $android_recepient = array();

                $android_recepient[] = $value->devicetoken;         

                $additionalData = array(

                    'notificationType' => 'booking',

                    'barberid' => $value->customer_id,

                    'read' => $readCount,

                    'unread' => $unreadCount,

                );

                $arr_push = array(

                    "devicetype" => $value->devicetype, 

                    "registatoin_ids" => $android_recepient,

                    "message" => $message,

                    "additionalData" => $additionalData

                );

                // echo "<br/>Push<pre>";

                // print_r($arr_push);

                // echo "</pre>";

                // exit;

                $notification = new Notification();

                $notification->sendAllBarberNotification($arr_email, $arr_sms, $arr_push);

                //

                // $notificationsave = new Notification();

                // $notificationsave->fromid = $value->saloon_id;

                // $notificationsave->toid = $value->customer_id;

                // $notificationsave->referenceid = $value->id;

                // $notificationsave->notification_type = "booking";

                // $notificationsave->notification_for = "C";

                // $notificationsave->message = $message;

                // $notificationsave->isread = "N";

                // $notificationsave->created_at = date("Y-m-d H:i:s");

                // $notificationsave->updated_at = date("Y-m-d H:i:s");

                // $notificationsave->save();

                // $notificationId = $notificationsave->id;

                // echo "<br/>Id = ".$notificationId;

            }

        }

    }


    public function unregister_customer(Request $request)
    {

        // DB::enableQueryLog();

        $bookings = DB::table("bookings");

        $bookings = $bookings->select("bookings.id","bookings.customer_mobile","bookings.saloon_id", "bookings.customer_id", "bookings.book_number", "bookings.book_date", "bookings.from_time", "bookings.to_time", "bookings.status", "bookings.booking_remainder_minute", "saloons.saloon_name",'barbers.name as barber_name')

        ->join("saloons", "saloons.id", "=", "bookings.saloon_id")

        ->join("barbers", "barbers.id", "=", "bookings.barber_id")

        ->where("bookings.status", "!=", "cancelled")

        // ->where("bookings.customer_id", 0)
        ->where("bookings.booked_by", "B")

        ->whereDate("bookings.book_date",date("Y-m-d"))

        ->where(DB::Raw("date_format(bookings.from_time - INTERVAL bookings.booking_remainder_minute Minute,'%H:%i')"), date("H:i"))

        ->get();

        // print_r($bookings);
        // exit;
        if(!(empty($bookings)))

        {

            foreach ($bookings as $key => $value)

            {

                $booking_services = BookingItems::with('Service')->with('SaloonService')->where("booking_id",$value->id)->get();
                $servicesname = array();
                foreach($booking_services as $serv)
                {
                    $servicesname[] = ((!empty($serv->SaloonService->service_name))?$serv->SaloonService->service_name:'');
                }

                $date = date("d-m-Y",strtotime($object->book_date));
                $startTime = date("h:i A",strtotime($object->from_time));
                $endTime = $object->to_time;
                $serviceName = implode(",", $servicesname);
                if($object->book_date == date('Y-m-d'))
                {
                    $date = "Today";
                }
                else if($object->book_date == date('Y-m-d',strtotime('+1 day')))
                {
                    $date = "Tomorrow";
                }
                else
                {
                    $date = "on ".date('jS F, Y',strtotime($object->book_date));
                    
                }
                
                $message = "You have a booking for ".$serviceName." in ".$value->saloon_name." by ".$value->barber_name." ".$date." at ".date("h:i A",strtotime($value->from_time))." - ".date("h:i A",strtotime($value->to_time))." via Blacour - Salon Booking App.";

                $mobile = $value->customer_mobile;
                CommonService::send_msg($mobile,$message);

            }

        }

    }


}