<?php

namespace App\Http\Controllers\Scheduler;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Validator;
use App\Customers;
use App\Saloons;
use App\SaloonServices;
use App\Services;
use App\Barbers;
use App\Bookings;
use App\BookingItems;
use App\Ratings;
use App\BarberSchedule;
use App\BarberBreak;
use App\ApiRequest;
use App\Notification;
use DB;

class ReminderthirtyminutebarberController extends Controller
{
    public function __construct()
    {
        // header('Access-Control-Allow-Origin: *');
        // header('Access-Control-Allow-Methods: GET, PUT, POST, DELETE, OPTIONS');
        // header("Content-Type: application/json");
    }

    public function index()
    {
        // DB::enableQueryLog();
        $bookings = DB::table("bookings");
        $bookings = $bookings->select("bookings.id", "bookings.customer_id", "bookings.saloon_id", "bookings.barber_id", "bookings.book_number", "bookings.book_date", "bookings.from_time", "bookings.to_time", "bookings.status", "barbers.id", "barbers.notification_30_min", "barbers.devicetype", "barbers.devicetoken", "saloons.saloon_name")
        ->join("barbers", "barbers.id", "=", "bookings.barber_id")
        ->join("saloons", "saloons.id", "=", "bookings.saloon_id")
        ->where("bookings.status", "!=", "cancelled")
        ->where("bookings.book_date", "=", "'".date("Y-m-d")."'")
        ->where("barbers.notification_30_min", "=", "Y")
        ->where(DB::Raw("date_format(bookings.from_time - INTERVAL 30 Minute,'%H:%i')"), date("H:i"))
        ->get();
        // dd(DB::getQueryLog());
        // echo "<pre>";
        // print_r($bookings);
        // echo "</pre>";
        // exit;
        if(!(empty($bookings)))
        {
            foreach ($bookings as $key => $value)
            {
                $message = "You have booking at '".$value->saloon_name."' at '".date('d-m-Y', strtotime($value->book_date))."' at '".date("H:i", strtotime($value->from_time))."'-'".date("H:i", strtotime($value->to_time))."'";
                //
                // Get read unread notifiction count
                $notificationReadInfo = Notification::select('id','fromid','toid','referenceid', 'notification_type', 'message', 'isread', 'created_at')
                ->where("notification.toid", $value->barber_id)
                ->where("notification.notification_for", "B")
                ->where("notification.isread", "Y")
                ->where("notification.is_deleted", 0)
                ->get();
                $readCount = $notificationReadInfo->count();
                $notificationUnreadInfo = Notification::select('id','fromid','toid','referenceid', 'notification_type', 'message', 'isread', 'created_at')
                ->where("notification.toid", $value->barber_id)
                ->where("notification.notification_for", "B")
                ->where("notification.isread", "N")
                ->where("notification.is_deleted", 0)
                ->get();
                $unreadCount = $notificationUnreadInfo->count();
                //
                $arr_email = array();
                $arr_sms = array();
                $arr_push = array();
                $android_recepient = array();
                $android_recepient[] = $value->devicetoken;         
                $additionalData = array(
                    'notificationType' => 'appointment_reminder',
                    'barberid' => $value->barber_id,
                    'read' => $readCount,
                    'read' => $unreadCount,
                );
                $arr_push = array(
                    "devicetype" => $value->devicetype, 
                    "registatoin_ids" => $android_recepient,
                    "message" => $message,
                    "additionalData" => $additionalData
                );
                // echo "<br/>Push<pre>";
                // print_r($arr_push);
                // echo "</pre>";
                // exit;
                $notification = new Notification();
                $notification->sendAllBarberNotification($arr_email, $arr_sms, $arr_push);
                //
                $notificationsave = new Notification();
                $notificationsave->fromid = $value->saloon_id;
                $notificationsave->toid = $value->barber_id;
                $notificationsave->referenceid = $value->id;
                $notificationsave->notification_type = "Appointment Reminder";
                $notificationsave->notification_for = "B";
                $notificationsave->message = $message;
                $notificationsave->isread = "N";
                $notificationsave->created_at = date("Y-m-d H:i:s");
                $notificationsave->updated_at = date("Y-m-d H:i:s");
                $notificationsave->save();
                $notificationId = $notificationsave->id;
                // echo "<br/>Id = ".$notificationId;
            }
        }
    }
}