<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Validator;

use App\Saloons;
use App\Services;
class ServicesController extends Controller
{
    public function __construct()
    {
        $this->middleware('auth');
    }
    public function list(){
    	$viewData['pageTitle'] = 'Services';
        $viewData['records'] = Services::orderBy('id','desc')->paginate();
        return view('services.list',$viewData);
    }
    
    public function addNew(){
        $viewData['pageTitle'] = 'Add Service';
        $viewData['timestamp'] = time();
        return view('services.add',$viewData);
    }

    public function save($saloon_id,Request $request){
        $validator = Validator::make($request->all(), [
            'name' => 'required',
        ]);

        if ($validator->fails()) {
            return redirect()->back()->withErrors($validator)->withInput();
        }
        
        $object = new Services();
        $object->name = $request->input("name");
        $object->created_by = \Auth::user()->id;
        if($request->input("status")){
        	$object->status = 1;	
        }else{
        	$object->status = 0;	
        }
        $object->save();


        return redirect('/admin/services')->with("success","Record added successfully");
    }

    public function edit($id){
        $viewData['pageTitle'] = 'Edit Service';
        $viewData['record'] = Services::find($id);
        return view('services.edit',$viewData);
    }

    public function update($id,Request $request){
    	$user = Services::find($id);
        $validator = Validator::make($request->all(), [
            'name' => 'required',
        ]);
        
        if ($validator->fails()) {
            return redirect()->back()->withErrors($validator)->withInput();
        }
        $object = Services::find($id);
        $object->name = $request->input("name");
        $object->updated_by = \Auth::user()->id;
        if($request->input("status")){
            $object->status = 1;    
        }else{
            $object->status = 0;    
        }
        $object->save();

        return redirect('/admin/services')->with("success","Record updated successfully");
    }

    public function deleteRecord($id){
        Services::where("id",$id)->update(['deleted_by'=>\Auth::user()->id]);
    	Services::where("id",$id)->delete();
    	return redirect('/admin/services')->with("success","Record deleted successfully");
    }
}
