<?php
namespace App\Http\Controllers\Webservices;
ini_set('max_execution_time', 600); 

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Validator;
use Illuminate\Support\Facades\Hash;
use App\Services\PhonepayService;

use App\Customers;
use App\Saloons;
use App\SaloonServices;
use App\Services;
use App\Barbers;
use App\Bookings;
use App\BookingItems;
use App\Ratings;
use App\BarberSchedule;
use App\BarberBreak;
use App\ApiRequest;
use App\Notification;
use App\Settings;
use App\BarbersServices;
use App\Services\CommonService;
use App\RzpLog;
use Razorpay\Api\Api;
use DB;
//
class CustomersController extends Controller
{
    public function __construct()
    {
        header('Access-Control-Allow-Origin: *');
        header('Access-Control-Allow-Methods: GET, PUT, POST, DELETE, OPTIONS');
        header("Content-Type: application/json");
    }

    public function loginAsCustomer(Request $request){
        try{
            $validator = Validator::make($request->all(), [
                'mobile' => 'required',
            ]);
            if ($validator->fails()) {
                $response['status'] = 'validation_error';
                $response['login'] = false;
                $error = $validator->errors()->toArray();
                $errMsg = '';
                foreach($error as $err){
                    $errMsg .= $err[0];
                }
                $response['message'] = $errMsg;
                return response()->json($response);
            }
            $mobile = $request->input("mobile");
            // $user = Customers::select('id','name','email','mobile')->where("mobile",$mobile)->first();
            $user = Customers::where('mobile',$mobile)->first();
            $readCount = 0;
            $unreadCount = 0;
            if(!(empty($user)))
            {
                // Get read unread notifiction count
                $notificationReadInfo = Notification::select('id','fromid','toid','referenceid', 'notification_type', 'message', 'isread', 'created_at')
                ->where("notification.toid", $user->id)
                ->where("notification.isread", "N")
                ->where("notification.is_deleted", 0)
                ->get();
                $readCount = $notificationReadInfo->count();
                $notificationUnreadInfo = Notification::select('id','fromid','toid','referenceid', 'notification_type', 'message', 'isread', 'created_at')
                ->where("notification.toid", $user->id)
                ->where("notification.isread", "N")
                ->where("notification.is_deleted", 0)
                ->get();
                $unreadCount = $notificationUnreadInfo->count();
                //
                $data = Customers::find($user->id);
                $data->devicetype = $request->input("devicetype");
                $data->devicetoken = $request->input("devicetoken");
                $data->save();
                //
                $user = Customers::select('customers.id', 'customers.name', 'customers.email', 'customers.mobile', 'customers.profileimage', 'customers.devicetype', 'customers.devicetoken', "customers.country_id", "customers.state_id", "customers.city_id", 'countries.name as countryname', 'states.name as statename', 'cities.name as cityname')
                ->leftJoin("countries", "countries.id", "=", "customers.country_id")
                ->leftJoin("states", "states.id", "=", "customers.state_id")
                ->leftJoin("cities", "cities.id", "=", "customers.city_id")
                ->where("customers.id",$user->id)->first();
                if(!(empty($user)))
                {
                    $user = array(
                        "id" => $user['id'],
                        "name" => $user['name'],
                        "email" => $user['email'],
                        "mobile" => $user['mobile'],
                        "profileimage" => $user['profileimage'],
                        "devicetype" => $this->render($user['devicetype']),
                        "devicetoken" => $this->render($user['devicetoken']),
                        "unread" => $unreadCount,
                        "countryid" => (string)$user['country_id'],
                        "stateid" => (string)$user['state_id'],
                        "cityid" => (string)$user['city_id'],
                        "countryname" => $user['countryname'],
                        "statename" => $user['statename'],
                        "cityname" => $user['cityname']
                    );
                }
            }
            // echo "<pre>";
            // print_r($user);
            // echo "</pre>";
            // exit;
            if(empty($user)){
                $response['status'] = 'error';
                $response['login'] = false;
                $response['message'] = 'Invalid mobile no';
                return response()->json($response);
            }else{                
                $response['status'] = 'success';
                $response['login'] = true;
                $response['message'] = 'Login success';
                $response['user'] = $user;
            }
        } catch (Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }

    public function customerRegister(Request $request){
        try{
            $validator = Validator::make($request->all(), [
                'name' => 'required',
                'email' => 'nullable|sometimes|email|unique:customers',
                'mobile' => 'required|unique:customers',
                // 'country_id' => 'required',
                // 'state_id' => 'required',
                // 'city_id' => 'required'
            ]);
            if ($validator->fails()) {
                $response['status'] = 'validation_error';
                $error = $validator->errors()->toArray();
                $errMsg = '';
                foreach($error as $err){
                    $errMsg .= " ".$err[0];
                }
                $response['message'] = $errMsg;
                return response()->json($response);
            }

            $object = new Customers();
            $object->name = $request->input("name");
            $object->email = $request->input("email");
            $object->mobile = $request->input("mobile");
            $object->status = 1;
            $object->gender = $request->input("gender");
            $object->devicetype = $request->input("devicetype");
            $object->devicetoken = $request->input("devicetoken");
            $object->country_id = $request->input("country_id");
            $object->state_id = $request->input("state_id");
            $object->city_id = $request->input("city_id");
            $object->save();
            $id = $object->id;
            $user = Customers::select('customers.id', 'customers.name', 'customers.email', 'customers.mobile', 'customers.profileimage', "customers.country_id as countryid", "customers.state_id as stateid", "customers.city_id as cityid", 'countries.name as countryname', 'states.name as statename', 'cities.name as cityname')
            ->leftJoin("countries", "countries.id", "=", "customers.country_id")
            ->leftJoin("states", "states.id", "=", "customers.state_id")
            ->leftJoin("cities", "cities.id", "=", "customers.city_id")
            ->where("customers.id",$id)
            ->first();
            Bookings::where('customer_id',0)->where('customer_mobile',$request->input("mobile"))->update(['customer_id'=>$id]);
            $response['status'] = 'success';
            $response['message'] = 'Register success';
            $response['user'] = $user;

        } catch (Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }
    
    /*public function editProfile(Request $request){
        try{
            $object = Customers::find($request->input("customer_id"));
            $validator = Validator::make($request->all(), [
                'customer_id' => 'required',
                'name' => 'required',
                'email' => 'required|email|unique:customers,email,'.$object->id,
                'mobile' => 'required|unique:customers,mobile,'.$object->id,
            ]);
            if ($validator->fails()) {
                $response['status'] = 'validation_error';
                $error = $validator->errors()->toArray();
                $errMsg = '';
                foreach($error as $err){
                    $errMsg .= " ".$err[0];
                }
                $response['message'] = $errMsg;
                return response()->json($response);
            }

            
            $object->name = $request->input("name");
            $object->email = $request->input("email");
            $object->mobile = $request->input("mobile");
            $object->status = 1;
            $object->save();
            $id = $object->id;
            $user = Customers::select('id','name','email','mobile')->where("id",$id)
                            ->first();
            $response['status'] = 'success';
            $response['message'] = 'Customer profile edited successfully';
            $response['user'] = $user;

        } catch (Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }*/
    
    /*public function getTimeSlotOld(Request $request){
        try{
            
            // $requestData  = json_encode($request->all());
            // $object = new ApiRequest();
            // $object->request_data = $requestData;
            // $object->save();

            $saloon_id = $request->input("saloon_id"); // updated by mustak
            $barber_id = $request->input("barber_id");
            $date = $request->input("book_date");
            $service_ids = $request->input("services");
            $service_time = SaloonServices::whereIn("id",$service_ids)->sum(\DB::raw("TIME_TO_SEC(duration)"));
            $service_time = (int)$service_time;
            $saloon = Saloons::where("id",$saloon_id)->first();
            // $sl_start_time = $saloon->open_time;
            // $sl_close_time = $saloon->close_time;

            $barber_schedule = BarberSchedule::where("schedule_date",$date)->where('barber_id',$barber_id)->first();
            if(empty($barber_schedule)){
                $response['status'] = 'error';
                $response['message'] = "Barber not available for the day";
                return response()->json($response);
            }            
            $sl_start_time = $barber_schedule->from_time;
            $sl_close_time = $barber_schedule->to_time;

            $minutes = $service_time/60;
            $starttime = date("Y-m-d H:i",strtotime($date." ".$sl_start_time));
            $endtime = date("Y-m-d H:i",strtotime($date." ".$sl_close_time));
           
            $array_of_time = array ();
            $start_time    = strtotime ($starttime); //change to strtotime
            $end_time      = strtotime ($endtime); //change to strtotime

            $add_mins  = $minutes * 60;
            // echo $add_mins;
            $bookings = Bookings::where("book_date",$date)
            ->where("payment_status", "C")
                                    ->whereHas("Saloon")
                                   ->whereHas("Barber")
                                   ->where("saloon_id",$saloon_id)
                                   ->where("barber_id",$barber_id)
                                   ->where("status","!=",'cancelled')                                   
                                   ->orderBy("from_time","asc")
                                   ->get(); 
            // pre($booked_slot->toArray());
            $available_time = array();
            $times = array();
            $prev_endtime = array();
            // pre($sl_start_time);
            // pre($sl_close_time);
            // echo "<hr>";
            $booked_slot = array();
            foreach($bookings as $slot){
                $temp = new \stdClass();
                $temp->from_time = $slot->from_time;
                $temp->to_time = $slot->to_time;
                $booked_slot[] = $temp;
            }

            $barber_break = BarberBreak::where("break_date",$date)->where('barber_id',$barber_id)->get();
            foreach($barber_break as $slot){
                $temp = new \stdClass();
                $temp->from_time = $slot->from_time;
                $temp->to_time = $slot->to_time;
                $booked_slot[] = $temp;
            }
            asort($booked_slot);
        
            $booked_slot = array_values($booked_slot);
            foreach($booked_slot as $key => $slot){
                // echo "<pre>";
                // print_r($slot);
                // echo "</pre>";
                if($key == 0){
                    $start_time = date("Y-m-d H:i",strtotime($date." ".$sl_start_time));
                    // echo "<br/>Start". $start_time."<br/>";
                    $end_time = date("Y-m-d H:i",strtotime($date." ".$slot->from_time));
                    // echo "<br/>End". $end_time."<br/>";
                    $prev_endtime[$key] = $slot->to_time;
                    // echo "<pre>";
                    // print_r($prev_endtime);
                    // echo "</pre>";
                    $starttime = strtotime($start_time);
                    $endtime = strtotime($end_time);
                    $valid = 1;
                    
                    $time_slots = $this->timeSlot($starttime,$endtime,$add_mins);
                    $array_of_time = array_merge($array_of_time,$time_slots);
                    // echo "<pre>";
                    // print_r($array_of_time);
                    // echo "</pre>";
                    // exit;                    
                }else{
                    
                    $start_time = date("Y-m-d H:i",strtotime($date." ".$prev_endtime[$key-1]));
                    $end_time = date("Y-m-d H:i",strtotime($date." ".$slot->from_time));

                    $prev_endtime[$key] = $slot->to_time;

                    $starttime = strtotime($start_time);
                    $endtime = strtotime($end_time);

                    $time_slots = $this->timeSlot($starttime,$endtime,$add_mins);
                    $array_of_time = array_merge($array_of_time,$time_slots);
                    
                }
            }
            if(count($booked_slot) > 0){
                $start_time = date("Y-m-d H:i",strtotime($date." ".end($prev_endtime)));
                $end_time = date("Y-m-d H:i",strtotime($date." ".$sl_close_time));
            }else{
                $start_time = date("Y-m-d H:i",strtotime($date." ".$sl_start_time));
                $end_time = date("Y-m-d H:i",strtotime($date." ".$sl_close_time));
            }
            // echo $start_time." - ".$end_time;
            // exit;
            $starttime = strtotime($start_time);
            $endtime = strtotime($end_time);

            $time_slots = $this->timeSlot($starttime,$endtime,$add_mins);
            // echo "<pre>";
            // print_r($time_slots);
            // echo "</pre>";
            // exit; 
            $array_of_time = array_merge($array_of_time,$time_slots);
            // echo "<pre>";
            // print_r($array_of_time);
            // echo "</pre>";
            // exit; 
            $array_of_time = array_values(array_unique($array_of_time));
            // echo "<pre>";
            // print_r($array_of_time);
            // echo "</pre>";
            // exit; 
            $available_time = array();
            for($i=0;$i < count($array_of_time);$i++){
                if(isset($array_of_time[$i+1])){
                    $to_time=strtotime($array_of_time[$i+1]);
                    // echo $array_of_time[$i]." to ".$array_of_time[$i+1]."<Br>";
                    $from_time=strtotime($array_of_time[$i]); 
                    $time = array("start_time"=>$array_of_time[$i],"end_time"=>$array_of_time[$i+1]);
                  
                    $checkTime = Bookings::where("saloon_id",$saloon_id)
                                   ->where("payment_status", "C")
                                   ->where("barber_id",$barber_id)
                                   ->whereDate("book_date",$date)
                                   ->where("status","!=",'cancelled') 
                                   ->whereHas("Saloon")
                                   ->whereHas("Barber")
                                   ->orderBy("from_time","asc")
                                   ->get(); 
                    // echo "<Br>".$checkTime;
                    // echo "<pre>";
                    // print_r($checkTime);
                    // echo "</pre>";
                    // exit;
                    $is_valid = 1;
                    foreach($checkTime as $ctime){
                         $f_time =strtotime($ctime->from_time);
                         $t_time =strtotime($ctime->to_time);
                         // echo $to_time."<br/>";
                         // echo $f_time."<br/>";
                         // echo $t_time."<br/>";
                         if($to_time > $f_time && $to_time <= $t_time){
                            $is_valid = 0;
                         }
                    }
                    // echo $is_valid;
                    // exit;
                    // if($checkTime > 0){
                    //     $is_valid = 0;
                    // }

                    $checkTime = BarberBreak::where("barber_id",$barber_id)
                                   ->whereDate("break_date",$date)
                                   ->get(); 
                    // echo "<pre>";
                    // print_r($checkTime);
                    // echo "</pre>";
                    // exit;
                    foreach($checkTime as $ctime){
                         $f_time =strtotime($ctime->from_time);
                         $t_time =strtotime($ctime->to_time);
                         if($to_time > $f_time && $to_time < $t_time){
                            $is_valid = 0;
                         }
                    }
                    // if($checkTime > 0){
                    //     $is_valid = 0;
                    // }
                    if($is_valid == 1){
                        $diff = round(abs($to_time - $from_time) / 60,2);
                        if($diff == $minutes){
                            $available_time[] = array("start_time"=>$array_of_time[$i],"end_time"=>$array_of_time[$i+1]);
                        }
                    }
                    
                }
            }
            $response['status'] = 'success';
            $response['minutes'] = $minutes;
            $response['available_time'] = $available_time;

        } catch (Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }*/

    // public function getTimeSlot(Request $request){
    //     try{
            
    //         // $requestData  = json_encode($request->all());
    //         // $object = new ApiRequest();
    //         // $object->request_data = $requestData;
    //         // $object->save();

            

    //         $saloon_id = $request->input("saloon_id"); // updated by mustak
    //         $barber_id = $request->input("barber_id");
    //         $date = $request->input("book_date");
    //         $service_ids = $request->input("services");
    //         $saloon_service_id = $request->input("saloon_service_id");

    //         $barber_name = "";
    //         $barberRes = Barbers::where('id',$barber_id)->first();
    //         if(!empty($barberRes))
    //         {
    //             $barber_name = $barberRes->name;
    //         }
    //         // $service_time = BarbersServices::whereIn("id",$service_ids)->sum(\DB::raw("TIME_TO_SEC(duration)"));
    //         $service_time = BarbersServices::where("saloon_id", $saloon_id)->where("barber_id", $barber_id)->whereIn("service_id",$service_ids)->whereIn("saloon_service_id", $saloon_service_id)->sum(\DB::raw("TIME_TO_SEC(duration)"));
    //         if(empty($service_time) || $service_time == 0)
    //         {
    //             $response['status'] = 'error';
    //             // $response['message'] = "Time slot not added for barber";
    //             $response['message'] = "No time slots available for ".$barber_name." on this day";
    //             return response()->json($response);
    //         }
    //         $service_time = (int)$service_time;
    //         $saloon = Saloons::where("id",$saloon_id)->first();
    //         // $sl_start_time = $saloon->open_time;
    //         // $sl_close_time = $saloon->close_time;

    //         $barber_schedule = BarberSchedule::where("schedule_date",$date)->where('barber_id',$barber_id)->first();
    //         if(empty($barber_schedule)){
    //             $response['status'] = 'error';
    //             // $response['message'] = "Barber not available for the day";
    //             $response['message'] = "No time slots available for ".$barber_name." on this day";
    //             return response()->json($response);
    //         }
    //         $sl_start_time = $barber_schedule->from_time;
    //         $sl_close_time = $barber_schedule->to_time;

    //         $minutes = $service_time/60;
    //         $starttime = date("Y-m-d H:i",strtotime($date." ".$sl_start_time));
    //         $endtime = date("Y-m-d H:i",strtotime($date." ".$sl_close_time));
           
    //         $array_of_time = array ();
    //         $start_time    = strtotime ($starttime); //change to strtotime
    //         $end_time      = strtotime ($endtime); //change to strtotime

    //         $add_mins  = $minutes * 60;
    //         // echo $add_mins;
    //         $bookings = Bookings::where("book_date",$date)
    //         ->where("payment_status", "C")
    //                                 ->whereHas("Saloon")
    //                                ->whereHas("Barber")
    //                                ->where("saloon_id",$saloon_id)
    //                                ->where("barber_id",$barber_id)
    //                                ->where("status","!=",'cancelled')                                   
    //                                ->orderBy("from_time","asc")
    //                                ->get(); 
    //         // pre($booked_slot->toArray());
    //         $available_time = array();
    //         $times = array();
    //         $prev_endtime = array();
    //         // pre($sl_start_time);
    //         // pre($sl_close_time);
    //         // echo "<hr>";
    //         $booked_slot = array();
    //         foreach($bookings as $slot){
    //             $temp = new \stdClass();
    //             $temp->from_time = $slot->from_time;
    //             $temp->to_time = $slot->to_time;
    //             $booked_slot[] = $temp;
    //         }

    //         $barber_break = BarberBreak::where("break_date",$date)->where('barber_id',$barber_id)->get();
    //         foreach($barber_break as $slot){
    //             $temp = new \stdClass();
    //             $temp->from_time = $slot->from_time;
    //             $temp->to_time = $slot->to_time;
    //             $booked_slot[] = $temp;
    //         }
    //         asort($booked_slot);
    //         $booked_slot = array_values($booked_slot);
    //         foreach($booked_slot as $key => $slot){
    //             // echo "<pre>";
    //             // print_r($slot);
    //             // echo "</pre>";
    //             if($key == 0){
    //                 $start_time = date("Y-m-d H:i",strtotime($date." ".$sl_start_time));
    //                 // echo "<br/>Start". $start_time."<br/>";
    //                 $end_time = date("Y-m-d H:i",strtotime($date." ".$slot->from_time));
    //                 // echo "<br/>End". $end_time."<br/>";
    //                 $prev_endtime[$key] = $slot->to_time;
    //                 // echo "<pre>";
    //                 // print_r($prev_endtime);
    //                 // echo "</pre>";
    //                 $starttime = strtotime($start_time);
    //                 $endtime = strtotime($end_time);
    //                 $valid = 1;
    //                 // echo "if";
    //                 // echo "STartTime = ".$starttime;
    //                 // echo "<br/>EndTime = ".$endtime;
    //                 // echo "<br/>Mins = ".$add_mins;
    //                 // $add_mins = ($endtime - $starttime)/60;
    //                 if(date('Y-m-d') == date('Y-m-d',strtotime($date)))
    //                 {
    //                     // if(date('H:i',strtotime($start_time)) > date('H:i'))
    //                     // {
    //                         $time_slots = $this->timeSlot($starttime,$endtime,$add_mins);
    //                         // echo "hereif";
    //                         // exit;
    //                         $array_of_time = array_merge($array_of_time,$time_slots);
    //                         // echo "<pre>";
    //                         // print_r($array_of_time);
    //                         // echo "</pre>";
    //                         // exit; 
    //                     // }
                        
    //                 }
    //                 else{
    //                     $time_slots = $this->timeSlot($starttime,$endtime,$add_mins);
    //                     // echo "hereif";
    //                     // exit;
    //                     $array_of_time = array_merge($array_of_time,$time_slots);
    //                     // echo "<pre>";
    //                     // print_r($array_of_time);
    //                     // echo "</pre>";
    //                     // exit; 
    //                 }
                                       
    //             }else{
                    
    //                 $start_time = date("Y-m-d H:i",strtotime($date." ".$prev_endtime[$key-1]));
    //                 $end_time = date("Y-m-d H:i",strtotime($date." ".$slot->from_time));

    //                 $prev_endtime[$key] = $slot->to_time;

    //                 $starttime = strtotime($start_time);
    //                 $endtime = strtotime($end_time);
    //                 // echo "else";

    //                 if(date('Y-m-d') == date('Y-m-d',strtotime($date)))
    //                 {
    //                     // if(date('H:i',strtotime($start_time)) > date('H:i'))
    //                     // {
    //                         $time_slots = $this->timeSlot($starttime,$endtime,$add_mins);
    //                         // echo "hereend";
    //                         // exit;
    //                         $array_of_time = array_merge($array_of_time,$time_slots);
    //                     // }
    //                 }
    //                 else{
    //                     $time_slots = $this->timeSlot($starttime,$endtime,$add_mins);
    //                         // echo "hereend";
    //                         // exit;
    //                         $array_of_time = array_merge($array_of_time,$time_slots);
    //                 }
                    
    //             }
    //         }

    //         if(count($booked_slot) > 0){
    //             $start_time = date("Y-m-d H:i",strtotime($date." ".end($prev_endtime)));
    //             $end_time = date("Y-m-d H:i",strtotime($date." ".$sl_close_time));
    //         }else{
    //             $start_time = date("Y-m-d H:i",strtotime($date." ".$sl_start_time));
    //             $end_time = date("Y-m-d H:i",strtotime($date." ".$sl_close_time));
    //         }
    //         // echo $start_time." - ".$end_time;
    //         // exit;
    //         $starttime = strtotime($start_time);
    //         $endtime = strtotime($end_time);
    //         $time_slots = $this->timeSlot($starttime,$endtime,$add_mins);
    //         // echo "<pre>";
    //         // print_r($time_slots);
    //         // echo "</pre>";
    //         // exit; 
    //         $array_of_time = array_merge($array_of_time,$time_slots);
    //         // echo "<pre>";
    //         // print_r($array_of_time);
    //         // echo "</pre>";
    //         // exit; 
    //         $array_of_time = array_values(array_unique($array_of_time));
    //         // echo "<pre>";
    //         // print_r($array_of_time);
    //         // echo "</pre>";
    //         // exit; 
    //         $available_time = array();
    //         for($i=0;$i < count($array_of_time);$i++){
    //             if(isset($array_of_time[$i+1])){
    //                 $to_time=strtotime($array_of_time[$i+1]);
    //                 // echo $array_of_time[$i]." to ".$array_of_time[$i+1]."<Br>";
    //                 $from_time=strtotime($array_of_time[$i]); 
    //                 $time = array("start_time"=>$array_of_time[$i],"end_time"=>$array_of_time[$i+1]);
                  
    //                 $checkTime = Bookings::where("saloon_id",$saloon_id)
    //                                ->where("payment_status", "C")
    //                                ->where("barber_id",$barber_id)
    //                                ->whereDate("book_date",$date)
    //                                ->where("status","!=",'cancelled') 
    //                                ->whereHas("Saloon")
    //                                ->whereHas("Barber")
    //                                ->orderBy("from_time","asc")
    //                                ->get(); 
    //                 // echo "<Br>".$checkTime;
    //                 // echo "<pre>";
    //                 // print_r($checkTime);
    //                 // echo "</pre>";
    //                 // exit;
    //                 $is_valid = 1;
    //                 foreach($checkTime as $ctime){
    //                      $f_time =strtotime($ctime->from_time);
    //                      $t_time =strtotime($ctime->to_time);
    //                      // echo $to_time."<br/>";
    //                      // echo $f_time."<br/>";
    //                      // echo $t_time."<br/>";
    //                      if($to_time > $f_time && $to_time <= $t_time){
    //                         $is_valid = 0;
    //                      }
    //                 }
    //                 // echo $is_valid;
    //                 // exit;
    //                 // if($checkTime > 0){
    //                 //     $is_valid = 0;
    //                 // }

    //                 $checkTime = BarberBreak::where("barber_id",$barber_id)
    //                                ->whereDate("break_date",$date)
    //                                ->get(); 
    //                 // echo "<pre>";
    //                 // print_r($checkTime);
    //                 // echo "</pre>";
    //                 // exit;
    //                 foreach($checkTime as $ctime){
    //                      $f_time =strtotime($ctime->from_time);
    //                      $t_time =strtotime($ctime->to_time);
    //                      if($to_time > $f_time && $to_time < $t_time){
    //                         $is_valid = 0;
    //                      }
    //                 }
    //                 // if($checkTime > 0){
    //                 //     $is_valid = 0;
    //                 // }
    //                 if($is_valid == 1){
    //                     $diff = round(abs($to_time - $from_time) / 60,2);
    //                     if($diff == $minutes){

    //                         if($date == date('Y-m-d'))
    //                         {
    //                             if(date('H:i',strtotime($array_of_time[$i])) > date('H:i'))
    //                             {
    //                                 $available_time[] = array("start_time"=>$array_of_time[$i],"end_time"=>$array_of_time[$i+1]);
    //                             }
    //                         }
    //                         else{
    //                             $available_time[] = array("start_time"=>$array_of_time[$i],"end_time"=>$array_of_time[$i+1]);
    //                         }
    //                     }
    //                 }
                    
    //             }
    //         }
    //         $messageText = "Success";
    //         if(empty($available_time))
    //         {
    //             $messageText = "No time slots available for ".$barber_name." on this day";
    //         }
    //         $response['status'] = 'success';
    //         $response['message'] = $messageText;
    //         $response['minutes'] = $minutes;
    //         $response['available_time'] = $available_time;

    //     } catch (\Exception $e) {
    //         $response['status'] = 'error';
    //         $response['message'] = $e->getMessage();
    //     }
    //     return response()->json($response);
    // }


    public function getTimeSlot(Request $request){
        try{
            
            // $requestData  = json_encode($request->all());
            // $object = new ApiRequest();
            // $object->request_data = $requestData;
            // $object->save();

            

            $saloon_id = $request->input("saloon_id"); // updated by mustak
            $barber_id = $request->input("barber_id");
            $date = $request->input("book_date");
            $service_ids = $request->input("services");
            $saloon_service_id = $request->input("saloon_service_id");

            $barber_name = "";
            $barberRes = Barbers::where('id',$barber_id)->first();
            if(!empty($barberRes))
            {
                $barber_name = $barberRes->name;
            }
            // $service_time = BarbersServices::whereIn("id",$service_ids)->sum(\DB::raw("TIME_TO_SEC(duration)"));
            $service_time = BarbersServices::where("saloon_id", $saloon_id)->where("barber_id", $barber_id)->whereIn("service_id",$service_ids)->whereIn("saloon_service_id", $saloon_service_id)->sum(\DB::raw("TIME_TO_SEC(duration)"));
            if(empty($service_time) || $service_time == 0)
            {
                $response['status'] = 'error';
                // $response['message'] = "Time slot not added for barber";
                $response['message'] = "No time slots available for ".$barber_name." on this day";
                return response()->json($response);
            }
            $service_time = (int)$service_time;
            $saloon = Saloons::where("id",$saloon_id)->first();
            // $sl_start_time = $saloon->open_time;
            // $sl_close_time = $saloon->close_time;

            $barber_schedule = BarberSchedule::where("schedule_date",$date)->where('barber_id',$barber_id)->first();
            if(empty($barber_schedule)){
                $response['status'] = 'error';
                // $response['message'] = "Barber not available for the day";
                $response['message'] = "No time slots available for ".$barber_name." on this day";
                return response()->json($response);
            }
            $sl_start_time = $barber_schedule->from_time;
            $sl_close_time = $barber_schedule->to_time;

            $sl_start_time = date('H:i',strtotime($barber_schedule->from_time));
            $sl_close_time = date('H:i',strtotime($barber_schedule->to_time));

            $sl_close_dt = date('Y-m-d H:i',strtotime($barber_schedule->schedule_date." ".$barber_schedule->to_time));

            $strStartTime = strtotime($sl_start_time);
			$strEndTime = strtotime($sl_close_time);
            $available_time = array();
            for($i= $strStartTime; $i <= $strEndTime; $i=$i+900)
            {
                
                $isBooked = "Y";
                $time_slots = array();
                $bookingTime = date("H:i", $i);
                $bookingEndTime = date('H:i',($i+$service_time));

                $bookingEndDT = date('Y-m-d H:i',strtotime($request->book_date." ".$bookingTime));

                $bookingEndDT = date("Y-m-d H:i", (strtotime(date($bookingEndDT)) + $service_time));

                if(date('Y-m-d') == date('Y-m-d',strtotime($request->book_date)))
                {
                    if($bookingTime > date('H:i') && $bookingEndDT <= $sl_close_dt)
                    {
                        
                        $bookingBeforeTime = date('H:i',$i-$service_time);

                        $bookingEndDateTime = date('Y-m-d H:i',strtotime($date.' '.$bookingTime));
                        $bookingEndDateTime = date("Y-m-d H:i:s", strtotime('+'.$service_time.' seconds', strtotime($bookingEndDateTime)));

                        $barberBreak = BarberBreak::where("break_date",$date)->where('barber_id',$barber_id)
                        ->where(function($q) use($bookingTime,$bookingEndTime){
                            $q->where('from_time','<=',$bookingTime)
                            ->orWhere('from_time','<',$bookingEndTime);
                        })
                        ->where(function($q1) use($bookingTime,$bookingEndTime){
                            $q1->where('to_time','>',$bookingTime)
                            ->orWhere('to_time','>=',$bookingEndTime);
                        })
                        ->count();
                        if($barberBreak == 0)
                        {
                            $checkBooking = Bookings::where("book_date",$date)
                            ->where("payment_status","=",'C') // added later 
                            ->where("status","!=",'cancelled') 
                            ->where(function($q) use($bookingTime,$bookingEndTime){
                                $q->where('from_time','<=',$bookingTime)
                                ->orWhere('from_time','<',$bookingEndTime);
                            })
                            ->where(function($q1) use($bookingTime,$bookingEndTime){
                                $q1->where('to_time','>',$bookingTime)
                                ->orWhere('to_time','>=',$bookingEndTime);
                            })
                            // ->where("from_time",">=",$booked_time['start_time'])
                            // ->where("to_time","<=",$booked_time['end_time'])
                            ->where("barber_id",$barber_id)
                            ->count();
                            if($checkBooking == 0)
                            {
                                $available_time[] = array("start_time"=>$bookingTime,"end_time"=>$bookingEndTime);

                            }
                        }
                    }
                }
                else{
                    if($bookingEndDT <= $sl_close_dt)
                    {
                        
                        $bookingBeforeTime = date('H:i',$i-$service_time);

                        $bookingEndDateTime = date('Y-m-d H:i',strtotime($date.' '.$bookingTime));
                        $bookingEndDateTime = date("Y-m-d H:i:s", strtotime('+'.$service_time.' seconds', strtotime($bookingEndDateTime)));

                        $barberBreak = BarberBreak::where("break_date",$date)->where('barber_id',$barber_id)
                        ->where(function($q) use($bookingTime,$bookingEndTime){
                            $q->where('from_time','<=',$bookingTime)
                            ->orWhere('from_time','<',$bookingEndTime);
                        })
                        ->where(function($q1) use($bookingTime,$bookingEndTime){
                            $q1->where('to_time','>',$bookingTime)
                            ->orWhere('to_time','>=',$bookingEndTime);
                        })
                        ->count();
                        if($barberBreak == 0)
                        {
                            $checkBooking = Bookings::where("book_date",$date)
                            ->where("payment_status","=",'C') // added later 
                            ->where("status","!=",'cancelled') 
                            ->where(function($q) use($bookingTime,$bookingEndTime){
                                $q->where('from_time','<=',$bookingTime)
                                ->orWhere('from_time','<',$bookingEndTime);
                            })
                            ->where(function($q1) use($bookingTime,$bookingEndTime){
                                $q1->where('to_time','>',$bookingTime)
                                ->orWhere('to_time','>=',$bookingEndTime);
                            })
                            // ->where("from_time",">=",$booked_time['start_time'])
                            // ->where("to_time","<=",$booked_time['end_time'])
                            ->where("barber_id",$barber_id)
                            ->count();
                            if($checkBooking == 0)
                            {
                                $available_time[] = array("start_time"=>$bookingTime,"end_time"=>$bookingEndTime);

                            }
                        }
                    }
                }

                

            }

            $minutes = $service_time/60;
            // $starttime = date("Y-m-d H:i",strtotime($date." ".$sl_start_time));
            // $endtime = date("Y-m-d H:i",strtotime($date." ".$sl_close_time));
           
            // $array_of_time = array ();
            // $start_time    = strtotime ($starttime); //change to strtotime
            // $end_time      = strtotime ($endtime); //change to strtotime

            // $add_mins  = $minutes * 60;
            // // echo $add_mins;
            // $bookings = Bookings::where("book_date",$date)
            // ->where("payment_status", "C")
            //                         ->whereHas("Saloon")
            //                        ->whereHas("Barber")
            //                        ->where("saloon_id",$saloon_id)
            //                        ->where("barber_id",$barber_id)
            //                        ->where("status","!=",'cancelled')                                   
            //                        ->orderBy("from_time","asc")
            //                        ->get(); 
            // // pre($booked_slot->toArray());
            // $available_time = array();
            // $times = array();
            // $prev_endtime = array();
            // // pre($sl_start_time);
            // // pre($sl_close_time);
            // // echo "<hr>";
            // $booked_slot = array();
            // foreach($bookings as $slot){
            //     $temp = new \stdClass();
            //     $temp->from_time = $slot->from_time;
            //     $temp->to_time = $slot->to_time;
            //     $booked_slot[] = $temp;
            // }

            // $barber_break = BarberBreak::where("break_date",$date)->where('barber_id',$barber_id)->get();
            // foreach($barber_break as $slot){
            //     $temp = new \stdClass();
            //     $temp->from_time = $slot->from_time;
            //     $temp->to_time = $slot->to_time;
            //     $booked_slot[] = $temp;
            // }
            // asort($booked_slot);
            // $booked_slot = array_values($booked_slot);
            // foreach($booked_slot as $key => $slot){
            //     // echo "<pre>";
            //     // print_r($slot);
            //     // echo "</pre>";
            //     if($key == 0){
            //         $start_time = date("Y-m-d H:i",strtotime($date." ".$sl_start_time));
            //         // echo "<br/>Start". $start_time."<br/>";
            //         $end_time = date("Y-m-d H:i",strtotime($date." ".$slot->from_time));
            //         // echo "<br/>End". $end_time."<br/>";
            //         $prev_endtime[$key] = $slot->to_time;
            //         // echo "<pre>";
            //         // print_r($prev_endtime);
            //         // echo "</pre>";
            //         $starttime = strtotime($start_time);
            //         $endtime = strtotime($end_time);
            //         $valid = 1;
            //         // echo "if";
            //         // echo "STartTime = ".$starttime;
            //         // echo "<br/>EndTime = ".$endtime;
            //         // echo "<br/>Mins = ".$add_mins;
            //         // $add_mins = ($endtime - $starttime)/60;
            //         if(date('Y-m-d') == date('Y-m-d',strtotime($date)))
            //         {
            //             // if(date('H:i',strtotime($start_time)) > date('H:i'))
            //             // {
            //                 $time_slots = $this->timeSlot($starttime,$endtime,900);
            //                 // echo "hereif";
            //                 // exit;
            //                 $array_of_time = array_merge($array_of_time,$time_slots);
            //                 // echo "<pre>";
            //                 // print_r($array_of_time);
            //                 // echo "</pre>";
            //                 // exit; 
            //             // }
                        
            //         }
            //         else{
            //             $time_slots = $this->timeSlot($starttime,$endtime,900);
            //             // echo "hereif";
            //             // exit;
            //             $array_of_time = array_merge($array_of_time,$time_slots);
            //             // echo "<pre>";
            //             // print_r($array_of_time);
            //             // echo "</pre>";
            //             // exit; 
            //         }
                                       
            //     }else{
                    
            //         $start_time = date("Y-m-d H:i",strtotime($date." ".$prev_endtime[$key-1]));
            //         $end_time = date("Y-m-d H:i",strtotime($date." ".$slot->from_time));

            //         $prev_endtime[$key] = $slot->to_time;

            //         $starttime = strtotime($start_time);
            //         $endtime = strtotime($end_time);
            //         // echo "else";

            //         if(date('Y-m-d') == date('Y-m-d',strtotime($date)))
            //         {
            //             // if(date('H:i',strtotime($start_time)) > date('H:i'))
            //             // {
            //                 $time_slots = $this->timeSlot($starttime,$endtime,900);
            //                 // echo "hereend";
            //                 // exit;
            //                 $array_of_time = array_merge($array_of_time,$time_slots);
            //             // }
            //         }
            //         else{
            //             $time_slots = $this->timeSlot($starttime,$endtime,900);
            //                 // echo "hereend";
            //                 // exit;
            //                 $array_of_time = array_merge($array_of_time,$time_slots);
            //         }
                    
            //     }
            // }

            // if(count($booked_slot) > 0){
            //     $start_time = date("Y-m-d H:i",strtotime($date." ".end($prev_endtime)));
            //     $end_time = date("Y-m-d H:i",strtotime($date." ".$sl_close_time));
            // }else{
            //     $start_time = date("Y-m-d H:i",strtotime($date." ".$sl_start_time));
            //     $end_time = date("Y-m-d H:i",strtotime($date." ".$sl_close_time));
            // }
            // // echo $start_time." - ".$end_time;
            // // exit;
            // $starttime = strtotime($start_time);
            // $endtime = strtotime($end_time);
            // $time_slots = $this->timeSlot($starttime,$endtime,900);
            // // echo "<pre>";
            // // print_r($time_slots);
            // // echo "</pre>";
            // // exit; 
            // $array_of_time = array_merge($array_of_time,$time_slots);
            // // echo "<pre>";
            // // print_r($array_of_time);
            // // echo "</pre>";
            // // exit; 
            // $array_of_time = array_values(array_unique($array_of_time));
            // // echo "<pre>";
            // // print_r($array_of_time);
            // // echo "</pre>";
            // // exit; 
            // $available_time = array();
            // for($i=0;$i < count($array_of_time);$i++){
            //     if(isset($array_of_time[$i+1])){
            //         $to_time=strtotime($array_of_time[$i+1]);
            //         // echo $array_of_time[$i]." to ".$array_of_time[$i+1]."<Br>";
            //         $from_time=strtotime($array_of_time[$i]); 
            //         $time = array("start_time"=>$array_of_time[$i],"end_time"=>$array_of_time[$i+1]);
                  
            //         $checkTime = Bookings::where("saloon_id",$saloon_id)
            //                        ->where("payment_status", "C")
            //                        ->where("barber_id",$barber_id)
            //                        ->whereDate("book_date",$date)
            //                        ->where("status","!=",'cancelled') 
            //                        ->whereHas("Saloon")
            //                        ->whereHas("Barber")
            //                        ->orderBy("from_time","asc")
            //                        ->get(); 
            //         // echo "<Br>".$checkTime;
            //         // echo "<pre>";
            //         // print_r($checkTime);
            //         // echo "</pre>";
            //         // exit;
            //         $is_valid = 1;
            //         foreach($checkTime as $ctime){
            //              $f_time =strtotime($ctime->from_time);
            //              $t_time =strtotime($ctime->to_time);
            //              // echo $to_time."<br/>";
            //              // echo $f_time."<br/>";
            //              // echo $t_time."<br/>";
            //              if($to_time > $f_time && $to_time <= $t_time){
            //                 $is_valid = 0;
            //              }
            //         }
            //         // echo $is_valid;
            //         // exit;
            //         // if($checkTime > 0){
            //         //     $is_valid = 0;
            //         // }

            //         $checkTime = BarberBreak::where("barber_id",$barber_id)
            //                        ->whereDate("break_date",$date)
            //                        ->get(); 
            //         // echo "<pre>";
            //         // print_r($checkTime);
            //         // echo "</pre>";
            //         // exit;
            //         foreach($checkTime as $ctime){
            //              $f_time =strtotime($ctime->from_time);
            //              $t_time =strtotime($ctime->to_time);
            //              if($to_time > $f_time && $to_time < $t_time){
            //                 $is_valid = 0;
            //              }
            //         }
            //         // if($checkTime > 0){
            //         //     $is_valid = 0;
            //         // }
            //         if($is_valid == 1){
            //             $diff = round(abs($to_time - $from_time) / 60,2);
            //             if($diff == $minutes){

            //                 if($date == date('Y-m-d'))
            //                 {
            //                     if(date('H:i',strtotime($array_of_time[$i])) > date('H:i'))
            //                     {
            //                         $available_time[] = array("start_time"=>$array_of_time[$i],"end_time"=>$array_of_time[$i+1]);
            //                     }
            //                 }
            //                 else{
            //                     $available_time[] = array("start_time"=>$array_of_time[$i],"end_time"=>$array_of_time[$i+1]);
            //                 }
            //             }
            //         }
                    
            //     }
            // }
            $messageText = "Success";
            if(empty($available_time))
            {
                $messageText = "No time slots available for ".$barber_name." on this day";
            }
            $response['status'] = 'success';
            $response['message'] = $messageText;
            $response['minutes'] = $minutes;
            $response['available_time'] = $available_time;
            $response['close_time'] = $sl_close_time;

        } catch (\Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }

    public function timeSlot($start_time,$end_time,$add_mins){        
        $array_of_time = array();
        // echo $start_time."<br/>";
        // echo $end_time."<br/>";
        // echo $add_mins."<br/>";
        // exit;
        while ($start_time <= $end_time) // loop between time
        {
           $array_of_time[] = date("H:i", $start_time);
           $start_time += $add_mins; // to check endtie=me
           // echo "Start Time = ".$start_time."<br/>";
        }
        // echo "<pre>";
        // print_r($start_time);
        // print_r($end_time);
        // print_r($add_mins);
        // print_r($array_of_time);
        // echo "</pre>";
        // exit;
        return $array_of_time;

    }

    public function bookService(Request $request){
        try{
            $validator = Validator::make($request->all(), [
                'salon_id' => 'required',
                'barber_id' => 'required',
                'customer_id' => 'required',
                'book_date' => 'required',
                'services' => 'required',
                'booked_time' => 'required',
                'amount' => 'required',
                'payment_type' => 'required'
            ]);
            if ($validator->fails()) {
                $response['status'] = 'validation_error';
                $error = $validator->errors()->toArray();
                $errMsg = '';
                foreach($error as $err){
                    $errMsg .= " ".$err[0];
                }
                $response['message'] = $errMsg;
                return response()->json($response);
            }
            $saloon_id = $request->input("salon_id");
            $booked_by = $request->input("booked_by");
            $barber_id = $request->input("barber_id");
            $customer_id = $request->input("customer_id");
            $date = $request->input("book_date");
            $service_ids = $request->input("services");
            $booked_time = $request->input("booked_time");

            $customer_name = $request->input('customer_name');
            $customer_email = $request->input('customer_email');
            $customer_phone = $request->input('customer_mobile');
            //
            $checkBooking = Bookings::where("book_date",$date)
            //->where("payment_status","=",'C') // added later 
            ->where("status","!=",'cancelled') 
            ->where(function($q) use($booked_time){
                $q->where('from_time','<=',$booked_time['start_time'])
                ->orWhere('from_time','<',$booked_time['end_time']);
            })
            ->where(function($q1) use($booked_time){
                $q1->where('to_time','>',$booked_time['start_time'])
                ->orWhere('to_time','>=',$booked_time['end_time']);
            })
            // ->where("from_time",">=",$booked_time['start_time'])
            // ->where("to_time","<=",$booked_time['end_time'])
            ->where("barber_id",$barber_id)
            ->count();
            // echo "<pre>";
            // print_r($checkBooking);
            // echo "</pre>";
            // exit;
            if($checkBooking > 0){
                $response['status'] = 'error';
                $response['message'] = 'Someone else has proceeded to payments page before you. You can wait for a few minutes in case their payment is canceled or they change their mind. You can also book other time slots which might suit your convenience.';
                return response()->json($response);
            }
            $customer = Customers::where("id",$customer_id)->first();
            if(!empty($customer))
            {
                $bcustomer_name = $customer->name;
                $bcustomer_email = $customer->email;
                $bcustomer_mobile = $customer->mobile;
            }
            else{
                $bcustomer_name = $customer_name;
                $bcustomer_email = $customer_email;
                $bcustomer_mobile = $customer_phone;
                
            }
            $total_price = SaloonServices::whereIn("id",$service_ids)->sum("price");
            $services = SaloonServices::whereIn("id",$service_ids)->get();

            $objSetting = new Settings();
            $commission = $objSetting->getSetting("Customer Charge");
            $commission1 = $objSetting->getSetting("Commission");
            $commission_price = ($total_price * $commission1) / 100;

            // $grand_total = $total_price+$commission_price;

            $grand_total = ($total_price * $commission) / 100;

            $object = new Bookings();
            $object->saloon_id = $saloon_id;
            $object->barber_id = $barber_id;
            $object->customer_id = $customer_id;
            $object->book_date = $date;
            $object->total = $total_price;
            $object->booked_by = $booked_by;
            $object->commission_amount = $commission_price;
            $object->grand_total = $grand_total;
            $object->from_time = $booked_time['start_time'];
            $object->to_time = $booked_time['end_time'];
            $object->book_number = mt_rand(100000,999999);
            // $object->transaction_id = mt_rand(100000,999999);
            $object->payment_status = "P";
            $object->billing_name = $bcustomer_name;
            $object->billing_mobile = $bcustomer_mobile;
            $object->billing_email = $bcustomer_email;
            $object->created_by = $customer_id;
            $object->customer_name = $customer_name;
            $object->customer_email = $customer_email;
            $object->customer_mobile = $customer_phone;
            $object->booking_remainder_minute = $request->booking_remainder_minute;
            $object->save();
            $book_id  = $object->id;
            foreach($services as $service){
                $newobj = new BookingItems();
                $newobj->booking_id = $book_id;
                $newobj->service_id = $service->service_id;
                $newobj->main_service_id = $service->id;
                $newobj->price = $service->price;
                $newobj->save();
            } 
            $booking = Bookings::select("id","book_number","book_date","from_time","to_time","total","billing_name","billing_email","billing_mobile")
                            ->where("id",$book_id)
                            ->first();
            // echo "<pre>";
            // print_r($booking);
            // echo "</pre>";
            // exit;
            $booking_services = BookingItems::with('Service')->where("booking_id",$book_id)->get();
            $services = array();
            $servicesname = array();
            foreach($booking_services as $serv){
                $temp['service_name'] = (!empty($serv->Service->name))?$serv->Service->name:'';
                $temp['service_price'] = $serv->price;
                $services[] = $temp;
                //
                $servicesname[] = ((!empty($serv->Service->name))?$serv->Service->name:'');
            }
            
            
            $salonRes = Saloons::where('id',$saloon_id)->first();
            $settings_razorpay_keyid = \DB::table("settings")
            ->select("setting_value")
            ->where("setting_title","=","Razorpay Keyid")
            ->get();
            $setting_razorpaykeyid = $settings_razorpay_keyid[0]->setting_value;
            //
            $settings_razorpay_secret = \DB::table("settings")
            ->select("setting_value")
            ->where("setting_title","=","Razorpay Secret")
            ->get();
            $setting_razorpaysecret = $settings_razorpay_secret[0]->setting_value;

            $OrderArr = array(
              'receipt' => $book_id,
              'amount' => ($grand_total * 100),
              'payment_capture' => 1,
              'currency' => 'INR'
              );

            if(!empty($salonRes))
            {
                if(!empty($salonRes->razorpay_account_id))
                {
                    // $objSetting = new Settings();
                    // $commission = $objSetting->getSetting("Commission");
                    // $nprice = ($request->input('amount') * $commission) / 100;
                    $salon_price = $total_price;

                    $OrderArr = array(
                      'receipt' => $book_id,
                      'amount' => ($grand_total * 100),
                      'payment_capture' => 1,
                      'currency' => 'INR',
                      'transfers' => array(
                            array(
                                'account' => $salonRes->razorpay_account_id,
                                'amount' => $salon_price*100,
                                'currency' => 'INR',
                                'notes' => array(
                                    'branch' => $book_id,
                                    'name' => $salonRes->saloon_name),
                                    'linked_account_notes' => array('branch'),
                                    'on_hold' => 0,
                                ),
                            )
                      );
                }
            }
            //
            $api = new Api($setting_razorpaykeyid, $setting_razorpaysecret);
            $order = $api->order->create($OrderArr);

            $orderLog = print_r($order, true);

            $rzpInsert = array(
                'member_id'=>$customer_id,
                'booking_id'=>$book_id,
                'salon_id'=>$saloon_id,
                'rzp_order_id'=>$order->id,
                'request'=>json_encode($OrderArr),
                'response'=>$orderLog,
                'created_at'=>date('Y-m-d H:i:s'),
                'updated_at'=>date('Y-m-d H:i:s')
            );

            RzpLog::insert($rzpInsert);

            
            // $data = array(
            //     'mobile'=>$customer_phone,
            //     'amount'=>$request->amount,
            //     'order_id'=>$book_id,
            //     'user_id'=>$customer_id
            // );
    
            // $phonepayRes = array(
            //     'status'=>'F'
            // );

            // if($request->payment_type == "card")
            // {
            //     $phonepayRes = PhonepayService::create_phonepay_payment_url($data);
            // }
            // else if($request->payment_type == 'upi'){
            //     $data['target_app'] = $request->package_name;
            //     $phonepayRes = PhonepayService::create_phonepay_upipayment_url($data);
            // }

            // if($phonepayRes['status'] == "S")
            // {
                $objectUpdate = Bookings::find($book_id);
                $objectUpdate->razorpay_orderid = $order->id;
                $objectUpdate->updated_at = date("Y-m-d H:i:s");
                $objectUpdate->save();

                $response['status'] = "success";
                $response['booking'] = $booking;
                $response['services'] = $services;
                $response['razorpayorderid'] = $order->id;
                // $response['payment_url']=$phonepayRes['url'];
                // $response['merchant_id']=$phonepayRes['merchant_id'];
                $response['order_id'] = $book_id;
            // }
            // else{
            //     $response['status'] = "error";
            // }
            //
            

            
            //
            
        } catch (Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }

    public function customerBookings(Request $request){
        // try{
            $customer_id = $request->input("customer_id");
            $bookings = Bookings::where("customer_id",$customer_id)
                                ->where("payment_status", "C")
                                ->whereHas("Saloon")
                                ->whereHas("Barber")
                                ->orderBy("book_date","desc")
                                ->orderBy("from_time","desc")->get();
            $bookingList = array();
            foreach($bookings as $booking){

                if(count($booking->Barber->Ratings) > 0){
                    $ratings = $booking->Barber->Ratings->avg("rating");
                }else{
                    $ratings = 0;
                }

                $barber_id = $booking->Barber->id;
                $queryBarberServicesBooking = \DB::table("bookings")->select("bookings.*","booking_items.id as itemid", "booking_items.main_service_id", "barbers_services.id as barber_service_id","barbers_services.duration")->where("bookings.barber_id","=",$barber_id)
                ->join("booking_items","booking_items.booking_id", "=", "bookings.id")
                // ->join("barbers_services","barbers_services.saloon_service_id", "=", "booking_items.main_service_id")
                ->join("barbers_services", function($join) use($barber_id){
                    $join->on("barbers_services.saloon_service_id", "=", "booking_items.main_service_id")
                    ->where("barbers_services.barber_id", $barber_id);
                })
                ->where("status","!=","cancelled")
                ->where("status","!=","emergency cancellation")
                ->where("payment_status","=","C")
                ->get();
                $working_hours = "";
                if(count($queryBarberServicesBooking) > 0)
                {
                    $time = 0;
                    foreach ($queryBarberServicesBooking as $skey => $svalue)
                    {
                        $arr_time = explode(":", $svalue->duration);
                        $hours_to_minutes = 0;
                        $hours = (int)$arr_time[0];
                        $hours_to_minutes = $hours * 60;
                        $minutes = (int)$arr_time[1];
                        $time = $time + $minutes + $hours_to_minutes;
                    }
                    $working_hours = ((floor($time / 60)).":".($time - floor($time / 60) * 60));
                }

                $temp = array();
                $temp['id'] = $booking->id;
                $temp['book_date'] = dateFormat($booking->book_date,"d-m-Y");
                $temp['salon_name'] = $booking->Saloon->saloon_name;
                $temp['latitude'] = $booking->Saloon->latitude;
                $temp['logitude'] = $booking->Saloon->logitude;
                $temp['salon_id'] = $booking->saloon_id;
                $temp['barber_name'] = $booking->Barber->name;
                $temp['barber_email'] = $booking->Barber->email;
                $temp['barber_mobile'] = $booking->Barber->mobile;
                $temp['barber_exp_year'] = $booking->Barber->exp_year;
                $temp['barber_exp_month'] = $booking->Barber->exp_month;
                $temp['barber_profile_image'] = url('/uploads/profile_images/'.$booking->Barber->profile_image);
                $temp['barber_id'] = $booking->barber_id;
                $temp['book_number'] = $booking->book_number;
                $temp['from_time'] = $booking->from_time;
                $temp['to_time'] = $booking->to_time;
                // $temp['total_price'] = number_format($booking->total+$booking->commission_amount,2);
                $temp['total_price'] = number_format($booking->grand_total,2);
                $temp['transaction_id'] = $booking->transaction_id;
                $temp['billing_name'] = $booking->billing_name;
                $temp['billing_mobile'] = $booking->billing_mobile;
                $temp['billing_email'] = $booking->billing_email;
                $temp['booked_by'] = $booking->booked_by;
                $temp['rating'] = $ratings;
                $temp['totalhours'] = $working_hours;
                $date = $booking->book_date." ".$booking->to_time;
                $current_date = date("Y-m-d H:i:s");

                /*if($date > $current_date){
                    $temp['status'] = 'Upcoming';
                }
                else
                {
                    $temp['status'] = 'Completed';
                }*/
                if($booking->status == 'active')
                {
                    $temp['status'] = 'Active';
                }
                if($date > $current_date){
                    $temp['status'] = 'Upcoming';
                }
                if($date < $current_date && ($booking->status != "cancelled" && $booking->status != "emergency cancellation") && $booking->payment_status == "C")
                {
                    $temp['status'] = 'Completed';
                }
                $cancel_date = "";
                if($booking->status == 'cancelled')
                {
                    $temp['status'] = 'Cancelled';
                    if(!(empty($booking->cancelled_at)))
                    {
                        $cancel_date = date("d-m-Y H:i:s", strtotime($booking->cancelled_at));
                    }
                }
                if($booking->status == 'emergency cancellation')
                {
                    $temp['status'] = 'Emergency Cancel';
                    if(!(empty($booking->cancelled_at)))
                    {
                        $cancel_date = date("d-m-Y H:i:s", strtotime($booking->cancelled_at));
                    }
                }
                $temp['cancel_date'] = $cancel_date;
                if($booking->status == "requested refund")
                {
                    $temp['status'] = 'Requested Refund';
                    $refund_request_date = date("d-m-Y H:i:s", strtotime($booking->refund_request_date));
                    $temp['refund_request_date'] = $refund_request_date;
                }

                $temp['action_type'] = "";
                if(!empty($booking->action_type))
                {
                    $temp['action_type'] = $booking->action_type;
                }

                $booking_services = BookingItems::with('Service')->with('SaloonService')->where("booking_id",$booking->id)->get();
                $services = array();
                foreach($booking_services as $serv){
                    if(!empty($serv->SaloonService))
                    {
                        $temp['service_id'] = $serv->SaloonService->id;
                        $temp['service_name'] = $serv->SaloonService->service_name;
                        if($serv->price > 0)
                        {
                            $objSetting = new Settings();
                            $commission = $objSetting->getSetting("Commission");
                            $nprice = ($serv->price * $commission) / 100;
                            $nprice = $serv->price + $nprice;
                            $serv->price = $nprice;
                        }
                        $temp['service_price'] = $serv->price;
                        $temp['main_service_id'] = $serv->service_id;
                        $services[] = $temp;
                    }
                }
                $temp['services'] = $services;
                //
                $is_rated = "N";
                $rating = Ratings::where("booking_id", $booking->id)->where("customer_id", $customer_id)->get();
                if(count($rating) > 0)
                {
                    $is_rated = "Y";
                }
                $temp['is_rated'] = $is_rated;
                //
                $is_fav = "N";
                $saloon_is_fav = \DB::table("saloon_favourite")->select("id")->where("customer_id", $customer_id)->where("saloon_id", $booking->saloon_id)->get();
                if(count($saloon_is_fav) > 0)
                {
                    $is_fav = "Y";
                }
                $temp['is_saloon_fav'] = $is_fav;
                // Get barber Reviews by saloon and customer
                $barberRatings = Ratings::select('ratings.id','ratings.customer_id','ratings.saloon_id','ratings.barber_id', 'ratings.rating', 'ratings.comment', 'ratings.booking_id', 'ratings.created_at', 'saloons.saloon_name', 'barbers.name', 'barbers.profile_image')
                ->join("saloons", "saloons.id", "=", "ratings.saloon_id")
                ->join("barbers", "barbers.id", "=", "ratings.barber_id")
                ->where("ratings.customer_id", $customer_id)
                ->where("ratings.booking_id", $booking->id)
                ->get();
                $data_review = array();
                if(!(empty($barberRatings)) && count($barberRatings) > 0)
                {
                    foreach ($barberRatings as $key => $value)
                    {
                        $barberprofileimage = "";
                        if(!(empty($value->profile_image)))
                        {
                            $barberprofileimage = url('/uploads/profile_images/'.$value->profile_image);
                        }
                        $data_review[] = array(
                            "id" => (string)$value->id,
                            "bookingid" => (string)$booking->id,
                            "customerid" => (string)$value->customer_id,
                            "rating" => (string)$value->rating,
                            "comment" => $value->comment,
                            "saloonname" => $value->saloon_name,
                            "barberid" => (string)$value->barber_id,
                            "barbername" => $value->name,
                            "barberprofileimage" => $barberprofileimage,
                            "created" => date("d-m-Y H:i:s", strtotime($value->created_at)),
                        );
                    }
                }
                $temp['reviews'] = $data_review;
                //
                $bookingList[] = $temp;
            }
            $response['status'] = 'success';
            $response['booking_list'] = $bookingList;
        // } catch (\Exception $e) {
        //     $response['status'] = 'error';
        //     $response['message'] = $e->getMessage();
        // }
        return response()->json($response);
    }


    public function customerBookingDetails(Request $request){
        try{
            $customer_id = $request->input("customer_id");
            $booking_id = $request->input("booking_id");
            $bookings = Bookings::where("customer_id",$customer_id)
                                ->where('id',$booking_id)
                                ->where("payment_status", "C")
                                ->whereHas("Saloon")
                                ->whereHas("Barber")
                                ->orderBy("book_date","desc")
                                ->orderBy("from_time","desc")->get();
            $bookingList = array();
            foreach($bookings as $booking){

                if(count($booking->Barber->Ratings) > 0){
                    $ratings = $booking->Barber->Ratings->avg("rating");
                }else{
                    $ratings = 0;
                }

                $barber_id = $booking->Barber->id;
                $queryBarberServicesBooking = \DB::table("bookings")->select("bookings.*","booking_items.id as itemid", "booking_items.main_service_id", "barbers_services.id as barber_service_id","barbers_services.duration")->where("bookings.barber_id","=",$barber_id)
                ->join("booking_items","booking_items.booking_id", "=", "bookings.id")
                // ->join("barbers_services","barbers_services.saloon_service_id", "=", "booking_items.main_service_id")
                ->join("barbers_services", function($join) use($barber_id){
                    $join->on("barbers_services.saloon_service_id", "=", "booking_items.main_service_id")
                    ->where("barbers_services.barber_id", $barber_id);
                })
                ->where("status","!=","cancelled")
                ->where("status","!=","emergency cancellation")
                ->where("payment_status","=","C")
                ->get();
                $working_hours = "";
                if(count($queryBarberServicesBooking) > 0)
                {
                    $time = 0;
                    foreach ($queryBarberServicesBooking as $skey => $svalue)
                    {
                        $arr_time = explode(":", $svalue->duration);
                        $hours_to_minutes = 0;
                        $hours = (int)$arr_time[0];
                        $hours_to_minutes = $hours * 60;
                        $minutes = (int)$arr_time[1];
                        $time = $time + $minutes + $hours_to_minutes;
                    }
                    $working_hours = ((floor($time / 60)).":".($time - floor($time / 60) * 60));
                }

                $temp = array();
                $temp['id'] = $booking->id;
                $temp['book_date'] = dateFormat($booking->book_date,"d-m-Y");
                $temp['salon_name'] = $booking->Saloon->saloon_name;
                $temp['salon_id'] = $booking->saloon_id;
                $temp['barber_name'] = $booking->Barber->name;
                $temp['barber_email'] = $booking->Barber->email;
                $temp['barber_mobile'] = $booking->Barber->mobile;
                $temp['barber_exp_year'] = $booking->Barber->exp_year;
                $temp['barber_exp_month'] = $booking->Barber->exp_month;
                $temp['barber_profile_image'] = url('/uploads/profile_images/'.$booking->Barber->profile_image);
                $temp['barber_id'] = $booking->barber_id;
                $temp['book_number'] = $booking->book_number;
                $temp['from_time'] = $booking->from_time;
                $temp['to_time'] = $booking->to_time;
                $temp['total_price'] = $booking->total;
                $temp['transaction_id'] = $booking->transaction_id;
                $temp['billing_name'] = $booking->billing_name;
                $temp['billing_mobile'] = $booking->billing_mobile;
                $temp['billing_email'] = $booking->billing_email;
                $temp['rating'] = $ratings;
                $temp['payment_status'] = $booking->payment_status;
                $temp['totalhours'] = $working_hours;
                $date = $booking->book_date." ".$booking->to_time;
                $current_date = date("Y-m-d H:i:s");

                /*if($date > $current_date){
                    $temp['status'] = 'Upcoming';
                }
                else
                {
                    $temp['status'] = 'Completed';
                }*/
                if($booking->status == 'active')
                {
                    $temp['status'] = 'Active';
                }
                if($date > $current_date){
                    $temp['status'] = 'Upcoming';
                }
                if($date < $current_date && ($booking->status != "cancelled" && $booking->status != "emergency cancellation") && $booking->payment_status == "C")
                {
                    $temp['status'] = 'Completed';
                }
                $cancel_date = "";
                if($booking->status == 'cancelled')
                {
                    $temp['status'] = 'Cancelled';
                    if(!(empty($booking->cancelled_at)))
                    {
                        $cancel_date = date("d-m-Y H:i:s", strtotime($booking->cancelled_at));
                    }
                }
                if($booking->status == 'emergency cancellation')
                {
                    $temp['status'] = 'Emergency Cancel';
                    if(!(empty($booking->cancelled_at)))
                    {
                        $cancel_date = date("d-m-Y H:i:s", strtotime($booking->cancelled_at));
                    }
                }
                $temp['cancel_date'] = $cancel_date;
                if($booking->status == "requested refund")
                {
                    $temp['status'] = 'Requested Refund';
                    $refund_request_date = date("d-m-Y H:i:s", strtotime($booking->refund_request_date));
                    $temp['refund_request_date'] = $refund_request_date;
                }

                $temp['action_type'] = "";
                if(!empty($booking->action_type))
                {
                    $temp['action_type'] = $booking->action_type;
                }

                $booking_services = BookingItems::with('Service')->where("booking_id",$booking->id)->get();
                $services = array();
                foreach($booking_services as $serv){
                    $temp['service_id'] = $serv->SaloonService->id;
                    $temp['service_name'] = $serv->SaloonService->service_name;
                    if($serv->price > 0)
                    {
                        $objSetting = new Settings();
                        $commission = $objSetting->getSetting("Commission");
                        $nprice = ($serv->price * $commission) / 100;
                        $nprice = $serv->price + $nprice;
                        $serv->price = $nprice;
                    }
                    $temp['service_price'] = $serv->price;
                    $temp['main_service_id'] = $serv->service_id;
                    $services[] = $temp;
                }
                $temp['services'] = $services;
                //
                $is_rated = "N";
                $rating = Ratings::where("booking_id", $booking->id)->where("customer_id", $customer_id)->get();
                if(count($rating) > 0)
                {
                    $is_rated = "Y";
                }
                $temp['is_rated'] = $is_rated;
                //
                $is_fav = "N";
                $saloon_is_fav = \DB::table("saloon_favourite")->select("id")->where("customer_id", $customer_id)->where("saloon_id", $booking->saloon_id)->get();
                if(count($saloon_is_fav) > 0)
                {
                    $is_fav = "Y";
                }
                $temp['is_saloon_fav'] = $is_fav;
                // Get barber Reviews by saloon and customer
                $barberRatings = Ratings::select('ratings.id','ratings.customer_id','ratings.saloon_id','ratings.barber_id', 'ratings.rating', 'ratings.comment', 'ratings.booking_id', 'ratings.created_at', 'saloons.saloon_name', 'barbers.name', 'barbers.profile_image')
                ->join("saloons", "saloons.id", "=", "ratings.saloon_id")
                ->join("barbers", "barbers.id", "=", "ratings.barber_id")
                ->where("ratings.customer_id", $customer_id)
                ->where("ratings.booking_id", $booking->id)
                ->get();
                $data_review = array();
                if(!(empty($barberRatings)) && count($barberRatings) > 0)
                {
                    foreach ($barberRatings as $key => $value)
                    {
                        $barberprofileimage = "";
                        if(!(empty($value->profile_image)))
                        {
                            $barberprofileimage = url('/uploads/profile_images/'.$value->profile_image);
                        }
                        $data_review[] = array(
                            "id" => (string)$value->id,
                            "bookingid" => (string)$booking->id,
                            "customerid" => (string)$value->customer_id,
                            "rating" => (string)$value->rating,
                            "comment" => $value->comment,
                            "saloonname" => $value->saloon_name,
                            "barberid" => (string)$value->barber_id,
                            "barbername" => $value->name,
                            "barberprofileimage" => $barberprofileimage,
                            "created" => date("d-m-Y H:i:s", strtotime($value->created_at)),
                        );
                    }
                }
                $temp['reviews'] = $data_review;
                //
                $bookingList[] = $temp;
            }
            $response['status'] = 'success';
            $response['booking_list'] = $bookingList;
        } catch (\Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }
    
    public function barberRating(Request $request){
        try{
            $validator = Validator::make($request->all(), [
                'barber_id' => 'required',
                'rating' => 'required',
                // 'comment' => 'required',
                'booking_id' => 'required'
            ]);
            if ($validator->fails()) {
                $response['status'] = 'validation_error';
                $error = $validator->errors()->toArray();
                $errMsg = '';
                foreach($error as $err){
                    $errMsg .= " ".$err[0];
                }
                $response['message'] = $errMsg;
                return response()->json($response);
            }
            $barber_id = $request->input("barber_id");
            $barber = Barbers::where("id",$barber_id)->first();
            
            $isRated = Ratings::select("id")
            ->where("booking_id", $request->input("booking_id"))
            ->where("customer_id", $request->input("customer_id"))
            ->get();
            if(!(empty($isRated)) && count($isRated) > 0)
            {
                $object = Ratings::find($isRated[0]->id);
                $object->rating = $request->input("rating");
                $object->comment = $request->input("comment");
                $object->save();
            }
            else
            {
                $object = new Ratings();
                $object->barber_id = $barber_id;
                $object->saloon_id = $barber->saloon_id;
                $object->rating = $request->input("rating");
                $object->customer_id = $request->input("customer_id");
                $object->booking_id = $request->input("booking_id");
                $object->comment = $request->input("comment");
                $object->save();
            }
            // Send notification to barber
            $booking_services = BookingItems::with('Service')->where("booking_id", $request->input("booking_id"))->get();
            $servicesname = array();
            foreach($booking_services as $serv)
            {
                $servicesname[] = ((!empty($serv->SaloonService->service_name))?$serv->SaloonService->service_name:'');
            }
            $arr_email = array();
            $arr_sms = array();
            $arr_push = array();
            $customer = Customers::where("id",$request->input("customer_id"))->first();
            // Get read unread notifiction count
            $notificationReadInfo = Notification::select('id','fromid','toid','referenceid', 'notification_type', 'message', 'isread', 'created_at')
            ->where("notification.toid", $barber_id)
            ->where("notification.notification_for", "B")
            ->where("notification.isread", "N")
            ->where("notification.is_deleted", 0)
            ->get();
            $readCount = $notificationReadInfo->count();
            $notificationUnreadInfo = Notification::select('id','fromid','toid','referenceid', 'notification_type', 'message', 'isread', 'created_at')
            ->where("notification.toid", $barber_id)
            ->where("notification.notification_for", "B")
            ->where("notification.isread", "N")
            ->where("notification.is_deleted", 0)
            ->get();
            $unreadCount = $notificationUnreadInfo->count();
            //
            $serviceName = implode(",", $servicesname);
            $message = $customer->name." gave you ".$request->input('rating')." Stars for ".$serviceName;
            // echo $message; exit;
            $arr_push = array();
            $android_recepient = array();
            $android_recepient[] = $barber->devicetoken;         
            $additionalData = array(
                'notificationType' => 'booking',
                'barber_id' => $barber->id,
                'read' => $readCount,
                'unread' => $unreadCount,
            );
            $arr_push = array(
                "devicetype" => $barber->devicetype, 
                "registatoin_ids" => $android_recepient,
                "message" => $message,
                "additionalData" => $additionalData
            );
            $notification = new Notification();
            $notification->sendAllBarberNotification($arr_email, $arr_sms, $arr_push);
            //
            $notificationsave = new Notification();
            $notificationsave->fromid = $request->input("customer_id");
            $notificationsave->toid = $barber->id;
            $notificationsave->referenceid = $request->input("booking_id");
            $notificationsave->notification_type = "Rating";
            $notificationsave->message = $message;
            $notificationsave->isread = "N";
            $notificationsave->created_at = date("Y-m-d H:i:s");
            $notificationsave->notification_for = "B";
            $notificationsave->save();
            $notificationId = $notificationsave->id;
            // echo "<br/>Id = ".$notificationId;

            $response['status'] = 'success';
            $response['message'] = 'Barber rated successfully';

        } catch (Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }

    // Added New functions

    public function render($value)
    {
        if($value === null)
        {
            $value = '';
        }
        return $value;
    }

    public function customerSocialRegister(Request $request)
    {
        try{
            $validator = Validator::make($request->all(), [
                'logintype' => 'required',
                'socialmediaid' => 'required'
            ]);
            if ($validator->fails()) {
                $response['status'] = 'validation_error';
                $error = $validator->errors()->toArray();
                $errMsg = '';
                foreach($error as $err){
                    $errMsg .= " ".$err[0];
                }
                $response['message'] = $errMsg;
                return response()->json($response);
            }
            else
            {
                $logintype = $request->input("logintype");
                $socialmediaid = $request->input("socialmediaid");
                $email = $request->input("email");
                $newUse = "Y";
                $isRecordExists = Customers::select('id','logintype', 'profileimage')
                ->where("logintype", $logintype)
                ->where("socialmediaid", $socialmediaid)
                ->first();
                $memberid = 0;
                if(!(empty($isRecordExists)))
                {
                    $newUse = "N";
                    $memberid = $isRecordExists['id'];
                    $isEmailExists = Customers::select('id','logintype')
                    ->where("id", "!=" ,$memberid)
                    ->where("email", $email)
                    ->get();
                    // echo "<pre>";
                    // print_r($isEmailExists);
                    // echo "</pre>";
                    // exit;
                    if(count($isEmailExists) > 0)
                    {
                        $response['status'] = 'error';
                        $response['message'] = "Account with same email already exists. Try again.";
                        return response()->json($response);
                    }
                    else
                    {
                        // update existing record
                        // echo $isRecordExists['id'];
                        // echo "<pre>";
                        // print_r($isRecordExists);
                        // echo "</pre>";
                        // exit;
                        $profileimage = $request->input('profileimage');
                        if(!(empty($isRecordExists['profileimage'])))
                        {
                            $profileimage = $isRecordExists['profileimage'];
                        }
                        $updateMemberData = array(
                            'username' => $request->input('username'),
                            'logintype' => $request->input('logintype'),
                            'profileimage' => $profileimage,
                            'socialmediaid' => $request->input('socialmediaid'),
                            'gender' => $request->input('gender'),
                            'ipaddress' => $_SERVER['REMOTE_ADDR'],
                            'devicetype' => $request->input('devicetype'),
                            'devicetoken' => $request->input('devicetoken'),
                            'updated_by' => $isRecordExists['id'],
                            'updated_at' => date('Y-m-d H:i:s')
                        );
                        Customers::where("id", $isRecordExists['id'])
                        ->update($updateMemberData);
                    }
                }
                else
                {
                    $isEmailExists = Customers::select("id", "logintype", "profileimage")
                    ->where("email", $email)->get();
                    // echo "<pre>";
                    // print_r($isEmailExists);
                    // echo "</pre>";
                    // exit;
                    if(count($isEmailExists) > 0)
                    {
                        /*$response['status'] = 'error';
                        $response['message'] = "Account with same email already exists. Try again.";*/
                        // echo json_encode($response);
                        $updateMemberData = array(
                            'logintype' => $request->input('logintype'),
                            'socialmediaid' => $request->input('socialmediaid'),
                            'ipaddress' => $_SERVER['REMOTE_ADDR'],
                            'devicetype' => $request->input('devicetype'),
                            'devicetoken' => $request->input('devicetoken'),
                            'updated_by' => $isEmailExists[0]['id'],
                            'updated_at' => date('Y-m-d H:i:s')
                        );
                        Customers::where("id", $isEmailExists[0]['id'])
                        ->update($updateMemberData);
                        $memberid = $isEmailExists[0]['id'];
                    }
                    else
                    {
                        //
                        $newUse = "Y";
                        
                        $name = $request->input('name');
                        if(empty($name))
                        {
                            $name = "";
                        }
                        $email = $request->input('email');
                        if(empty($name))
                        {
                            $email = "";
                        }
                        
                        // insert new record
                        $customerObj = new Customers();
                        $customerObj->name = $name;
                        $customerObj->username = $request->input('username');
                        $customerObj->email = $email;
                        $customerObj->logintype = $request->input('logintype');
                        $customerObj->profileimage = $request->input('profileimage');
                        $customerObj->socialmediaid = $request->input('socialmediaid');
                        $customerObj->gender = $request->input('gender');
                        $customerObj->ipaddress = $_SERVER['REMOTE_ADDR'];
                        $customerObj->devicetype = $request->input('devicetype');
                        $customerObj->devicetoken = $request->input('devicetoken');
                        $customerObj->created_at = date('Y-m-d H:i:s');
                        $customerObj->updated_at = date('Y-m-d H:i:s');
                        $customerObj->save();
                        $memberId = $customerObj->id;
                        // Updating token in table for new signup user
                        $updateMemberData = array(
                        'created_by' => $memberId,
                        'updated_by' => $memberId,
                        );
                        Customers::where("id", $memberId)
                        ->update($updateMemberData);
                        $memberid = $memberId;
                        // Registration welcome email
                        // $keyvalues = array(
                        // "{{username}}" => $firstname." ".$lastname
                        // );
                        // $templateslug = "email_welcome";
                        // $toemail = $email;
                        // $arr_email = $this->notification_model->getEmailTemplate($keyvalues, $templateslug, $toemail, $tocc=null, $tobcc=null);
                        // //
                        // $this->notification_model->sendAllNotification($arr_email,array(), array());
                    }
                }

                $arr_data = array();
                if($memberid > 0)
                {
                    $userData = Customers::select("id", "name", "email", "mobile", "logintype", "profileimage", "socialmediaid", "gender", "devicetype", "devicetoken")
                    ->where("id", $memberid)
                    ->get();
                    // echo "<pre>";
                    // print_r($userData);
                    // echo "</pre>";
                    // exit;
                    if (!(empty($userData)))
                    {
                        $arr_data[] = array(
                            'id' => (string)$memberid,
                            'name' => $this->render($userData[0]['name']),
                            'email' => $userData[0]['email'],
                            'mobile' => $userData[0]['mobile'],
                            'logintype' => $userData[0]['logintype'],
                            'profileimage' => $this->render($userData[0]['profileimage']),
                            'socialmediaid' => $userData[0]['socialmediaid'],
                            'gender' => $userData[0]['gender'],
                            'devicetype' => $this->render($userData[0]['devicetype']),
                            'devicetoken' => $this->render($userData[0]['devicetoken']),
                            'newuse' => $newUse
                        );
                        $response['status'] = 'success';
                        $response['message'] = "You have successfully registered.";
                        $response['data'] = $arr_data;
                        return response()->json($response);
                    }
                    else
                    {
                        $response['status'] = 'error';
                        $response['message'] = "Invalid user.";
                        $response['data'] = $arr_data;
                        // echo json_encode($response);
                    }
                }
            }

        } catch (Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }

    public function customerChecklogin(Request $request){
        try{
            $validator = Validator::make($request->all(), [
                'socialmediaid' => 'required',
            ]);
            if ($validator->fails()) {
                $response['status'] = 'validation_error';
                $error = $validator->errors()->toArray();
                $errMsg = '';
                foreach($error as $err){
                    $errMsg .= " ".$err[0];
                }
                $response['message'] = $errMsg;
                return response()->json($response);
            }
            $arr_data = array();
            $userInfo = Customers::select("customers.id", "customers.name", "customers.username", "customers.email", "customers.mobile", "customers.logintype", "customers.profileimage", "customers.socialmediaid", "customers.ipaddress", "customers.gender", "customers.devicetype", "customers.devicetoken", "customers.country_id", "customers.state_id", "customers.city_id", 'countries.name as countryname', 'states.name as statename', 'cities.name as cityname')
            ->leftJoin("countries", "countries.id", "=", "customers.country_id")
            ->leftJoin("states", "states.id", "=", "customers.state_id")
            ->leftJoin("cities", "cities.id", "=", "customers.city_id")
            ->where("customers.socialmediaid", $request->input('socialmediaid'))
            ->get();
            if (!(empty($userInfo)))
            {
                $arr_data[] = array(
                    'id' => (string)$userInfo[0]['id'],
                    'name' => $userInfo[0]['name'],
                    'email' => $userInfo[0]['email'],
                    'mobile' => $userInfo[0]['mobile'],
                    'logintype' => $userInfo[0]['logintype'],
                    'profileimage' => $this->render($userInfo[0]['profileimage']),
                    'socialmediaid' => $userInfo[0]['socialmediaid'],
                    'gender' => $this->render($userInfo[0]['gender']),
                    'devicetype' => $this->render($userInfo[0]['devicetype']),
                    'devicetoken' => $this->render($userInfo[0]['devicetoken']),
                    'country_id' => (string)$userInfo[0]->country_id,
                    'countryname' => $userInfo[0]->countryname,
                    'state_id' => (string)$userInfo[0]->state_id,
                    'statename' => $userInfo[0]->statename,
                    'city_id' => $userInfo[0]->city_id,
                    'cityname' => $userInfo[0]->cityname,
                );
                $response['status'] = 'success';
                $response['message'] = "Record found successfully.";
                $response['data'] = $arr_data;
                // echo json_encode($response);
            }
            else
            {
                $response['status']='error';
                $response['message']="Record not found.";
                // echo json_encode($response);
            }

        } catch (Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }

    public function editProfile(Request $request){
        try{
            $object = Customers::find($request->input("customer_id"));
            $validator = Validator::make($request->all(), [
                'customer_id' => 'required',
                'name' => 'required',
                'email' => 'nullable|sometimes|email|unique:customers,email,'.$object->id,
                // 'photo' => 'required',
                // 'country_id' => 'required',
                // 'state_id' => 'required',
                // 'city_id' => 'required',
            ]);
            if ($validator->fails()) {
                $response['status'] = 'validation_error';
                $error = $validator->errors()->toArray();
                $errMsg = '';
                foreach($error as $err){
                    $errMsg .= " ".$err[0];
                }
                $response['message'] = $errMsg;
                return response()->json($response);
            }

            
            $object->name = $request->input("name");
            $object->email = $request->input("email");
            if($request->hasFile("photo"))
            {
                $photo = $request->file('photo');
                $destinationPath = 'uploads/customer_profileimage/';
                if($photo->move($destinationPath, $request->file('photo')->getClientOriginalName()))
                {
                    $object->profileimage = url('/uploads/customer_profileimage/'.$request->file('photo')->getClientOriginalName());
                }
                
            }
            $object->status = 1;
            $object->country_id = $request->input("country_id");
            $object->state_id = $request->input("state_id");
            $object->city_id = $request->input("city_id");
            $object->save();
            $id = $object->id;
            $user = Customers::select('customers.id','customers.name','email','profileimage', 'customers.country_id as countryid', 'customers.state_id as stateid', 'customers.city_id as cityid', 'countries.name as countryname', 'states.name as statename', 'cities.name as cityname')
            ->leftJoin("countries", "countries.id", "=", "customers.country_id")
            ->leftJoin("states", "states.id", "=", "customers.state_id")
            ->leftJoin("cities", "cities.id", "=", "customers.city_id")
            ->where("customers.id",$id)
            ->first();
            //
            // $user['profileimage'] = url('public/uploads/customer_profileimage/'.$user['profileimage']);
            $response['status'] = 'success';
            $response['message'] = 'Customer profile edited successfully';
            $response['user'] = $user;

        } catch (Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }


    public function editLocation(Request $request){
        try{
            $object = Customers::find($request->input("customer_id"));
            $validator = Validator::make($request->all(), [
                'customer_id' => 'required',
                'country_id' => 'required',
                'state_id' => 'required',
                'city_id' => 'required',
            ]);
            if ($validator->fails()) {
                $response['status'] = 'validation_error';
                $error = $validator->errors()->toArray();
                $errMsg = '';
                foreach($error as $err){
                    $errMsg .= " ".$err[0];
                }
                $response['message'] = $errMsg;
                return response()->json($response);
            }

            $object->country_id = $request->input("country_id");
            $object->state_id = $request->input("state_id");
            $object->city_id = $request->input("city_id");
            $object->save();
            $id = $object->id;
            $user = Customers::select('customers.id','customers.name','email','profileimage', 'customers.country_id as countryid', 'customers.state_id as stateid', 'customers.city_id as cityid', 'countries.name as countryname', 'states.name as statename', 'cities.name as cityname')
            ->leftJoin("countries", "countries.id", "=", "customers.country_id")
            ->leftJoin("states", "states.id", "=", "customers.state_id")
            ->leftJoin("cities", "cities.id", "=", "customers.city_id")
            ->where("customers.id",$id)
            ->first();
            //
            // $user['profileimage'] = url('public/uploads/customer_profileimage/'.$user['profileimage']);
            $response['status'] = 'success';
            $response['message'] = 'Customer profile edited successfully';
            $response['user'] = $user;

        } catch (Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }

    public function editMobile(Request $request){
        try{
            $object = Customers::find($request->input("customer_id"));
            $validator = Validator::make($request->all(), [
                'customer_id' => 'required',
                'mobile' => 'required|unique:customers,mobile,'.$object->id,
            ]);
            if ($validator->fails()) {
                $response['status'] = 'validation_error';
                $error = $validator->errors()->toArray();
                $errMsg = '';
                foreach($error as $err){
                    $errMsg .= " ".$err[0];
                }
                $response['message'] = $errMsg;
                return response()->json($response);
            }
            $object->mobile = $request->input("mobile");
            $object->status = 1;
            $object->save();
            $id = $object->id;
            $user = Customers::select('id','name','email','mobile')->where("id",$id)
                            ->first();
            $response['status'] = 'success';
            $response['message'] = 'Customer mobile edited successfully';
            $response['user'] = $user;

        } catch (Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }

    public function getNotificationSetting(Request $request){
        try{
            $object = Customers::find($request->input("customer_id"));
            $validator = Validator::make($request->all(), [
                'customer_id' => 'required',
            ]);
            if ($validator->fails()) {
                $response['status'] = 'validation_error';
                $error = $validator->errors()->toArray();
                $errMsg = '';
                foreach($error as $err){
                    $errMsg .= " ".$err[0];
                }
                $response['message'] = $errMsg;
                return response()->json($response);
            }
            $id = $object->id;
            $user = Customers::select('id','notification_10_min','notification_30_min','notification_1_hour','booking_notification','cancellation_notification','booking_remainder_notification','booking_remainder_notification_minute')->where("id",$id)->first();
            $data = array(
                "id" => (string)$user['id'],
                "notification_10_min" => $user['notification_10_min'],
                "notification_30_min" => $user['notification_30_min'],
                "notification_1_hour" => $user['notification_1_hour'],
                "booking_notification" => $user['booking_notification'],
                "cancellation_notification" => $user['cancellation_notification'],
                'booking_remainder_notification'=>$user['booking_remainder_notification'],
                'booking_remainder_notification_minute'=>(string)$user['booking_remainder_notification_minute'],

            );
            $response['status'] = 'success';
            $response['message'] = 'Customer notification settings get successfully';
            $response['user'] = $data;

        } catch (Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }

    public function editNotificationSetting(Request $request){
        try{
            $object = Customers::find($request->input("customer_id"));
            $validator = Validator::make($request->all(), [
                'customer_id' => 'required',
                'notification_10_min' => 'required',
                'notification_30_min' => 'required',
                'notification_1_hr' => 'required'
            ]);
            if ($validator->fails()) {
                $response['status'] = 'validation_error';
                $error = $validator->errors()->toArray();
                $errMsg = '';
                foreach($error as $err){
                    $errMsg .= " ".$err[0];
                }
                $response['message'] = $errMsg;
                return response()->json($response);
            }
            $object->notification_10_min = $request->input("notification_10_min");
            $object->notification_30_min = $request->input("notification_30_min");
            $object->notification_1_hour = $request->input("notification_1_hr");
            $object->save();
            $response['status'] = 'success';
            $response['message'] = 'Customer notification settings edited successfully';

        } catch (Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }

    public function getCustomerNotification(Request $request)
    {
        try{
            $validator = Validator::make($request->all(), [
                'customer_id' => 'required',
            ]);
            if ($validator->fails()) {
                $response['status'] = 'validation_error';
                $error = $validator->errors()->toArray();
                $errMsg = '';
                foreach($error as $err){
                    $errMsg .= " ".$err[0];
                }
                $response['message'] = $errMsg;
                return response()->json($response);
            }
            $data = array();
            $customer_id = $request->input("customer_id");
            $notification = Notification::select('id','fromid','toid','referenceid', 'notification_type', 'message', 'isread', 'created_at')
            ->where("notification.notification_for", "C")
            ->where("notification.toid", $customer_id)
            ->where("notification.is_deleted", 0)
            ->orderBy('notification.id','desc')
            ->get();
            // echo "<pre>";
            // print_r($notification);
            // echo "</pre>";
            // exit;
            if(!(empty($notification)))
            {
                foreach ($notification as $key => $value)
                {
                    $salon_name = "";
                    $barber_name = "";
                    $services = "";
                    $from_time = "";
                    $to_time = "";
                    $book_date = "";
                    $booking_status = "";

                    if($value->notification_type == "Booking")
                    {
                        $bookingRes = Bookings::select('bookings.from_time','bookings.to_time','bookings.book_date','bookings.status','barbers.name as barber_name','saloons.saloon_name','bookings.barber_id')
                        ->join('saloons','saloons.id','=','bookings.saloon_id','left')
                        ->join('barbers','barbers.id','=','bookings.barber_id','left')
                        ->where('bookings.id',$value->referenceid)
                        ->first();

                        if(!empty($bookingRes))
                        {
                            $barber_id = $bookingRes->barber_id;
                            $salon_name = $bookingRes->saloon_name;
                            $barber_name = $bookingRes->barber_name;
                            $from_time = date("H:i:s",strtotime($bookingRes->from_time));
                            $to_time = date("H:i:s",strtotime($bookingRes->to_time));
                            $book_date = date("Y-m-d",strtotime($bookingRes->book_date));
                            $booking_status = $bookingRes->status;
                            $bookingItemsRes = BookingItems::select('saloon_services.service_name')
                            ->join("saloon_services","saloon_services.id", "=", "booking_items.main_service_id")
                            ->where('booking_items.booking_id',$value->referenceid)
                            ->get();
                            if(!empty($bookingItemsRes))
                            {
                                $comma = "";
                                foreach($bookingItemsRes as $ikey =>$ivalue)
                                {
                                    $services .= $comma." ".$ivalue->service_name;
                                    $comma = ",";
                                }
                            }
                        }
                    }

                    // echo "<pre>";
                    // print_r($value);
                    // print_r($value->getAttribute("id"));
                    // echo "</pre>";
                    // exit;
                    $data[] = array(
                        "id" => $value->id,
                        "fromid" => $value->fromid,
                        "toid" => $value->toid,
                        "referenceid" => $value->referenceid,
                        "notificationtype" => $value->notification_type,
                        "notificationfor" => $value->notification_for,
                        "message" => $value->message,
                        "isread" => $value->isread,
                        "saloon_name"=>$salon_name,
                        "barber_name"=>$barber_name,
                        "services"=>trim($services),
                        "from_time"=>$from_time,
                        "to_time"=>$to_time,
                        "booking_date"=>$book_date,
                        "booking_status"=>$booking_status,
                        "created" => date("d-m-Y H:i:s", strtotime($value->created_at)),
                    );
                }
            }
            $response['status'] = 'success';
            $response['message'] = 'Customer notification get successfully';
            $response['notification'] = $data;

        } catch (\Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }

    public function readCustomerNotification(Request $request)
    {
        try{
            $validator = Validator::make($request->all(), [
                'customer_id' => 'required',
                'notification_id' => 'required',
            ]);
            if ($validator->fails()) {
                $response['status'] = 'validation_error';
                $error = $validator->errors()->toArray();
                $errMsg = '';
                foreach($error as $err){
                    $errMsg .= " ".$err[0];
                }
                $response['message'] = $errMsg;
                return response()->json($response);
            }
            $notification_id = $request->input("notification_id");
            $customer_id = $request->input("customer_id");
            $updateNotificationData = array(
                "isread" => "Y",
                "updated_at" => date("Y-m-d H:i:s")
            );
            $notificationInfo = Notification::where("toid", $customer_id)->where("notification_for", "C")->where("id", $notification_id)->update($updateNotificationData);
            // echo "<pre>";
            // print_r($notificationInfo);
            // echo "</pre>";
            $response['status'] = 'success';
            $response['message'] = 'Customer notification read successfully';

        } catch (Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }

    public function deleteCustomerNotification(Request $request)
    {
        try{
            $validator = Validator::make($request->all(), [
                'customer_id' => 'required',
                'notification_id' => 'required',
            ]);
            if ($validator->fails()) {
                $response['status'] = 'validation_error';
                $error = $validator->errors()->toArray();
                $errMsg = '';
                foreach($error as $err){
                    $errMsg .= " ".$err[0];
                }
                $response['message'] = $errMsg;
                return response()->json($response);
            }
            $notification_id = $request->input("notification_id");
            $customer_id = $request->input("customer_id");
            $updateNotificationData = array(
                "is_deleted" => 1,
                "updated_at" => date("Y-m-d H:i:s")
            );
            $notificationInfo = Notification::where("toid", $customer_id)->where("notification_for", "C")->where("id", $notification_id)->update($updateNotificationData);
            // echo "<pre>";
            // print_r($notificationInfo);
            // echo "</pre>";
            $response['status'] = 'success';
            $response['message'] = 'Customer notification deleted successfully';

        } catch (Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }

    public function getSettings(Request $request)
    {
        try{
            $data = array();
            $settings_razorpay_keyid = \DB::table("settings")
            ->select("setting_value")
            ->where("setting_title","=","Razorpay Keyid")
            ->get();
            $data['razorpay_key'] = $settings_razorpay_keyid[0]->setting_value;
            //
            $settings_razorpay_secret = \DB::table("settings")
            ->select("setting_value")
            ->where("setting_title","=","Razorpay Secret")
            ->get();
            $data['razorpay_secret'] = $settings_razorpay_secret[0]->setting_value;
            $settings_commission = \DB::table("settings")
            ->select("setting_value")
            ->where("setting_title","=","Commission")
            ->get();
            $data['commission'] = $settings_commission[0]->setting_value;
            
            $response['status'] = 'success';
            $response['message'] = 'Settings get successfully';
            $response['setttings'] = $data;

        } catch (Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }

    public function updatePaymentStatus(Request $request){
        try{
            $validator = Validator::make($request->all(), [
                'appointment_id' => 'required',
                'transaction_id' => 'required',
                'customer_id' => 'required',
            ]);
            if ($validator->fails()) {
                $response['status'] = 'validation_error';
                $error = $validator->errors()->toArray();
                $errMsg = '';
                foreach($error as $err){
                    $errMsg .= " ".$err[0];
                }
                $response['message'] = $errMsg;
                return response()->json($response);
            }
            $object = Bookings::find($request->input("appointment_id"));
            $object->payment_status = "C";
            $object->payment_mode = "Credit Card";
            $object->transaction_id = $request->input("transaction_id");
            $object->updated_at = date("Y-m-d H:i:s");
            $object->save();
            // For Sending notification
            $booking_services = BookingItems::with('Service')->with('SaloonService')->where("booking_id",$object->id)->get();
            $servicesname = array();
            foreach($booking_services as $serv)
            {
                $servicesname[] = ((!empty($serv->SaloonService->service_name))?$serv->SaloonService->service_name:'');
            }
            //
            $barber = Barbers::where("id", $object->barber_id)->first();
            $customer = Customers::where("id",$request->input("customer_id"))->first();
            $saloon = Saloons::where("id",$object->saloon_id)->first();
            $bookingRes = Bookings::where('id',$request->input("appointment_id"))->first();

            $saloon_name = $saloon->saloon_name;
            $arr_email = array();
            $arr_sms = array();
            $arr_push = array();
            
            if(!(empty($customer)))
            {
                // Get read unread notifiction count
                $notificationReadInfo = Notification::select('id','fromid','toid','referenceid', 'notification_type', 'message', 'isread', 'created_at')
                ->where("notification.toid", $customer['id'])
                ->where("notification.notification_for", "C")
                ->where("notification.isread", "N")
                ->where("notification.is_deleted", 0)
                ->get();
                $readCount = $notificationReadInfo->count();
                $notificationUnreadInfo = Notification::select('id','fromid','toid','referenceid', 'notification_type', 'message', 'isread', 'created_at')
                ->where("notification.toid", $customer['id'])
                ->where("notification.notification_for", "C")
                ->where("notification.isread", "N")
                ->where("notification.is_deleted", 0)
                ->get();
                $unreadCount = $notificationUnreadInfo->count();
                //
                $book_id = $object->id;
                $date = date("d-m-Y",strtotime($object->book_date));
                $startTime = date("h:i A",strtotime($object->from_time));
                $endTime = $object->to_time;
                $serviceName = implode(",", $servicesname);
                if($object->book_date == date('Y-m-d'))
                {
                    $date = "Today";
                }
                else if($object->book_date == date('Y-m-d',strtotime('+1 day')))
                {
                    $date = "Tomorrow";
                }
                else
                {
                    $date = "on ".date('jS M, l',strtotime($object->book_date));
                    if($bookingRes->booked_by == "B")
                    {
                        $date = "on ".date("jS M",strtotime($object->book_date));
                    }
                }
                $message = "Booking successful for ".$serviceName." at ".$saloon_name." ".$date." at ".$startTime;
                if($bookingRes->booked_by == "B")
                {
                    $message = "Your booking for ".$serviceName." at ".date("h:i A",strtotime($object->from_time))." ".$date." at ".$saloon_name."  is Booked Successfully By Barber.";
                }
                
                // echo $message; exit;
                $arr_push = array();
                $android_recepient = array();
                $android_recepient[] = $customer['devicetoken'];         
                $additionalData = array(
                    'notificationType' => 'booking',
                    'customerid' => $customer['id'],
                    'read' => $readCount,
                    'unread' => $unreadCount,
                );
                $arr_push = array(
                    "devicetype" => $customer['devicetype'], 
                    "registatoin_ids" => $android_recepient,
                    "message" => $message,
                    "additionalData" => $additionalData
                );
                // echo "<br/>Push<pre>";
                // print_r($arr_push);
                // echo "</pre>";
                // exit;
                if($customer['booking_notification'] == "Y")
                {
                    $notification = new Notification();
                    $notification->sendAllNotification($arr_email, $arr_sms, $arr_push);
                }
                
                //
                $notificationsave = new Notification();
                $notificationsave->fromid = $saloon['id'];
                $notificationsave->toid = $customer['id'];
                $notificationsave->referenceid = $book_id;
                $notificationsave->notification_type = "Booking";
                $notificationsave->message = $message;
                $notificationsave->isread = "N";
                $notificationsave->created_at = date("Y-m-d H:i:s");
                $notificationsave->notification_for = "C";
                $notificationsave->save();
                $notificationId = $notificationsave->id;
                // echo "<br/>Id = ".$notificationId;
            }
            // if($object->customer_id == 0){
                if($bookingRes->booked_by == "B")
                {
                    $date = date("d-m-Y",strtotime($object->book_date));
                    $startTime = date("h:i A",strtotime($object->from_time));
                    $endTime = $object->to_time;
                    $serviceName = implode(",", $servicesname);
                    if($object->book_date == date('Y-m-d'))
                    {
                        $date = "Today";
                    }
                    else if($object->book_date == date('Y-m-d',strtotime('+1 day')))
                    {
                        $date = "Tomorrow";
                    }
                    else
                    {
                        $date = "on ".date('jS F, Y',strtotime($object->book_date));
                        
                    }
                    $serviceName = implode(",", $servicesname);
                    $mobile = $object->customer_mobile;
                    $msg_text = "Your booking for ".$serviceName." in ".$saloon_name." by ".$barber->name." at ".date("h:i A",strtotime($object->from_time))." to ".date("h:i A",strtotime($object->to_time))." ".$date." is booked successfully via Blacour - Salon Booking App";
                    CommonService::send_msg($mobile,$msg_text);
                }
            // }

            if(!(empty($barber)))
            {
                // Barber Notification
                $book_id = $object->id;
                $date = date("d-m-Y",strtotime($object->book_date));
                $startTime = date("h:i A",strtotime($object->from_time));
                $endTime = $object->to_time;
                $serviceName = implode(",", $servicesname);
                if($object->book_date == date('Y-m-d'))
                {
                    $date = "Today";
                }
                else if($object->book_date == date('Y-m-d',strtotime('+1 day')))
                {
                    $date = "Tomorrow";
                }
                else
                {
                    $date = "on ".date('jS M l',strtotime($object->book_date));
                }
                $barberMessage = "You recieved a booking for ".$serviceName." at ".$startTime." ".$date;
                $arr_email = array();
                $arr_sms = array();
                $arr_push = array();
                // Get barber read unread notifiction count
                $notificationReadInfo = Notification::select('id','fromid','toid','referenceid', 'notification_type', 'message', 'isread', 'created_at')
                ->where("notification.toid", $barber['id'])
                ->where("notification.notification_for", "B")
                ->where("notification.isread", "N")
                ->where("notification.is_deleted", 0)
                ->get();
                $readCount = $notificationReadInfo->count();
                $notificationUnreadInfo = Notification::select('id','fromid','toid','referenceid', 'notification_type', 'message', 'isread', 'created_at')
                ->where("notification.toid", $barber['id'])
                ->where("notification.notification_for", "B")
                ->where("notification.isread", "N")
                ->where("notification.is_deleted", 0)
                ->get();
                $unreadCount = $notificationUnreadInfo->count();
                //
                $arr_push = array();
                $android_recepient = array();
                $android_recepient[] = $barber['devicetoken'];         
                $additionalData = array(
                    'notificationType' => 'booking',
                    'barberid' => $barber['id'],
                    'read' => $readCount,
                    'unread' => $unreadCount,
                );
                $arr_push = array(
                    "devicetype" => $barber['devicetype'], 
                    "registatoin_ids" => $android_recepient,
                    "message" => $barberMessage,
                    "additionalData" => $additionalData
                );
                // echo "<br/>Push<pre>";
                 //print_r($arr_push);
                // echo "</pre>";
                // exit;
                $notification = new Notification();
                $notification->sendAllBarberNotification($arr_email, $arr_sms, $arr_push);
                //
                $barbernotificationsave = new Notification();
                $barbernotificationsave->fromid = $saloon['id'];
                $barbernotificationsave->toid = $barber['id'];
                $barbernotificationsave->referenceid = $book_id;
                $barbernotificationsave->notification_type = "Booking";
                $barbernotificationsave->message = $barberMessage;
                $barbernotificationsave->isread = "N";
                $barbernotificationsave->created_at = date("Y-m-d H:i:s");
                $barbernotificationsave->notification_for = "B";
                $barbernotificationsave->save();
                
                //
            }
            
            $response['status'] = 'success';
            $response['message'] = 'Booking Successful';

        } catch (\Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }

    public function favSaloon(Request $request){
        try{
            $validator = Validator::make($request->all(), [
                'customer_id' => 'required',
                'saloon_id' => 'required',
            ]);
            if ($validator->fails()) {
                $response['status'] = 'validation_error';
                $error = $validator->errors()->toArray();
                $errMsg = '';
                foreach($error as $err){
                    $errMsg .= " ".$err[0];
                }
                $response['message'] = $errMsg;
                return response()->json($response);
            }
            $favObj = \DB::table("saloon_favourite")->select("id")
            ->where("customer_id", $request->input('customer_id'))
            ->where("saloon_id", $request->input('saloon_id'))
            ->get();
            $message_fav = "";
            if(count($favObj) > 0)
            {
                // Unfav
                \DB::table("saloon_favourite")->select("id")
                ->where("customer_id", $request->input('customer_id'))
                ->where("saloon_id", $request->input('saloon_id'))
                ->delete();
                $message_fav = "Removed from favourite list successfully.";
            }
            else
            {
                // Fav
                $array_fav = array(
                    "customer_id" => $request->input("customer_id"),
                    "saloon_id" => $request->input("saloon_id"),
                    "created_at" => date("Y-m-d H:i:s"),
                    "updated_at" => date("Y-m-d H:i:s")
                );
                \DB::table('saloon_favourite')->insert($array_fav);
                $message_fav = "Added to favourite list successfully.";
            }
            //
            // $user['profileimage'] = url('public/uploads/customer_profileimage/'.$user['profileimage']);
            $response['status'] = 'success';
            $response['message'] = $message_fav;

        } catch (Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }

    public function createBooking(Request $request)
    {
        // This is used in case of emeregency cancellation
        try{
            $validator = Validator::make($request->all(), [
                'booking_id' => 'required',
                'salon_id' => 'required',
                'barber_id' => 'required',
                'book_date' => 'required',
                'services' => 'required',
                'booked_time' => 'required',
                'amount' => 'required',
                'customer_id' => 'required',
            ]);
            if ($validator->fails())
            {
                $response['status'] = 'validation_error';
                $error = $validator->errors()->toArray();
                $errMsg = '';
                foreach($error as $err){
                    $errMsg .= " ".$err[0];
                }
                $response['message'] = $errMsg;
                return response()->json($response);
            }
            $booking_id = $request->input("booking_id");
            $saloon_id = $request->input("salon_id");
            $barber_id = $request->input("barber_id");
            $date = $request->input("book_date");
            $service_ids = $request->input("services");
            $booked_time = $request->input("booked_time");
            $customer_id = $request->input("customer_id");
            //
            $checkBooking = Bookings::where("book_date",$date)
            ->where("payment_status","=",'C')
            ->where("status","!=",'cancelled') 
            ->where("from_time",">=",$booked_time['start_time'])
            ->where("to_time","<=",$booked_time['end_time'])
            ->where("barber_id",$barber_id)
            ->where("id", "!=", $booking_id)
            ->count();
            // echo "<pre>";
            // print_r($checkBooking);
            // echo "</pre>";
            // exit;
            if($checkBooking > 0)
            {
                $response['status'] = 'error';
                $response['message'] = 'Time Slot already booked';
                return response()->json($response);
            }
            $customer = Customers::where("id",$customer_id)->first();
            $total_price = SaloonServices::whereIn("id",$service_ids)->sum("price");
            $services = SaloonServices::whereIn("id",$service_ids)->get();

            $object = Bookings::find($booking_id);
            $object->barber_id = $barber_id;
            $object->book_date = $date;
            $object->from_time = $booked_time['start_time'];
            $object->to_time = $booked_time['end_time'];
            $object->status = "active";
            $object->updated_at = date("Y-m-d H:i:s");
            $object->save();
            /*foreach($services as $service){
                $newobj = new BookingItems();
                $newobj->booking_id = $book_id;
                $newobj->service_id = $service->service_id;
                $newobj->main_service_id = $service->id;
                $newobj->price = $service->price;
                $newobj->save();
            }*/
            // For Sending notification
            $booking_services = BookingItems::with('Service')->with('SaloonService')->where("booking_id",$booking_id)->get();
            $servicesname = array();
            foreach($booking_services as $serv)
            {
                $servicesname[] = ((!empty($serv->SaloonService->service_name))?$serv->SaloonService->service_name:'');
            }
            //
            $barber = Barbers::where("id", $object->barber_id)->first();
            $customer = Customers::where("id",$request->input("customer_id"))->first();
            $saloon = Saloons::where("id",$object->saloon_id)->first();
            $arr_email = array();
            $arr_sms = array();
            $arr_push = array();
            if(!(empty($customer)))
            {
                // Get read unread notifiction count
                $notificationReadInfo = Notification::select('id','fromid','toid','referenceid', 'notification_type', 'message', 'isread', 'created_at')
                ->where("notification.toid", $customer['id'])
                ->where("notification.notification_for", "C")
                ->where("notification.isread", "N")
                ->where("notification.is_deleted", 0)
                ->get();
                $readCount = $notificationReadInfo->count();
                $notificationUnreadInfo = Notification::select('id','fromid','toid','referenceid', 'notification_type', 'message', 'isread', 'created_at')
                ->where("notification.toid", $customer['id'])
                ->where("notification.notification_for", "C")
                ->where("notification.isread", "N")
                ->where("notification.is_deleted", 0)
                ->get();
                $unreadCount = $notificationUnreadInfo->count();
                //
                $book_id = $object->id;
                $date = $object->book_date;
                $startTime = date('h:i A',strtotime($object->from_time));
                $endTime = $object->to_time;
                $serviceName = implode(",", $servicesname);
                if($object->book_date == date('Y-m-d'))
                {
                    $date = "Today";
                }
                else if($object->book_date == date('Y-m-d',strtotime('+1 day')))
                {
                    $date = 'Tomorrow';
                }
                else{
                    $date = "on ".date('jS M l',strtotime($object->book_date));
                }
                $booking_status = $object->status;
                $message = "Your booking for ".$serviceName." at ".$saloon['saloon_name']." is rescheduled to ".date('h:i A',strtotime($startTime))." ".$date;
                // echo $message; exit;
                $arr_push = array();
                $android_recepient = array();
                $android_recepient[] = $customer['devicetoken'];         
                $additionalData = array(
                    'notificationType' => 'booking',
                    'customerid' => $customer['id'],
                    'read' => $readCount,
                    'unread' => $unreadCount,
                );
                $arr_push = array(
                    "devicetype" => $customer['devicetype'], 
                    "registatoin_ids" => $android_recepient,
                    "message" => $message,
                    "additionalData" => $additionalData
                );
                // echo "<br/>Push<pre>";
                // print_r($arr_push);
                // echo "</pre>";
                // exit;
                $notification = new Notification();
                $notification->sendAllNotification($arr_email, $arr_sms, $arr_push);
                //
                $notificationsave = new Notification();
                $notificationsave->fromid = $saloon['id'];
                $notificationsave->toid = $customer['id'];
                $notificationsave->referenceid = $book_id;
                $notificationsave->notification_type = "Booking";
                $notificationsave->message = $message;
                $notificationsave->isread = "N";
                $notificationsave->created_at = date("Y-m-d H:i:s");
                $notificationsave->notification_for = "C";
                $notificationsave->booking_status = $booking_status;
                $notificationsave->save();
                $notificationId = $notificationsave->id;
                // echo "<br/>Id = ".$notificationId;
            }
            // if($request->customer_id == 0){
                if($object->booked_by == "B")
                {
                    $date = date("d-m-Y",strtotime($object->book_date));
                    $startTime = date("h:i A",strtotime($object->from_time));
                    $endTime = $object->to_time;
                    $serviceName = implode(",", $servicesname);
                    if($object->book_date == date('Y-m-d'))
                    {
                        $date = "Today";
                    }
                    else if($object->book_date == date('Y-m-d',strtotime('+1 day')))
                    {
                        $date = "Tomorrow";
                    }
                    else
                    {
                        $date = "on ".date('jS F, Y',strtotime($object->book_date));
                        
                    }
                    $mobile = $object->customer_mobile;
                    $msg_text = "Your booking with Blacour - Salon Booking App for ".$serviceName." in ".$saloon['saloon_name']." by ".$barber->name." is rescheduled by barber. Here are the details for the new booking - ".date("h:i A",strtotime($object->from_time))." to ".date("h:i A",strtotime($object->to_time))." ".$date;
                    CommonService::send_msg($mobile,$msg_text);
                }
                
            // }

            // Barber Notification
            $arr_email = array();
            $arr_sms = array();
            $arr_push = array();
            if(!(empty($barber)))
            {
                // Get barber read unread notifiction count
                $notificationReadInfo = Notification::select('id','fromid','toid','referenceid', 'notification_type', 'message', 'isread', 'created_at')
                ->where("notification.toid", $barber['id'])
                ->where("notification.notification_for", "B")
                ->where("notification.isread", "N")
                ->where("notification.is_deleted", 0)
                ->get();
                $readCount = $notificationReadInfo->count();
                $notificationUnreadInfo = Notification::select('id','fromid','toid','referenceid', 'notification_type', 'message', 'isread', 'created_at')
                ->where("notification.toid", $barber['id'])
                ->where("notification.notification_for", "B")
                ->where("notification.isread", "N")
                ->where("notification.is_deleted", 0)
                ->get();
                $unreadCount = $notificationUnreadInfo->count();
                //
                $book_id = $object->id;
                $date = $object->book_date;
                $startTime = date('h:i A',strtotime($object->from_time));
                $endTime = $object->to_time;
                $serviceName = implode(",", $servicesname);
                if($object->book_date == date('Y-m-d'))
                {
                    $date = "Today";
                }
                else if($object->book_date == date('Y-m-d',strtotime('+1 day')))
                {
                    $date = 'Tomorrow';
                }
                else{
                    $date = "on ".date('jS M l',strtotime($object->book_date));
                }
                $message = "You received a booking for ".$serviceName." at ".$startTime." ".$date;
                $arr_push = array();
                $android_recepient = array();
                $android_recepient[] = $barber['devicetoken'];         
                $additionalData = array(
                    'notificationType' => 'booking',
                    'barberid' => $barber['id'],
                    'read' => $readCount,
                    'unread' => $unreadCount,
                );
                $arr_push = array(
                    "devicetype" => $barber['devicetype'], 
                    "registatoin_ids" => $android_recepient,
                    "message" => $message,
                    "additionalData" => $additionalData
                );
                // echo "<br/>Push<pre>";
                // print_r($arr_push);
                // echo "</pre>";
                // exit;
                $notification = new Notification();
                $notification->sendAllBarberNotification($arr_email, $arr_sms, $arr_push);
                //
                $barbernotificationsave = new Notification();
                $barbernotificationsave->fromid = $saloon['id'];
                $barbernotificationsave->toid = $barber['id'];
                $barbernotificationsave->referenceid = $book_id;
                $barbernotificationsave->notification_type = "Booking";
                $barbernotificationsave->message = $message;
                $barbernotificationsave->isread = "N";
                $barbernotificationsave->created_at = date("Y-m-d H:i:s");
                $barbernotificationsave->notification_for = "B";
                $barbernotificationsave->save();
                //
            }
            $booking = Bookings::select("id","book_number","book_date","from_time","to_time","total","billing_name","billing_email","billing_mobile")
                            ->where("id",$book_id)
                            ->first();
            // echo "<pre>";
            // print_r($booking);
            // echo "</pre>";
            // exit;
            $booking_services = BookingItems::with('Service')->where("booking_id",$book_id)->get();
            $services = array();
            $servicesname = array();
            foreach($booking_services as $serv){
                $temp['service_name'] = (!empty($serv->Service->name))?$serv->Service->name:'';
                $temp['service_price'] = $serv->price;
                $services[] = $temp;
                //
                $servicesname[] = ((!empty($serv->Service->name))?$serv->Service->name:'');
            }
            //
            $response['status'] = "success";
            $response['booking'] = $booking;
            $response['services'] = $services;
        } catch (Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }

    public function requestRefund(Request $request)
    {
        try{
            $validator = Validator::make($request->all(), [
                'booking_id' => 'required',
            ]);
            if ($validator->fails())
            {
                $response['status'] = 'validation_error';
                $error = $validator->errors()->toArray();
                $errMsg = '';
                foreach($error as $err){
                    $errMsg .= " ".$err[0];
                }
                $response['message'] = $errMsg;
                return response()->json($response);
            }
            $booking_id = $request->input("booking_id");

            $bookingRes = Bookings::where('id',$request->booking_id)->first();
            
            $settings_razorpay_keyid = \DB::table("settings")
            ->select("setting_value")
            ->where("setting_title","=","Razorpay Keyid")
            ->get();
            $setting_razorpaykeyid = $settings_razorpay_keyid[0]->setting_value;
            //
            $settings_razorpay_secret = \DB::table("settings")
            ->select("setting_value")
            ->where("setting_title","=","Razorpay Secret")
            ->get();
            $setting_razorpaysecret = $settings_razorpay_secret[0]->setting_value;
            $object = Bookings::find($booking_id);
            if(!empty($bookingRes->transaction_id))
            {
                $api = new Api($setting_razorpaykeyid, $setting_razorpaysecret);
                $rzpRes = $api->payment->fetch($bookingRes->transaction_id)->refund(array('reverse_all'=>'1'));
                if(isset($rzpRes->id))
                {
                    $object->rzp_refund_id = $rzpRes->id;
                }
                
            }
            
            $object->is_refund_request = "Y";
            
            $object->status = "requested refund";
            $object->refund_request_date = date("Y-m-d H:i:s");
            $object->updated_at = date("Y-m-d H:i:s");
            $object->save();
            $response['status'] = "success";
        } catch (Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }

    public function customerPinLogin(Request $request)
    {
        // This api used for customer login with generated 4 digit pin number
        // customerPinLogin : mobile, login_pin, devicetype, devicetoken
        try{
            $validator = Validator::make($request->all(), [
                'mobile' => 'required',
                'login_pin' => 'required'
            ]);
            if ($validator->fails())
            {
                $response['status'] = 'validation_error';
                $error = $validator->errors()->toArray();
                $errMsg = '';
                foreach($error as $err){
                    $errMsg .= " ".$err[0];
                }
                $response['message'] = $errMsg;
                return response()->json($response);
            }
            $mobile = $request->input("mobile");
            $login_pin = $request->input("login_pin");
            //
            // $login_pin = Hash::make($login_pin);
            // $customer = Customers::where("mobile",$mobile)->where("login_pin", $login_pin)->first();
            $customer = Customers::select('customers.id', 'customers.name', 'customers.email', 'customers.mobile', 'customers.profileimage', 'customers.login_pin', "customers.country_id", "customers.state_id", "customers.city_id", 'countries.name as countryname', 'states.name as statename', 'cities.name as cityname')
            ->leftJoin("countries", "countries.id", "=", "customers.country_id")
            ->leftJoin("states", "states.id", "=", "customers.state_id")
            ->leftJoin("cities", "cities.id", "=", "customers.city_id")
            ->where("mobile",$mobile)
            ->first();
            // echo Hash::check($login_pin, $customer->login_pin);
            // echo $customer->name;
            // echo "<pre>";
            // print_r($customer);
            // echo "</pre>";
            // exit;
            $user = array();
            if(empty($customer))
            {
                $response['status'] = 'error';
                $response['login'] = false;
                $response['message'] = 'Invalid login credentials';
                return response()->json($response);
            }
            else if(!(Hash::check($login_pin, $customer['login_pin'])))
            {
                $response['status'] = 'error';
                $response['login'] = false;
                $response['message'] = 'Invalid login credentials';
                return response()->json($response);
            }
            else
            {
                // Get read unread notifiction count
                $notificationReadInfo = Notification::select('id','fromid','toid','referenceid', 'notification_type', 'message', 'isread', 'created_at')
                ->where("notification.toid", $customer['id'])
                ->where("notification.isread", "N")
                ->where("notification.is_deleted", 0)
                ->get();
                $readCount = $notificationReadInfo->count();
                $notificationUnreadInfo = Notification::select('id','fromid','toid','referenceid', 'notification_type', 'message', 'isread', 'created_at')
                ->where("notification.toid", $customer['id'])
                ->where("notification.isread", "N")
                ->where("notification.is_deleted", 0)
                ->get();
                $unreadCount = $notificationUnreadInfo->count();
                //
                $data = Customers::find($customer['id']);
                $data->devicetype = $request->input("devicetype");
                $data->devicetoken = $request->input("devicetoken");
                $data->save();
                //
                $user = array(
                    "id" => (string)$customer['id'],
                    "name" => $customer['name'],
                    "email" => $customer['email'],
                    "mobile" => $customer['mobile'],
                    "profileimage" => $this->render($customer['profileimage']),
                    "devicetype" => $this->render($customer['devicetype']),
                    "devicetoken" => $this->render($customer['devicetoken']),
                    "unread" => (string)$unreadCount,
                    "countryid" => (string)$customer['country_id'],
                    "stateid" => (string)$customer['state_id'],
                    "cityid" => (string)$customer['city_id'],
                    "countryname" => $customer['countryname'],
                    "statename" => $customer['statename'],
                    "cityname" => $customer['cityname']
                );
                $response['status'] = "success";
                $response['login'] = true;
                $response['message'] = "Login success";
                $response['user'] = $user;
            }
            //
        } catch (Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }

    public function addCustomerLoginPin(Request $request)
    {
        // This api used to generate 4 digit customer login pin
        // addCustomerLoginPin : customer_id, login_pin
        try{
            $validator = Validator::make($request->all(), [
                'customer_id' => 'required',
                'login_pin' => 'required'
            ]);
            if ($validator->fails())
            {
                $response['status'] = 'validation_error';
                $error = $validator->errors()->toArray();
                $errMsg = '';
                foreach($error as $err){
                    $errMsg .= " ".$err[0];
                }
                $response['message'] = $errMsg;
                return response()->json($response);
            }
            $customer_id = $request->input("customer_id");
            $login_pin = $request->input("login_pin");
            //
            $customer = Customers::find($customer_id);
            // echo "<pre>";
            // print_r($customer);
            // echo "</pre>";
            // exit;
            $user = array();
            if(empty($customer))
            {
                $response['status'] = 'error';
                $response['message'] = 'Customer not found';
                return response()->json($response);
            }
            else
            {
                $login_pin = Hash::make($login_pin);
                $customer->login_pin = $login_pin;
                $customer->updated_at = date("Y-m-d H:i:s");
                $customer->save();
                //
                $user = Customers::select('customers.id', 'customers.name', 'customers.email', 'customers.mobile', 'customers.profileimage', "customers.country_id as countryid", "customers.state_id as stateid", "customers.city_id as cityid", 'countries.name as countryname', 'states.name as statename', 'cities.name as cityname')
                ->leftJoin("countries", "countries.id", "=", "customers.country_id")
                ->leftJoin("states", "states.id", "=", "customers.state_id")
                ->leftJoin("cities", "cities.id", "=", "customers.city_id")
                ->where("customers.id",$customer->id)
                ->first();
                $response['status'] = "success";
                $response['message'] = "Pin generated successfully";
                $response['user'] = $user;
            }
            //
        } catch (Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }

    public function forgotCustomerLoginPin(Request $request)
    {
        // forgotCustomerLoginPin : mobile
        try{
            $validator = Validator::make($request->all(), [
                'mobile' => 'required',
            ]);
            if ($validator->fails())
            {
                $response['status'] = 'validation_error';
                $error = $validator->errors()->toArray();
                $errMsg = '';
                foreach($error as $err){
                    $errMsg .= " ".$err[0];
                }
                $response['message'] = $errMsg;
                return response()->json($response);
            }
            $mobile = $request->input("mobile");
            //
            $customer = Customers::where("mobile", $mobile)->first();
            // echo "<pre>";
            // print_r($customer);
            // echo "</pre>";
            // exit;
            $user = array();
            if(empty($customer))
            {
                $response['status'] = 'error';
                $response['message'] = 'Customer not found';
                return response()->json($response);
            }
            else
            {
                $user = array(
                    "id" => $customer['id']
                );
                $response['status'] = "success";
                $response['message'] = "Customer found";
                $response['user'] = $user;
            }
            //
        } catch (Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }

    public function updateBookingAction(Request $request)
    {
        // updateBookingAction : booking_id, customer_id, action_type
        try{
            $validator = Validator::make($request->all(), [
                'booking_id' => 'required',
                'action_type' => 'required'
            ]);
            if ($validator->fails())
            {
                $response['status'] = 'validation_error';
                $error = $validator->errors()->toArray();
                $errMsg = '';
                foreach($error as $err){
                    $errMsg .= " ".$err[0];
                }
                $response['message'] = $errMsg;
                return response()->json($response);
            }
            $booking_id = $request->input("booking_id");
            $action_type = $request->input("action_type");
            //
            $booking = Bookings::find($booking_id);
            if(empty($booking))
            {
                $response['status'] = 'error';
                $response['message'] = 'Booking not found';
                return response()->json($response);
            }
            else
            {
                $booking->action_type = $action_type;
                $booking->updated_at = date("Y-m-d H:i:s");
                $booking->save();
                //
                $response['status'] = "success";
                if($action_type == "R")
                {
                    $response['message'] = "Refund Request Successful";
                }
                else{
                    $response['message'] = "Booking action saved successfully";
                }
                
            }
            //
        } catch (Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }

    public function isCustomerExist(Request $request){
        try{
            $validator = Validator::make($request->all(), [
                'mobile' => 'required|unique:customers'
            ]);
            if ($validator->fails()) 
            {
                $response['status'] = 'success';
                $response['is_customer_exist'] = 'Y';
                $user = Customers::select('id', 'name', 'email', 'mobile', 'profileimage')->where("mobile",$request->input("mobile"))
                            ->first();
                $response['user'] = $user;
                return response()->json($response);
            }
            $response['status'] = 'success';
            $response['is_customer_exist'] = 'N';
            $response['user'] = (object)array();

        } catch (Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }

    public function cancelCustomerBookingById(Request $request)
    {
        try{
            $validator = Validator::make($request->all(), [
                'booking_id' => 'required'
            ]);
            if ($validator->fails())
            {
                $response['status'] = 'validation_error';
                $error = $validator->errors()->toArray();
                $errMsg = '';
                foreach($error as $err){
                    $errMsg .= " ".$err[0];
                }
                $response['message'] = $errMsg;
                return response()->json($response);
            }
            $booking_id = $request->input("booking_id");
            //
            $booking = Bookings::find($booking_id);
            // echo "<pre>";
            // print_r($booking);
            // echo "</pre>";
            // exit;
            $user = array();
            if(empty($booking))
            {
                $response['status'] = 'error';
                $response['message'] = 'Booking not found';
                return response()->json($response);
            }
            else
            {
                $booking->status = "cancelled";
                $booking->updated_at = date("Y-m-d H:i:s");
                $booking->cancelled_at = date("Y-m-d H:i:s");
                $booking->save();
                //
                $response['status'] = 'success';
                $response['message'] = 'Booking status updated successfully';
                //
            }
            //
        } catch (Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }

    public function checkCustomerAppVersion(Request $request)
    {
        // checkCustomerAppVersion : version
        try{
            $validator = Validator::make($request->all(), [
                'version' => 'required',
            ]);
            if ($validator->fails())
            {
                $response['status'] = 'validation_error';
                $error = $validator->errors()->toArray();
                $errMsg = '';
                foreach($error as $err){
                    $errMsg .= " ".$err[0];
                }
                $response['message'] = $errMsg;
                return response()->json($response);
            }
            $version = $request->input("version");
            $appcurrentversion = new Settings();
            $currentversion = $appcurrentversion->getSetting("Customer App Version");
            if($version == $currentversion)
            {
                $response['status'] = 'success';
                $response['message'] = "Using version up to date";
            }
            else
            {
                $response['status'] = 'error';
                $response['message'] = "There is newer version of this application available, click Ok to upgrade now.";
            }
        } catch (Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }


    public function checkAppVersionCustomer(Request $request)
    {       
        // checkAppVersion : version
        try{
            $validator = Validator::make($request->all(), [
                'version' => 'required',
            ]);
            if ($validator->fails())
            {
                $response['status'] = 'validation_error';
                $response['error_type'] = 'version';
                $error = $validator->errors()->toArray();
                $errMsg = '';
                foreach($error as $err){
                    $errMsg .= " ".$err[0];
                }
                $response['message'] = $errMsg;
                return response()->json($response);
            }
            $version = $request->input("version");
            $appcurrentversion = new Settings();
            $currentversion = $appcurrentversion->getSetting("Customer App Version");
            if($version >= $currentversion)
            {
                $validator = Validator::make($request->all(), [
                    'mobile' => 'required',
                    'customer_id' => 'required'
                ]);
                if ($validator->fails())
                {
                    $response['status'] = 'validation_error';
                    $response['error_type'] = 'pin';
                    $error = $validator->errors()->toArray();
                    $errMsg = '';
                    foreach($error as $err){
                        $errMsg .= " ".$err[0];
                    }
                    $response['message'] = $errMsg;
                    return response()->json($response);
                }
                $mobile = $request->input("mobile");
                // $login_pin = $request->input("login_pin");
                //
                // $login_pin = Hash::make($login_pin);
                // $customer = Customers::where("mobile",$mobile)->where("login_pin", $login_pin)->first();
                $customer = Customers::select('customers.id', 'customers.name', 'customers.email', 'customers.mobile', 'customers.profileimage', 'customers.login_pin', "customers.country_id", "customers.state_id", "customers.city_id", 'countries.name as countryname', 'states.name as statename', 'cities.name as cityname')
                ->leftJoin("countries", "countries.id", "=", "customers.country_id")
                ->leftJoin("states", "states.id", "=", "customers.state_id")
                ->leftJoin("cities", "cities.id", "=", "customers.city_id")
                ->where("mobile",$mobile)
                ->where("customers.id",$request->customer_id)
                ->first();
                // echo Hash::check($login_pin, $customer->login_pin);
                // echo $customer->name;
                // echo "<pre>";
                // print_r($customer);
                // echo "</pre>";
                // exit;
                $user = array();
                if(empty($customer))
                {
                    $response['status'] = 'error';
                    $response['login'] = false;
                    $response['error_type'] = 'pin';
                    $response['message'] = 'Invalid login credentials';
                    return response()->json($response);
                }
                // else if(!(Hash::check($login_pin, $customer['login_pin'])))
                // {
                //     $response['status'] = 'error';
                //     $response['login'] = false;
                //     $response['error_type'] = 'pin';
                //     $response['message'] = 'Invalid login credentials';
                //     return response()->json($response);
                // }
                else
                {
                    // Get read unread notifiction count
                    $notificationReadInfo = Notification::select('id','fromid','toid','referenceid', 'notification_type', 'message', 'isread', 'created_at')
                    ->where("notification.toid", $customer['id'])
                    ->where("notification.isread", "N")
                    ->where("notification.is_deleted", 0)
                    ->get();
                    $readCount = $notificationReadInfo->count();
                    $notificationUnreadInfo = Notification::select('id','fromid','toid','referenceid', 'notification_type', 'message', 'isread', 'created_at')
                    ->where("notification.toid", $customer['id'])
                    ->where("notification.isread", "N")
                    ->where("notification.is_deleted", 0)
                    ->get();
                    $unreadCount = $notificationUnreadInfo->count();
                    //
                    $data = Customers::find($customer['id']);
                    $data->devicetype = $request->input("devicetype");
                    $data->devicetoken = $request->input("devicetoken");
                    $data->save();
                    //
                    $user = array(
                        "id" => (string)$customer['id'],
                        "name" => $customer['name'],
                        "email" => $customer['email'],
                        "mobile" => $customer['mobile'],
                        "profileimage" => $this->render($customer['profileimage']),
                        "devicetype" => $this->render($customer['devicetype']),
                        "devicetoken" => $this->render($customer['devicetoken']),
                        "unread" => (string)$unreadCount,
                        "countryid" => (string)$customer['country_id'],
                        "stateid" => (string)$customer['state_id'],
                        "cityid" => (string)$customer['city_id'],
                        "countryname" => $customer['countryname'],
                        "statename" => $customer['statename'],
                        "cityname" => $customer['cityname']
                    );
                    $response['status'] = "success";
                    $response['login'] = true;
                    $response['message'] = "Login success";
                    $response['user'] = $user;
                }
            }
            else
            {
                $response['status'] = 'error';
                $response['error_type'] = 'version';
                $response['message'] = "There is newer version of this application available, click Ok to upgrade now.";
            }
        } catch (Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }

    public function test_payment(Request $request)
    {
        $data = array(
            'mobile'=>$request->mobile,
            'amount'=>$request->amount,
            'order_id'=>$request->order_id,
            'user_id'=>$request->user_id
        );

        PhonepayService::create_phonepay_payment_url($data);
    }

    public function checkpaymentstatus(Request $request){
        try{
            $customer_id = $request->input("customer_id");
            $booking_id = $request->input("booking_id");
            $bookings = Bookings::where('id',$booking_id)
                                ->whereHas("Saloon")
                                ->whereHas("Barber")
                                ->orderBy("book_date","desc")
                                ->orderBy("from_time","desc")->get();
            $bookingList = array();
            foreach($bookings as $booking){

                if(count($booking->Barber->Ratings) > 0){
                    $ratings = $booking->Barber->Ratings->avg("rating");
                }else{
                    $ratings = 0;
                }

                $barber_id = $booking->Barber->id;
                $queryBarberServicesBooking = \DB::table("bookings")->select("bookings.*","booking_items.id as itemid", "booking_items.main_service_id", "barbers_services.id as barber_service_id","barbers_services.duration")->where("bookings.barber_id","=",$barber_id)
                ->join("booking_items","booking_items.booking_id", "=", "bookings.id")
                // ->join("barbers_services","barbers_services.saloon_service_id", "=", "booking_items.main_service_id")
                ->join("barbers_services", function($join) use($barber_id){
                    $join->on("barbers_services.saloon_service_id", "=", "booking_items.main_service_id")
                    ->where("barbers_services.barber_id", $barber_id);
                })
                ->where("status","!=","cancelled")
                ->where("status","!=","emergency cancellation")
                ->where("payment_status","=","C")
                ->get();
                $working_hours = "";
                if(count($queryBarberServicesBooking) > 0)
                {
                    $time = 0;
                    foreach ($queryBarberServicesBooking as $skey => $svalue)
                    {
                        $arr_time = explode(":", $svalue->duration);
                        $hours_to_minutes = 0;
                        $hours = (int)$arr_time[0];
                        $hours_to_minutes = $hours * 60;
                        $minutes = (int)$arr_time[1];
                        $time = $time + $minutes + $hours_to_minutes;
                    }
                    $working_hours = ((floor($time / 60)).":".($time - floor($time / 60) * 60));
                }

                $temp = array();
                $temp['id'] = $booking->id;
                $temp['book_date'] = dateFormat($booking->book_date,"d-m-Y");
                $temp['salon_name'] = $booking->Saloon->saloon_name;
                $temp['salon_id'] = $booking->saloon_id;
                $temp['barber_name'] = $booking->Barber->name;
                $temp['barber_email'] = $booking->Barber->email;
                $temp['barber_mobile'] = $booking->Barber->mobile;
                $temp['barber_exp_year'] = $booking->Barber->exp_year;
                $temp['barber_exp_month'] = $booking->Barber->exp_month;
                $temp['barber_profile_image'] = url('/uploads/profile_images/'.$booking->Barber->profile_image);
                $temp['barber_id'] = $booking->barber_id;
                $temp['book_number'] = $booking->book_number;
                $temp['from_time'] = $booking->from_time;
                $temp['to_time'] = $booking->to_time;
                $temp['total_price'] = $booking->total;
                $temp['transaction_id'] = $booking->transaction_id;
                $temp['billing_name'] = $booking->billing_name;
                $temp['billing_mobile'] = $booking->billing_mobile;
                $temp['billing_email'] = $booking->billing_email;
                $temp['rating'] = $ratings;
                $temp['payment_status'] = $booking->payment_status;
                $temp['totalhours'] = $working_hours;
                $date = $booking->book_date." ".$booking->to_time;
                $current_date = date("Y-m-d H:i:s");

                /*if($date > $current_date){
                    $temp['status'] = 'Upcoming';
                }
                else
                {
                    $temp['status'] = 'Completed';
                }*/
                if($booking->status == 'active')
                {
                    $temp['status'] = 'Active';
                }
                if($date > $current_date){
                    $temp['status'] = 'Upcoming';
                }
                if($date < $current_date && ($booking->status != "cancelled" && $booking->status != "emergency cancellation") && $booking->payment_status == "C")
                {
                    $temp['status'] = 'Completed';
                }
                $cancel_date = "";
                if($booking->status == 'cancelled')
                {
                    $temp['status'] = 'Cancelled';
                    if(!(empty($booking->cancelled_at)))
                    {
                        $cancel_date = date("d-m-Y H:i:s", strtotime($booking->cancelled_at));
                    }
                }
                if($booking->status == 'emergency cancellation')
                {
                    $temp['status'] = 'Emergency Cancel';
                    if(!(empty($booking->cancelled_at)))
                    {
                        $cancel_date = date("d-m-Y H:i:s", strtotime($booking->cancelled_at));
                    }
                }
                $temp['cancel_date'] = $cancel_date;
                if($booking->status == "requested refund")
                {
                    $temp['status'] = 'Requested Refund';
                    $refund_request_date = date("d-m-Y H:i:s", strtotime($booking->refund_request_date));
                    $temp['refund_request_date'] = $refund_request_date;
                }

                $temp['action_type'] = "";
                if(!empty($booking->action_type))
                {
                    $temp['action_type'] = $booking->action_type;
                }

                $booking_services = BookingItems::with('Service')->where("booking_id",$booking->id)->get();
                $services = array();
                foreach($booking_services as $serv){
                    $temp['service_id'] = $serv->SaloonService->id;
                    $temp['service_name'] = $serv->SaloonService->service_name;
                    if($serv->price > 0)
                    {
                        $objSetting = new Settings();
                        $commission = $objSetting->getSetting("Commission");
                        $nprice = ($serv->price * $commission) / 100;
                        $nprice = $serv->price + $nprice;
                        $serv->price = $nprice;
                    }
                    $temp['service_price'] = $serv->price;
                    $temp['main_service_id'] = $serv->service_id;
                    $services[] = $temp;
                }
                $temp['services'] = $services;
                //
                $is_rated = "N";
                $rating = Ratings::where("booking_id", $booking->id)->where("customer_id", $customer_id)->get();
                if(count($rating) > 0)
                {
                    $is_rated = "Y";
                }
                $temp['is_rated'] = $is_rated;
                //
                $is_fav = "N";
                $saloon_is_fav = \DB::table("saloon_favourite")->select("id")->where("customer_id", $customer_id)->where("saloon_id", $booking->saloon_id)->get();
                if(count($saloon_is_fav) > 0)
                {
                    $is_fav = "Y";
                }
                $temp['is_saloon_fav'] = $is_fav;
                // Get barber Reviews by saloon and customer
                $barberRatings = Ratings::select('ratings.id','ratings.customer_id','ratings.saloon_id','ratings.barber_id', 'ratings.rating', 'ratings.comment', 'ratings.booking_id', 'ratings.created_at', 'saloons.saloon_name', 'barbers.name', 'barbers.profile_image')
                ->join("saloons", "saloons.id", "=", "ratings.saloon_id")
                ->join("barbers", "barbers.id", "=", "ratings.barber_id")
                ->where("ratings.customer_id", $customer_id)
                ->where("ratings.booking_id", $booking->id)
                ->get();
                $data_review = array();
                if(!(empty($barberRatings)) && count($barberRatings) > 0)
                {
                    foreach ($barberRatings as $key => $value)
                    {
                        $barberprofileimage = "";
                        if(!(empty($value->profile_image)))
                        {
                            $barberprofileimage = url('/uploads/profile_images/'.$value->profile_image);
                        }
                        $data_review[] = array(
                            "id" => (string)$value->id,
                            "bookingid" => (string)$booking->id,
                            "customerid" => (string)$value->customer_id,
                            "rating" => (string)$value->rating,
                            "comment" => $value->comment,
                            "saloonname" => $value->saloon_name,
                            "barberid" => (string)$value->barber_id,
                            "barbername" => $value->name,
                            "barberprofileimage" => $barberprofileimage,
                            "created" => date("d-m-Y H:i:s", strtotime($value->created_at)),
                        );
                    }
                }
                $temp['reviews'] = $data_review;
                //
                $bookingList[] = $temp;
            }
            $response['status'] = 'success';
            $response['booking_list'] = $bookingList;
        } catch (\Exception $e) {
            $response['status'] = 'error';
            $response['message'] = $e->getMessage();
        }
        return response()->json($response);
    }
}
