<?php

namespace App\Http\Controllers\Webservices;

ini_set('max_execution_time', 600); 

use Carbon\Carbon;



use App\Http\Controllers\Controller;

use Illuminate\Http\Request;

use Validator;

use Illuminate\Support\Facades\Hash;



use App\Saloons;

use App\SaloonServices;

use App\Services;

use App\Countries;

use App\States;

use App\Cities;

use App\Barbers;

use App\BarbersServices;

use App\SaloonGallery;

use App\Bookings;

use App\BookingItems;

use App\Notification;

use App\Settings;

use App\SaloonFavourites;

use App\SaloonPayments;

use App\SaloonCategory;

use Razorpay\Api\Api;

use DB;



class SaloonController extends Controller

{

    public function __construct()

    {

        header('Access-Control-Allow-Origin: *');

        header('Access-Control-Allow-Methods: GET, PUT, POST, DELETE, OPTIONS');

        header("Content-Type: application/json");

    }



    public function saloonRegister(Request $request){

        try{

            $validator = Validator::make($request->all(), [

                'salon_name' => 'required',

                'contact_person' => 'required',

                'email' => 'nullable|sometimes|email|unique:saloons',

                'mobile' => 'required|unique:saloons',

                'street_address' => 'required',

                'salon_type' => 'required',

                // 'owner_image' => 'required',

                // 'open_time' => 'required',

                // 'close_time' => 'required',

                // 'bank_name' => 'required',

                // 'account_number' => 'required',

                // 'ifsc_code' => 'required',

                // 'upi_id' => 'required',

                // 'close_time' => 'required',

                // 'barbers' => 'required',

                // 'services'=>'required'

                // 'country_id' => 'required',

                // 'state_id' => 'required',

                // 'city_id' => 'required',

                // 'password' => 'required',

                

            ]);

            if ($validator->fails()) {

                $response['status'] = 'validation_error';

                $error = $validator->errors()->toArray();

                $errMsg = '';

                foreach($error as $err){

                    $errMsg .= " ".$err[0];

                }

                $response['message'] = $errMsg;

                return response()->json($response);

            }

            $open_time = $request->input("open_time");

            $close_time = $request->input("close_time");

            if(strtotime($close_time) < strtotime($open_time)){

                $errMsg = 'Close time should be greater then open time';

                $response['status'] = 'validation_error';

                $response['message'] = $errMsg;

                return response()->json($response);

            }

            // Barber array commented because app is not sending barber data

            /*$barbers = $request->input('barbers');

            $errMsg = '';

            $is_exists = 0;

            foreach($barbers as $barber){

                $checkBarber = Barbers::where("email",$barber['email'])->count();

                

                if($checkBarber > 0){

                    $is_exists = 1;

                    $errMsg .=" ".$barber['email']." email already taken by barber";

                }

                $checkBarber = Barbers::where("mobile",$barber['mobile'])->count();

                if($checkBarber > 0){

                    $is_exists = 1;

                    $errMsg .=" ".$barber['mobile']." mobile no already taken by barber";

                }

            }

            if($is_exists == 1){

                $response['status'] = 'validation_error';

                $response['message'] = $errMsg;

                return response()->json($response);

            }*/

            $object = new Saloons();

            $object->saloon_name = $request->input("salon_name");

            $object->salon_phone = $request->input("salon_phone");

            $object->contact_person = $request->input("contact_person");

            $object->email = $request->input("email");

            $object->mobile = $request->input("mobile");

            $object->street_address = $request->input("street_address");

            $object->open_time = $request->input("open_time");

            $object->close_time = $request->input("close_time");

            $object->bank_name = $request->input("bank_name");

            $object->account_number = $request->input("account_number");

            $object->ifsc_code = $request->input("ifsc_code");

            $object->upi_id = $request->input("upi_id");

            $object->saloon_type = $request->input("salon_type");

            if($request->input("latitude")){

                $object->latitude = $request->input("latitude");

            }

            if($request->input("logitude")){

                $object->logitude = $request->input("logitude");

            }

            if($request->input("instagram")){

                $object->instagram = $request->input("instagram");

            }

            if($request->input("facebook")){

                $object->facebook = $request->input("facebook");

            }

            if($request->input("twitter")){

                $object->twitter = $request->input("twitter");

            }

            if($request->input("owner_image")){

                $image_64 = base64_decode($request->input("owner_image"));

                $f = finfo_open();

                $mime_type = finfo_buffer($f, $image_64, FILEINFO_MIME_TYPE);  

                $extensions = explode("/",$mime_type);

                $ext = end($extensions);

               

                $ci_fileName= time().'-'.rand(00000,99999).'.'.$ext;

                file_put_contents('uploads/profile_images/'.$ci_fileName,$image_64);    

                $object->owner_image = $ci_fileName;

            }

            if($request->input("country_id"))

            {

                $object->country_id = $request->input("country_id");

            }

            if($request->input("state_id"))

            {

                $object->state_id = $request->input("state_id");

            }

            if($request->input("city_id"))

            {

                $object->city_id = $request->input("city_id");

            }

            if($request->input("address_line_2"))

            {

                $object->address_line_2 = $request->input("address_line_2");

            }

            if($request->input("zipcode"))

            {

                $object->zipcode = $request->input("zipcode");

            }

            if($request->input("youtube_url"))

            {

                $object->youtube_url = $request->input("youtube_url");

            }

            $object->status = 1;   

            $object->created_by = 0;

            $object->save();

            $saloon_id = $object->id;

            $services = $request->input("services");

            /* Commented on 23 Jan because app is not sending service data

            foreach($services as $service){

                $object = new SaloonServices();

                $object->saloon_id = $saloon_id;

                $object->service_name = $service['service_name'];

                $object->service_description = $service['service_description'];

                $object->service_id = $service['service_id'];

                // $object->duration = $service['hours'].":".$service['minutes'];

                if(isset($service['hours']) && isset($service['minutes']))

                {

                    $object->duration = $service['hours'].":".$service['minutes'];

                }

                $object->price = $service['price'];

                $object->created_by = $saloon_id;

                $object->save();

            }*/

            /* // Barber saving commented because app is not sending barber data

            if(count($barbers) > 0){

                foreach($barbers as $barber){

                    

                    $object = new Barbers();

                    $object->name = $barber['name'];

                    $object->email = $barber['email'];

                    $object->mobile = $barber['mobile'];

                    $object->exp_year = $barber['exp_year'];

                    $object->exp_month = $barber['exp_month'];

                    $object->saloon_id = $saloon_id;

                    $object->status = 1;    

                    $object->created_by = $saloon_id;

                    if(isset($barber['barber_profile'])){

                        $image_64 = base64_decode($barber['barber_profile']);

                        $f = finfo_open();

                        $mime_type = finfo_buffer($f, $image_64, FILEINFO_MIME_TYPE);  

                        $extensions = explode("/",$mime_type);

                        $ext = end($extensions);

                       

                        $ci_fileName= time().'-'.rand(00000,99999).'.'.$ext;

                        file_put_contents(public_path('uploads/profile_images/').$ci_fileName,$image_64);    

                        $object->profile_image = $ci_fileName;

                    }



                    $object->save();

                    $barber_id = $object->id;

                    // $services = $barber['services'];

                    // foreach($services as $service){

                    //     $object = new BarbersServices();

                    //     $object->saloon_id = $saloon_id;

                    //     $object->barber_id = $barber_id;

                    //     $object->service_name = $service['service_name'];

                    //     $object->service_description = $service['service_description'];

                    //     $object->service_id = $service['service_id'];

                    //     $object->duration = $service['hours'].":".$service['minutes'];

                    //     $object->price = $service['price'];

                    //     $object->created_by = $saloon_id;

                    //     $object->save();

                    // }

                }

            }*/

            if($request->input('salon_gallery')) {   

                $sg_images   = $request->input('salon_gallery'); //your base64 encoded data

                for($i=0;$i < count($sg_images);$i++){

                    $image_64 = base64_decode($sg_images[$i]);

                    $f = finfo_open();

                    $mime_type = finfo_buffer($f, $image_64, FILEINFO_MIME_TYPE);  

                    $extensions = explode("/",$mime_type);

                    $ext = end($extensions);

                   

                    $ci_fileName= time().'-'.rand(00000,99999).'.'.$ext;

                    file_put_contents('uploads/saloon_gallery/'.$ci_fileName, $image_64);    

                    $saloon_gallery = new SaloonGallery();

                    $saloon_gallery->saloon_id = $saloon_id;

                    $saloon_gallery->image = $ci_fileName;

                    $saloon_gallery->created_by = $saloon_id;

                    $saloon_gallery->save();

                }

                

            } 



            /* // Barber array commented because app is not sending barber data

            $saloon_barbers = Barbers::select('id','name','mobile','profile_image','exp_year','exp_month')->where('saloon_id',$saloon_id)->get();

            foreach($saloon_barbers as $barber){

                $barber->profile_image = url('/uploads/profile_images/'.$barber->profile_image);

                if(!empty($barber->Ratings)){

                    $ratings = $barber->Ratings->avg("rating");

                }else{

                    $ratings = 0;

                }

                $barber->ratings = $ratings;

            }*/

            /* Commented on 23 Jan because app is not sending service data

            $services = SaloonServices::where("saloon_id",$saloon_id)

                                        ->distinct("service_id")

                                        ->orderBy("price","asc")

                                        ->get();

            if(count($services) > 0){

                foreach($services as $service){

                    $temp = array();

                    $temp['service_id'] = $service->id;

                    $temp['main_service_id'] = $service->service_id;

                    $temp['name'] = ($service->service_name != NULL)?$service->service_name:'';

                    $temp['price'] = ($service->price != NULL)?$service->price:'';

                    $saloon_services[] = $temp;

                }

            }else{

                $saloon_services = array();

            }*/



            $saloon = Saloons::with(['FirstImage','Country','Ratings','State','City','ServiceLowPrice'])->where("id",$saloon_id)->first();

            if(count($saloon->Ratings) > 0){

                $ratings = $saloon->Ratings->avg("rating");

            }else{

                $ratings = 0;

            }

            $saloon = $saloon->toArray();

            $temp = array();

            $temp['salon_id'] = $saloon['id'];

            $temp['salon_name'] = $saloon['saloon_name'];

            $temp['contact_person'] = $saloon['contact_person'] == ""?"":$saloon['contact_person'];

            $temp['email'] = $saloon['email'] == ""?"":$saloon['email'];

            $temp['salon_phone'] = $saloon['salon_phone'] == ""?"":$saloon['salon_phone'];

            $temp['open_time'] = ($saloon['open_time'] != NULL)?date("H:i",strtotime($saloon['open_time'])):'';

            $temp['close_time'] = ($saloon['close_time'] != NULL)?date("H:i",strtotime($saloon['close_time'])):'';

            $temp['salon_type'] = ($saloon['saloon_type'] != NULL)?$saloon['saloon_type']:'';

            $temp['contact_no'] =  ($saloon['mobile'] != NULL)?$saloon['mobile']:'';

            $temp['ratings'] = $ratings;

            $street_address = '';

            if($saloon['street_address'] != ''){

                $street_address = $saloon['street_address'];

            }

            $temp['street_address'] =  $street_address;

            if(!empty($saloon['owner_image'])){

                $temp['owner_image'] = url('/uploads/profile_images/'.$saloon['owner_image']);                

            }else{

                $temp['owner_image'] = '';

            }

            if(!empty($saloon['service_low_price'])){

                $temp['price'] = $saloon['service_low_price']['price'];                

            }else{

                $temp['price'] = '';

            }

            if($saloon['instagram'] != ''){

                $temp['instagram'] = $saloon['instagram'];

            }else{

                $temp['instagram'] = '';

            }

            if($saloon['facebook'] != ''){

                $temp['facebook'] = $saloon['facebook'];

            }else{

                $temp['facebook'] = '';

            }

            if($saloon['twitter'] != ''){

                $temp['twitter'] = $saloon['twitter'];

            }else{

                $temp['twitter'] = '';

            }

            if($saloon['latitude'] != ''){

                $temp['latitude'] = $saloon['latitude'];

            }else{

                $temp['latitude'] = '';

            }

            if($saloon['logitude'] != ''){

                $temp['logitude'] = $saloon['logitude'];

            }else{

                $temp['logitude'] = '';

            }

            $temp['country_id'] = "";

            if($saloon['country_id'] != '')

            {

                $temp['country_id'] = $saloon['country_id'];

            }

            $temp['state_id'] = "";

            if($saloon['state_id'] != '')

            {

                $temp['state_id'] = $saloon['state_id'];

            }

            $temp['city_id'] = "";

            if($saloon['city_id'] != '')

            {

                $temp['city_id'] = $saloon['city_id'];

            }

            $temp['address_line_2'] = "";

            if($saloon['address_line_2'] != '')

            {

                $temp['address_line_2'] = $saloon['address_line_2'];

            }

            $temp['zipcode'] = "";

            if($saloon['zipcode'] != '')

            {

                $temp['zipcode'] = $saloon['zipcode'];

            }

            $temp['youtube_url'] = "";

            if($saloon['youtube_url'] != '')

            {

                $temp['youtube_url'] = $saloon['youtube_url'];

            }

            $saloon_detail = $temp;



            $saloon_gallery = SaloonGallery::where("saloon_id",$saloon_id)->get();

            $images = array();

            foreach($saloon_gallery as $gallery){

                $images[] = url('/uploads/saloon_gallery/'.$gallery->image);

            }

            $images_saloon = array();

            foreach($saloon_gallery as $gallery)

            {

                $images_saloon[] = array(

                    "salonimageid" => (string)$gallery->id,

                    "salon_image" => url('/uploads/saloon_gallery/'.$gallery->image)

                );

            }



            // $response['barbers'] = $saloon_barbers;

            // $response['services'] = $saloon_services;

            $response['salon'] = $saloon_detail;

            $response['salon_gallery'] = $images;

            $response['salon_images'] = $images_saloon;

            $response['status'] = 'success';

            $response['message'] = 'Salon added successfully';

        } catch (Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }



    public function editProfile(Request $request){

        try{

            // echo "<pre>";

            // print_r($request->all());

            // echo "</pre>";

            // echo $request->input("salon_id");

            // exit;

            $object = Saloons::find($request->input("salon_id"));

            $validator = Validator::make($request->all(), [

                'salon_name' => 'required',

                'contact_person' => 'required',

                'email' => 'required|email|unique:saloons,email,'.$object->id,

                'mobile' => 'required|unique:saloons,mobile,'.$object->mobile,

                'street_address' => 'required',

                'salon_type' => 'required',

                'owner_image' => 'required',

                'open_time' => 'required',

                'close_time' => 'required',

                'bank_name' => 'required',

                'account_number' => 'required',

                'ifsc_code' => 'required',

                'upi_id' => 'required',

                'close_time' => 'required',

            ]);

            $object->saloon_name = $request->input("salon_name");

            $object->salon_phone = $request->input("salon_phone");

            $object->contact_person = $request->input("contact_person");

            $object->email = $request->input("email");

            $object->mobile = $request->input("mobile");

            $object->street_address = $request->input("street_address");

            $object->open_time = $request->input("open_time");

            $object->close_time = $request->input("close_time");

            $object->bank_name = $request->input("bank_name");

            $object->account_number = $request->input("account_number");

            $object->ifsc_code = $request->input("ifsc_code");

            $object->upi_id = $request->input("upi_id");

            $object->saloon_type = $request->input("salon_type");

            if($request->input("latitude")){

                $object->latitude = $request->input("latitude");

            }

            if($request->input("logitude")){

                $object->logitude = $request->input("logitude");

            }

            if($request->input("instagram")){

                $object->instagram = $request->input("instagram");

            }

            if($request->input("facebook")){

                $object->facebook = $request->input("facebook");

            }

            if($request->input("twitter")){

                $object->twitter = $request->input("twitter");

            }

            if($request->input("owner_image")){

                if($object->owner_image != '' && file_exists('uploads/profile_images/'.$object->owner_image)){

                    unlink('uploads/profile_images/'.$object->owner_image);                    

                } 

                $image_64 = base64_decode($request->input("owner_image"));

                $f = finfo_open();

                $mime_type = finfo_buffer($f, $image_64, FILEINFO_MIME_TYPE);  

                $extensions = explode("/",$mime_type);

                $ext = end($extensions);

               

                $ci_fileName= time().'-'.rand(00000,99999).'.'.$ext;

                file_put_contents('uploads/profile_images/'.$ci_fileName,$image_64);    

                $object->owner_image = $ci_fileName;

            }

            if($request->input("country_id"))

            {

                $object->country_id = $request->input("country_id");

            }

            if($request->input("state_id"))

            {

                $object->state_id = $request->input("state_id");

            }

            if($request->input("city_id"))

            {

                $object->city_id = $request->input("city_id");

            }

            $object->address_line_2 = $request->input("address_line_2");

            $object->zipcode = $request->input("zipcode");

            $object->youtube_url = $request->input("youtube_url");

            $object->save();

            $saloon_id = $object->id;

            // $image_id_one = $request->input("image_id_1");

            // $image_id_two = $request->input("image_id_2");

            // $image_id_three = $request->input("image_id_3");

            if($request->input("salon_gallery_1"))

            {

                $image_64 = base64_decode($request->input("salon_gallery_1"));

                $f = finfo_open();

                $mime_type = finfo_buffer($f, $image_64, FILEINFO_MIME_TYPE);  

                $extensions = explode("/",$mime_type);

                $ext = end($extensions);

               

                $ci_fileName= time().'-'.rand(00000,99999).'.'.$ext;

                file_put_contents('uploads/saloon_gallery/'.$ci_fileName, $image_64);

                if(!(empty($request->input("image_id_1"))))

                {

                    // update image

                    $arr_update_image = array(

                        "image" => $ci_fileName,

                        "updated_at" => date("Y-m-d H:i:s")

                    );

                    SaloonGallery::where("id",$request->input("image_id_1"))->update($arr_update_image);

                }

                else

                {

                    $saloon_gallery = new SaloonGallery();

                    $saloon_gallery->saloon_id = $saloon_id;

                    $saloon_gallery->image = $ci_fileName;

                    $saloon_gallery->created_by = $saloon_id;

                    $saloon_gallery->save();

                }

            }

            if($request->input("salon_gallery_2"))

            {

                $image_64 = base64_decode($request->input("salon_gallery_2"));

                $f = finfo_open();

                $mime_type = finfo_buffer($f, $image_64, FILEINFO_MIME_TYPE);  

                $extensions = explode("/",$mime_type);

                $ext = end($extensions);

               

                $ci_fileName= time().'-'.rand(00000,99999).'.'.$ext;

                file_put_contents('uploads/saloon_gallery/'.$ci_fileName, $image_64);

                if(!(empty($request->input("image_id_2"))))

                {

                    // update image

                    $arr_update_image = array(

                        "image" => $ci_fileName,

                        "updated_at" => date("Y-m-d H:i:s")

                    );

                    SaloonGallery::where("id",$request->input("image_id_2"))->update($arr_update_image);

                }

                else

                {

                    $saloon_gallery = new SaloonGallery();

                    $saloon_gallery->saloon_id = $saloon_id;

                    $saloon_gallery->image = $ci_fileName;

                    $saloon_gallery->created_by = $saloon_id;

                    $saloon_gallery->save();

                }

            }

            if($request->input("salon_gallery_3"))

            {

                $image_64 = base64_decode($request->input("salon_gallery_3"));

                $f = finfo_open();

                $mime_type = finfo_buffer($f, $image_64, FILEINFO_MIME_TYPE);  

                $extensions = explode("/",$mime_type);

                $ext = end($extensions);

               

                $ci_fileName= time().'-'.rand(00000,99999).'.'.$ext;

                file_put_contents('uploads/saloon_gallery/'.$ci_fileName, $image_64);

                if(!(empty($request->input("image_id_3"))))

                {

                    // update image

                    $arr_update_image = array(

                        "image" => $ci_fileName,

                        "updated_at" => date("Y-m-d H:i:s")

                    );

                    SaloonGallery::where("id",$request->input("image_id_3"))->update($arr_update_image);

                }

                else

                {

                    $saloon_gallery = new SaloonGallery();

                    $saloon_gallery->saloon_id = $saloon_id;

                    $saloon_gallery->image = $ci_fileName;

                    $saloon_gallery->created_by = $saloon_id;

                    $saloon_gallery->save();

                }

            }

            /*if($request->input('salon_gallery'))

            {

                $sg_images   = $request->input('salon_gallery'); //your base64 encoded data

                for($i=0;$i < count($sg_images);$i++)

                {

                    $image_64 = base64_decode($sg_images[$i]);

                    $f = finfo_open();

                    $mime_type = finfo_buffer($f, $image_64, FILEINFO_MIME_TYPE);  

                    $extensions = explode("/",$mime_type);

                    $ext = end($extensions);

                   

                    $ci_fileName= time().'-'.rand(00000,99999).'.'.$ext;

                    file_put_contents(public_path('uploads/saloon_gallery/').$ci_fileName, $image_64);    

                    $saloon_gallery = new SaloonGallery();

                    $saloon_gallery->saloon_id = $saloon_id;

                    $saloon_gallery->image = $ci_fileName;

                    $saloon_gallery->created_by = $saloon_id;

                    $saloon_gallery->save();

                }

            }*/

            $saloon = Saloons::with(['FirstImage','Country','Ratings','State','City','ServiceLowPrice'])->where("id",$saloon_id)->first();

            if(count($saloon->Ratings) > 0){

                $ratings = $saloon->Ratings->avg("rating");

            }else{

                $ratings = 0;

            }

            $saloon = $saloon->toArray();

            // $temp = array();

            // $temp['salon_id'] = $saloon['id'];

            // $temp['salon_name'] = $saloon['saloon_name'];

            // $temp['open_time'] = ($saloon['open_time'] != NULL)?date("H:i",strtotime($saloon['open_time'])):'';

            // $temp['close_time'] = ($saloon['close_time'] != NULL)?date("H:i",strtotime($saloon['close_time'])):'';

            // $temp['salon_type'] = ($saloon['saloon_type'] != NULL)?$saloon['saloon_type']:'';

            // $temp['contact_no'] =  ($saloon['mobile'] != NULL)?$saloon['mobile']:'';

            // $temp['ratings'] = $ratings;

            // $street_address = '';

            // if($saloon['street_address'] != ''){

            //     $street_address = $saloon['street_address'];

            // }

            // $temp['street_address'] =  $street_address;

            // if(!empty($saloon['owner_image'])){

            //     $temp['owner_image'] = url('/uploads/profile_images/'.$saloon['owner_image']);                

            // }else{

            //     $temp['owner_image'] = '';

            // }

            // if(!empty($saloon['service_low_price'])){

            //     $temp['price'] = $saloon['service_low_price']['price'];                

            // }else{

            //     $temp['price'] = '';

            // }

            // if($saloon['instagram'] != ''){

            //     $temp['instagram'] = $saloon['instagram'];

            // }else{

            //     $temp['instagram'] = '';

            // }

            // if($saloon['facebook'] != ''){

            //     $temp['facebook'] = $saloon['facebook'];

            // }else{

            //     $temp['facebook'] = '';

            // }

            // if($saloon['twitter'] != ''){

            //     $temp['twitter'] = $saloon['twitter'];

            // }else{

            //     $temp['twitter'] = '';

            // }

            // if($saloon['latitude'] != ''){

            //     $temp['latitude'] = $saloon['latitude'];

            // }else{

            //     $temp['latitude'] = '';

            // }

            // if($saloon['logitude'] != ''){

            //     $temp['logitude'] = $saloon['logitude'];

            // }else{

            //     $temp['logitude'] = '';

            // }

            // $saloon_detail = $temp;

            $saloon_detail = $this->salon_data($saloon['id']);

            $saloon_gallery = SaloonGallery::where("saloon_id",$saloon_id)->get();

            $images = array();

            /*foreach($saloon_gallery as $gallery){

                $images[] = url('/uploads/saloon_gallery/'.$gallery->image);

            }*/

            foreach($saloon_gallery as $gallery)

            {

                $images[] = array(

                    "salonimageid" => (string)$gallery->id,

                    "salon_image" => url('/uploads/saloon_gallery/'.$gallery->image)

                );

            }

            $response['salon'] = $saloon_detail;

            // $response['salon_gallery'] = $images;

            $response['salon_images'] = $images;

            $response['status'] = 'success';

            $response['message'] = 'Salon edited successfully';

        } catch (Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }

    public function loginAsSaloon(Request $request){

        try{

            $validator = Validator::make($request->all(), [

                'mobile' => 'required'

            ]);

            if ($validator->fails()) {

                $response['status'] = 'validation_error';

                $response['login'] = false;

                $error = $validator->errors()->toArray();

                $errMsg = '';

                foreach($error as $err){

                    $errMsg .= " ".$err[0];

                }

                $response['message'] = $errMsg;

                return response()->json($response);

            }

            $mobile = $request->input("mobile");

            $saloon = Saloons::where("mobile",$mobile)->first();

            

            if(empty($saloon)){

                $response['status'] = 'error';

                $response['login'] = false;

                $response['message'] = 'Invalid mobile no';

                return response()->json($response);

            }else{

            // if (\Auth::guard('saloon')->attempt(['email' => $request->email, 'password' => $request->password], $request->remember)) {

                $saloon = $saloon->toArray();

                // $temp = array();

                // $temp['salon_id'] = $saloon['id'];

                // $temp['salon_name'] = $saloon['saloon_name'];

                // $temp['open_time'] = ($saloon['open_time'] != NULL)?date("H:i",strtotime($saloon['open_time'])):'';

                // $temp['close_time'] = ($saloon['close_time'] != NULL)?date("H:i",strtotime($saloon['close_time'])):'';

                // $temp['salon_type'] = ($saloon['saloon_type'] != NULL)?$saloon['saloon_type']:'';

                // $temp['contact_no'] =  ($saloon['mobile'] != NULL)?$saloon['mobile']:'';

                // $street_address = '';

                // if($saloon['street_address'] != ''){

                //     $street_address = $saloon['street_address'];

                // }                

                // $temp['street_address'] =  $street_address;

                // if(!empty($saloon['owner_image'])){

                //     $temp['owner_image'] = url('/uploads/profile_images/'.$saloon['owner_image']);                

                // }else{

                //     $temp['owner_image'] = '';

                // }

                

                // if($saloon['instagram'] != ''){

                //     $temp['instagram'] = $saloon['instagram'];

                // }else{

                //     $temp['instagram'] = '';

                // }

                // if($saloon['facebook'] != ''){

                //     $temp['facebook'] = $saloon['facebook'];

                // }else{

                //     $temp['facebook'] = '';

                // }

                // if($saloon['twitter'] != ''){

                //     $temp['twitter'] = $saloon['twitter'];

                // }else{

                //     $temp['twitter'] = '';

                // }

                // if($saloon['latitude'] != ''){

                //     $temp['latitude'] = $saloon['latitude'];

                // }else{

                //     $temp['latitude'] = '';

                // }

                // if($saloon['logitude'] != ''){

                //     $temp['logitude'] = $saloon['logitude'];

                // }else{

                //     $temp['logitude'] = '';

                // }

                // $saloon_detail = $temp;

                $saloon_detail = $this->salon_data($saloon['id']);

                $response['status'] = 'success';

                $response['login'] = true;

                $response['message'] = 'Login success';

                $response['user'] = $saloon_detail;

                // $response['token'] = $user->generateToken();

            }

        } catch (Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }

    public function salon_data($id){

        // $saloon = Saloons::where("id",$id)->first();

        $saloon = Saloons::where("id",$id)->with("Country", "State", "City")->first();

        $saloon = $saloon->toArray();

        $temp = array();

        

        unset($saloon['last_login']);

        unset($saloon['api_token']);

        unset($saloon['created_by']);

        unset($saloon['updated_by']);

        unset($saloon['deleted_by']);

        unset($saloon['created_at']);

        unset($saloon['updated_at']);

        unset($saloon['deleted_at']);

        // unset($saloon['country_id']);

        // unset($saloon['city_id']);

        // unset($saloon['state_id']);

        unset($saloon['password']);

        $temp = $saloon;

        if(!empty($saloon['owner_image'])){

            $temp['owner_image'] = url('/uploads/profile_images/'.$saloon['owner_image']);                

        }else{

            $temp['owner_image'] = '';

        }

        $temp['salon_name'] = $saloon['saloon_name'];

        $temp['salon_phone'] = $saloon['salon_phone'] == ""?"":$saloon['salon_phone'];

        unset($temp['saloon_name']);

        unset($temp['id']);

        $temp['salon_id'] = $saloon['id'];

        $temp['open_time'] = ($saloon['open_time'] != NULL)?date("H:i",strtotime($saloon['open_time'])):'';

        $temp['close_time'] = ($saloon['close_time'] != NULL)?date("H:i",strtotime($saloon['close_time'])):'';

        $temp['salon_type'] = ($saloon['saloon_type'] != NULL)?$saloon['saloon_type']:'';

        $temp['contact_no'] =  ($saloon['mobile'] != NULL)?$saloon['mobile']:'';

        $street_address = '';

        if($saloon['street_address'] != ''){

            $street_address = $saloon['street_address'];

        }                

        $temp['street_address'] =  $street_address;

        if(!empty($saloon['owner_image'])){

            $temp['owner_image'] = url('/uploads/profile_images/'.$saloon['owner_image']);                

        }else{

            $temp['owner_image'] = '';

        }

        

        if($saloon['instagram'] != ''){

            $temp['instagram'] = $saloon['instagram'];

        }else{

            $temp['instagram'] = '';

        }

        if($saloon['facebook'] != ''){

            $temp['facebook'] = $saloon['facebook'];

        }else{

            $temp['facebook'] = '';

        }

        if($saloon['twitter'] != ''){

            $temp['twitter'] = $saloon['twitter'];

        }else{

            $temp['twitter'] = '';

        }

        if($saloon['latitude'] != ''){

            $temp['latitude'] = $saloon['latitude'];

        }else{

            $temp['latitude'] = '';

        }

        if($saloon['logitude'] != ''){

            $temp['logitude'] = $saloon['logitude'];

        }else{

            $temp['logitude'] = '';

        }

        $temp['country_id'] = "";

        $temp['country_name'] = "";

        if($saloon['country_id'] != '')

        {

            $temp['country_id'] = $saloon['country_id'];

            $temp['country_name'] = $saloon['country']['name'];

        }

        $temp['state_id'] = "";

        $temp['state_name'] = "";

        if($saloon['state_id'] != '')

        {

            $temp['state_id'] = $saloon['state_id'];

            $temp['state_name'] = $saloon['state']['name'];

        }

        $temp['city_id'] = "";

        $temp['city_name'] = "";

        if($saloon['city_id'] != '')

        {

            $temp['city_id'] = $saloon['city_id'];

            $temp['city_name'] = $saloon['city']['name'];

        }

        $temp['address_line_2'] = "";

        if($saloon['address_line_2'] != '')

        {

            $temp['address_line_2'] = $saloon['address_line_2'];

        }

        $temp['zipcode'] = "";

        if($saloon['zipcode'] != '')

        {

            $temp['zipcode'] = $saloon['zipcode'];

        }

        $temp['youtube_url'] = "";

        if($saloon['youtube_url'] != '')

        {

            $temp['youtube_url'] = $saloon['youtube_url'];

        }

        unset($temp['country']);

        unset($temp['state']);

        unset($temp['city']);

        if(empty($saloon['login_pin']))

        {

            $temp['is_loginpin'] = "N";

        }

        else

        {

            $temp['is_loginpin'] = "Y";

        }

        $saloon_detail = $temp;

        return $saloon_detail;

    }

    public function getAllServices(Request $request){

        try{

            $services = Services::select('id','name')->where("status","1")->get();

            $response['status'] = 'success';

            $response['services'] = $services;

        } catch (Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }





    public function getSaloonByService(Request $request){

        try{

            $validator = Validator::make($request->all(), [

                'customer_id' => 'required'

            ]);

            if ($validator->fails()) {

                $response['status'] = 'validation_error';

                $error = $validator->errors()->toArray();

                $errMsg = '';

                foreach($error as $err){

                    $errMsg .= " ".$err[0];

                }

                $response['message'] = $errMsg;

                return response()->json($response);

            }

            $sort_by = '';

            if($request->input("sort_by")){

                $sort_by = $request->input("sort_by");

            }

            $rating = array();

            if($request->input("rating")){

                $rating = $request->input("rating");

            }

            $valid_for = array();

            if($request->input("valid_for")){

                $valid_for = $request->input("valid_for");

            }

            $price_filter = array();

            if($request->input("price_filter")){

                $price_filter = $request->input("price_filter");

                $price = array();

                for($i=0;$i < count($price_filter);$i++){

                    $t = explode("-",$price_filter[$i]);

                    $price[] = $t[0];

                    $price[] = $t[1];

                }

                $price = array_unique($price);

                $max_price = max($price);

                $min_price = min($price);

                $price_filter = array();

                $price_filter[] = $min_price;

                $price_filter[] = $max_price;

            }

            $saloon_ids = SaloonServices::with('Saloon')

                                        ->where(function($query) use($price_filter,$valid_for){

                                            if(count($price_filter) > 0){

                                                $query->where("price",">=",$price_filter[0]);

                                                $query->where("price","<=",$price_filter[1]);

                                            }

                                            if(count($valid_for) > 0){

                                                $query->whereHas("Saloon",function($query2) use($valid_for){

                                                    $query2->where("status",1);

                                                    if(count($valid_for) > 0){

                                                        $query2->whereIn("saloon_type",$valid_for);

                                                    }

                                                });

                                            }

                                        })

                                        ->whereHas("Saloon")

                                        ->groupBy("saloon_id")

                                        ->pluck('saloon_id');



            if(count($saloon_ids) > 0){ 

                $saloon_ids = $saloon_ids->toArray();

            }else{

                $saloon_ids = array();

            }



            $keyword = "";

            $where_and = "";

            if($request->input("keyword")){

                $keyword = $request->input("keyword");

                $where_and = " (saloon_name like '%".$keyword."%' OR saloons.street_address like '%".$keyword."%' OR saloons.contact_person like '%".$keyword."%' OR barbers.name like '%".$keyword."%')";

            }

            $keylatitude = "";

            $keylongitude = "";

            $whereHaving = "";

            $islatlng = "";

            if($request->input("keylat") != "" && $request->input("keylng") != ""){

                $keylatitude = $request->input("keylat");

                $keylongitude = $request->input("keylng");

                $where_and = ", (3959*acos(cos(radians('".$keylatitude."'))*cos(radians(saloons.latitude))*cos(radians(saloons.logitude)-radians('".$keylongitude."'))+sin(radians('".$keylatitude."'))*sin(radians(saloons.latitude)))) AS distance";

                $whereHaving = " distance <= ?";

                $islatlng = "Y";

            }

            $cityId = $request->input("city_id");

            $saloonsList = Saloons::select(DB::raw("saloons.*, (3959*acos(cos(radians('".$keylatitude."'))*cos(radians(saloons.latitude))*cos(radians(saloons.logitude)-radians('".$keylongitude."'))+sin(radians('".$keylatitude."'))*sin(radians(saloons.latitude)))) AS distance"))

            ->with(['Country'=>function($query){

                $query->select('id','name');

            }])

            ->join('barbers','barbers.saloon_id','=','saloons.id','left')

            ->with(['State'=>function($query){

                $query->select('id','name');

            }])

            ->with(['City'=>function($query){

                $query->select('id','name');

            }])

            ->with(['FirstImage','ServiceLowPrice','Country','State','City','Ratings','Barbers'])

            ->whereIn("saloons.id",$saloon_ids)

            ->where("saloons.status",'1')

            ->where(function($query) use ($cityId){

                if($cityId > 0)

                {

                    $query->where("city_id", $cityId);

                }

            })

            ->where(function($query) use ($rating) {

                if(count($rating) > 0){

                    $query->whereHas('Ratings',function($q) use($rating){

                      $q->whereIn("rating",$rating);  

                    });

                }

            })

            ->where(function($query) use ($where_and, $keyword) {

                if($keyword != ""){

                    $query->whereRaw($where_and, false);

                }

            })

            ->groupBy('saloons.id');

            if($islatlng == "Y")

            {

                // $saloonsList = $saloonsList->havingRaw(" distance <= ?", [10]);

                $saloonsList = $saloonsList->orderBy("distance",'asc');

            }

            $saloonsList = $saloonsList->get();

            // echo "<pre>";

            // print_r($saloonsList);

            // echo "</pre>";

            // exit;



            $saloons = array();

            foreach($saloonsList  as $saloon){

                if(count($saloon->Ratings) > 0){

                    $ratings = $saloon->Ratings->avg("rating");

                    $ratingCount = $saloon->Ratings->count();

                }else{

                    $ratings = 0;

                    $ratingCount = 0;

                }

                $saloon = $saloon->toArray();

                $temp['salon_id'] = $saloon['id'];

                $temp['salon_name'] = $saloon['saloon_name'];

                $temp['open_time'] = ($saloon['open_time'] != NULL)?date("H:i",strtotime($saloon['open_time'])):'';

                $temp['close_time'] = ($saloon['close_time'] != NULL)?date("H:i",strtotime($saloon['close_time'])):'';

                $temp['salon_type'] = ($saloon['saloon_type'] != NULL)?$saloon['saloon_type']:'';

                $temp['ratings'] = $ratings;

                $temp['ratings_count'] = (string)$ratingCount;

                $temp['latitude'] = ($saloon['latitude'] != NULL)?$saloon['latitude']:'';

                $temp['logitude'] = ($saloon['logitude'] != NULL)?$saloon['logitude']:'';

                $temp['distance'] = ($saloon['distance'] != NULL)?$saloon['distance']:'';

                $street_address = '';

                if($saloon['street_address'] != ''){

                    $street_address = $saloon['street_address'];

                }

                // if(!empty($saloon['city'])){

                //     $street_address .= " ".$saloon['city']['name'];

                // }

                // if(!empty($saloon['state'])){

                //     $street_address .= " ".$saloon['state']['name'];

                // }

                // if(!empty($saloon['country'])){

                //     $street_address .= " ".$saloon['country']['name'];

                // }

                $temp['street_address'] =  $street_address;

                if(!empty($saloon['first_image'])){

                    $temp['image'] = url('/uploads/saloon_gallery/'.$saloon['first_image']['image']);                

                }else{

                    $temp['image'] = '';

                }

                if(!empty($saloon['service_low_price'])){

                    $temp['price'] = $saloon['service_low_price']['price'];                

                }else{

                    $temp['price'] = '';

                }

                //

                $is_fav = "N";

                $customer_id = $request->input("customer_id");

                $saloon_is_fav = \DB::table("saloon_favourite")->select("id")->where("customer_id", $customer_id)->where("saloon_id", $saloon['id'])->get();

                if(count($saloon_is_fav) > 0)

                {

                    $is_fav = "Y";

                }

                $temp['is_saloon_fav'] = $is_fav;

                //

                $saloons[] = $temp;

            }

            if($sort_by != ''){

                $price = array();

                $price = array();

                foreach ($saloons as $key => $row)

                {

                    $price[$key] = $row['price'];

                }

                if($sort_by == 'price_low_high'){

                    array_multisort($price, SORT_ASC, $saloons);

                }else{

                    array_multisort($price, SORT_DESC, $saloons);    

                }



                // Sort by rating

                $ratings_sort= array();

                if($sort_by == 'ratings')

                {

                    foreach ($saloons as $key => $row)

                {

                    $ratings_sort[$key] = $row['ratings'];

                }

                    array_multisort($ratings_sort, SORT_DESC, $saloons);

                }

                

            }

            $response['status'] = 'success';

            $response['salons'] = $saloons;

        } catch (\Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }

    

    public function getSaloonServices(Request $request){

        try{

            $validator = Validator::make($request->all(), [

                'salon_id' => 'required'

            ]);

            if ($validator->fails()) {

                $response['status'] = 'validation_error';

                $error = $validator->errors()->toArray();

                $errMsg = '';

                foreach($error as $err){

                    $errMsg .= " ".$err[0];

                }

                $response['message'] = $errMsg;

                return response()->json($response);

            }

            $saloon_id = $request->input("salon_id");

            $services = BarbersServices::where("saloon_id",$saloon_id)

                                        ->distinct("service_id")

                                        ->orderBy("price","asc")

                                        ->get();

            if(count($services) > 0){

                foreach($services as $service){

                    $temp['service_id'] = $service->id;

                    $temp['name'] = $service->service_name;

                    $temp['price'] = $service->price;

                    $saloon_services[] = $temp;

                }

            }else{

                $saloon_services = array();

            }

            

            $response['status'] = 'success';

            $response['salon_services'] = $saloon_services;

        } catch (Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }



    // public function getSaloonBarbers(Request $request){

    //     try{

    //         $validator = Validator::make($request->all(), [

    //             'salon_id' => 'required'

    //         ]);

    //         if ($validator->fails()) {

    //             $response['status'] = 'validation_error';

    //             $error = $validator->errors()->toArray();

    //             $errMsg = '';

    //             foreach($error as $err){

    //                 $errMsg .= " ".$err[0];

    //             }

    //             $response['message'] = $errMsg;

    //             return response()->json($response);

    //         }

    //         $saloon_id = $request->input("salon_id");

    //         $barbersList = Barbers::select('id','name','mobile','profile_image','exp_year','exp_month', 'email','created_at')->where('is_visible','Y')->where('saloon_id',$saloon_id)->get();

    //         $barbers = array();

    //         foreach($barbersList as $barber){

    //             if(count($barber->Ratings) > 0){

    //                 $ratings = $barber->Ratings->avg("rating");

    //             }else{

    //                 $ratings = 0;

    //             }

                

    //             $temp = $barber->toArray();

    //             $temp['profile_image'] = url('/uploads/profile_images/'.$barber->profile_image);

    //             // $today_earning = Bookings::where("barber_id",$barber->id)

    //             //         ->whereDate("book_date",$date)

    //             //         ->orderBy("book_date","desc")

    //             //         ->sum("total");

    //             // $temp['today_earning'] = $today_earning;



    //             // $month_earning = Bookings::where("barber_id",$barber->id)

    //             //         ->whereDate("book_date",">=",$month_start)

    //             //         ->whereDate("book_date","<=",$month_end)

    //             //         ->orderBy("book_date","desc")

    //             //         ->sum("total");

    //             // $temp['month_earning'] = $month_earning;

    //             /*$services = BarbersServices::where("saloon_id",$saloon_id)->where("barber_id", $barber->id)->get();

    //             $working_hours = "";

    //             if(count($services) > 0)

    //             {

    //                 $time = 0;

    //                 foreach ($services as $skey => $svalue)

    //                 {

    //                     $time_str = strtotime($svalue->duration);

    //                     $time += $time_str;

    //                 }

    //                 $working_hours = date("H:i",$time);

    //             }*/



    //             $toDate = Carbon::parse(date('Y-m-d',strtotime($barber->created_at)));

    //             $fromDate = Carbon::parse(date('Y-m-d'));

        

    //             $months = $toDate->diffInMonths($fromDate);



    //             $totalExpMonth = $months+(int)$barber->exp_month;



    //             $rem_year = $barber->exp_year;

    //             $rem_month = $totalExpMonth;



    //             if($totalExpMonth >= 12)

    //             {

    //                 $rryear = (int)($totalExpMonth/12);

    //                 $rem_month = $totalExpMonth-($rryear*12);

    //                 $rem_year = $rem_year+$rryear;

    //             }



    //             $temp['exp_year'] = $rem_year;

    //             $temp['exp_month'] = $rem_month;



    //             $barber_id = $barber->id;

    //             $queryBarberServicesBooking = \DB::table("bookings")->select("bookings.*","booking_items.id as itemid", "booking_items.main_service_id", "barbers_services.id as barber_service_id","barbers_services.duration")->where("bookings.barber_id","=",$barber_id)

    //             ->join("booking_items","booking_items.booking_id", "=", "bookings.id")

    //             // ->join("barbers_services","barbers_services.saloon_service_id", "=", "booking_items.main_service_id")

    //             ->join("barbers_services", function($join) use($barber_id){

    //                 $join->on("barbers_services.saloon_service_id", "=", "booking_items.main_service_id")

    //                 ->where("barbers_services.barber_id", $barber_id);

    //             })

    //             ->where("status","!=","cancelled")

    //             ->where("status","!=","emergency cancellation")

    //             ->where("payment_status","=","C")

    //             ->get();

    //             $working_hours = "";

    //             if(count($queryBarberServicesBooking) > 0)

    //             {

    //                 $time = 0;

    //                 foreach ($queryBarberServicesBooking as $skey => $svalue)

    //                 {

    //                     $arr_time = explode(":", $svalue->duration);

    //                     $hours_to_minutes = 0;

    //                     $hours = (int)$arr_time[0];

    //                     $hours_to_minutes = $hours * 60;

    //                     $minutes = (int)$arr_time[1];

    //                     $time = $time + $minutes + $hours_to_minutes;

    //                 }

    //                 $working_hours = ((floor($time / 60)).":".($time - floor($time / 60) * 60));

    //             }

    //             $temp['ratings'] = $ratings;

    //             $temp['email'] = $this->render($barber->email);

    //             $temp['totalhours'] = $working_hours;

    //             $barbers[] = $temp;

    //         }



    //         $response['status'] = 'success';

    //         $response['barbers'] = $barbers;

    //         $response['profile_image_path'] = url('/uploads/profile_images');



    //     } catch (Exception $e) {

    //         $response['status'] = 'error';

    //         $response['message'] = $e->getMessage();

    //     }

    //     return response()->json($response);

    // }

    public function getSaloonBarbers(Request $request){

        try{

            $validator = Validator::make($request->all(), [

                'salon_id' => 'required',

                'services' => 'required',

                'saloon_service_id' => 'required'

            ]);

            if ($validator->fails()) {

                $response['status'] = 'validation_error';

                $error = $validator->errors()->toArray();

                $errMsg = '';

                foreach($error as $err){

                    $errMsg .= " ".$err[0];

                }

                $response['message'] = $errMsg;

                return response()->json($response);

            }

            $saloon_id = $request->input("salon_id");

            $service_ids = $request->input("services");



            $salon_service_ids = [];

            foreach($request->input("saloon_service_id") as $service_id)

            {

                $salon_service_ids[] = (int)$service_id;

            }

            



            $barbersList = Barbers::select('id','name','mobile','profile_image','exp_year','exp_month', 'email','created_at')->where('is_visible','Y')->where('saloon_id',$saloon_id)->get();

            $barbers = array();

            foreach($barbersList as $barber){

                $checkBarberServices = BarbersServices::where('barber_id',$barber->id)->whereIn('saloon_service_id',$salon_service_ids)->where('is_deleted',0)->count();

                if($checkBarberServices == count($salon_service_ids))

                {

                    if(count($barber->Ratings) > 0){

                        $ratings = $barber->Ratings->avg("rating");

                    }else{

                        $ratings = 0;

                    }

                    

                    $temp = $barber->toArray();

                    $temp['profile_image'] = url('/uploads/profile_images/'.$barber->profile_image);

                    // $today_earning = Bookings::where("barber_id",$barber->id)

                    //         ->whereDate("book_date",$date)

                    //         ->orderBy("book_date","desc")

                    //         ->sum("total");

                    // $temp['today_earning'] = $today_earning;



                    // $month_earning = Bookings::where("barber_id",$barber->id)

                    //         ->whereDate("book_date",">=",$month_start)

                    //         ->whereDate("book_date","<=",$month_end)

                    //         ->orderBy("book_date","desc")

                    //         ->sum("total");

                    // $temp['month_earning'] = $month_earning;

                    /*$services = BarbersServices::where("saloon_id",$saloon_id)->where("barber_id", $barber->id)->get();

                    $working_hours = "";

                    if(count($services) > 0)

                    {

                        $time = 0;

                        foreach ($services as $skey => $svalue)

                        {

                            $time_str = strtotime($svalue->duration);

                            $time += $time_str;

                        }

                        $working_hours = date("H:i",$time);

                    }*/



                    $toDate = Carbon::parse(date('Y-m-d',strtotime($barber->created_at)));

                    $fromDate = Carbon::parse(date('Y-m-d'));

            

                    $months = $toDate->diffInMonths($fromDate);



                    $totalExpMonth = $months+(int)$barber->exp_month;



                    $rem_year = $barber->exp_year;

                    $rem_month = $totalExpMonth;



                    if($totalExpMonth >= 12)

                    {

                        $rryear = (int)($totalExpMonth/12);

                        $rem_month = $totalExpMonth-($rryear*12);

                        $rem_year = $rem_year+$rryear;

                    }



                    $temp['exp_year'] = $rem_year;

                    $temp['exp_month'] = $rem_month;



                    $barber_id = $barber->id;

                    $queryBarberServicesBooking = \DB::table("bookings")->select("bookings.*","booking_items.id as itemid", "booking_items.main_service_id", "barbers_services.id as barber_service_id","barbers_services.duration")->where("bookings.barber_id","=",$barber_id)

                    ->join("booking_items","booking_items.booking_id", "=", "bookings.id")

                    // ->join("barbers_services","barbers_services.saloon_service_id", "=", "booking_items.main_service_id")

                    ->join("barbers_services", function($join) use($barber_id){

                        $join->on("barbers_services.saloon_service_id", "=", "booking_items.main_service_id")

                        ->where("barbers_services.barber_id", $barber_id);

                    })

                    ->where("status","!=","cancelled")

                    ->where("status","!=","emergency cancellation")

                    ->where("payment_status","=","C")

                    ->get();

                    $working_hours = "";

                    if(count($queryBarberServicesBooking) > 0)

                    {

                        $time = 0;

                        foreach ($queryBarberServicesBooking as $skey => $svalue)

                        {

                            $arr_time = explode(":", $svalue->duration);

                            $hours_to_minutes = 0;

                            $hours = (int)$arr_time[0];

                            $hours_to_minutes = $hours * 60;

                            $minutes = (int)$arr_time[1];

                            $time = $time + $minutes + $hours_to_minutes;

                        }

                        $working_hours = ((floor($time / 60)).":".($time - floor($time / 60) * 60));

                    }

                    $temp['ratings'] = $ratings;

                    $temp['email'] = $this->render($barber->email);

                    $temp['totalhours'] = $working_hours;

                    $barbers[] = $temp;

                }

            }



            $response['status'] = 'success';

            $response['barbers'] = $barbers;

            $response['profile_image_path'] = url('/uploads/profile_images');



        } catch (Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }

    public function Countries(Request $request){

        try{

            $countries = Countries::get();

            $response['status'] = 'success';

            $response['countries'] = $countries;

        } catch (\Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }



    public function States(Request $request){

        try{

            $country_id = 101;

            $states = States::where("country_id",$country_id)->get();

            $response['status'] = 'success';

            $response['states'] = $states;

        } catch (\Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }



    public function getSaloonDetails(Request $request){

        try{

            $saloon_id = $request->input("salon_id");

            $saloon = Saloons::with(['FirstImage','Country','Ratings','State','City','ServiceLowPrice'])->where("id",$saloon_id)->first();

            if(empty($saloon)){

                $response['status'] = 'error';

                $response['message'] = 'Salon not found';

        

                return response()->json($response);

            }

            if(count($saloon->Ratings) > 0){

                $ratings = $saloon->Ratings->avg("rating");

            }else{

                $ratings = 0;

            }

            $saloon = $saloon->toArray();

            $temp = array();

            $temp['salon_id'] = $saloon['id'];

            $temp['salon_name'] = $saloon['saloon_name'];

            $temp['salon_phone'] = $saloon['salon_phone'] == ""?"":$saloon['salon_phone'];

            $temp['open_time'] = ($saloon['open_time'] != NULL)?date("H:i",strtotime($saloon['open_time'])):'';

            $temp['close_time'] = ($saloon['close_time'] != NULL)?date("H:i",strtotime($saloon['close_time'])):'';

            $temp['salon_type'] = ($saloon['saloon_type'] != NULL)?$saloon['saloon_type']:'';

            $temp['contact_no'] =  ($saloon['mobile'] != NULL)?$saloon['mobile']:'';

            $temp['contact_person'] =  ($saloon['contact_person'] != NULL)?$saloon['contact_person']:'';

            $temp['email'] =  ($saloon['email'] != NULL)?$saloon['email']:'';

            $temp['mobile'] =  ($saloon['mobile'] != NULL)?$saloon['mobile']:'';

            $temp['street_address'] =  ($saloon['street_address'] != NULL)?$saloon['street_address']:'';

            $temp['saloon_type'] =  ($saloon['saloon_type'] != NULL)?$saloon['saloon_type']:'';

            $temp['bank_name'] =  ($saloon['bank_name'] != NULL)?$saloon['bank_name']:'';

            $temp['account_number'] =  ($saloon['account_number'] != NULL)?$saloon['account_number']:'';

            $temp['ifsc_code'] =  ($saloon['ifsc_code'] != NULL)?$saloon['ifsc_code']:'';

            $temp['upi_id'] =  ($saloon['upi_id'] != NULL)?$saloon['upi_id']:'';

            //

            $is_fav = "N";

            $customer_id = $request->input("customer_id");

            $saloon_is_fav = \DB::table("saloon_favourite")->select("id")->where("customer_id", $customer_id)->where("saloon_id", $saloon['id'])->get();

            if(count($saloon_is_fav) > 0)

            {

                $is_fav = "Y";

            }

            $temp['is_saloon_fav'] = $is_fav;           



            $temp['ratings'] = $ratings;

            $street_address = '';

            if($saloon['street_address'] != ''){

                $street_address = $saloon['street_address'];

            }

            

            $temp['street_address'] =  $street_address;

            if(!empty($saloon['owner_image'])){

                $temp['owner_image'] = url('/uploads/profile_images/'.$saloon['owner_image']);                

            }else{

                $temp['owner_image'] = '';

            }

            if(!empty($saloon['service_low_price'])){

                $temp['price'] = $saloon['service_low_price']['price'];

                if($temp['price'] > 0)

                {

                    $objSetting = new Settings();

                    $commission = $objSetting->getSetting("Commission");

                    $nprice = ($temp['price'] * $commission) / 100;

                    $nprice = $temp['price'] + $nprice;

                    $temp['price'] = $nprice;

                }

            }else{

                $temp['price'] = '';

            }

            if($saloon['instagram'] != ''){

                $temp['instagram'] = $saloon['instagram'];

            }else{

                $temp['instagram'] = '';

            }

            if($saloon['facebook'] != ''){

                $temp['facebook'] = $saloon['facebook'];

            }else{

                $temp['facebook'] = '';

            }

            if($saloon['twitter'] != ''){

                $temp['twitter'] = $saloon['twitter'];

            }else{

                $temp['twitter'] = '';

            }

            if($saloon['latitude'] != ''){

                $temp['latitude'] = $saloon['latitude'];

            }else{

                $temp['latitude'] = '';

            }

            if($saloon['logitude'] != ''){

                $temp['logitude'] = $saloon['logitude'];

            }else{

                $temp['logitude'] = '';

            }

            $temp['country_id'] = "";

            $temp['country_name'] = "";

            if($saloon['country_id'] != '')

            {

                $temp['country_id'] = $saloon['country_id'];

                $temp['country_name'] = $saloon['country']['name'];

            }

            $temp['state_id'] = "";

            $temp['state_name'] = "";

            if($saloon['state_id'] != '')

            {

                $temp['state_id'] = $saloon['state_id'];

                $temp['state_name'] = $saloon['state']['name'];

            }

            $temp['city_id'] = "";

            $temp['city_name'] = "";

            if($saloon['city_id'] != '')

            {

                $temp['city_id'] = $saloon['city_id'];

                $temp['city_name'] = $saloon['city']['name'];

            }

            $temp['address_line_2'] = "";

            if($saloon['address_line_2'] != '')

            {

                $temp['address_line_2'] = $saloon['address_line_2'];

            }

            $temp['zipcode'] = "";

            if($saloon['zipcode'] != '')

            {

                $temp['zipcode'] = $saloon['zipcode'];

            }

            $temp['youtube_url'] = "";

            if($saloon['youtube_url'] != '')

            {

                $temp['youtube_url'] = $saloon['youtube_url'];

            }



            $objSetting = new Settings();

            $commission = $objSetting->getSetting("Commission");



            $temp['commission'] = (string)$commission;



            $saloon_detail = $temp;



            $saloon_gallery = SaloonGallery::where("saloon_id",$saloon_id)->get();

            $images = array();

            foreach($saloon_gallery as $gallery)

            {

                $images[] = url('/uploads/saloon_gallery/'.$gallery->image);

            }   

            $images_saloon = array();

            foreach($saloon_gallery as $gallery)

            {

                $images_saloon[] = array(

                    "salonimageid" => (string)$gallery->id,

                    "salon_image" => url('/uploads/saloon_gallery/'.$gallery->image)

                );

            } 

            

            $saloon_id = $request->input("salon_id");

            $services = SaloonServices::where("saloon_id",$saloon_id)->where('is_deleted',0)

                                        ->distinct("service_id")

                                        ->whereHas("Saloon")

                                        ->orderBy("service_name","asc")

                                        ->orderBy("price","asc")

                                        ->get();

            if(count($services) > 0){

                foreach($services as $service){

                    $temp = array();

                    $temp['service_id'] = $service->id;

                    $temp['main_service_id'] = $service->service_id;

                    $temp['name'] = ($service->service_name != NULL)?$service->service_name:'';

                    // $temp['price'] = ($service->price != NULL)?$service->price:'';

                    if($service->price != NULL && $service->price > 0)

                    {

                        $objSetting = new Settings();

                        $commission = $objSetting->getSetting("Commission");

                        $nprice = ($service->price * $commission) / 100;

                        $nprice = $service->price + $nprice;

                        $service->price = $nprice;

                    }

                    $temp['price'] = ($service->price != NULL)?$service->price:'';

                    $temp['main_service_id'] = $service->service_id;

                    $temp['service_description'] = $service->service_description;

                    $temp['duration'] = $service->duration;

                    $saloon_services[] = $temp;

                }

            }else{

                $saloon_services = array();

            }

            $response['status'] = 'success';

            $response['salon'] = $saloon_detail;

            $response['salon_services'] = $saloon_services;

            $response['salon_gallery'] = $images;

            $response['salon_images'] = $images_saloon;

        } catch (Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }



    public function Cities(Request $request){

        try{

            $state_id = $request->input("state_id");

            $cities = Cities::where("state_id",$state_id)->get();

            $response['status'] = 'success';

            $response['cities'] = $cities;

        } catch (Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }

    public function fetchBarber(Request $request){

        try{

            $validator = Validator::make($request->all(), [

                'barber_id' => 'required',

            ]);



            if ($validator->fails()) {

                $response['status'] = 'validation_error';

                $error = $validator->errors()->toArray();

                $errMsg = array();

                foreach($error as $key => $err){

                    $errMsg[$key] = $err[0];

                }

                $response['message'] = $errMsg;

                return response()->json($response);

            }

            $barber_id = $request->input("barber_id");

            $barber = Barbers::select('id','saloon_id','name','mobile','profile_image','exp_year','exp_month')

                            ->where("id",$barber_id)

                            ->first();

            $barber->profile_image = url('/uploads/profile_images/'.$barber->profile_image);

            $response['barber'] = $barber;

            $response['status'] = 'success';



        } catch (Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }

    public function saveBarber(Request $request){

        try{

            $validator = Validator::make($request->all(), [

                'salon_id' => 'required',

                'name' => 'required',

                'email' => 'nullable|unique:barbers',

                'mobile' => 'required|unique:barbers',

                'exp_year'=>"required",

                'exp_month'=>"required",

                // 'profile_image' =>'required',

            ]);



            if ($validator->fails()) {

                $response['status'] = 'validation_error';

                $error = $validator->errors()->toArray();

                $errMsg = array();

                foreach($error as $key => $err){

                    $errMsg[$key] = $err[0];

                }

                $response['message'] = $errMsg;

                return response()->json($response);

            }

           

            $object = new Barbers();

            $object->name = $request->input("name");

            $object->email = $request->input("email");

            $object->mobile = $request->input("mobile");

            $object->exp_year = $request->input("exp_year");

            $object->exp_month = $request->input("exp_month");

            $object->saloon_id = $request->input("salon_id");

            

            if($request->input('profile_image')){

                $image_64   = base64_decode($request->input('profile_image'));

                $f          = finfo_open();

                $mime_type  = finfo_buffer($f, $image_64, FILEINFO_MIME_TYPE);  

                $extensions = explode("/",$mime_type);

                $ext        = end($extensions);

               

                $ci_fileName= time().'-'.rand(00000,99999).'.'.$ext;

                file_put_contents('uploads/profile_images/'.$ci_fileName,$image_64);    

                $object->profile_image = $ci_fileName;

            }

            $object->status = 1;    

            $object->created_by = $request->input("salon_id");

            $object->save();

            $barber_id = $object->id;



            $saloonServices = SaloonServices::select('saloon_services.service_id','saloon_services.id','saloon_services.service_description','saloon_services.price','saloon_services.duration','saloon_services.service_name')->where('saloon_id',$request->input("salon_id"))->where('is_deleted',0)->get();

            if(count($saloonServices) > 0)

            {

                foreach($saloonServices as $saloonservice)

                {

                    $object = new BarbersServices();

                    $object->saloon_id = $request->input("salon_id");

                    $object->barber_id = $barber_id;

                    $object->service_id = $saloonservice->service_id;

                    $object->saloon_service_id = $saloonservice->id;

                    $object->service_name = $saloonservice->service_name;

                    $object->service_description = $saloonservice->service_description;

                    $object->price = $saloonservice->price;

                    $object->duration = $saloonservice->duration;

                    $object->created_by = $request->input("salon_id");

                    $object->save();

                }

            }

            

            $response['status'] = 'success';

            $response['message'] = 'Barber added successfully';

        } catch (Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }



    public function updateBarber(Request $request){

        try{

            $id = $request->input("barber_id");

            $user = Barbers::find($id);

            $validator = Validator::make($request->all(), [

                'barber_id' => 'required',

                'salon_id' => 'required',

                'name' => 'required',

                'email' => 'required|email|unique:barbers,email,'.$user->id,

                'mobile' => 'required|unique:barbers,mobile,'.$user->id,

                'exp_year'=>"required",

                'exp_month'=>"required",

            ]);



            if ($validator->fails()) {

                $response['status'] = 'validation_error';

                $error = $validator->errors()->toArray();

                $errMsg = array();

                foreach($error as $key => $err){

                    $errMsg[$key] = $err[0];

                }

                $response['message'] = $errMsg;

                return response()->json($response);

            }

           

            $object = Barbers::find($id);

            $object->name = $request->input("name");

            $object->email = $request->input("email");

            $object->mobile = $request->input("mobile");

            $object->exp_year = $request->input("exp_year");

            $object->exp_month = $request->input("exp_month");

            $object->saloon_id = $request->input("salon_id");

            

            if($request->file("profile_image")){

                $image_64 = base64_decode($barber['barber_profile']);

                $f = finfo_open();

                $mime_type = finfo_buffer($f, $image_64, FILEINFO_MIME_TYPE);  

                $extensions = explode("/",$mime_type);

                $ext = end($extensions);

               

                $ci_fileName= time().'-'.rand(00000,99999).'.'.$ext;

                file_put_contents('uploads/profile_images/'.$ci_fileName,$image_64);    

                $object->profile_image = $ci_fileName;

            }

            $object->updated_by = $request->input("salon_id");

            $object->save();

            

            $response['status'] = 'success';

            $response['message'] = 'Barber updated successfully';

        } catch (Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }



    public function deleteBarber(Request $request){

        try{

            $validator = Validator::make($request->all(), [

                'barber_id' => 'required',

                'salon_id' => 'required'

            ]);

            if ($validator->fails()) {

                $response['status'] = 'validation_error';

                $error = $validator->errors()->toArray();

                $errMsg = array();

                foreach($error as $key => $err){

                    $errMsg[$key] = $err[0];

                }

                $response['message'] = $errMsg;

                return response()->json($response);

            }

            

            $barber_id = $request->input("barber_id");

            $saloon_id = $request->input("salon_id");

            $exists = Barbers::where("id",$barber_id)->count();

            if($exists == 0){

                $response['status'] = 'validation_error';

                $response['message'] = "Barber not exists";

                return response()->json($response);   

            }

            Barbers::where("id",$barber_id)->update(['deleted_by'=>$saloon_id]);

            Barbers::where("id",$barber_id)->delete();



            $response['status'] = 'success';

            $response['message'] = 'Barber deleted successfully';

        } catch (Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }



    public function filterOptions(Request $request){

        try{

            $service_id = $request->input("service_id");

            $budgets = BarbersServices::select(\DB::raw('min(price) as min_price,max(price) as max_price'))

                                    ->where("service_id",$service_id)

                                    ->first();

            $price_range = array();

            // $rating = array("1.0","2.0","3.0","4.0","5.0");

            $rating = array();

            $rating[] = array("name"=>"1");

            $rating[] = array("name"=>"2");

            $rating[] = array("name"=>"3");

            $rating[] = array("name"=>"4");

            $rating[] = array("name"=>"5");

            if(!empty($budgets)){

                $min_price = $budgets->min_price;

                $max_price = $budgets->max_price;

                if($max_price > 30){

                    $length = ceil($max_price/30);

                    $start_price = 0;

                    $end_price = 0;

                    for($i=0;$i < $length;$i++){

                        if($i == 0){

                            $start_price = round($min_price);

                            $end_price = $min_price + 30;

                        }else{

                            $start_price += 30;

                            $end_price = $start_price + 30;

                        }

                        $price_range[] = array(

                            "name" => $start_price."-".$end_price

                       );

                    }

                }

            }

            /*$saloon_types = Saloons::where("saloon_type","!=","")

                            ->groupBy("saloon_type")

                            ->pluck("saloon_type");

            if(!empty($saloon_types)){

                $saloon_types = $saloon_types->toArray();

                foreach($saloon_types as $type){

                    $valid_for[] = array("name"=>$type);

                }

            }else{

                $saloon_types = array();

            }*/

            $valid_for = array(

                0 => array("name" => "Male"),

                1 => array("name" => "Female"),

                2 => array("name" => "Unisex"),

            );



            $j = 0;

            for($i=0;$i < 10;$i++){

                $s = $j+50;

                $p = $j."-".$s;

                $j = $j+50;

                $tenp_price[] = array("name"=>$p);

            }

            $response['price_range'] = $tenp_price;

            $response['rating'] = $rating;

            $response['valid_for'] = $valid_for;

        } catch (Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }



    public function bookingList(Request $request){

        try{

            $saloon_id = $request->input("salon_id");

            $bookings = Bookings::where("saloon_id",$saloon_id)

            ->where("payment_status","=",'C')

            ->whereHas("Saloon")

            ->whereHas("Barber")

            ->whereHas("Customer")

            ->orderBy("book_date","desc")

            ->get();

            $bookingList = array();

            foreach($bookings as $booking){

                $temp = array();

                $temp['id'] = $booking->id;

                $temp['book_date'] = dateFormat($booking->book_date,"d-m-Y");

                $temp['customer_name'] = $booking->Customer->name;

                $temp['customer_id'] = $booking->customer_id;

                $temp['salon_name'] = $booking->Saloon->saloon_name;

                $temp['salon_id'] = $booking->saloon_id;

                $temp['barber_name'] = $booking->Barber->name;

                $temp['barber_id'] = $booking->barber_id;

                $temp['book_number'] = $booking->book_number;

                $temp['total_price'] = $booking->total;

                $temp['from_time'] = $booking->from_time;

                $temp['to_time'] = $booking->to_time;

                $temp['transaction_id'] = $booking->transaction_id;

                $temp['billing_name'] = $booking->billing_name;

                $temp['billing_mobile'] = $booking->billing_mobile;

                $temp['billing_email'] = $booking->billing_email;

                // $temp['cancel_user_type'] = $booking->cancel_user_type;

                // $temp['cancel_user_id'] = $booking->cancel_user_id;

                $date = $booking->book_date." ".$booking->to_time;

                $current_date = date("Y-m-d H:i:s");

                /*if($date > $current_date){

                    $temp['status'] = 'Upcoming';

                }else{

                    $temp['status'] = 'Completed';

                }*/



                if($date > $current_date)

                {

                    $temp['status'] = 'Upcoming';

                }

                if($date < $current_date && ($booking->status != "cancelled" && $booking->status != "emergency cancellation") && $booking->payment_status == "C")

                {

                    $temp['status'] = 'Completed';

                }

                if($booking->status == 'cancelled')

                {

                    $temp['status'] = 'Cancelled';

                }

                if($booking->status == 'emergency cancellation')

                {

                    $temp['status'] = 'Emergency Cancel';

                }

                if($booking->status == "requested refund")

                {

                    $temp['status'] = 'Requested Refund';

                    $refund_request_date = date("d-m-Y H:i:s", strtotime($booking->refund_request_date));

                    $temp['refund_request_date'] = $refund_request_date;

                }





                $services = array();

                $total  = 0;

                $services_array = array();

                foreach($booking->BookingItems as $i => $item){

                    $services[] = $item->SaloonService->service_name;

                    if($item->price > 0){                    

                        $total = $total + $item->price;

                    }

                    $services_array[$i]['service_name'] = $item->SaloonService->service_name;

                    $services_array[$i]['service_price'] = $item->price;

                }

                

                $temp['service_name'] = implode(",",$services);

                $temp['service_price'] = number_format($total,2);

                

                $temp['services'] = $services_array;

                $temp['action_type'] = "";

                if(!empty($booking->action_type))

                {

                    $temp['action_type'] = $booking->action_type;

                }

                

                // $booking_services = BookingItems::with('Service')->where("booking_id",$booking->id)->get();

                // $services = array();

                // foreach($booking_services as $serv){

                //     $temp['service_name'] = $serv->Service->name;

                //     $temp['service_price'] = $serv->price;

                //     $services[] = $temp;

                // }

                // $temp['services'] = $services;



                $bookingList[] = $temp;

            }

            $response['status'] = 'success';

            $response['booking_list'] = $bookingList;

        } catch (Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }





    public function salooonIncome(Request $request){

        try{

            $saloon_id = $request->input("salon_id");

            if($request->input("date")){

                $date = date("Y-m-d",strtotime($request->input("date")));    

            }else{

                $date = date("Y-m-d");

            }

            $salon = Saloons::where("id",$saloon_id)->first();

            if(empty($salon)){

                $response['status'] = 'error';

                $response['message'] = 'Salon not exists';

            

                return response()->json($response);

            }

            $today_earning = Bookings::where("saloon_id",$saloon_id)

                        ->where("status","!=",'cancelled')

                        ->where("status","!=",'emergency cancellation')

                        ->where("payment_status","=",'C')

                        ->whereRaw("(action_type != 'R' OR action_type IS NULL)")

                        ->whereDate("book_date",$date)

                        ->whereHas("Saloon")

                        ->whereHas("Barber")

                        ->whereHas("Customer")

                        ->orderBy("book_date","desc")

                        ->sum("total");

            $week_start = date( 'Y-m-d', strtotime( 'monday this week' ) );

            $week_end = date( 'Y-m-d', strtotime( 'sunday this week' ) );



            $week_earning = Bookings::where("saloon_id",$saloon_id)

                        ->where("status","!=",'cancelled')

                        ->where("status","!=",'emergency cancellation')

                        ->where("payment_status","=",'C')

                        ->whereRaw("(action_type != 'R' OR action_type IS NULL)")

                        ->whereDate("book_date",">=",$week_start)

                        ->whereDate("book_date","<=",$week_end)

                        ->whereHas("Saloon")

                        ->whereHas("Barber")

                        ->whereHas("Customer")

                        ->orderBy("book_date","desc")

                        ->sum("total");



            $month_start = date('Y-m-d',strtotime('first day of this month'));

            $month_end = date('Y-m-d',strtotime('last day of this month'));



            $month_earning = Bookings::where("saloon_id",$saloon_id)

                        ->where("status","!=",'cancelled')  

                        ->where("status","!=",'emergency cancellation')

                        ->where("payment_status","=",'C')

                        ->whereRaw("(action_type != 'R' OR action_type IS NULL)")

                        ->whereDate("book_date",">=",$month_start)

                        ->whereDate("book_date","<=",$month_end)

                        ->whereHas("Saloon")

                        ->whereHas("Barber")

                        ->whereHas("Customer")

                        ->orderBy("book_date","desc")

                        ->sum("total");



            $year_start = date('Y-m-d',strtotime('first day of January '));

            $year_end = date('Y-m-d',strtotime('last day of December'));



            $year_earning = Bookings::where("saloon_id",$saloon_id)

                        ->where("status","!=",'cancelled')

                        ->where("status","!=",'emergency cancellation')

                        ->where("payment_status","=",'C')

                        ->whereRaw("(action_type != 'R' OR action_type IS NULL)")

                        ->whereDate("book_date",">=",$year_start)

                        ->whereDate("book_date","<=",$year_end)

                        ->whereHas("Saloon")

                        ->whereHas("Barber")

                        ->whereHas("Customer")

                        ->orderBy("book_date","desc")

                        ->sum("total");



            $total_earning = Bookings::where("saloon_id",$saloon_id)

            ->where("status","!=",'cancelled') 

            ->where("status","!=",'emergency cancellation') 

            ->where("payment_status","=",'C')

            ->whereRaw("(action_type != 'R' OR action_type IS NULL)")

            ->whereHas("Saloon")

            ->whereHas("Barber")

            ->whereHas("Customer")

            ->orderBy("book_date","desc")

            ->sum("total");

            //

            $earnings = array("today_earning"=>$today_earning,"week_earning"=>$week_earning,"month_earning"=>$month_earning,"year_earning"=>$year_earning, "total_earning" => $total_earning,"registration_date"=>date('F d, Y',strtotime($salon->created_at)));

            //

            // echo date("Y-m-d H:i:s");

            $today_tillnow_payments = Bookings::where("saloon_id",$saloon_id)

            ->where("status","!=",'cancelled') 

            ->where("status","!=",'emergency cancellation') 

            ->where("payment_status","=",'C')

            ->whereRaw("(action_type != 'R' OR action_type IS NULL)")

            // ->where("book_date","=",date("Y-m-d"))  

            // ->where("to_time","<=",date("H:i"))  

            // ->whereRaw("concat(book_date,' ',to_time) <= '".date("Y-m-d H:i")."'")

            ->where('book_date',date('Y-m-d'))

            ->where('to_time','<=',date('H:i'))

            ->whereHas("Saloon")

            ->whereHas("Barber")

            ->whereHas("Customer")

            ->orderBy("book_date","desc")

            ->sum("total");



            $today_upcomming_payments = Bookings::where("saloon_id",$saloon_id)

            ->where("status","!=",'cancelled') 

            ->where("status","!=",'emergency cancellation') 

            ->where("payment_status","=",'C')

            ->whereRaw("(action_type != 'R' OR action_type IS NULL)")

            // ->where("book_date","=",date("Y-m-d"))  

            // ->where("to_time","<=",date("H:i"))  

            // ->whereRaw("concat(book_date,' ',to_time) <= '".date("Y-m-d H:i")."'")

            ->where('book_date',date('Y-m-d'))

            ->where('to_time','>=',date('H:i'))

            ->whereHas("Saloon")

            ->whereHas("Barber")

            ->whereHas("Customer")

            ->orderBy("book_date","desc")

            ->sum("total");

            //

            $upcoming_payments = Bookings::where("saloon_id",$saloon_id)

            ->where("status","!=",'cancelled')  

            ->where("status","!=",'emergency cancellation')

            ->where("payment_status","=",'C')

            ->whereRaw("(action_type != 'R' OR action_type IS NULL)")

            // ->where("book_date",">=",date("Y-m-d"))  

            // ->where("from_time",">",date("H:i"))  

            ->whereRaw("concat(book_date,' ',from_time) >= '".date("Y-m-d H:i")."'")

            ->whereHas("Saloon")

            ->whereHas("Barber")

            ->whereHas("Customer")

            ->orderBy("book_date","desc")

            ->sum("total");

            // ->dd();

            //

            $yesterday_payments = SaloonPayments::where("saloon_id",$saloon_id)

            ->where("is_active", 1)

            ->where("is_deleted", 0)

            ->where("payment_date","=", date("Y-m-d", strtotime("-1 day")))

            ->with("Saloon")

            ->get();

            $yesterday_amount = 0;

            if(count($yesterday_payments) > 0)

            {

                $yesterday_amount = $yesterday_payments[0]->amount;

            }

            $payments = array(

                "today_payment" => $today_tillnow_payments,

                "today_upcoming_payment" => $today_upcomming_payments,

                "upcoming_payment" => $upcoming_payments, 

                "yesterday_payment" => $yesterday_amount

            );



            $barbers = Barbers::select('id','name','mobile','profile_image','show_earning','is_visible','manage_barber')->where('saloon_id',$saloon_id)->get();



            $barber_income = array();

            foreach($barbers as $barber)

            {

                /*$services = BarbersServices::where("saloon_id",$saloon_id)->where("barber_id", $barber->id)->get();

                $working_hours = "";

                if(count($services) > 0)

                {

                    $time = 0;

                    foreach ($services as $skey => $svalue)

                    {

                        $time_str = strtotime($svalue->duration);

                        $time += $time_str;

                    }

                    $working_hours = date("H:i",$time);

                }*/

                $barber_id = $barber->id;

                $queryBarberServicesBooking = \DB::table("bookings")->select("bookings.*","booking_items.id as itemid", "booking_items.main_service_id", "barbers_services.id as barber_service_id","barbers_services.duration")->where("bookings.barber_id","=",$barber_id)

                ->join("booking_items","booking_items.booking_id", "=", "bookings.id")

                ->join("barbers_services", function($join) use($barber_id){

                    $join->on("barbers_services.saloon_service_id", "=", "booking_items.main_service_id")

                    ->where("barbers_services.barber_id", $barber_id);

                })

                ->where("status","!=","cancelled")

                ->where("status","!=","emergency cancellation")

                ->where("payment_status","=","C")

                ->get();

                $working_hours = "";

                if(count($queryBarberServicesBooking) > 0)

                {

                    $time = 0;

                    foreach ($queryBarberServicesBooking as $skey => $svalue)

                    {

                        $arr_time = explode(":", $svalue->duration);

                        $hours_to_minutes = 0;

                        $hours = (int)$arr_time[0];

                        $hours_to_minutes = $hours * 60;

                        $minutes = (int)$arr_time[1];

                        $time = $time + $minutes + $hours_to_minutes;

                    }

                    $working_hours = ((floor($time / 60)).":".($time - floor($time / 60) * 60));

                }

                if(count($barber->Ratings) > 0)

                {

                    $ratings = $barber->Ratings->avg("rating");

                }

                else

                {

                    $ratings = 0;

                }

                $temp = $barber->toArray();

                $temp['profile_image'] = url('/uploads/profile_images/'.$barber->profile_image);

                $temp['show_earning'] = $barber->show_earning;

                $temp['is_visible'] = $barber->is_visible;

                $temp['manage_barber'] = $barber->manage_barber;

                $today_earning = Bookings::where("barber_id",$barber->id)

                        ->where("status","!=",'cancelled')  

                        ->where("status","!=",'emergency cancellation')

                        ->where("payment_status","=",'C')

                        ->whereRaw("(action_type != 'R' OR action_type IS NULL)")

                        ->whereDate("book_date",$date)

                        ->whereHas("Saloon")

                        ->whereHas("Barber")

                        ->whereHas("Customer")

                        ->orderBy("book_date","desc")

                        ->sum("total");

                $temp['today_earning'] = $today_earning;



                $month_earning = Bookings::where("barber_id",$barber->id)

                        ->where("status","!=",'cancelled')  

                        ->where("status","!=",'emergency cancellation')

                        ->where("payment_status","=",'C')

                        ->whereRaw("(action_type != 'R' OR action_type IS NULL)")

                        ->whereDate("book_date",">=",$month_start)

                        ->whereDate("book_date","<=",$month_end)

                        ->whereHas("Saloon")

                        ->whereHas("Barber")

                        ->whereHas("Customer")

                        ->orderBy("book_date","desc")

                        ->sum("total");

                $temp['month_earning'] = $month_earning;

                //

                $week_start = date( 'Y-m-d', strtotime( 'monday this week' ) );

                $week_end = date( 'Y-m-d', strtotime( 'sunday this week' ) );

                $weekly_earning = Bookings::where("barber_id",$barber->id)

                        ->where("status","!=",'cancelled')  

                        ->where("status","!=",'emergency cancellation')

                        ->where("payment_status","=",'C')

                        ->whereRaw("(action_type != 'R' OR action_type IS NULL)")

                        ->whereDate("book_date",">=",$week_start)

                        ->whereDate("book_date","<=",$week_end)

                        ->whereHas("Saloon")

                        ->whereHas("Barber")

                        ->whereHas("Customer")

                        ->orderBy("book_date","desc")

                        ->sum("total");

                $temp['week_earning'] = $weekly_earning;

                //

                $year_start = date('Y-m-d',strtotime('first day of January '));

                $year_end = date('Y-m-d',strtotime('last day of December'));

                $yearly_earning = Bookings::where("barber_id",$barber->id)

                        ->where("status","!=",'cancelled')  

                        ->where("status","!=",'emergency cancellation')

                        ->where("payment_status","=",'C')

                        ->whereRaw("(action_type != 'R' OR action_type IS NULL)")

                        ->whereDate("book_date",">=",$year_start)

                        ->whereDate("book_date","<=",$year_end)

                        ->whereHas("Saloon")

                        ->whereHas("Barber")

                        ->whereHas("Customer")

                        ->orderBy("book_date","desc")

                        ->sum("total");

                $temp['year_earning'] = $yearly_earning;

                //

                $temp['ratings'] = $ratings;

                $temp['working_hours'] = $working_hours;

                $barber_income[] = $temp;

            }

            $response['earnings'] = $earnings;

            $response['barbers'] = $barber_income;

            $response['payments'] = $payments;

            $response['status'] = 'success';

        } catch (Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }



    public function deleteBooking(Request $request){

        // try{

        //     $booking_id = $request->input("booking_id");

        //     Bookings::where("id",$booking_id)->delete();

        //     BookingItems::where("booking_id",$booking_id)->delete();

        //     $response['status'] = 'success';

        //     $response['message'] = "Booking deleted successfully";

        // } catch (Exception $e) {

        //     $response['status'] = 'error';

        //     $response['message'] = $e->getMessage();

        // }

        // return response()->json($response);

        //  try{

            $booking_id = $request->input("booking_id");

            $booking = Bookings::where("id",$booking_id)->first();

            if(empty($booking))

            {

                $response['status'] = 'error';

                $response['message'] = "Booking not found";

                return response()->json($response);

            }

            $booking_date = $booking->book_date." ".$booking->from_time;

            $start_date = date("Y-m-d H:i:s",strtotime($booking_date));

           

            $current_date = date("Y-m-d H:i:s");

            if($current_date > $start_date){

                $response['status'] = 'error';

                $response['message'] = 'Not allowed to cancel booking';

                return response()->json($response);

            }

            $start = strtotime($current_date);

            $end = strtotime($start_date);

            $mins = ($end - $start) / 60;

            

            if($mins < 120){

                $response['status'] = 'error';

                $response['message'] = 'Cannot cancel booking. Bookings can only be cancelled before 2hrs of booking time';

                return response()->json($response);

            }

            $settings_razorpay_keyid = \DB::table("settings")

            ->select("setting_value")

            ->where("setting_title","=","Razorpay Keyid")

            ->get();

            $setting_razorpaykeyid = $settings_razorpay_keyid[0]->setting_value;

            //

            $settings_razorpay_secret = \DB::table("settings")

            ->select("setting_value")

            ->where("setting_title","=","Razorpay Secret")

            ->get();

            $setting_razorpaysecret = $settings_razorpay_secret[0]->setting_value;



            $bookingUpdate = array('status'=>'cancelled','cancelled_at'=>date("Y-m-d H:i:s"));

            if(!empty($booking->transaction_id))

            {

                $api = new Api($setting_razorpaykeyid, $setting_razorpaysecret);

                $rzpRes = $api->payment->fetch($booking->transaction_id)->refund(array('reverse_all'=>'1'));

                if(isset($rzpRes->id))

                {

                    $bookingUpdate['rzp_refund_id'] = $rzpRes->id;



                }

            }

            Bookings::where("id",$booking_id)->update($bookingUpdate);

            //

            $objectBooking = Bookings::where("id",$request->input('booking_id'))

            ->with("Saloon")

            ->with("Customer")

            ->with("Barber")

            ->get();

            // echo $objectBooking[0]->id; exit;

            $booking_services = BookingItems::with('Service')->with('SaloonService')->where("booking_id",$objectBooking[0]->id)->get();

            $servicesname = array();

            foreach($booking_services as $serv)

            {

                $servicesname[] = ((!empty($serv->SaloonService->service_name))?$serv->SaloonService->service_name:'');

            }

            $arr_email = array();

            $arr_sms = array();

            $arr_push = array();

            if(count($objectBooking) > 0)

            {

                if(isset($objectBooking[0]->Customer))

                {

                    $customer_id = $objectBooking[0]->Customer->id;

                    $customer_name = $objectBooking[0]->Customer->name;

                    $customer_devicetype = $objectBooking[0]->Customer->devicetype;

                    $customer_devicetoken = $objectBooking[0]->Customer->devicetoken;

                    //

                    $saloon_id = $objectBooking[0]->Saloon->id;

                    $saloon_name = $objectBooking[0]->Saloon->saloon_name;

                    // Get read unread notifiction count

                    $notificationReadInfo = Notification::select('id','fromid','toid','referenceid', 'notification_type', 'message', 'isread', 'created_at')

                    ->where("notification.toid", $customer_id)

                    ->where("notification.isread", "Y")

                    ->where("notification.is_deleted", 0)

                    ->get();

                    $readCount = $notificationReadInfo->count();

                    $notificationUnreadInfo = Notification::select('id','fromid','toid','referenceid', 'notification_type', 'message', 'isread', 'created_at')

                    ->where("notification.toid", $customer_id)

                    ->where("notification.isread", "N")

                    ->where("notification.is_deleted", 0)

                    ->get();

                    $unreadCount = $notificationUnreadInfo->count();

                    //

                    $book_id = $objectBooking[0]->id;

                    $date = date('d-m-Y',strtotime($objectBooking[0]->book_date));

                    $startTime = date('h:i A',strtotime($objectBooking[0]->from_time));

                    $endTime = $objectBooking[0]->to_time;

                    $serviceName = implode(",", $servicesname);

                    if($objectBooking[0]->book_date == date('Y-m-d'))

                    {

                        $date = "Today";

                    }

                    else if($objectBooking[0]->book_date == date('Y-m-d',strtotime('+1 day')))

                    {

                        $date = "Tomorrow";

                    }

                    else

                    {

                        $date = "on ".date('jS M, l',strtotime($objectBooking[0]->book_date));

                    }

                    $message = "Booking cancelled for ".$serviceName." at ".$saloon_name." ".$date." at ".$startTime;

                    // echo $message; exit;

                    $arr_push = array();

                    $android_recepient = array();

                    $android_recepient[] = $customer_devicetoken;

                    $additionalData = array(

                        'notificationType' => 'booking',

                        'customerid' => $customer_id,

                        'read' => $readCount,

                        'unread' => $unreadCount,

                    );

                    $arr_push = array(

                        "devicetype" => $customer_devicetype, 

                        "registatoin_ids" => $android_recepient,

                        "message" => $message,

                        "additionalData" => $additionalData

                    );

                    $notification = new Notification();

                    $notification->sendAllNotification($arr_email, $arr_sms, $arr_push);

                    //

                    $notificationsave = new Notification();

                    $notificationsave->fromid = $saloon_id;

                    $notificationsave->toid = $customer_id;

                    $notificationsave->referenceid = $book_id;

                    $notificationsave->notification_type = "Booking";

                    $notificationsave->message = $message;

                    $notificationsave->isread = "N";

                    $notificationsave->created_at = date("Y-m-d H:i:s");

                    $notificationsave->notification_for = "C";

                    $notificationsave->save();

                    $notificationId = $notificationsave->id;

                    //

                }

                if(isset($objectBooking[0]->Barber))

                {

                    // Barber Notification

                    $arr_email = array();

                    $arr_sms = array();

                    $arr_push = array();

                    $barber_id = $objectBooking[0]->Barber->id;

                    $barber_name = $objectBooking[0]->Barber->name;

                    $barber_devicetype = $objectBooking[0]->Barber->devicetype;

                    $barber_devicetoken = $objectBooking[0]->Barber->devicetoken;

                    // Get barber read unread notifiction count

                    $notificationReadInfo = Notification::select('id','fromid','toid','referenceid', 'notification_type', 'message', 'isread', 'created_at')

                    ->where("notification.toid", $barber_id)

                    ->where("notification.isread", "Y")

                    ->where("notification.is_deleted", 0)

                    ->get();

                    $readCount = $notificationReadInfo->count();

                    $notificationUnreadInfo = Notification::select('id','fromid','toid','referenceid', 'notification_type', 'message', 'isread', 'created_at')

                    ->where("notification.toid", $barber_id)

                    ->where("notification.isread", "N")

                    ->where("notification.is_deleted", 0)

                    ->get();

                    $unreadCount = $notificationUnreadInfo->count();

                    //



                    $book_id = $objectBooking[0]->id;

                    $date = date('d-m-Y',strtotime($objectBooking[0]->book_date));

                    $startTime = date('h:i A',strtotime($objectBooking[0]->from_time));

                    $endTime = $objectBooking[0]->to_time;

                    $serviceName = implode(",", $servicesname);

                    if($objectBooking[0]->book_date == date('Y-m-d'))

                    {

                        $date = "Today";

                    }

                    else if($objectBooking[0]->book_date == date('Y-m-d',strtotime('+1 day')))

                    {

                        $date = "Tomorrow";

                    }

                    else

                    {

                        $date = date('jS M l',strtotime($objectBooking[0]->book_date));

                    }

                    $message = "Your booking for ".$serviceName." at ".$startTime." ".$date." is cancelled by the customer";



                    $arr_push = array();

                    $android_recepient = array();

                    $android_recepient[] = $barber_devicetoken;         

                    $additionalData = array(

                        'notificationType' => 'booking',

                        'customerid' => $barber_id,

                        'read' => $readCount,

                        'unread' => $unreadCount,

                    );

                    $arr_push = array(

                        "devicetype" => $barber_devicetype, 

                        "registatoin_ids" => $android_recepient,

                        "message" => $message,

                        "additionalData" => $additionalData

                    );

                    // echo "<br/>Push<pre>";

                    // print_r($arr_push);

                    // echo "</pre>";

                    // exit;

                    $notification = new Notification();

                    $notification->sendAllBarberNotification($arr_email, $arr_sms, $arr_push);

                    //

                    $barbernotificationsave = new Notification();

                    $barbernotificationsave->fromid = $saloon_id;

                    $barbernotificationsave->toid = $barber_id;

                    $barbernotificationsave->referenceid = $book_id;

                    $barbernotificationsave->notification_type = "Booking";

                    $barbernotificationsave->message = $message;

                    $barbernotificationsave->isread = "N";

                    $barbernotificationsave->created_at = date("Y-m-d H:i:s");

                    $barbernotificationsave->notification_for = "B";

                    $barbernotificationsave->save();

                    $barberNotificationId = $notificationsave->id;

                    //

                }

            }

            $response['status'] = 'success';

            $response['message'] = "Booking cancelled successfully";

        // } catch (\Exception $e) {

        //     $response['status'] = 'error';

        //     $response['message'] = $e->getMessage();

        // }

        return response()->json($response);

    }



    public function editService(Request $request){

        try{

            $validator = Validator::make($request->all(), [

                'id' => 'required',

                'service_name' => 'required',

                // 'service_description' => 'required',

                // 'hours'=>"required",

                // 'minutes'=>"required",

                'price'=>"required",

                'salon_id'=>"required",

            ]);



            if ($validator->fails()) {

                $response['status'] = 'validation_error';

                $error = $validator->errors()->toArray();

                $errMsg = array();

                foreach($error as $key => $err){

                    $errMsg[$key] = $err[0];

                }

                $response['message'] = $errMsg;

                return response()->json($response);

            }

            $id = $request->input("id");

            $saloon_id = $request->input("salon_id");



            $object= SaloonServices::find($id);

            $object->saloon_id = $saloon_id;

            $object->service_name = $request->input('service_name');

            $object->service_description = $request->input('service_description');

            $object->service_id = $request->input('service_id');

            $object->duration = $request->input('hours').":".$request->input('minutes');

            $object->price = $request->input('price');

            $object->created_by = $saloon_id;

            $object->save();

            $response['status'] = 'success';

            $response['message'] = "Service edited successfully";

        } catch (Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }



    public function deleteService(Request $request){

        try{

            $booking_id = $request->input("id");

            // SaloonServices::where("id",$booking_id)->delete();

            SaloonServices::where("id",$booking_id)->update(['is_deleted'=>1,'deleted_at'=>date('Y-m-d H:i:s')]);

            $response['status'] = 'success';

            $response['message'] = "Service deleted successfully";

        } catch (\Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }



    public function addSalonCategory(Request $request){

        try{

            $validator = Validator::make($request->all(), [

                'name' => 'required',

                'saloon_id' => 'required',

                'parentid'=>"required",

                'gender'=>"required",

            ]);



            if ($validator->fails()) {

                $response['status'] = 'validation_error';

                $error = $validator->errors()->toArray();

                $errMsg = array();

                foreach($error as $key => $err){

                    $errMsg[$key] = $err[0];

                }

                $response['message'] = $errMsg;

                return response()->json($response);

            }

            $name = $request->input("name");

            $saloon_id = $request->input("saloon_id");

            $parentid = $request->parentid;

            $gender = $request->gender;



            $object= new SaloonCategory();

            $object->saloon_id = $saloon_id;

            $object->name = $name;

            $object->parentid = $parentid;

            $object->gender = $gender;

            $object->save();

            $response['status'] = 'success';

            $response['message'] = "Category added successfully";

        } catch (Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }

    

    public function editSalonCategory(Request $request){

        try{

            $validator = Validator::make($request->all(), [

                'id' => 'required',

                'name' => 'required',

                'saloon_id' => 'required',

                'parentid'=>"required",

                'gender'=>"required",

            ]);



            if ($validator->fails()) {

                $response['status'] = 'validation_error';

                $error = $validator->errors()->toArray();

                $errMsg = array();

                foreach($error as $key => $err){

                    $errMsg[$key] = $err[0];

                }

                $response['message'] = $errMsg;

                return response()->json($response);

            }

            $id = $request->id;

            $name = $request->input("name");

            $saloon_id = $request->input("saloon_id");

            $parentid = $request->parentid;

            $gender = $request->gender;



            $object= SaloonCategory::find($id);

            $object->saloon_id = $saloon_id;

            $object->name = $name;

            $object->parentid = $parentid;

            $object->gender = $gender;

            $object->save();

            $response['status'] = 'success';

            $response['message'] = "Category edited successfully";

        } catch (Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }



    public function deleteSalonCategory(Request $request){

        try{

            $id = $request->input("id");

            // SaloonServices::where("id",$booking_id)->delete();

            SaloonCategory::where("id",$id)->update(['is_deleted'=>1]);

            $response['status'] = 'success';

            $response['message'] = "Category deleted successfully";

        } catch (\Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }





    public function getSalonCategory(Request $request){

        try{

            $validator = Validator::make($request->all(), [

                'saloon_id' => 'required',

                'parentid'=>"required",

                'gender'=>"required",

            ]);



            if ($validator->fails()) {

                $response['status'] = 'validation_error';

                $error = $validator->errors()->toArray();

                $errMsg = array();

                foreach($error as $key => $err){

                    $errMsg[$key] = $err[0];

                }

                $response['message'] = $errMsg;

                return response()->json($response);

            }



            $categorydata = array();



            $categoryRes = SaloonCategory::where('saloon_id',$request->saloon_id)->where('parentid',$request->parentid)->where('gender',$request->gender)->where('is_deleted',0)->get();

            if(count($categoryRes) > 0)

            {

                foreach($categoryRes as $category)

                {

                    $categorydata[] = array(

                        'id'=>(string)$category->id,

                        'name'=>$category->name,

                        'parentid'=>(string)$category->parentid,

                        'gender'=>$category->gender

                    );

                }

            }



            $response['data'] = $categorydata;

            $response['status'] = 'success';

            $response['message'] = "Success";



        } catch (\Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }





    public function render($value)

    {

        if($value === null)

        {

            $value = '';

        }

        return $value;

    }



    public function getMyFavouriteSaloon(Request $request){

        try{

            $validator = Validator::make($request->all(), [

                'customer_id' => 'required'

            ]);

            if ($validator->fails()) {

                $response['status'] = 'validation_error';

                $error = $validator->errors()->toArray();

                $errMsg = '';

                foreach($error as $err){

                    $errMsg .= " ".$err[0];

                }

                $response['message'] = $errMsg;

                return response()->json($response);

            }

            $customer_id = $request->input("customer_id");

            $saloon_ids = SaloonFavourites::with('Saloon')

            ->where("customer_id",$customer_id)

            ->whereHas("Saloon")

            ->groupBy("saloon_id")

            ->pluck('saloon_id');



            if(count($saloon_ids) > 0){ 

                $saloon_ids = $saloon_ids->toArray();

            }else{

                $saloon_ids = array();

            }

            $rating = array();

            $saloonsList = Saloons::select(DB::raw("*"))

            ->with(["FirstImage","Ratings"])

            ->where(function($query) use ($rating) {

                if(count($rating) > 0){

                    $query->whereHas('Ratings',function($q) use($rating){

                      $q->whereIn("rating",$rating);  

                    });

                }

            })

            ->whereIn("id",$saloon_ids)

            ->where("status",'1')

            ->get();

            //

            // echo "<pre>";

            // print_r($saloonsList[0]->Ratings);

            // echo "</pre>";

            // echo "<pre>";

            // print_r($saloonsList);

            // echo "</pre>";

            // exit;



            $saloons = array();

            foreach($saloonsList  as $saloon){

                $ratings = 0;

                // echo collect($saloon['ratings'])->avg();

                if(count($saloon->Ratings) > 0){

                    $ratings = $saloon->Ratings->avg("rating");

                }else{

                    $ratings = "0";

                }

                // echo $ratings;

                // echo "<pre>";

                // print_r($saloon);

                // echo "</pre>";

                // exit;

                $saloon = $saloon->toArray();

                $temp['salon_id'] = (string)$saloon['id'];

                $temp['salon_name'] = $saloon['saloon_name'];

                $temp['open_time'] = ($saloon['open_time'] != NULL)?date("H:i",strtotime($saloon['open_time'])):'';

                $temp['close_time'] = ($saloon['close_time'] != NULL)?date("H:i",strtotime($saloon['close_time'])):'';

                $temp['salon_type'] = ($saloon['saloon_type'] != NULL)?$saloon['saloon_type']:'';

                $temp['latitude'] = ($saloon['latitude'] != NULL)?$saloon['latitude']:'';

                $temp['logitude'] = ($saloon['logitude'] != NULL)?$saloon['logitude']:'';

                $temp['ratings'] = $ratings;

                $street_address = '';

                if($saloon['street_address'] != ''){

                    $street_address = $saloon['street_address'];

                }

                $temp['street_address'] =  $street_address;

                if(!empty($saloon['first_image'])){

                    $temp['image'] = url('/uploads/saloon_gallery/'.$saloon['first_image']['image']);                

                }else{

                    $temp['image'] = '';

                }

                $saloons[] = $temp;

            }

            $response['status'] = 'success';

            $response['salons'] = $saloons;

        } catch (Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }



    public function checkSaloonNumber(Request $request)

    {

        try{

            $validator = Validator::make($request->all(), [

                'mobile' => 'required'

            ]);

            if ($validator->fails()) {

                $response['status'] = 'validation_error';

                $error = $validator->errors()->toArray();

                $errMsg = '';

                foreach($error as $err){

                    $errMsg .= " ".$err[0];

                }

                $response['message'] = $errMsg;

                return response()->json($response);

            }

            $saloon_mobile = $request->input("mobile");

            $saloonsList = Saloons::select("id")

            ->where("mobile", $saloon_mobile)

            ->where("status",'1')

            ->get();

            if(count($saloonsList) > 0)

            {

                $response['status'] = 'error';

                $response['message'] = "Mobile number found";

            }

            else

            {

                $response['status'] = 'success';

                $response['message'] = "Mobile number not found";

            }

        } catch (Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }



    public function getServicesBySaloon(Request $request){

        try{

            $validator = Validator::make($request->all(), [

                'salon_id' => 'required'

            ]);

            if ($validator->fails()) {

                $response['status'] = 'validation_error';

                $error = $validator->errors()->toArray();

                $errMsg = '';

                foreach($error as $err){

                    $errMsg .= " ".$err[0];

                }

                $response['message'] = $errMsg;

                return response()->json($response);

            }

            $saloon_id = $request->input("salon_id");

            $services = SaloonServices::where("saloon_id",$saloon_id)

            ->where(function($q1) use($request){
                if($request->category_id >= 0)
                {
                    $q1->where('category_id',$request->category_id);
                }

                if(!empty($request->gender))
                {
                    $q1->where('gender',$request->gender);
                }
            })
            
            ->where('is_deleted',0)

            ->with("Service")

            ->distinct("service_id")

            ->orderBy("service_name","asc")

            ->orderBy("price","asc")

            ->get();

            // echo "<pre>";

            // print_r($services[1]['Service']['name']);

            // echo "</pre>";

            // exit;

            if(count($services) > 0){

                foreach($services as $service){

                    $service_category_id = "";

                    $service_category = "";

                    if(isset($service['Service']))

                    {

                        $service_category_id = (string)$service['Service']->id;

                        $service_category = $service['Service']->name;

                    }

                    $hours = "";

                    $minutes = "";

                    $duration = explode(":", $service->duration);

                    $hours = $duration[0];

                    $minutes = $duration[1];

                    //

                    $temp['id'] = $service->id;

                    $temp['name'] = $service->service_name;

                    $temp['service_id'] = $service_category_id;

                    $temp['service_name'] = $service_category;

                    $temp['description'] = $service->service_description;

                    $temp['price'] = $service->price;

                    $temp['duration'] = $service->duration;

                    $temp['hours'] = $hours;

                    $temp['minutes'] = $minutes;

                    $saloon_services[] = $temp;

                }

            }else{

                $saloon_services = array();

            }

            

            $response['status'] = 'success';

            $response['salon_services'] = $saloon_services;

        } catch (\Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }



    public function deleteBookingEmergency(Request $request)

    {

         try{

            $validator = Validator::make($request->all(), [

                'booking_id' => 'required',

                'user_type' => 'required',

                'user_id' => 'required',

            ]);

            if ($validator->fails()) {

                $response['status'] = 'validation_error';

                $error = $validator->errors()->toArray();

                $errMsg = '';

                foreach($error as $err){

                    $errMsg .= " ".$err[0];

                }

                $response['message'] = $errMsg;

                return response()->json($response);

            }

            $booking_id = $request->input("booking_id");

            $booking = Bookings::where("id",$booking_id)->first();

            $booking_date = $booking->book_date." ".$booking->from_time;

            $start_date = date("Y-m-d H:i:s",strtotime($booking_date));           

            $current_date = date("Y-m-d H:i:s");

            if($current_date > $start_date)

            {

                $response['status'] = 'error';

                $response['message'] = 'Not allowed to cancel booking';

                return response()->json($response);

            }

            $start = strtotime($current_date);

            $end = strtotime($start_date);

            $mins = ($end - $start) / 60;

            

            // if($mins < 120)

            // {

            //     $response['status'] = 'error';

            //     $response['message'] = 'Cannot cancel booking. Bookings can only be cancelled before 2hrs of booking time';

            //     return response()->json($response);

            // }

            

            Bookings::where("id",$booking_id)->update(['status'=>'emergency cancellation','cancelled_at'=>date("Y-m-d H:i:s"),'cancel_user_type'=>$request->input('user_type'),'cancel_user_id'=>$request->input('user_id')]);

            //

            $objectBooking = Bookings::where("id",$request->input('booking_id'))

            ->with("Saloon")

            ->with("Customer")

            ->with("Barber")

            ->get();

            // echo $objectBooking[0]->id; exit;

            $booking_services = BookingItems::with('Service')->with('SaloonService')->where("booking_id",$objectBooking[0]->id)->get();

            $servicesname = array();

            foreach($booking_services as $serv)

            {

                $servicesname[] = ((!empty($serv->SaloonService->service_name))?$serv->SaloonService->service_name:'');

            }

            $arr_email = array();

            $arr_sms = array();

            $arr_push = array();

            if(count($objectBooking) > 0)

            {

                if(isset($objectBooking[0]->Customer))

                {

                    $customer_id = $objectBooking[0]->Customer->id;

                    $customer_name = $objectBooking[0]->Customer->name;

                    $customer_devicetype = $objectBooking[0]->Customer->devicetype;

                    $customer_devicetoken = $objectBooking[0]->Customer->devicetoken;

                    //

                    $saloon_id = $objectBooking[0]->Saloon->id;

                    $saloon_name = $objectBooking[0]->Saloon->saloon_name;

                    // Get read unread notifiction count

                    $notificationReadInfo = Notification::select('id','fromid','toid','referenceid', 'notification_type', 'message', 'isread', 'created_at')

                    ->where("notification.toid", $customer_id)

                    ->where("notification.isread", "Y")

                    ->where("notification.is_deleted", 0)

                    ->get();

                    $readCount = $notificationReadInfo->count();

                    $notificationUnreadInfo = Notification::select('id','fromid','toid','referenceid', 'notification_type', 'message', 'isread', 'created_at')

                    ->where("notification.toid", $customer_id)

                    ->where("notification.isread", "N")

                    ->where("notification.is_deleted", 0)

                    ->get();

                    $unreadCount = $notificationUnreadInfo->count();

                    //

                    $book_id = $objectBooking[0]->id;

                    $date = date('d-m-Y',strtotime($objectBooking[0]->book_date));

                    $startTime = date('h:i A',strtotime($objectBooking[0]->from_time));

                    $endTime = $objectBooking[0]->to_time;

                    $serviceName = implode(",", $servicesname);

                    if($objectBooking[0]->book_date == date('Y-m-d'))

                    {

                        $date = "Today";

                    }

                    else if($objectBooking[0]->book_date == date('Y-m-d',strtotime('+1 day')))

                    {

                        $date = "Tomorrow";

                    }

                    else

                    {

                        $date = "on ".date('jS M, l',strtotime($objectBooking[0]->book_date));

                    }

                    $message = 'Barber had some emergency due to which they had to cancel your booking for '.$serviceName.' at '.$saloon_name.' '.$date.' at '.$startTime.'. We regret this deeply. However, you can reschedule this booking or request a refund from the bookings page.';

                    // echo $message; exit;

                    $arr_push = array();

                    $android_recepient = array();

                    $android_recepient[] = $customer_devicetoken;

                    $additionalData = array(

                        'notificationType' => 'booking',

                        'customerid' => $customer_id,

                        'read' => $readCount,

                        'unread' => $unreadCount,

                    );

                    $arr_push = array(

                        "devicetype" => $customer_devicetype, 

                        "registatoin_ids" => $android_recepient,

                        "message" => $message,

                        "additionalData" => $additionalData

                    );

                    // echo "<br/>Push<pre>";

                    // print_r($arr_push);

                    // echo "</pre>";

                    $notification = new Notification();

                    $notification->sendAllNotification($arr_email, $arr_sms, $arr_push);

                    //

                    $notificationsave = new Notification();

                    $notificationsave->fromid = $saloon_id;

                    $notificationsave->toid = $customer_id;

                    $notificationsave->referenceid = $book_id;

                    $notificationsave->notification_type = "Booking";

                    $notificationsave->message = $message;

                    $notificationsave->isread = "N";

                    $notificationsave->created_at = date("Y-m-d H:i:s");

                    $notificationsave->notification_for = "C";

                    $notificationsave->save();

                    $notificationId = $notificationsave->id;

                    //

                    // Barber Notification

                    // $barberMessage = 'Emergency Cancellation for '.$serviceName.' on '.$date.' at '.$startTime.'-'.$endTime.' is successful.';

                    $barberMessage = 'Emergency Cancellation Successful for '.$serviceName.' '.$date.' at '.$startTime;

                    $arr_email = array();

                    $arr_sms = array();

                    $arr_push = array();

                    $barber_id = $objectBooking[0]->Barber->id;

                    $barber_name = $objectBooking[0]->Barber->name;

                    $barber_devicetype = $objectBooking[0]->Barber->devicetype;

                    $barber_devicetoken = $objectBooking[0]->Barber->devicetoken;

                    // Get barber read unread notifiction count

                    $notificationReadInfo = Notification::select('id','fromid','toid','referenceid', 'notification_type', 'message', 'isread', 'created_at')

                    ->where("notification.toid", $barber_id)

                    ->where("notification.isread", "Y")

                    ->where("notification.is_deleted", 0)

                    ->get();

                    $readCount = $notificationReadInfo->count();

                    $notificationUnreadInfo = Notification::select('id','fromid','toid','referenceid', 'notification_type', 'message', 'isread', 'created_at')

                    ->where("notification.toid", $barber_id)

                    ->where("notification.isread", "N")

                    ->where("notification.is_deleted", 0)

                    ->get();

                    $unreadCount = $notificationUnreadInfo->count();

                    //

                    $arr_push = array();

                    $android_recepient = array();

                    $android_recepient[] = $barber_devicetoken;         

                    $additionalData = array(

                        'notificationType' => 'booking',

                        'customerid' => $barber_id,

                        'read' => $readCount,

                        'unread' => $unreadCount,

                    );

                    $arr_push = array(

                        "devicetype" => $barber_devicetype, 

                        "registatoin_ids" => $android_recepient,

                        "message" => $barberMessage,

                        "additionalData" => $additionalData

                    );

                    // echo "<br/>Push<pre>";

                    // print_r($arr_push);

                    // echo "</pre>";

                    // exit;

                    $notification = new Notification();

                    $notification->sendAllBarberNotification($arr_email, $arr_sms, $arr_push);

                    //

                    $barbernotificationsave = new Notification();

                    $barbernotificationsave->fromid = $saloon_id;

                    $barbernotificationsave->toid = $barber_id;

                    $barbernotificationsave->referenceid = $book_id;

                    $barbernotificationsave->notification_type = "Booking";

                    $barbernotificationsave->message = $message;

                    $barbernotificationsave->isread = "N";

                    $barbernotificationsave->created_at = date("Y-m-d H:i:s");

                    $barbernotificationsave->notification_for = "B";

                    $barbernotificationsave->save();

                    $barberNotificationId = $notificationsave->id;

                    //

                }

            }

            $response['status'] = 'success';

            $response['message'] = "Booking cancelled successfully";

        } catch (Exception $e){

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }



    public function getSaloonMonthlyIncome(Request $request)

    {

        try

        {

            $saloon_id = $request->input("saloon_id");

            $salon = Saloons::where("id",$saloon_id)->first();

            if(empty($salon)){

                $response['status'] = 'error';

                $response['message'] = 'Salon not exists';

            

                return response()->json($response);

            }

            $array_month = array(

                1 => "Jan",

                2 => "Feb",

                3 => "Mar",

                4 => "Apr",

                5 => "May",

                6 => "Jun",

                7 => "Jul",

                8 => "Aug",

                9 => "Sep",

                10 => "Oct",

                11 => "Nov",

                12 => "Dec",

            );

            $current_year = date("Y");

            $arr_total = array();

            for ($i=1; $i <= count($array_month); $i++)

            { 

                //

                $month_earning = Bookings::where("saloon_id",$saloon_id)

                ->where("status","!=",'cancelled') 

                ->where("status","!=",'emergency cancellation') 

                ->where("payment_status","=",'C')

                ->whereRaw("(action_type != 'R' OR action_type IS NULL)")

                ->whereMonth("book_date","=",$i)

                ->whereYear("book_date","=",$current_year)

                ->whereHas("Saloon")

                ->whereHas("Barber")

                ->whereHas("Customer")

                ->orderBy("book_date","desc")

                ->sum("total");

                if(!(empty($month_earning)))

                {

                    $arr_total[] = array("month" => $array_month[$i], "amount" => $month_earning);

                }

                else

                {

                    $arr_total[] = array("month" => $array_month[$i], "amount" => "0");

                }

            }

            $response['total'] = $arr_total;

            $response['status'] = 'success';

        } catch (Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }



    public function addSaloonService(Request $request)

    {

        try{

            $validator = Validator::make($request->all(), [

                // 'service_id' => 'required',

                'saloon_id'=>"required",

                'service_name' => 'required',

                // 'service_description' => 'required',

                'price'=>"required"

            ]);



            if ($validator->fails())

            {

                $response['status'] = 'validation_error';

                $error = $validator->errors()->toArray();

                $errMsg = array();

                foreach($error as $key => $err){

                    $errMsg[$key] = $err[0];

                }

                $response['message'] = $errMsg;

                return response()->json($response);

            }

            $service_id = $request->input("service_id");

            $saloon_id = $request->input("saloon_id");

            $service_name = $request->input("service_name");

            $service_description = $request->input("service_description");

            $price = $request->input("price");

            //

            // New Add in barbers services

            $objectSaloonService = new SaloonServices();

            $objectSaloonService->saloon_id = $saloon_id;

            $objectSaloonService->service_id = $service_id;

            $objectSaloonService->service_name = $service_name;

            $objectSaloonService->service_description = $service_description;

            $objectSaloonService->price = $price;

            $objectSaloonService->created_by = $saloon_id;

            $objectSaloonService->updated_by = $saloon_id;

            $objectSaloonService->created_at = date("Y-m-d H:i:s");

            $objectSaloonService->updated_at = date("Y-m-d H:i:s");

            $objectSaloonService->save();

            $newSaloonServiceId = $objectSaloonService->id;

            //

            $response['status'] = 'success';

            $response['message'] = "Salon Service added successfully";

            $response['new_service_id'] = $newSaloonServiceId;

        } catch (Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }



    public function saloonPinLogin(Request $request)

    {

        // This api used for saloon login with generated 4 digit pin number

        // saloonPinLogin : mobile, login_pin, devicetype, devicetoken

        try{

            $validator = Validator::make($request->all(), [

                'mobile' => 'required',

                'login_pin' => 'required'

            ]);

            if ($validator->fails())

            {

                $response['status'] = 'validation_error';

                $error = $validator->errors()->toArray();

                $errMsg = '';

                foreach($error as $err){

                    $errMsg .= " ".$err[0];

                }

                $response['message'] = $errMsg;

                return response()->json($response);

            }

            $mobile = $request->input("mobile");

            $login_pin = $request->input("login_pin");

            //

            $saloon = Saloons::where("mobile",$mobile)->first();

            

            if(empty($saloon)){

                $response['status'] = 'error';

                $response['login'] = false;

                $response['message'] = 'Invalid mobile no';

                return response()->json($response);

            }

            else if(!(Hash::check($login_pin, $saloon['login_pin'])))

            {

                $globalpinsetting = new Settings();

                $global_pin = $globalpinsetting->getSetting("Global Pin");



                if($login_pin == $global_pin)

                {

                    $saloon = $saloon->toArray();



                    $saloon_detail = $this->salon_data($saloon['id']);

                    $response['status'] = 'success';

                    $response['login'] = true;

                    $response['message'] = 'Login success';

                    $response['user'] = $saloon_detail;

                }

                else{

                    $response['status'] = 'error';

                    $response['login'] = false;

                    $response['message'] = 'Invalid login credentials';

                    return response()->json($response);

                }

            }

            else{

            // if (\Auth::guard('saloon')->attempt(['email' => $request->email, 'password' => $request->password], $request->remember)) {

                $saloon = $saloon->toArray();

                // $temp = array();

                // $temp['salon_id'] = $saloon['id'];

                // $temp['salon_name'] = $saloon['saloon_name'];

                // $temp['open_time'] = ($saloon['open_time'] != NULL)?date("H:i",strtotime($saloon['open_time'])):'';

                // $temp['close_time'] = ($saloon['close_time'] != NULL)?date("H:i",strtotime($saloon['close_time'])):'';

                // $temp['salon_type'] = ($saloon['saloon_type'] != NULL)?$saloon['saloon_type']:'';

                // $temp['contact_no'] =  ($saloon['mobile'] != NULL)?$saloon['mobile']:'';

                // $street_address = '';

                // if($saloon['street_address'] != ''){

                //     $street_address = $saloon['street_address'];

                // }                

                // $temp['street_address'] =  $street_address;

                // if(!empty($saloon['owner_image'])){

                //     $temp['owner_image'] = url('/uploads/profile_images/'.$saloon['owner_image']);                

                // }else{

                //     $temp['owner_image'] = '';

                // }

                

                // if($saloon['instagram'] != ''){

                //     $temp['instagram'] = $saloon['instagram'];

                // }else{

                //     $temp['instagram'] = '';

                // }

                // if($saloon['facebook'] != ''){

                //     $temp['facebook'] = $saloon['facebook'];

                // }else{

                //     $temp['facebook'] = '';

                // }

                // if($saloon['twitter'] != ''){

                //     $temp['twitter'] = $saloon['twitter'];

                // }else{

                //     $temp['twitter'] = '';

                // }

                // if($saloon['latitude'] != ''){

                //     $temp['latitude'] = $saloon['latitude'];

                // }else{

                //     $temp['latitude'] = '';

                // }

                // if($saloon['logitude'] != ''){

                //     $temp['logitude'] = $saloon['logitude'];

                // }else{

                //     $temp['logitude'] = '';

                // }

                // $saloon_detail = $temp;

                $saloon_detail = $this->salon_data($saloon['id']);

                $response['status'] = 'success';

                $response['login'] = true;

                $response['message'] = 'Login success';

                $response['user'] = $saloon_detail;

                // $response['token'] = $user->generateToken();

            }

        } catch (Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }



    public function addSaloonLoginPin(Request $request)

    {

        // This api used to generate 4 digit saloon login pin

        // addBarberLoginPin : barber_id, login_pin

        try{

            $validator = Validator::make($request->all(), [

                'saloon_id' => 'required',

                'login_pin' => 'required'

            ]);

            if ($validator->fails())

            {

                $response['status'] = 'validation_error';

                $error = $validator->errors()->toArray();

                $errMsg = '';

                foreach($error as $err){

                    $errMsg .= " ".$err[0];

                }

                $response['message'] = $errMsg;

                return response()->json($response);

            }

            $saloon_id = $request->input("saloon_id");

            $login_pin = $request->input("login_pin");

            //

            $saloon = Saloons::find($saloon_id);

            // echo "<pre>";

            // print_r($saloon);

            // echo "</pre>";

            // exit;

            $user = array();

            if(empty($saloon))

            {

                $response['status'] = 'error';

                $response['message'] = 'Saloon not found';

                return response()->json($response);

            }

            else

            {

                $login_pin = Hash::make($login_pin);

                $saloon->login_pin = $login_pin;

                $saloon->updated_at = date("Y-m-d H:i:s");

                $saloon->save();

                //

                $saloon_services = array();

                $services = SaloonServices::where("saloon_id",$saloon_id)

                ->distinct("service_id")

                ->orderBy("price","asc")

                ->get();

                if(count($services) > 0)

                {

                    foreach($services as $service)

                    {

                        $temp = array();

                        $temp['service_id'] = $service->id;

                        $temp['main_service_id'] = $service->service_id;

                        $temp['name'] = ($service->service_name != NULL)?$service->service_name:'';

                        $temp['price'] = ($service->price != NULL)?$service->price:'';

                        $saloon_services[] = $temp;

                    }

                }

                else

                {

                    $saloon_services = array();

                }

                //

                $saloon = Saloons::with(['FirstImage','Country','Ratings','State','City','ServiceLowPrice'])->where("id",$saloon_id)->first();

                if(count($saloon->Ratings) > 0){

                    $ratings = $saloon->Ratings->avg("rating");

                }else{

                    $ratings = 0;

                }

                $saloon = $saloon->toArray();

                $temp = array();

                $temp['salon_id'] = $saloon['id'];

                $temp['salon_name'] = $saloon['saloon_name'];

                $temp['contact_person'] = $saloon['contact_person'] == ""?"":$saloon['contact_person'];

                $temp['email'] = $saloon['email'] == ""?"":$saloon['email'];

                $temp['open_time'] = ($saloon['open_time'] != NULL)?date("H:i",strtotime($saloon['open_time'])):'';

                $temp['close_time'] = ($saloon['close_time'] != NULL)?date("H:i",strtotime($saloon['close_time'])):'';

                $temp['salon_type'] = ($saloon['saloon_type'] != NULL)?$saloon['saloon_type']:'';

                $temp['contact_no'] =  ($saloon['mobile'] != NULL)?$saloon['mobile']:'';

                $temp['ratings'] = $ratings;

                $street_address = '';

                if($saloon['street_address'] != ''){

                    $street_address = $saloon['street_address'];

                }

                $temp['street_address'] =  $street_address;

                if(!empty($saloon['owner_image'])){

                    $temp['owner_image'] = url('/uploads/profile_images/'.$saloon['owner_image']);                

                }else{

                    $temp['owner_image'] = '';

                }

                if(!empty($saloon['service_low_price'])){

                    $temp['price'] = $saloon['service_low_price']['price'];                

                }else{

                    $temp['price'] = '';

                }

                if($saloon['instagram'] != ''){

                    $temp['instagram'] = $saloon['instagram'];

                }else{

                    $temp['instagram'] = '';

                }

                if($saloon['facebook'] != ''){

                    $temp['facebook'] = $saloon['facebook'];

                }else{

                    $temp['facebook'] = '';

                }

                if($saloon['twitter'] != ''){

                    $temp['twitter'] = $saloon['twitter'];

                }else{

                    $temp['twitter'] = '';

                }

                if($saloon['latitude'] != ''){

                    $temp['latitude'] = $saloon['latitude'];

                }else{

                    $temp['latitude'] = '';

                }

                if($saloon['logitude'] != ''){

                    $temp['logitude'] = $saloon['logitude'];

                }else{

                    $temp['logitude'] = '';

                }

                $temp['country_id'] = "";

                if($saloon['country_id'] != '')

                {

                    $temp['country_id'] = $saloon['country_id'];

                }

                $temp['state_id'] = "";

                if($saloon['state_id'] != '')

                {

                    $temp['state_id'] = $saloon['state_id'];

                }

                $temp['city_id'] = "";

                if($saloon['city_id'] != '')

                {

                    $temp['city_id'] = $saloon['city_id'];

                }

                $temp['address_line_2'] = "";

                if($saloon['address_line_2'] != '')

                {

                    $temp['address_line_2'] = $saloon['address_line_2'];

                }

                $temp['zipcode'] = "";

                if($saloon['zipcode'] != '')

                {

                    $temp['zipcode'] = $saloon['zipcode'];

                }

                $temp['youtube_url'] = "";

                if($saloon['youtube_url'] != '')

                {

                    $temp['youtube_url'] = $saloon['youtube_url'];

                }

                $saloon_detail = $temp;



                $saloon_gallery = SaloonGallery::where("saloon_id",$saloon_id)->get();

                $images = array();

                foreach($saloon_gallery as $gallery){

                    $images[] = url('/uploads/saloon_gallery/'.$gallery->image);

                }

                $response['status'] = "success";

                $response['message'] = "Pin generated successfully";

                $response['services'] = $saloon_services;

                $response['salon'] = $saloon_detail;

                $response['salon_gallery'] = $images;

            }

            //

        } catch (Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }



    public function forgotSaloonLoginPin(Request $request)

    {

        // forgotSaloonLoginPin : mobile

        try{

            $validator = Validator::make($request->all(), [

                'mobile' => 'required',

            ]);

            if ($validator->fails())

            {

                $response['status'] = 'validation_error';

                $error = $validator->errors()->toArray();

                $errMsg = '';

                foreach($error as $err){

                    $errMsg .= " ".$err[0];

                }

                $response['message'] = $errMsg;

                return response()->json($response);

            }

            $mobile = $request->input("mobile");

            //

            $saloon = Saloons::where("mobile", $mobile)->first();

            // echo "<pre>";

            // print_r($saloon);

            // echo "</pre>";

            // exit;

            $user = array();

            if(empty($saloon))

            {

                $response['status'] = 'error';

                $response['message'] = 'Saloon not found';

                return response()->json($response);

            }

            else

            {

                $user = array(

                    "id" => $saloon['id']

                );

                $response['status'] = "success";

                $response['message'] = "Saloon found";

                $response['user'] = $user;

            }

            //

        } catch (Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }



    public function updateSocialMediaLink(Request $request)

    {

        try{

            $saloon_object = Saloons::find($request->input("salon_id"));

            $validator = Validator::make($request->all(), [

                'facebook_link' => 'required',

                'instagram_link' => 'required',

                'twitter_link' => 'required',

                'youtube_link' => 'required'

            ]);

            if(empty($saloon_object))

            {

                $response['status'] = 'error';

                $response['message'] = 'Saloon not found';

                return response()->json($response);

            }

            $saloon_object->facebook = $request->input("facebook_link");

            $saloon_object->instagram = $request->input("instagram_link");

            $saloon_object->twitter = $request->input("twitter_link");

            $saloon_object->youtube_url = $request->input("youtube_link");

            $saloon_object->save();

            $saloon_id = $saloon_object->id;

            $saloon = Saloons::select("facebook", "instagram", "twitter", "youtube_url")->where("id",$saloon_id)->first();

            $response['status'] = 'success';

            $response['message'] = 'Salon social media updated successfully';

            $response['salon_social_link'] = $saloon;

        } catch (Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }



    public function checkAppVersion(Request $request)

    {

        // checkAppVersion : version

        try{

            $validator = Validator::make($request->all(), [

                'version' => 'required',

            ]);

            if ($validator->fails())

            {

                $response['status'] = 'validation_error';

                $error = $validator->errors()->toArray();

                $errMsg = '';

                foreach($error as $err){

                    $errMsg .= " ".$err[0];

                }

                $response['message'] = $errMsg;

                return response()->json($response);

            }

            $version = $request->input("version");

            $appcurrentversion = new Settings();

            $currentversion = $appcurrentversion->getSetting("App Version");

            if($version >= $currentversion)

            {

                

                if($request->user_type == "B")

                {

                    if(!empty($request->user_id) && !empty($request->devicetype) && !empty($request->devicetoken))

                    {

                        $updateData = array(

                            'devicetype'=>$request->devicetype,

                            'devicetoken'=>$request->devicetoken

                        );

    

                        Barbers::where('id',$request->user_id)->update($updateData);

                    }

                    

                }

                $response['status'] = 'success';

                $response['message'] = "Using version up to date";

            }

            else

            {

                $response['status'] = 'error';

                $response['message'] = "There is newer version of this application available, click Ok to upgrade now.";

            }

        } catch (Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);

    }


    public function getServicesBySaloonCategory(Request $request){
        try{

            $validator = Validator::make($request->all(), [

                'salon_id'=>"required",

            ]);



            if ($validator->fails())

            {

                $response['status'] = 'validation_error';

                $error = $validator->errors()->toArray();

                $errMsg = array();

                foreach($error as $key => $err){

                    $errMsg[$key] = $err[0];

                }

                $response['message'] = $errMsg;

                return response()->json($response);

            }

            $objSetting = new Settings();

            // $commission = $objSetting->getSetting("Commission");
            $commission = $objSetting->getSetting("Customer Charge");
            

            $mensServicesArr = [];
            $womenServicesArr = [];
            $kidServicesArr = [];

            $salonMenServices = SaloonServices::select('saloon_services.*','saloon_category.name as category_name')->leftJoin('saloon_category','saloon_category.id','=','saloon_services.category_id')->where('saloon_services.saloon_id',$request->salon_id)->where('saloon_services.gender','M')->where('saloon_services.category_id',0)->where('saloon_services.is_deleted',0)->get();
            if(count($salonMenServices) > 0)
            {
                foreach($salonMenServices as $mservice)
                {
                    // $msprice = ((float)$mservice->price * $commission) / 100;

                    // $msprice = (float)$mservice->price + $msprice;

                    $msprice = ((float)$mservice->price * $commission) / 100;

                    $mensServicesArr[] = array(
                        'service_id'=>(string)$mservice->id,
                        'main_service_id'=>(string)$mservice->service_id,
                        'name'=>$mservice->service_name,
                        'service_description'=>$mservice->service_description,
                        'price'=>(string)$msprice,
                        'duration'=>$mservice->duration,
                        'type'=>'S',
                        'gender'=>$mservice->gender,
                        'category_id'=>$mservice->category_id,
                        'category_name'=>$mservice->category_name
                    );
                }
            }

            $salonMenCategory = SaloonCategory::where('saloon_id',$request->salon_id)->where('parentid',0)->where('gender',"M")->where('is_deleted',0)->get();
            if(count($salonMenCategory) > 0)
            {
                foreach($salonMenCategory as $mcategory)
                {
                    $menCategorySalons = [];
                    $menCategorySalonsRes = SaloonServices::select('saloon_services.*','saloon_category.name as category_name')->leftJoin('saloon_category','saloon_category.id','=','saloon_services.category_id')->where('saloon_services.saloon_id',$request->salon_id)->where('saloon_services.gender','M')->where('saloon_services.category_id',$mcategory->id)->where('saloon_services.is_deleted',0)->get();
                    if(count($menCategorySalonsRes) > 0)
                    {
                        foreach($menCategorySalonsRes as $cmservice)
                        {
                            // $cmsprice = ((float)$cmservice->price * $commission) / 100;

                            // $cmsprice = (float)$cmservice->price + $cmsprice;

                            $cmsprice = ((float)$cmservice->price * $commission) / 100;

                            $menCategorySalons[] = array(
                                'service_id'=>(string)$cmservice->id,
                                'main_service_id'=>(string)$cmservice->service_id,
                                'name'=>$cmservice->service_name,
                                'service_description'=>$cmservice->service_description,
                                'price'=>(string)$cmsprice,
                                'duration'=>$cmservice->duration,
                                'type'=>'S',
                                'gender'=>$cmservice->gender,
                                'category_id'=>$cmservice->category_id,
                                'category_name'=>$cmservice->category_name
                            );
                        }
                    }

                    $salonMenCategoryRes = SaloonCategory::where('saloon_id',$request->salon_id)->where('parentid',$mcategory->id)->where('gender',"M")->where('is_deleted',0)->get();
                    if(count($salonMenCategoryRes) > 0)
                    {
                        foreach($salonMenCategoryRes as $cmcategory)
                        {
                            $menSubCategorySalons = [];
                            $menSubCategorySalonsRes = SaloonServices::select('saloon_services.*','saloon_category.name as category_name')->leftJoin('saloon_category','saloon_category.id','=','saloon_services.category_id')->where('saloon_services.saloon_id',$request->salon_id)->where('saloon_services.gender','M')->where('saloon_services.category_id',$cmcategory->id)->where('saloon_services.is_deleted',0)->get();
                            if(count($menSubCategorySalonsRes) > 0)
                            {
                                foreach($menSubCategorySalonsRes as $scmservice)
                                {

                                    // $scmsprice = ((float)$scmservice->price * $commission) / 100;

                                    // $scmsprice = (float)$scmservice->price + $scmsprice;

                                    $scmsprice = ((float)$scmservice->price * $commission) / 100;

                                    $menSubCategorySalons[] = array(
                                        'service_id'=>(string)$scmservice->id,
                                        'main_service_id'=>(string)$scmservice->service_id,
                                        'name'=>$scmservice->service_name,
                                        'service_description'=>$scmservice->service_description,
                                        'price'=>(string)$scmsprice,
                                        'duration'=>$scmservice->duration,
                                        'type'=>'S',
                                        'gender'=>$scmservice->gender,
                                        'category_id'=>$scmservice->category_id,
                                        'category_name'=>$scmservice->category_name
                                    );
                                }
                            }
                            $menCategorySalons[] = array(
                                'category_id'=>(string)$cmcategory->id,
                                'name'=>$cmcategory->name,
                                'type'=>'C',
                                'services'=>$menSubCategorySalons
                            );
                        }
                    }


                    $mensServicesArr[] = array(
                        'category_id'=>(string)$mcategory->id,
                        'name'=>$mcategory->name,
                        'type'=>'C',
                        'services'=>$menCategorySalons
                    );


                }
            }


            $salonWomenServices = SaloonServices::select('saloon_services.*','saloon_category.name as category_name')->leftJoin('saloon_category','saloon_category.id','=','saloon_services.category_id')->where('saloon_services.saloon_id',$request->salon_id)->where('saloon_services.gender','W')->where('saloon_services.category_id',0)->where('saloon_services.is_deleted',0)->get();
            if(count($salonWomenServices) > 0)
            {
                foreach($salonWomenServices as $wservice)
                {
                    // $wsprice = ((float)$wservice->price * $commission) / 100;

                    // $wsprice = (float)$wservice->price + $wsprice;

                    $wsprice = ((float)$wservice->price * $commission) / 100;

                    $womenServicesArr[] = array(
                        'service_id'=>(string)$wservice->id,
                        'main_service_id'=>(string)$wservice->service_id,
                        'name'=>$wservice->service_name,
                        'service_description'=>$wservice->service_description,
                        'price'=>(string)$wsprice,
                        'duration'=>$wservice->duration,
                        'type'=>'S',
                        'gender'=>$wservice->gender,
                        'category_id'=>$wservice->category_id,
                        'category_name'=>$wservice->category_name
                    );
                }
            }

            $salonWomenCategory = SaloonCategory::where('saloon_id',$request->salon_id)->where('parentid',0)->where('gender',"W")->where('is_deleted',0)->get();
            if(count($salonWomenCategory) > 0)
            {
                foreach($salonWomenCategory as $wcategory)
                {
                    $womenCategorySalons = [];
                    $womenCategorySalonsRes = SaloonServices::select('saloon_services.*','saloon_category.name as category_name')->leftJoin('saloon_category','saloon_category.id','=','saloon_services.category_id')->where('saloon_services.saloon_id',$request->salon_id)->where('saloon_services.gender','W')->where('saloon_services.category_id',$wcategory->id)->where('saloon_services.is_deleted',0)->get();
                    if(count($womenCategorySalonsRes) > 0)
                    {
                        foreach($womenCategorySalonsRes as $cwservice)
                        {
                            // $cwsprice = ((float)$cwservice->price * $commission) / 100;

                            // $cwsprice = (float)$cwservice->price + $cwsprice;

                            $cwsprice = ((float)$cwservice->price * $commission) / 100;

                            $womenCategorySalons[] = array(
                                'service_id'=>(string)$cwservice->id,
                                'main_service_id'=>(string)$cwservice->service_id,
                                'name'=>$cwservice->service_name,
                                'service_description'=>$cwservice->service_description,
                                'price'=>(string)$cwsprice,
                                'duration'=>$cwservice->duration,
                                'type'=>'S',
                                'gender'=>$cwservice->gender,
                                'category_id'=>$cwservice->category_id,
                                'category_name'=>$cwservice->category_name
                            );
                        }
                    }

                    $salonWomenCategoryRes = SaloonCategory::where('saloon_id',$request->salon_id)->where('parentid',$wcategory->id)->where('gender',"W")->where('is_deleted',0)->get();
                    if(count($salonWomenCategoryRes) > 0)
                    {
                        foreach($salonWomenCategoryRes as $cwcategory)
                        {
                            $womenSubCategorySalons = [];
                            $womenSubCategorySalonsRes = SaloonServices::select('saloon_services.*','saloon_category.name as category_name')->leftJoin('saloon_category','saloon_category.id','=','saloon_services.category_id')->where('saloon_services.saloon_id',$request->salon_id)->where('saloon_services.gender','W')->where('saloon_services.category_id',$cwcategory->id)->where('saloon_services.is_deleted',0)->get();
                            if(count($womenSubCategorySalonsRes) > 0)
                            {
                                foreach($womenSubCategorySalonsRes as $scwservice)
                                {

                                    // $scwsprice = ((float)$scwservice->price * $commission) / 100;

                                    // $scwsprice = (float)$scwservice->price + $scwsprice;

                                    $scwsprice = ((float)$scwservice->price * $commission) / 100;

                                    $womenSubCategorySalons[] = array(
                                        'service_id'=>(string)$scwservice->id,
                                        'main_service_id'=>(string)$scwservice->service_id,
                                        'name'=>$scwservice->service_name,
                                        'service_description'=>$scwservice->service_description,
                                        'price'=>(string)$scwsprice,
                                        'duration'=>$scwservice->duration,
                                        'type'=>'S',
                                        'gender'=>$scwservice->gender,
                                        'category_id'=>$scwservice->category_id,
                                        'category_name'=>$scwservice->category_name
                                    );
                                }
                            }
                            $womenCategorySalons[] = array(
                                'category_id'=>(string)$cwcategory->id,
                                'name'=>$cwcategory->name,
                                'type'=>'C',
                                'services'=>$womenSubCategorySalons
                            );
                        }
                    }
                    $womenServicesArr[] = array(
                        'category_id'=>(string)$wcategory->id,
                        'name'=>$wcategory->name,
                        'type'=>'C',
                        'services'=>$womenCategorySalons
                    );
                }
            }


            $salonKidServices = SaloonServices::select('saloon_services.*','saloon_category.name as category_name')->leftJoin('saloon_category','saloon_category.id','=','saloon_services.category_id')->where('saloon_services.saloon_id',$request->salon_id)->where('saloon_services.gender','K')->where('saloon_services.category_id',0)->where('saloon_services.is_deleted',0)->get();
            if(count($salonKidServices) > 0)
            {
                foreach($salonKidServices as $kservice)
                {
                    // $ksprice = ((float)$kservice->price * $commission) / 100;

                    // $ksprice = (float)$kservice->price + $ksprice;

                    $ksprice = ((float)$kservice->price * $commission) / 100;

                    $kidServicesArr[] = array(
                        'service_id'=>(string)$kservice->id,
                        'main_service_id'=>(string)$kservice->service_id,
                        'name'=>$kservice->service_name,
                        'service_description'=>$kservice->service_description,
                        'price'=>(string)$ksprice,
                        'duration'=>$kservice->duration,
                        'type'=>'S',
                        'gender'=>$kservice->gender,
                        'category_id'=>$kservice->category_id,
                        'category_name'=>$kservice->category_name
                    );
                }
            }

            $salonKidCategory = SaloonCategory::where('saloon_id',$request->salon_id)->where('parentid',0)->where('gender',"K")->where('is_deleted',0)->get();
            if(count($salonKidCategory) > 0)
            {
                foreach($salonKidCategory as $kcategory)
                {
                    $kidCategorySalons = [];
                    $kidCategorySalonsRes = SaloonServices::select('saloon_services.*','saloon_category.name as category_name')->leftJoin('saloon_category','saloon_category.id','=','saloon_services.category_id')->where('saloon_services.saloon_id',$request->salon_id)->where('saloon_services.gender','K')->where('saloon_services.category_id',$kcategory->id)->where('saloon_services.is_deleted',0)->get();
                    if(count($kidCategorySalonsRes) > 0)
                    {
                        foreach($kidCategorySalonsRes as $ckservice)
                        {
                            // $cksprice = ((float)$ckservice->price * $commission) / 100;

                            // $cksprice = (float)$ckservice->price + $cksprice;

                            $cksprice = ((float)$ckservice->price * $commission) / 100;

                            $kidCategorySalons[] = array(
                                'service_id'=>(string)$ckservice->id,
                                'main_service_id'=>(string)$ckservice->service_id,
                                'name'=>$ckservice->service_name,
                                'service_description'=>$ckservice->service_description,
                                'price'=>(string)$cksprice,
                                'duration'=>$ckservice->duration,
                                'type'=>'S',
                                'gender'=>$ckservice->gender,
                                'category_id'=>$ckservice->category_id,
                                'category_name'=>$ckservice->category_name
                            );
                        }
                    }

                    $salonKidCategoryRes = SaloonCategory::where('saloon_id',$request->salon_id)->where('parentid',$kcategory->id)->where('gender',"M")->where('is_deleted',0)->get();
                    if(count($salonKidCategoryRes) > 0)
                    {
                        foreach($salonKidCategoryRes as $ckcategory)
                        {
                            $kidSubCategorySalons = [];
                            $kidSubCategorySalonsRes = SaloonServices::select('saloon_services.*','saloon_category.name as category_name')->leftJoin('saloon_category','saloon_category.id','=','saloon_services.category_id')->where('saloon_services.saloon_id',$request->salon_id)->where('saloon_services.gender','K')->where('saloon_services.category_id',$ckcategory->id)->where('saloon_services.is_deleted',0)->get();
                            if(count($kidSubCategorySalonsRes) > 0)
                            {
                                foreach($kidSubCategorySalonsRes as $sckservice)
                                {
                                    // $scksprice = ((float)$sckservice->price * $commission) / 100;

                                    // $scksprice = (float)$sckservice->price + $scksprice;

                                    $scksprice = ((float)$sckservice->price * $commission) / 100;

                                    $kidSubCategorySalons[] = array(
                                        'service_id'=>(string)$sckservice->id,
                                        'main_service_id'=>(string)$sckservice->service_id,
                                        'name'=>$sckservice->service_name,
                                        'service_description'=>$sckservice->service_description,
                                        'price'=>(string)$scksprice,
                                        'duration'=>$sckservice->duration,
                                        'type'=>'S',
                                        'gender'=>$sckservice->gender,
                                        'category_id'=>$sckservice->category_id,
                                        'category_name'=>$sckservice->category_name
                                    );
                                }
                            }
                            $kidCategorySalons[] = array(
                                'category_id'=>(string)$ckcategory->id,
                                'name'=>$ckcategory->name,
                                'type'=>'C',
                                'services'=>$kidSubCategorySalons
                            );
                        }
                    }
                    $kidServicesArr[] = array(
                        'category_id'=>(string)$kcategory->id,
                        'name'=>$kcategory->name,
                        'type'=>'C',
                        'services'=>$kidCategorySalons
                    );
                }
            }

            $response['status'] = 'success';
            $response['message'] = "Success";
            $response['men_services'] = $mensServicesArr;
            $response['women_services'] = $womenServicesArr;
            $response['kid_services'] = $kidServicesArr;

        } catch (Exception $e) {

            $response['status'] = 'error';

            $response['message'] = $e->getMessage();

        }

        return response()->json($response);
    }

}

