<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Support\Facades\Auth;
use App\Barbers;

class BarberAuthenticate
{
    /**
     * Get the path the user should be redirected to when they are not authenticated.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return string|null
     */

    public function handle($request, Closure $next)
    {
        $headers = $request->header();
        if(isset($headers['token']) && $headers['token'][0]){
            $token = $headers['token'][0];
            if(isset($headers['id'][0])){
                $id = $headers['id'][0];
                $checkToken = Barbers::where("api_token",$token)
                            ->where("id",$id)
                             ->first();
                if(empty($checkToken)){
                    $response['status'] = 'token_error';
                    $response['message'] = 'Invalid token';
                }else{
                    return $next($request);
                }
            }else{
                $response['status'] = 'token_error';
                $response['message'] = 'Barber Id not send';
            }
        }else{
            $response['status'] = 'token_error';
            $response['message'] = 'Token not send';
        }
        return response()->json($response);
        // if(Auth::guard('barber')->check()){
        //     return $next($request);
        // }else{
        //    $response['status'] = 'invalid_login';
        //    $response['message'] = 'Login to access Api';
        //    return response()->json($response);
        // }
    }
    // protected function redirectTo($request)
    // {
    //     if (! $request->expectsJson()) {
    //         $response['status'] = 'invalid_login';
    //         $response['message'] = 'Login to access Api';
    //         return response()->json($response);
    //     }
    // }
}

