<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Support\Str;
use Carbon\Carbon;

use Illuminate\Foundation\Auth\User as Authenticatable;

class Saloons extends Authenticatable
{
    protected $table = 'saloons';

    public function Services()
    {
        return $this->hasMany('App\SaloonServices','saloon_id');
    }

    public function generateToken()
    {	
    	
        $this->api_token = Str::random(60);
        $this->last_login = Carbon::now()->toDateTimeString();
        $this->save();

        return $this->api_token;
    }
    public function FirstImage()
    {
        return $this->hasOne('App\SaloonGallery','saloon_id');
    }
    public function SaloonGallery()
    {
        return $this->hasMany('App\SaloonGallery','saloon_id');
    }
    public function Country()
    {
        return $this->belongsTo('App\Countries','country_id');
    }
    public function ServiceLowPrice()
    {
        return $this->hasOne('App\SaloonServices','saloon_id')->orderBy('price','asc');
    }
    public function State()
    {
        return $this->belongsTo('App\States','state_id');
    }

    public function City()
    {
        return $this->belongsTo('App\Cities','city_id');
    }

    public function Ratings(){
        return $this->hasMany('App\Ratings','saloon_id');   
    }

    public function Bookings()
    {
        return $this->hasMany('App\Bookings','saloon_id');
    }

    public function Barbers()
    {
        return $this->hasMany('App\Barbers','saloon_id');
    }
}
