<?php

namespace App\Services;

use Illuminate\Support\Facades\DB;

class PhonepayService{
    public static function create_phonepay_payment_url($data)
    {
        $merchantRes = DB::table("settings")
        ->select("setting_value")
        ->where("setting_title","=","Phonepay Merchant Id")
        ->first();
        $merchantid = $merchantRes->setting_value;
        //
        $saltRes = DB::table("settings")
        ->select("setting_value")
        ->where("setting_title","=","Phonepay Salt Key")
        ->first();
        $saltkey = $saltRes->setting_value;


        $apiURL = env('PHONEPAY_API_URL');

        $dataArr = array(
            "merchantId"=> $merchantid,
            "merchantTransactionId"=> (string)$data['order_id'],
            "merchantUserId"=> (string)$data['user_id'],
            "amount"=> (float)$data['amount']*100,
            "redirectUrl"=> "https://blacourdb.com/salondemo/payment_done",
            "redirectMode"=> "REDIRECT",
            "callbackUrl"=> url("/admin/api/phonepay-callback"),
            "mobileNumber"=> (string)$data['mobile'],
            "paymentInstrument"=> array(
                "type"=> "PAY_PAGE"
            )
        );



        $dataencode = base64_encode(json_encode($dataArr));

        // POST Data
        // $postInput = '{"request":'.$dataencode.'}';

        $verify_token = hash('sha256', $dataencode.'/pg/v1/pay'.$saltkey).'###1';
        // $verify_token = hash('sha256', $dataencode.'/pg/v1/pay'.'05992a0b-5254-4f37-86fb-e23bb79ea7e7').'###1';


        $client = new \GuzzleHttp\Client();

        // // $response = Http::withHeaders($headers)->post($apiURL, $postInput);

        $postInput = [
            'request'=>$dataencode,
        ];

        $response = $client->request('POST', $apiURL, [
            'body' => json_encode($postInput),
            'headers' => [
              'Content-Type' => 'application/json',
              'accept' => 'application/json',
              'X-VERIFY'=>$verify_token
            ],
        ]);

  
        // $statusCode = $response->status();
        $responseBody = json_decode($response->getBody(), true);
        // echo $statusCode;
        // print_r($responseBody['data']['instrumentResponse']['redirectInfo']['url']);
        // exit;
        if(isset($responseBody['success']))
        {
            if($responseBody['success'] == 1)
            {
                if($responseBody['code'] == "PAYMENT_INITIATED")
                {
                    return array(
                        'status'=>'S',
                        'url'=>$responseBody['data']['instrumentResponse']['redirectInfo']['url'],
                        'merchant_id'=>$responseBody['data']['merchantId'],
                    );
                }
                else{
                    return array(
                        'status'=>'F',
                        'error'=>$responseBody
                    );
                }
            }
            else{
                return array(
                    'status'=>'F',
                    'error'=>$responseBody
                );
            }
        }
        else{
            return array(
                'status'=>'F',
                'error'=>$responseBody
            );
        }
    }


    public static function create_phonepay_upipayment_url($data)
    {
        $merchantRes = DB::table("settings")
        ->select("setting_value")
        ->where("setting_title","=","Phonepay Merchant Id")
        ->first();
        $merchantid = $merchantRes->setting_value;
        //
        $saltRes = DB::table("settings")
        ->select("setting_value")
        ->where("setting_title","=","Phonepay Salt Key")
        ->first();
        $saltkey = $saltRes->setting_value;


        $apiURL = env('PHONEPAY_API_URL');

        $dataArr = array(
            "merchantId"=> $merchantid,
            "merchantTransactionId"=> (string)$data['order_id'],
            "merchantUserId"=> (string)$data['user_id'],
            "amount"=> (float)$data['amount']*100,
            "callbackUrl"=> url("/admin/api/phonepay-callback"),
            "mobileNumber"=> (string)$data['mobile'],
            "deviceContext"=>array(
                "deviceOS"=> "ANDROID"
            ),
            "paymentInstrument"=> array(
                "type"=> "UPI_INTENT",
                "targetApp"=>$data['target_app']
            )
        );



        $dataencode = base64_encode(json_encode($dataArr));

        // POST Data
        // $postInput = '{"request":'.$dataencode.'}';

        $verify_token = hash('sha256', $dataencode.'/pg/v1/pay'.$saltkey).'###1';
        // $verify_token = hash('sha256', $dataencode.'/pg/v1/pay'.'05992a0b-5254-4f37-86fb-e23bb79ea7e7').'###1';


        $client = new \GuzzleHttp\Client();

        // // $response = Http::withHeaders($headers)->post($apiURL, $postInput);

        $postInput = [
            'request'=>$dataencode,
        ];

        $response = $client->request('POST', $apiURL, [
            'body' => json_encode($postInput),
            'headers' => [
              'Content-Type' => 'application/json',
              'accept' => 'application/json',
              'X-VERIFY'=>$verify_token
            ],
        ]);

  
        // $statusCode = $response->status();
        $responseBody = json_decode($response->getBody(), true);
        // echo $statusCode;
        // print_r($responseBody['data']['instrumentResponse']['redirectInfo']['url']);
        // exit;
        if(isset($responseBody['success']))
        {
            if($responseBody['success'] == 1)
            {
                if($responseBody['code'] == "PAYMENT_INITIATED")
                {
                    return array(
                        'status'=>'S',
                        'url'=>$responseBody['data']['instrumentResponse']['intentUrl'],
                        'merchant_id'=>$responseBody['data']['merchantId'],
                    );
                }
                else{
                    return array(
                        'status'=>'F',
                        'error'=>$responseBody
                    );
                }
            }
            else{
                return array(
                    'status'=>'F',
                    'error'=>$responseBody
                );
            }
        }
        else{
            return array(
                'status'=>'F',
                'error'=>$responseBody
            );
        }
    }
}