<div class="modal-dialog modal-lg">
  <div class="modal-content">
    <div class="modal-header">
      <h4 class="modal-title">{{$pageTitle}}</h4>
      <button type="button" class="close" data-dismiss="modal" aria-label="Close">
        <span aria-hidden="true">&times;</span>
      </button>
    </div>
    <div class="modal-body">
      <form method="post" action="{{ url('admin/barbers/updateschedule/'.$record->id) }}" id="modalForm">
          {{csrf_field()}}
          <div class="card-body">
            <div class="row">
              <div class="col-md-12 col-sm-12 col-xs-12">
                <div class="form-group">
                  <label>Schdule Date</label>
                  <input type="text" class="form-control @error('schedule_date') is-invalid @enderror" name="schedule_date" id="schedule_date" value="{{date('d-m-Y', strtotime($record->schedule_date))}}" placeholder="Select Schdule Date" required>
                  @error('schedule_date')
                      <div class="text-danger mt-2 mb-2" role="alert">
                          <strong>{{ $message }}</strong>
                      </div>
                  @enderror
                </div>
              </div>
            </div>
            <div class="row">
              <div class="col-md-6 col-sm-6 col-xs-12">
                <div class="form-group">
                  <label>From Time</label>
                  <input type='text' name="from_time" id='from_time' class="form-control @error('from_time') is-invalid @enderror" value="{{date('h:i A', strtotime($record->from_time))}}" required />
                  @error('from_time')
                      <div class="text-danger mt-2 mb-2" role="alert">
                          <strong>{{ $message }}</strong>
                      </div>
                  @enderror
                </div>
              </div>
              <div class="col-md-6 col-sm-6 col-xs-12">
                <div class="form-group">
                  <label>To Time</label>
                  <input type='text' name="to_time" id='to_time' class="form-control @error('to_time') is-invalid @enderror" value="{{date('h:i A', strtotime($record->to_time))}}" required />
                  @error('to_time')
                      <div class="text-danger mt-2 mb-2" role="alert">
                          <strong>{{ $message }}</strong>
                      </div>
                  @enderror
                </div>
              </div>
            </div>
            <br/>
            <h3>Schedule Breaks</h3>
            <hr/>
            @if(!(empty($barber_break)) && count($barber_break) > 0)
                <div class="row">
                  <div class="col-lg-6 col-md-6 col-sm-6 col-xs-12 text-center">
                    <big><strong>Break From</strong></big>
                  </div>
                  <div class="col-lg-6 col-md-6 col-sm-6 col-xs-12 text-center">
                    <big><strong>Break To</strong></big>
                  </div>
                </div>
              @foreach($barber_break as $bkey => $bvalue)
                <div class="row break_start">
                  <div class="col-lg-6 col-md-6 col-sm-6 col-xs-12 text-center">
                    {{date("h:i A", strtotime($bvalue->from_time))}}
                  </div>
                  <div class="col-lg-6 col-md-6 col-sm-6 col-xs-12 text-center">
                    {{date("h:i A", strtotime($bvalue->to_time))}}
                  </div>
                </div>
                <hr/>
              @endforeach
            @endif
            <br/>
            <div class="row">
              <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12 break_div">
              </div>
              <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12 text-center">
                <button type="button" class="btn btn-danger" id="btnAddBreak" onclick="addBreak()">Add Break</button>
              </div>
            </div>
          </div>
          <!-- /.card-body -->
        </form>
    </div>
    <div class="modal-footer justify-content-between">
      <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
      <button type="submit" id="submit_form" form="modalForm" class="btn btn-primary">Save</button>
    </div>
  </div>
</div>
<script src="assets/plugins/inputmask/jquery.inputmask.min.js"></script>
<script>
  $("#schedule_date").datepicker({
    format: "dd-mm-yyyy",
    defaultViewDate:"today",
    startDate:"today",
    todayHighlight:true,
    autoclose:true,
  });

  $('#from_time').datetimepicker({
    format: 'LT',
    icons: {
        time: "fa fa-clock-o",
        date: "fa fa-calendar",
        up: "fa fa-arrow-up",
        down: "fa fa-arrow-down"
    }
  });
  $('#to_time').datetimepicker({
    format: 'LT',
    icons: {
        time: "fa fa-clock-o",
        date: "fa fa-calendar",
        up: "fa fa-arrow-up",
        down: "fa fa-arrow-down"
    }
  });
$(document).ready(function(){
  initSelect();

  $('[data-mask]').inputmask();


  $("#modalForm").submit(function(e){
        e.preventDefault(); // avoid to execute the actual submit of the form.
        var url = $("#modalForm").attr("action");
        $.ajax({
            type: "POST",
            url: url,
            data:$("#modalForm").serialize(),
            dataType:'json',
            beforeSend:function(){
                // $("#submit_form").html("<i class='fa fa-spin fa-spinner'></i>");
                $("#submit_form").attr("disabled","disabled");
            },
            success:function(response){
              // $("#submit_form").removeClass("spinner-border spinner-border-sm");
              $("#submit_form").removeAttr("disabled");
              if(response.status == true){
                  successMessage(response.message); 
                  closeModal();
                  loadSchedule('{{$record->barber_id}}');
              }else{
                errorMessageSchedule(response.message);
              }
            }
        });
    })
});

function errorMessageSchedule(message){
    toastr.error("{{ session('error') }}", message);
}
var count_row = 0;
function addBreak()
{
  count_row += 1;
  var html_break = '<div class="row break_row">'+
                  '<div class="col-lg-6 col-md-6 col-sm-6 col-xs-12">'+
                    '<div class="form-group">'+
                      '<label>Break From Time</label>'+
                      '<input type="text" name="break_from_time[]" id="break_from_time'+count_row+'" class="form-control @error("break_from_time") is-invalid @enderror" value="" required />@error("break_from_time")                          <div class="text-danger mt-2 mb-2" role="alert">                              <strong>{{ $message }}</strong>                          </div>                      @enderror'+
                    '</div>'+
                  '</div>'+
                  '<div class="col-lg-6 col-md-6 col-sm-6 col-xs-12">'+
                    '<div class="form-group">'+
                      '<label>Break To Time</label>'+
                      '<input type="text" name="break_to_time[]" id="break_to_time'+count_row+'" class="form-control @error("break_to_time") is-invalid @enderror" value="" required />                      @error("break_to_time")                          <div class="text-danger mt-2 mb-2" role="alert">                              <strong>{{ $message }}</strong>'+
                          '</div>                      @enderror'+
                    '</div>'+
                  '</div>'+
                  '<a href="javascript:;" id="remove_'+count_row+'" class="btn btn-danger" style="position:absolute; right:10px; margin-top:-3px;" onclick="removeBarberBreak(this.id)">x</a>'+
                '</div>';
  $(".break_div").append(html_break);
  $("#break_from_time"+count_row).datetimepicker({
    format: 'LT',
    icons: {
        time: "fa fa-clock-o",
        date: "fa fa-calendar",
        up: "fa fa-arrow-up",
        down: "fa fa-arrow-down"
    }
  });
  $("#break_to_time"+count_row).datetimepicker({
    format: 'LT',
    icons: {
        time: "fa fa-clock-o",
        date: "fa fa-calendar",
        up: "fa fa-arrow-up",
        down: "fa fa-arrow-down"
    }
  });
  /*var countBreak = $(".break_div").find(".break_row").length;
  var countAddedBreak = parseInt($(".break_start").length);
  var finalBreak = (3 - countAddedBreak);
  // alert(countBreak);
  if(finalBreak < 3 && (finalBreak - countBreak) == 0)
  {
    // $("#btnAddBreak").hide();
  }*/
}

function removeBarberBreak(elementId)
{
  $("#"+elementId).parent().remove();
  /*var countBreak = $(".break_div").find(".break_row").length;
  if(countBreak < 3)
  {
    // $("#btnAddBreak").show();
  }*/
}
</script>