@extends('layouts.master')

@section('content')
<style type="text/css">
.dropdown-menu
{
  margin: 0px;
  padding: .0rem 0;
}
.dropdown-menu li
{
  display: block;
  padding: 2px;
}
.dropdown-menu li a.userAction
{
  text-decoration: none;
  color: #000;
  padding: 5px;
  display: block;
}
</style>
@php
  use App\Saloons;
  use App\Barbers;
  use App\Customers;
@endphp
<!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0 text-dark">{{$pageTitle}}</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="{{ url('/admin') }}">Dashboard</a></li>
              <li class="breadcrumb-item active">{{$pageTitle}}</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <!-- Small boxes (Stat box) -->
        <div class="row">
          <div class="col-lg-12 col-12">
             <div class="card">
              <div class="card-header">
                <h3 class="card-title float-left">Contact Us List</h3>
 <!--                <div class="float-right">
                  <a href="{{ url('admin/barbers/add') }}" class="btn btn-primary btn-sm"><i class="fa fa-plus"></i> Add New</a>
                  <div class="clearfix"></div>
                </div> -->
              </div>
              <!-- /.card-header -->
              <div class="card-body">
                <table class="table table-bordered">
                  <thead>
                    <tr>
                      
                      <th style="width: 10px">#</th>
                      
                      <th>Name</th>
                      <th>Type</th>
                      <th>Message</th>
                      <th>Attachment</th>
                    </tr>
                  </thead>
                  <tbody>
                    @if(count($records) > 0)
                    @foreach($records as $record)

                      @php
                      $name = "";
                      $type = "";
                        if($record->type == "C")
                        {
                          $type = "Customer";
                          $barberRes = Customers::where('id',$record->customer_id)->first();
                          if(!empty($barberRes))
                          {
                            $name = $barberRes->name;
                          }
                        }
                        else if($record->type == "B")
                        {
                          $type = "Barber";
                          $barberRes = Barbers::where('id',$record->customer_id)->first();
                          if(!empty($barberRes))
                          {
                            $name = $barberRes->name;
                          }
                        }
                        else if($record->type == "O")
                        {
                          $type = "Salon";
                          $barberRes = Saloons::where('id',$record->customer_id)->first();
                          if(!empty($barberRes))
                          {
                            $name = $barberRes->saloon_name;
                          }
                        }

                      @endphp
                    <tr>

                      <td>{{ $record->id }}</td>
                      <td>{{ $name }}</td>
                      <td>{{ $type }}</td>
                      <td>{{ $record->message }}</td>
                      <td>
                        <div class="profile_image">
                        @if($record->image != '' && file_exists('uploads/contact/'.$record->image))
                          <a href="{{ url('/uploads/contact/'.$record->image) }}" target="_new">
                            <img src="{{ url('/uploads/contact/'.$record->image) }}" class="img-circle elevation-2" width="80" height="80" />
                          </a>
                        @endif
                        </div>
                      </td>
                    </tr>
                    @endforeach
                    @endif
                  </tbody>
                </table>
                @if(count($records) <= 0)
                  <div class="text-danger text-center mt-1">No records available</div>
                @endif
              </div>
              <!-- /.card-body -->
              <div class="card-footer clearfix">
                <div class="pagination pagination-sm m-0 float-right">
                  {{$records->links()}}
                </div>
              </div>
            </div>
          </div>
         
        </div>
      </div><!-- /.container-fluid -->
    </section>


@endsection

@section("javascript")
<script>







</script>
@endsection