@extends('layouts.master')



@section('content')

<iframe id="export_frame" style="display:none;"></iframe>

<!-- Content Header (Page header) -->

    <div class="content-header">

      <div class="container-fluid">

        <div class="row mb-2">

          <div class="col-sm-6">

            <h1 class="m-0 text-dark">{{$pageTitle}}</h1>

          </div><!-- /.col -->

          <div class="col-sm-6">

            <ol class="breadcrumb float-sm-right">

              <li class="breadcrumb-item"><a href="{{ url('/admin') }}">Dashboard</a></li>

              <li class="breadcrumb-item active">{{$pageTitle}}</li>

            </ol>

          </div><!-- /.col -->

        </div><!-- /.row -->

      </div><!-- /.container-fluid -->

    </div>

    <!-- /.content-header -->



    <!-- Main content -->

    <section class="content">

      <div class="container-fluid">

        <!-- Small boxes (Stat box) -->

        <div class="row">

          <div class="col-lg-12 col-12">

             <!-- general form elements -->

            <div class="card card-primary">

              <div class="card-header">

                <h3 class="card-title float-left">

                  <span class="mt-1 d-block">Fill form detail</span>

                </h3>

                <div class="float-right">

                  <a href="{{ url('admin/defaultservices') }}" class="btn btn-secondary btn-sm"><i class="fa fa-angle-left"></i> Back</a>

                </div>

                <div  class="clearfix"></div>

              </div>

              <!-- /.card-header -->

              <!-- form start -->

              <form method="post" enctype='multipart/form-data'>

                {{csrf_field()}}

                <div class="card-body">

                  <div class="form-group">

                    <label>Service Name</label>

                    <input type="text" class="form-control @error('name') is-invalid @enderror" name="name" value="{{ $record->name }}" placeholder="Enter Name" required>

                    @error('name')

                        <div class="text-danger mt-2 mb-2" role="alert">

                            <strong>{{ $message }}</strong>

                        </div>

                    @enderror

                  </div>

                  <div class="form-group">

                    <label>Description</label>

                    <input type="text" class="form-control @error('description') is-invalid @enderror" name="description" value="{{ $record->description }}" placeholder="Enter Description" required>

                    @error('description')

                        <div class="text-danger mt-2 mb-2" role="alert">

                            <strong>{{ $message }}</strong>

                        </div>

                    @enderror

                  </div>

                  <div class="form-group">

                    <label>Duration</label>

                    <input type="text" id="duration" class="form-control @error('duration') is-invalid @enderror" name="duration" value="{{$record->duration}}" placeholder="HH:MM" required  data-inputmask='"mask": "99:99:99"' data-mask>

                    @error('duration')

                        <div class="text-danger mt-2 mb-2" role="alert">

                            <strong>{{ $message }}</strong>

                        </div>

                    @enderror

                  </div>

                  <div class="form-group">

                    <label>Price</label>

                    <input type="text" class="form-control @error('price') is-invalid @enderror" name="price" value="{{ $record->price }}" placeholder="Enter Price" required>

                    @error('price')

                        <div class="error invalid-feedback mt-2 mb-2" role="alert">

                            <strong>{{ $message }}</strong>

                        </div>

                    @enderror

                  </div>


                  <div class="form-group">

                    <label>Status</label>

                    <div>

                      <input type="checkbox" name="status" {{ ($record->is_active)?'checked':'' }} data-bootstrap-switch>

                    </div>

                  </div>
                  

                </div>

                <!-- /.card-body -->



                <div class="card-footer">

                  <button type="submit" class="btn btn-primary">Submit</button>

                </div>

              </form>

            </div>

            <!-- /.card -->

          </div>

        </div>

      </div><!-- /.container-fluid -->

    </section>

    <!-- /.content -->

@endsection



@section('javascript')

<link rel="stylesheet" href="assets/plugins/bs-stepper/css/bs-stepper.min.css">

<!-- <link rel="stylesheet" href="assets/plugins/daterangepicker/daterangepicker.css"> -->

<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datetimepicker/4.17.47/css/bootstrap-datetimepicker-standalone.css" />

<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.9.0/css/bootstrap-datepicker.css" />

<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datetimepicker/4.17.47/js/bootstrap-datetimepicker.min.js"></script>

<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.9.0/js/bootstrap-datepicker.min.js"></script>



<script src="assets/plugins/bootstrap-switch/js/bootstrap-switch.min.js"></script>

<script src="assets/plugins/bs-stepper/js/bs-stepper.min.js"></script>

<script src="assets/plugins/moment/moment.min.js"></script>


<script src="assets/plugins/inputmask/jquery.inputmask.min.js"></script>

<!-- <script src="assets/plugins/daterangepicker/daterangepicker.js"></script> -->



<script type="text/javascript">

$(document).ready(function(){

    
    $('[data-mask]').inputmask();

    $("input[data-bootstrap-switch]").each(function(){

      $(this).bootstrapSwitch({

        onText:"Enable",

        offText:"Disable"

      });

    });

})

</script>

@endsection