@extends('layouts.master')

@section('content')
<!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0 text-dark">{{$pageTitle}}</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="{{ url('/admin') }}">Dashboard</a></li>
              <li class="breadcrumb-item active">{{$pageTitle}}</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <!-- Small boxes (Stat box) -->
        <div class="row">
          <div class="col-lg-12 col-12">
             <div class="card">
              <div class="card-header">

                <div class="float-left">
                  <form id="search">
                  	<input type="hidden" name="filter" value="1" />
                  	<div class="form-group float-left mr-2">
	                  <label>Start Date:</label>
	                    <div class="input-group date">
                        @if($start_date == "")
                        <?php $start_date = date("d-m-Y") ?>
                        @endif
	                        <input type="text" name="start_date" id="start_date" value="{{ $start_date }}" class="form-control datetimepicker-input" />
	                        <div class="input-group-append">
	                            <div class="input-group-text"><i class="fa fa-calendar"></i></div>
	                        </div>
	                    </div>
	                </div>
                    <div class="form-group float-left mr-2">
                      <label>Filter by Salon</label>
                      <div>
                        <select class="select2" name="saloon">
                          <option value="">All</option>
                          @foreach($saloons as $saloon)
                          <option {{ ($saloon->id == $selected_saloon)?'selected':'' }} value="{{ $saloon->id }}">{{$saloon->saloon_name}}</option>
                          @endforeach
                        </select>
                      </div>
                    </div>
                    
                    <button class="btn btn-primary" style="margin-top:29px"><i class="fa fa-search"></i></button>
                    <div class="clearfix"></div>
                </form>
                  <div class="clearfix"></div>
                </div>
                <div class="clearfix"></div>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
                <table class="table table-bordered">
                  <thead>
                    <tr>
                      <th style="width: 10px">#</th>
                      <th>Salon</th>
                      <th>Owner Name</th>
                      <th>Book Date</th>
                      <th>Total</th>
                    </tr>
                  </thead>
                  <tbody>
                    @if(count($records) > 0)
                    @foreach($records as $record)
                    <tr>
                      <td>{{ $record->id }}</td>
                      <td>{{ $record->Saloon->saloon_name }}</td>
                      <td>{{ $record->Saloon->contact_person }}</td>
                      <td>{{ dateFormat($record->book_date) }}</td>
                      <td>₹{{ $record->total }}</td>
                      
                    </tr>
                    @endforeach
                    @endif
                  </tbody>
                </table>
                @if(count($records) <= 0)
                  <div class="text-danger text-center mt-1">No records available</div>
                @endif
              </div>
              <!-- /.card-body -->
              @if(count($records) > 0)
              <div class="card-footer clearfix">
                <div class="pagination pagination-sm m-0 float-right">
                  {{$records->appends(Request::except('page'))->links()}}
                </div>
              </div>
              @endif
            </div>
          </div>
         
        </div>
      </div><!-- /.container-fluid -->
    </section>
    
@endsection

@section("javascript")
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.9.0/css/bootstrap-datepicker.css" />
<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.9.0/js/bootstrap-datepicker.min.js"></script>
<script>
$('#start_date').datepicker({
      format: "dd-mm-yyyy",
      defaultViewDate:"today",
      todayHighlight:true
});
var delete_user ='';
function confirmDelete(id){
  delete_user = id;
  $("#delete-confirmation").modal("show");
}
function deleteUser(){
  if(delete_user != ''){
    var url = "{{ url('admin/barbers/delete') }}/"+delete_user;
    redirect(url);
  }else{
    errorMessage("Invalid record selected");
  }
}
</script>
@endsection