@extends('layouts.master')

@section('content')
<!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0 text-dark">{{$pageTitle}}</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="{{ url('/admin') }}">Dashboard</a></li>
              <li class="breadcrumb-item active">{{$pageTitle}}</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <!-- Small boxes (Stat box) -->
        <div class="row">
          <div class="col-lg-12 col-12">
             <div class="card">
              <div class="card-header">
                <h3 class="card-title float-left">Booking Detail</h3>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
                <table class="table table-bordered">
                  <tbody>
                    <tr>
                      <!-- <th>Image</th> -->
                      <th>Customer</th>
                      <td>{{$record->Customer->name}}</td>
                    </tr>
                    <tr>
                      <th>Salon</th>
                      <td>{{$record->Saloon->saloon_name}}</td>
                    </tr>
                    <tr>
                      <th>Barber</th>
                      <td>{{$record->Barber->name}}</td>
                    </tr>
                    <tr>
                      <th>Time</th>
                      <td>{{ $record->from_time }} to {{$record->to_time}}</td>
                    </tr>
                    <tr>
                      <th>Book Date</th>
                      <td>{{ dateFormat($record->book_date) }}</td>
                    </tr>
                    <tr>
                      <th>Services</th>
                      <td>
                        @foreach($record->BookingItems as $item)
                          <div>
                            <b>{{$item->SaloonService->service_name}} - </b> ₹{{$item->price}}
                          </div>
                        @endforeach
                      </td>
                    </tr>
                    <tr>
                      <th>Razorpay Refund Id</th>
                      <td>
                        {{ $record->rzp_rufund_id }}
                      </td>
                    </tr>
                    <tr>
                      <th>Status</th>
                      <td>
                        @if($record->status == 'cancelled')
                           <span class="badge badge-warning">Cancelled</span>
                        @elseif($record->book_date." ".$record->to_time > date('Y-m-d H:i:s'))
                           <span class="badge badge-success">Upcoming</span>
                        @else
                           <span class="badge badge-danger">Completed</span>
                        @endif
                      </td>
                    </tr>
                    <tr>
                      <th>Total Amount</th>
                      <td><h3>₹{{ $record->total}}</h3></td>
                    </tr>
                  </tbody>
                </table>
              </div>
              <!-- /.card-body -->
            </div>
          </div>
         
        </div>
      </div><!-- /.container-fluid -->
    </section>
    <div class="modal fade" id="delete-confirmation">
        <div class="modal-dialog">
          <div class="modal-content">
            
            <div class="modal-header">
              <h4 class="modal-title">Confirm Delete</h4>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <p>Are you sure to delete the record?</p>
            </div>
            <div class="modal-footer justify-content-between">
              <button type="button" class="btn btn-default" data-dismiss="modal">Cancel</button>
              <button onclick="deleteUser()" type="button" class="btn btn-danger">Delete</button>
            </div>
          </div>
          <!-- /.modal-content -->
        </div>
        <!-- /.modal-dialog -->
      </div>
    <!-- /.content -->
@endsection

@section("javascript")

@endsection