@extends('layouts.master')

@section('content')
<!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0 text-dark">{{$pageTitle}}</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="{{ url('/admin') }}">Dashboard</a></li>
              <li class="breadcrumb-item active">{{$pageTitle}}</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <!-- Small boxes (Stat box) -->
        <div class="row">
          <div class="col-lg-12 col-12">
             <!-- general form elements -->
            <div class="card card-primary">
              <div class="card-header">
                <h3 class="card-title float-left">
                  <span class="mt-1 d-block">Fill form detail</span>
                </h3>
                <div class="float-right">
                  <a href="{{ url('admin/payments') }}" class="btn btn-secondary btn-sm"><i class="fa fa-angle-left"></i> Back</a>
                </div>
                <div  class="clearfix"></div>
              </div>
              <!-- /.card-header -->
              <!-- form start -->
              <form method="post" id="new_payment_form">
                {{csrf_field()}}
                <div class="card-body">
                  <div class="form-group">
                    <label>Saloon</label>
                    <select name="saloon_id" id="saloon_id" class="form-control select2" required>
                        <option value="">Select Saloon</option>
                        @foreach($saloons as $saloon)
                        <option value="{{ $saloon->id }}">{{$saloon->saloon_name}}</option>
                        @endforeach
                    </select>
                    @error('saloon_id')
                        <div class="text-danger mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div> 

                  <div class="form-group">
                    <div class="row">
                      <div class="col-md-6">
                        <label>Date</label>
                        <div class="input-group date">
                          <input type="text" name="date" id="date" value="" class="form-control datetimepicker-input" required />
                          <div class="input-group-append">
                              <div class="input-group-text"><i class="fa fa-calendar"></i></div>
                          </div>
                        </div>
                        @error('saloon_id')
                            <div class="text-danger mt-2 mb-2" role="alert">
                                <strong>{{ $message }}</strong>
                            </div>
                        @enderror
                      </div>
                      <div class="col-md-6">
                        <label>Amount</label>
                        <div class="input-group date">
                          <input type="number" name="amount" id="amount" value="" class="form-control" required />
                        </div>
                        @error('amount')
                            <div class="text-danger mt-2 mb-2" role="alert">
                                <strong>{{ $message }}</strong>
                            </div>
                        @enderror
                      </div>
                    </div>
                  </div>                  
                </div>
                <!-- /.card-body -->

                <div class="card-footer">
                  <button type="submit" class="btn btn-primary" onclick="return checkpayment();">Submit</button>
                </div>
              </form>
            </div>
            <!-- /.card -->
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
@endsection

@section('javascript')
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.9.0/css/bootstrap-datepicker.css" />
<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.9.0/js/bootstrap-datepicker.min.js"></script>
<script type="text/javascript">
$(document).ready(function(){
  $('#date').datepicker({
    format: "dd-mm-yyyy",
    endDate:"today",
  })
});

function checkpayment()
{
  var saloonId = $("#saloon_id").val();
  var date = $("#date").val();
  $.ajax({
    url:"<?php echo url('admin/payments/checkpayment') ?>",
    type:"POST",
    data:{saloon_id: saloonId, date:date, _token:"<?php echo csrf_token() ?>"},
    success:function(result){
      // console.log(result);
      if(result == 0)
      {
        alert("Payment entry already exists");
        return false;
      }
      $("#new_payment_form")[0].submit();
    }
  });
  return false;
}
</script>
@endsection