@extends('layouts.master')

@section('content')
<!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0 text-dark">{{$pageTitle}}</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="{{ url('/admin') }}">Dashboard</a></li>
              <li class="breadcrumb-item active">{{$pageTitle}}</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <!-- Small boxes (Stat box) -->
        <div class="row">
          <div class="col-lg-12 col-12">
             <!-- general form elements -->
            <div class="card card-primary">
              <div class="card-header">
                <h3 class="card-title float-left">
                  <span class="mt-1 d-block">Fill form detail</span>
                </h3>
                <div class="float-right">
                  <a href="{{ url('admin/payments') }}" class="btn btn-secondary btn-sm"><i class="fa fa-angle-left"></i> Back</a>
                </div>
                <div  class="clearfix"></div>
              </div>
              <!-- /.card-header -->
              <!-- form start -->
              <form method="post">
                {{csrf_field()}}
                <div class="card-body">
                  <div class="form-group">
                    <label>Saloon</label>
                    <select name="saloon_id" id="saloon_id" class="form-control select2" disabled>
                        <option value="">Select Saloon</option>
                        @foreach($saloons as $saloon)
                        <option {{($saloon->id == $record->saloon_id)?'selected':''}} value="{{ $saloon->id }}">{{$saloon->saloon_name}}</option>
                        @endforeach
                    </select>
                  </div>

                  <div class="form-group">
                    <div class="row">
                      <div class="col-md-6">
                        <label>Date</label>
                        <div class="input-group date">
                          <input type="text" name="date" id="date" value="{{date('d-m-Y', strtotime($record->payment_date))}}" class="form-control datetimepicker-input" disabled />
                          <div class="input-group-append">
                              <div class="input-group-text"><i class="fa fa-calendar"></i></div>
                          </div>
                        </div>
                      </div>
                      <div class="col-md-6">
                        <label>Amount</label>
                        <div class="input-group date">
                          <input type="number" name="amount" id="amount" value="{{$record->amount}}" class="form-control" required />
                        </div>
                        @error('amount')
                            <div class="text-danger mt-2 mb-2" role="alert">
                                <strong>{{ $message }}</strong>
                            </div>
                        @enderror
                      </div>
                    </div>
                  </div>
                </div>
                <!-- /.card-body -->

                <div class="card-footer">
                  <button type="submit" class="btn btn-primary">Submit</button>
                </div>
              </form>
            </div>
            <!-- /.card -->
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
@endsection

@section('javascript')
<link rel="stylesheet" href="assets/plugins/bs-stepper/css/bs-stepper.min.css">
<script src="assets/plugins/bootstrap-switch/js/bootstrap-switch.min.js"></script>
<script src="assets/plugins/bs-stepper/js/bs-stepper.min.js"></script>
<script type="text/javascript">
$(document).ready(function(){
  $("input[data-bootstrap-switch]").each(function(){
      $(this).bootstrapSwitch({
        onText:"Enable",
        offText:"Disable"
      });
    });
})
function showPassword(e){
  if($(e).is(":checked")){
    $("#password").attr("type","text");
  }else{
    $("#password").attr("type","password");
  }
}
function fetchStates(id){
  $.ajax({
        url:"{{ url('/fetch-states') }}",
        type:"get",
        data:{
            country_id:id
        },
        beforeSend:function(){
            $("#states").html('');
        },
        success:function(response){
          if(response.status == true){
            $("#states").html(response.options);
          }
        }
    })
}

function fetchCities(id){
  $.ajax({
        url:"{{ url('/fetch-cities') }}",
        type:"get",
        data:{
            state_id:id
        },
        beforeSend:function(){
            $("#cities").html('');
        },
        success:function(response){
          if(response.status == true){
            $("#cities").html(response.options);
          }
        }
    })
}
</script>
@endsection