@extends('layouts.master')

@section('content')
<!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0 text-dark">{{$pageTitle}}</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="{{ url('/admin') }}">Dashboard</a></li>
              <li class="breadcrumb-item active">{{$pageTitle}}</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <!-- Small boxes (Stat box) -->
        <div class="row">
          <div class="col-lg-12 col-12">
             <!-- general form elements -->
            <div class="card card-primary">
              <div class="card-header">
                <h3 class="card-title float-left">
                  <span class="mt-1 d-block">Fill form detail</span>
                </h3>
                <div class="float-right">
                  <a href="{{ url('admin/salons') }}" class="btn btn-secondary btn-sm"><i class="fa fa-angle-left"></i> Back</a>
                </div>
                <div  class="clearfix"></div>
              </div>
              <!-- /.card-header -->
              <!-- form start -->
              <form method="post" enctype="multipart/form-data">
                {{csrf_field()}}
                <div class="card-body">
                  <div class="form-group">
                    <label>Salon Name</label>
                    <input type="text" class="form-control @error('saloon_name') is-invalid @enderror" name="saloon_name" value="{{ old('saloon_name') }}" placeholder="Enter Salon Name" required>
                    @error('saloon_name')
                        <div class="text-danger mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>
                  <div class="form-group">
                    <label>Contact Person Name</label>
                    <input type="text" class="form-control @error('contact_person') is-invalid @enderror" name="contact_person" value="{{ old('contact_person') }}" placeholder="Enter Contact Person Name" required>
                    @error('contact_person')
                        <div class="text-danger mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>
                  <div class="form-group">
                    <label>Email</label>
                    <input type="email" class="form-control @error('email') is-invalid @enderror" name="email" value="{{ old('email') }}" placeholder="Enter Email" required>
                    @error('email')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>
                  <div class="form-group">
                    <label>Mobile</label>
                    <input type="text" class="form-control @error('mobile') is-invalid @enderror" name="mobile" value="{{ old('mobile') }}" placeholder="Enter Mobile Number" required>
                    @error('mobile')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>
                  <div class="form-group">
                    <label>Address</label>
                    <textarea class="form-control @error('street_address') is-invalid @enderror" name="street_address" placeholder="Enter Address" required>{{ old('street_address') }}</textarea>
                    @error('street_address')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>

                  <div class="form-group">
                    <label>Address Line 2</label>
                    <input type="text" class="form-control @error('address_line_2') is-invalid @enderror" name="address_line_2" value="{{ old('address_line_2') }}" placeholder="Enter address line 2">
                    @error('address_line_2')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>

                  <div class="form-group">
                    <label>Country</label>
                    <select name="country_id" class="form-control select2" onchange="fetchStates(this.value)" required>
                        <option value="">Select Country</option>
                        @foreach($countries as $country)
                        <option value="{{ $country->id }}">{{$country->name}}</option>
                        @endforeach
                    </select>
                    @error('country_id')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>
                  <div class="form-group">
                    <label>States</label>
                    <select name="state_id" id='states' class="form-control select2" onchange="fetchCities(this.value)"  required></select>
                    @error('state_id')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>
                  <div class="form-group">
                    <label>City</label>
                    <select id="cities" class="form-control select2" name="city_id"></select>
                    <!-- <input type="text" class="form-control @error('city') is-invalid @enderror" name="city" value="{{ old('city') }}" placeholder="Enter City" required> -->
                    @error('city_id')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>

                  <div class="form-group">
                    <label>Zipcode</label>
                    <input type="number" class="form-control @error('zipcode') is-invalid @enderror" name="zipcode" value="{{ old('zipcode') }}" placeholder="Enter zipcode">
                    @error('zipcode')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>

                  <div class="form-group">
                    <label>Open/Close Time</label>
                      <div class="row">
                        <div class="col-md-6">
                          <div class="input-group date" id="open-timepicker" data-target-input="nearest">
                            <input type="text" onblur="checkTime()" name="open_time" autocomplete="off" placeholder="Enter Open Time" value="{{ old('open_time') }}" class="form-control datetimepicker-input" data-target="#open-timepicker"/>
                            <div class="input-group-append" data-target="#open-timepicker" data-toggle="datetimepicker">
                                <div class="input-group-text"><i class="far fa-clock"></i></div>
                            </div>
                          </div>
                          @error('open_time')
                              <div class="error invalid-feedback mt-2 mb-2" role="alert">
                                  <strong>{{ $message }}</strong>
                              </div>
                          @enderror
                        </div>
                        <div class="col-md-6">
                          <div class="input-group date" id="close-timepicker" data-target-input="nearest">
                            <input type="text" onblur="checkTime()" name="close_time" autocomplete="off" placeholder="Enter Close Time" value="{{ old('close_time') }}" class="form-control datetimepicker-input" data-target="#close-timepicker"/>
                            <div class="input-group-append" data-target="#close-timepicker" data-toggle="datetimepicker">
                                <div class="input-group-text"><i class="far fa-clock"></i></div>
                            </div>
                          </div>
                          @error('close_time')
                              <div class="error invalid-feedback mt-2 mb-2" role="alert">
                                  <strong>{{ $message }}</strong>
                              </div>
                          @enderror
                          @if (session('time_error'))
                              <div class="text-danger mt-2 mb-2" role="alert">
                                  <strong>{{ session('time_error') }}</strong>
                              </div>
                          @endif
                        </div>
                      </div>
                  </div>
                  <div class="form-group">
                    <label>Password</label>
                    <input type="password" id="password" class="form-control @error('password') is-invalid @enderror" name="password" placeholder="Password">
                    @error('password')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                    <div class="mt-2">
                      <div class="icheck-primary d-inline">
                        <input type="checkbox" id="checkboxPrimary1" onchange="showPassword(this)">
                        <label for="checkboxPrimary1">Show Password</label>
                      </div>
                    </div>
                  </div>
                  <div class="form-group">
                    <label>Bank Name</label>
                    <input type="text" class="form-control @error('bank_name') is-invalid @enderror" name="bank_name" value="{{ old('bank_name') }}" placeholder="Enter Bank Name" required>
                    @error('bank_name')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>
                  <div class="form-group">
                    <label>Account Number</label>
                    <input type="text" class="form-control @error('account_number') is-invalid @enderror" name="account_number" value="{{ old('account_number') }}" placeholder="Enter Bank Account Number" required>
                    @error('account_number')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>
                  <div class="form-group">
                    <label>IFSC Code</label>
                    <input type="text" class="form-control @error('ifsc_code') is-invalid @enderror" name="ifsc_code" value="{{ old('ifsc_code') }}" placeholder="Enter Bank IFSC Code" required>
                    @error('ifsc_code')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>
                  <div class="form-group">
                    <label>UPI ID</label>
                    <input type="text" class="form-control @error('upi_id') is-invalid @enderror" name="upi_id" value="{{ old('upi_id') }}" placeholder="Enter UPI Id" required>
                    @error('upi_id')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>

                  <div class="form-group">
                    <label>Razorpay Account Id</label>
                    <input type="text" class="form-control @error('razorpay_account_id') is-invalid @enderror" name="razorpay_account_id" value="{{ old('razorpay_account_id') }}" placeholder="Enter Razorpay Account Id" required>
                    @error('razorpay_account_id')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>

                  <div class="form-group">
                    <label>Youtube URL</label>
                    <input type="url" class="form-control @error('youtube_url') is-invalid @enderror" name="youtube_url" value="{{ old('youtube_url') }}" placeholder="Enter Youtube Url">
                    @error('youtube_url')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>

                  <div class="form-group">
                    <label for="exampleInputFile">Owner Image</label>
                    <div class="input-group">
                      <div class="custom-file">
                        <input type="file" class="custom-file-input" id="exampleInputFile" name="owner_image" required="true">
                        <label class="custom-file-label" for="exampleInputFile">Choose file</label>
                      </div>
                      <!-- <div class="input-group-append">
                        <span class="input-group-text">Upload</span>
                      </div> -->
                    </div>
                    @error('owner_image')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>

                  <div class="row">
                    <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
                      <h3>Gallery Images</h3>
                    </div>
                    <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
                      <div class="form-group">
                        <label for="exampleInputFile">Image 1</label>
                        <div class="input-group">
                          <div class="custom-file">
                            <input type="file" class="custom-file-input" id="exampleInputFile" name="gallery_image_1" required="true">
                            <label class="custom-file-label" for="exampleInputFile">Choose file</label>
                          </div>
                          <!-- <div class="input-group-append">
                            <span class="input-group-text">Upload</span>
                          </div> -->
                        </div>
                        @error('gallery_image_1')
                            <div class="error invalid-feedback mt-2 mb-2" role="alert">
                                <strong>{{ $message }}</strong>
                            </div>
                        @enderror
                      </div>
                      <div class="form-group">
                        <label for="exampleInputFile">Image 2</label>
                        <div class="input-group">
                          <div class="custom-file">
                            <input type="file" class="custom-file-input" id="exampleInputFile" name="gallery_image_2">
                            <label class="custom-file-label" for="exampleInputFile">Choose file</label>
                          </div>
                          <!-- <div class="input-group-append">
                            <span class="input-group-text">Upload</span>
                          </div> -->
                        </div>
                        @error('gallery_image_2')
                            <div class="error invalid-feedback mt-2 mb-2" role="alert">
                                <strong>{{ $message }}</strong>
                            </div>
                        @enderror
                      </div>
                      <div class="form-group">
                        <label for="exampleInputFile">Image 3</label>
                        <div class="input-group">
                          <div class="custom-file">
                            <input type="file" class="custom-file-input" id="exampleInputFile" name="gallery_image_3">
                            <label class="custom-file-label" for="exampleInputFile">Choose file</label>
                          </div>
                          <!-- <div class="input-group-append">
                            <span class="input-group-text">Upload</span>
                          </div> -->
                        </div>
                        @error('gallery_image_3')
                            <div class="error invalid-feedback mt-2 mb-2" role="alert">
                                <strong>{{ $message }}</strong>
                            </div>
                        @enderror
                      </div>
                    </div>
                  </div>

                  <div class="form-group">
                    <label>Status</label>
                    <div>
                      <input type="checkbox" name="status" checked data-bootstrap-switch>
                    </div>
                  </div>
                  <div class="services">
                    @error('services')
                        <div class="text-danger mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                    <!-- <table class="table">
                        <thead>
                        <tr>
                          <th colspan="3">Select Services</th>
                        </tr>
                        <tr>
                          <th>
                            <div class="icheck-primary d-inline">
                              <input type="checkbox" id="checkboxPrimary-all">
                              <label for="checkboxPrimary-all">
                              </label>
                            </div>
                          </th>
                          <th>Services</th>
                          <th>Service Name</th>
                          <th>Description</th>
                          <th>Duration</th>
                          <th>Price</th>
                        </tr>
                        </thead>
                        <tbody>
                          @foreach($services as $key => $service)
                          <tr>
                              <td>
                                <input type="hidden" disabled name="services_ids[]" value="{{ $service->id }}" class="form-control" required />
                                <div class="icheck-primary d-inline">
                                  <input {{ isset($saloon_services[$service->id])?'checked':'' }} type="checkbox" id="checkboxPrimary-{{ $key }}" value="{{ $service->id }}" class="service_id" name="services[{{ $key }}][service_id]">
                                  <label for="checkboxPrimary-{{ $key }}">
                                  </label>
                                </div>
                              </td>
                              <td>{{$service->name}}</td>
                              <td>
                                <input type="text" disabled name="services[{{ $key }}][service_name]" class="form-control" placeholder="Enter Service Name" required  />
                              </td>
                              <td>
                                <input type="text" disabled name="services[{{ $key }}][service_description]" class="form-control" placeholder="Enter Service Description" required  />
                              </td>
                              <td>
                                <input type="text" disabled name="services[{{ $key }}][duration]" class="form-control" placeholder="Enter Duration"  }} type="text" name="services[{{ $key }}][duration]" class="form-control" placeholder="HH:MM" required  data-inputmask='"mask": "99:99:99"' data-mask   />
                              </td>
                              <td>
                                <input type="text" disabled name="services[{{ $key }}][price]" class="form-control" placeholder="Enter Price" required  />
                              </td>
                          </tr>
                          @endforeach
                        </tbody>
                    </table> -->
                  </div>
                </div>
                <!-- /.card-body -->

                <div class="card-footer">
                  <button type="submit" class="btn btn-primary">Submit</button>
                </div>
              </form>
            </div>
            <!-- /.card -->
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
@endsection

@section('javascript')
<link rel="stylesheet" href="assets/plugins/bs-stepper/css/bs-stepper.min.css">
<link rel="stylesheet" href="assets/plugins/daterangepicker/daterangepicker.css">

<script src="assets/plugins/bootstrap-switch/js/bootstrap-switch.min.js"></script>
<script src="assets/plugins/bs-stepper/js/bs-stepper.min.js"></script>
<script src="assets/plugins/moment/moment.min.js"></script>
<script src="assets/plugins/daterangepicker/daterangepicker.js"></script>
<script src="assets/plugins/inputmask/jquery.inputmask.min.js"></script>
<script type="text/javascript">
$(document).ready(function(){
    $("input[data-bootstrap-switch]").each(function(){
      $(this).bootstrapSwitch({
        onText:"Enable",
        offText:"Disable"
      });
    });
    $('#open-timepicker').datetimepicker({
        format: 'HH:mm',
        pickDate: false,
        pickSeconds: false,
        pick12HourFormat: false   
    });

    $('#close-timepicker').datetimepicker({
        format: 'HH:mm',
        pickDate: false,
        pickSeconds: false,
        pick12HourFormat: false   
    });
    $("#checkboxPrimary-all").change(function(){
        if($(this).is(":checked")){
          $(".service_id").prop("checked",true);
          $(".services .form-control").removeAttr("disabled");
        }else{
          $(".service_id").prop("checked",false);
          $(".services .form-control").attr("disabled","disabled");
        }
    });

    $(".service_id").change(function(){
        if($(this).is(":checked")){
          $(this).parents('tr').find(".form-control").removeAttr("disabled");
        }else{
          $(this).parents('tr').find(".form-control").attr("disabled","disabled");
        }
    });
    $('[data-mask]').inputmask();
})
function checkTime(){
  var timefrom = $('#open-timepicker input').val();
  var timeto =$('#close-timepicker input').val();

  if(timeto !='' && timefrom != ''){
    if(Date.parse(timeto) < Date.parse(timefrom)){
      errorMessage('Close time should be greater then open time');
      $("#close-timepicker input").val('');
    }
  }
}
function showPassword(e){
  if($(e).is(":checked")){
    $("#password").attr("type","text");
  }else{
    $("#password").attr("type","password");
  }
}

function fetchStates(id){
  $.ajax({
        url:"{{ url('/fetch-states') }}",
        type:"get",
        data:{
            country_id:id
        },
        beforeSend:function(){
            $("#states").html('');
        },
        success:function(response){
          if(response.status == true){
            $("#states").html(response.options);
          }
        }
    })
}

function fetchCities(id){
  $.ajax({
        url:"{{ url('/fetch-cities') }}",
        type:"get",
        data:{
            state_id:id
        },
        beforeSend:function(){
            $("#cities").html('');
        },
        success:function(response){
          if(response.status == true){
            $("#cities").html(response.options);
          }
        }
    })
}
</script>
@endsection