<div class="modal-dialog modal-lg">
  <div class="modal-content">
    <div class="modal-header">
      <h4 class="modal-title">{{$pageTitle}}</h4>
      <button type="button" class="close" data-dismiss="modal" aria-label="Close">
        <span aria-hidden="true">&times;</span>
      </button>
    </div>
    <div class="modal-body">
      <form method="post" action="{{ url('admin/salons/services/edit/'.$record->id) }}" id="modalForm">
          {{csrf_field()}}
          <div class="card-body">
            
            <div class="form-group">
              <label>Service</label>
              <select id="states" name="service_id" class="form-control select2"  required>
                  <option value="">Select Service</option>
                  @foreach($services as $service)
                  <option {{ ($record->service_id == $service->id)?'selected':'' }} value="{{ $service->id }}">{{$service->name}}</option>
                  @endforeach
              </select>
              @error('service_id')
                  <div class="text-danger mt-2 mb-2" role="alert">
                      <strong>{{ $message }}</strong>
                  </div>
              @enderror
            </div>
            <div class="form-group">
              <label>Service Name</label>
              <input type="text" class="form-control @error('service_name') is-invalid @enderror" name="service_name" value="{{$record->service_name}}" placeholder="Enter Service Name" required>
              @error('service_name')
                  <div class="text-danger mt-2 mb-2" role="alert">
                      <strong>{{ $message }}</strong>
                  </div>
              @enderror
            </div>
            <div class="form-group">
              <label>Description</label>
              <input type="text" class="form-control @error('service_description') is-invalid @enderror" name="service_description" value="{{$record->service_description}}" placeholder="Enter service description" required>
              @error('service_description')
                  <div class="text-danger mt-2 mb-2" role="alert">
                      <strong>{{ $message }}</strong>
                  </div>
              @enderror
            </div>
            <div class="form-group">
              <label>Duration</label>
              <input type="text" id="duration" class="form-control @error('duration') is-invalid @enderror" name="duration" value="{{$record->duration}}" placeholder="HH:MM" required  data-inputmask='"mask": "99:99:99"' data-mask>
              @error('duration')
                  <div class="text-danger mt-2 mb-2" role="alert">
                      <strong>{{ $message }}</strong>
                  </div>
              @enderror
            </div>
            <div class="form-group">
              <label>Price</label>
              <input type="text" class="form-control @error('price') is-invalid @enderror" name="price" value="{{$record->price}}" placeholder="Enter Price" required>
              @error('price')
                  <div class="text-danger mt-2 mb-2" role="alert">
                      <strong>{{ $message }}</strong>
                  </div>
              @enderror
            </div>
          </div>
          <!-- /.card-body -->
        </form>
    </div>
    <div class="modal-footer justify-content-between">
      <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
      <button type="submit" id="submit_form" form="modalForm" class="btn btn-primary">Save</button>
    </div>
  </div>
</div>
<script src="assets/plugins/inputmask/jquery.inputmask.min.js"></script>
<script>
$(document).ready(function(){
  initSelect();

  $('[data-mask]').inputmask();


  $("#modalForm").submit(function(e){
        e.preventDefault(); // avoid to execute the actual submit of the form.
        var url = $("#modalForm").attr("action");
        $.ajax({
            type: "POST",
            url: url,
            data:$("#modalForm").serialize(),
            dataType:'json',
            beforeSend:function(){
                $("#submit_form").html("<i class='fa fa-spin fa-spinner'></i>");
                $("#submit_form").attr("disabled","disabled");

            },
            success:function(response){
             $("#submit_form").removeClass("spinner-border spinner-border-sm");
              if(response.status == true){
                  successMessage(response.message); 
                  closeModal();
                  loadServices('{{$record->saloon_id}}');
              }else{
                errorMessage(response.message);
              }
            }
        });
    })
});
</script>