@extends('layouts.master')

@section('content')
<iframe id="export_frame" style="display:none;"></iframe>
<!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0 text-dark">{{$pageTitle}}</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="{{ url('/admin') }}">Dashboard</a></li>
              <li class="breadcrumb-item active">{{$pageTitle}}</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <!-- Small boxes (Stat box) -->
        <div class="row">
          <div class="col-lg-12 col-12">
             <!-- general form elements -->
            <div class="card card-primary">
              <div class="card-header">
                <h3 class="card-title float-left">
                  <span class="mt-1 d-block">Fill form detail</span>
                </h3>
                <div class="float-right">
                  <a href="{{ url('admin/salons') }}" class="btn btn-secondary btn-sm"><i class="fa fa-angle-left"></i> Back</a>
                </div>
                <div  class="clearfix"></div>
              </div>
              <!-- /.card-header -->
              <!-- form start -->
              <form method="post" enctype="multipart/form-data">
                {{csrf_field()}}
                <div class="card-body">
                  <div class="form-group">
                    <label>Salon Name</label>
                    <input type="text" class="form-control @error('saloon_name') is-invalid @enderror" name="saloon_name" value="{{ $record->saloon_name }}" placeholder="Enter Salon Name" required>
                    @error('saloon_name')
                        <div class="text-danger mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>
                  <div class="form-group">
                    <label>Contact Person Name</label>
                    <input type="text" class="form-control @error('contact_person') is-invalid @enderror" name="contact_person" value="{{ $record->contact_person }}" placeholder="Enter Contact Person Name" required>
                    @error('contact_person')
                        <div class="text-danger mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>
                  <div class="form-group">
                    <label>Email</label>
                    <input type="email" class="form-control @error('email') is-invalid @enderror" name="email" value="{{ $record->email }}" placeholder="Enter Email">
                    @error('email')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>
                  <div class="form-group">
                    <label>Mobile</label>
                    <input type="text" class="form-control @error('mobile') is-invalid @enderror" name="mobile" value="{{ $record->mobile }}" placeholder="Enter Mobile Number" required>
                    @error('mobile')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>
                  <div class="form-group">
                    <label>Address</label>
                    <textarea class="form-control @error('street_address') is-invalid @enderror" name="street_address" placeholder="Enter Address">{{ $record->street_address }}</textarea>
                    @error('street_address')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>

                  <div class="form-group">
                    <label>Address Line 2</label>
                    <input type="text" class="form-control @error('address_line_2') is-invalid @enderror" name="address_line_2" value="{{ $record->address_line_2 }}" placeholder="Enter address line 2">
                    @error('address_line_2')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>

                  <div class="form-group">
                    <label>Country</label>
                    <select name="country_id" class="form-control select2" onchange="fetchStates(this.value)">
                        <option value="">Select Country</option>
                        @foreach($countries as $country)
                        <option {{($country->id == $record->country_id)?'selected':''}} value="{{ $country->id }}">{{$country->name}}</option>
                        @endforeach
                    </select>
                    <!-- <input type="text" class="form-control @error('city') is-invalid @enderror" name="city" value="{{ $record->city }}" placeholder="Enter City" required> -->
                    @error('country_id')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>
                  <div class="form-group">
                    <label>State</label>
                    <select id="states" name="state_id" class="form-control select2" onchange="fetchCities(this.value)">
                        <option value="">Select State</option>
                        @foreach($states as $state)
                        <option {{($state->id == $record->state_id)?'selected':''}} value="{{ $state->id }}">{{$state->name}}</option>
                        @endforeach
                    </select>
                    <!-- <input type="text" class="form-control @error('city') is-invalid @enderror" name="city" value="{{ $record->city }}" placeholder="Enter City" required> -->
                    @error('state_id')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>
                  <div class="form-group">
                    <label>City</label>
                    <select id="cities" name="city_id" class="form-control select2">
                        <option value="">Select City</option>
                        @foreach($cities as $city)
                        <option {{($city->id == $record->city_id)?'selected':''}} value="{{ $city->id }}">{{$city->name}}</option>
                        @endforeach
                    </select>
                    <!-- <input type="text" class="form-control @error('city') is-invalid @enderror" name="city" value="{{ $record->city }}" placeholder="Enter City" required> -->
                    @error('city')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>

                  <div class="form-group">
                    <label>Zipcode</label>
                    <input type="number" class="form-control @error('zipcode') is-invalid @enderror" name="zipcode" value="{{ $record->zipcode }}" placeholder="Enter zipcode">
                    @error('zipcode')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>

                  <div class="form-group">
                    <label>Open/Close Time</label>
                      <div class="row">
                        <div class="col-md-6">
                          <div class="input-group date" id="open-timepicker" data-target-input="nearest">
                            <input type="text" name="open_time" autocomplete="off" placeholder="Enter Open Time" value="{{ $record->open_time }}" class="form-control datetimepicker-input" data-target="#open-timepicker"/>
                            <div class="input-group-append" data-target="#open-timepicker" data-toggle="datetimepicker">
                                <div class="input-group-text"><i class="far fa-clock"></i></div>
                            </div>
                          </div>
                          @error('open_time')
                              <div class="error invalid-feedback mt-2 mb-2" role="alert">
                                  <strong>{{ $message }}</strong>
                              </div>
                          @enderror
                        </div>
                        <div class="col-md-6">
                          <div class="input-group date" id="close-timepicker" data-target-input="nearest">
                            <input type="text" name="close_time" autocomplete="off" placeholder="Enter Close Time" value="{{ $record->close_time }}" class="form-control datetimepicker-input" data-target="#close-timepicker"/>
                            <div class="input-group-append" data-target="#close-timepicker" data-toggle="datetimepicker">
                                <div class="input-group-text"><i class="far fa-clock"></i></div>
                            </div>
                          </div>
                          @error('close_time')
                              <div class="error invalid-feedback mt-2 mb-2" role="alert">
                                  <strong>{{ $message }}</strong>
                              </div>
                          @enderror
                          @if (session('time_error'))
                              <div class="text-danger mt-2 mb-2" role="alert">
                                  <strong>{{ session('time_error') }}</strong>
                              </div>
                          @endif
                        </div>
                      </div>
                  </div>
                  <div class="form-group">
                    <label>Password</label>
                    <input type="password" id="password" class="form-control @error('password') is-invalid @enderror" name="password" placeholder="Password">
                    @error('password')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                    <div class="mt-2">
                      <div class="icheck-primary d-inline">
                        <input type="checkbox" id="checkboxPrimary1" onchange="showPassword(this)">
                        <label for="checkboxPrimary1">Show Password</label>
                      </div>
                    </div>
                  </div>
                  <div class="form-group">
                    <label>Bank Name</label>
                    <input type="text" class="form-control @error('bank_name') is-invalid @enderror" name="bank_name" value="{{ $record->bank_name }}" placeholder="Enter Bank Name">
                    @error('bank_name')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>
                  <div class="form-group">
                    <label>Account Number</label>
                    <input type="text" class="form-control @error('account_number') is-invalid @enderror" name="account_number" value="{{ $record->account_number }}" placeholder="Enter Bank Account Number">
                    @error('account_number')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>
                  <div class="form-group">
                    <label>IFSC Code</label>
                    <input type="text" class="form-control @error('ifsc_code') is-invalid @enderror" name="ifsc_code" value="{{ $record->ifsc_code }}" placeholder="Enter Bank IFSC Code">
                    @error('ifsc_code')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>
                  <div class="form-group">
                    <label>UPI ID</label>
                    <input type="text" class="form-control @error('upi_id') is-invalid @enderror" name="upi_id" value="{{ $record->upi_id }}" placeholder="Enter UPI Id">
                    @error('upi_id')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>

                  <div class="form-group">
                    <label>Razorpay Account Id</label>
                    <input type="text" class="form-control @error('razorpay_account_id') is-invalid @enderror" name="razorpay_account_id" value="{{ $record->razorpay_account_id }}" placeholder="Enter Razorpay Account Id">
                    @error('razorpay_account_id')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>
                  
                  

                  <div class="form-group">
                    <label>Youtube URL</label>
                    <input type="url" class="form-control @error('youtube_url') is-invalid @enderror" name="youtube_url" value="{{ $record->youtube_url }}" placeholder="Enter Youtube Url">
                    @error('youtube_url')
                        <div class="error invalid-feedback mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>

                  <div class="form-group">
                    <label for="exampleInputFile">File input</label>
                    <div class="input-group">
                      <div class="custom-file">
                        <input type="file" class="custom-file-input" id="exampleInputFile" name="owner_image">
                        <label class="custom-file-label" for="exampleInputFile">Choose file</label>
                      </div>
                      <!-- <div class="input-group-append">
                        <span class="input-group-text">Upload</span>
                      </div> -->
                    </div>
                    <div class="mt-2">
                      @if($record->owner_image != '' && file_exists('uploads/profile_images/'.$record->owner_image))
                       <img src="{{ url('/uploads/profile_images/'.$record->owner_image) }}" class="img-circle elevation-2" width="80" height="80" />
                      @endif
                    </div>
                    <div class="mt-2">
                      <button type="button" id="btn_owner_image" class="btn btn-default" onclick="downloadownerimage('{{$record->owner_image}}')"><i class="fa fa-download"></i> Download</button>
                    </div>
                  </div>

                  <div class="row">
                    <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
                      <h3>Gallery Images</h3>
                    </div>
                    <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
                      @if(isset($gallery[0]->id))
                      <input type="hidden" name="gallery_image_1_id" value="{{$gallery[0]->id}}">
                      @endif
                      <div class="form-group">
                        <label for="exampleInputFile">Image 1</label>
                        <div class="input-group">
                          <div class="custom-file">
                            <input type="file" class="custom-file-input" id="exampleInputFile" name="gallery_image_1">
                            <label class="custom-file-label" for="exampleInputFile">Choose file</label>
                          </div>
                          <!-- <div class="input-group-append">
                            <span class="input-group-text">Upload</span>
                          </div> -->
                        </div>
                        @if(count($gallery) > 0 && isset($gallery[0]))
                          <div class="mt-2">
                            @if($gallery[0]->image != '' && file_exists('uploads/saloon_gallery/'.$gallery[0]->image))
                             <img src="{{ url('/uploads/saloon_gallery/'.$gallery[0]->image) }}" class="img-circle elevation-2" width="80" height="80" />
                            @endif
                          </div>
                          <div class="mt-2">
                            <button type="button" id="btn_gallery_1" class="btn btn-default" onclick="downloadimage('{{$gallery[0]->image}}')"><i class="fa fa-download"></i> Download</button>
                          </div>
                        @endif
                      </div>
                    </div>

                    <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
                      @if(isset($gallery[1]->id))
                      <input type="hidden" name="gallery_image_2_id" value="{{$gallery[1]->id}}">
                      @endif
                      <div class="form-group">
                        <label for="exampleInputFile">Image 2</label>
                        <div class="input-group">
                          <div class="custom-file">
                            <input type="file" class="custom-file-input" id="exampleInputFile" name="gallery_image_2">
                            <label class="custom-file-label" for="exampleInputFile">Choose file</label>
                          </div>
                          <!-- <div class="input-group-append">
                            <span class="input-group-text">Upload</span>
                          </div> -->
                        </div>
                        @if(count($gallery) > 0 && isset($gallery[1]))
                          <div class="mt-2">
                            @if($gallery[1]->image != '' && file_exists('uploads/saloon_gallery/'.$gallery[1]->image))
                             <img src="{{ url('/uploads/saloon_gallery/'.$gallery[1]->image) }}" class="img-circle elevation-2" width="80" height="80" />
                            @endif
                          </div>
                          <div class="mt-2">
                            <button type="button" id="btn_gallery_2" class="btn btn-default" onclick="downloadimage('{{$gallery[1]->image}}')"><i class="fa fa-download"></i> Download</button>
                          </div>
                        @endif
                      </div>
                    </div>

                    <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
                      @if(isset($gallery[2]->id))
                      <input type="hidden" name="gallery_image_3_id" value="{{$gallery[2]->id}}">
                      @endif
                      <div class="form-group">
                        <label for="exampleInputFile">Image 3</label>
                        <div class="input-group">
                          <div class="custom-file">
                            <input type="file" class="custom-file-input" id="exampleInputFile" name="gallery_image_3">
                            <label class="custom-file-label" for="exampleInputFile">Choose file</label>
                          </div>
                          <!-- <div class="input-group-append">
                            <span class="input-group-text">Upload</span>
                          </div> -->
                        </div>
                        @if(count($gallery) > 0 && isset($gallery[2]))
                          <div class="mt-2">
                            @if($gallery[2]->image != '' && file_exists('uploads/saloon_gallery/'.$gallery[2]->image))
                             <img src="{{ url('/uploads/saloon_gallery/'.$gallery[2]->image) }}" class="img-circle elevation-2" width="80" height="80" />
                            @endif
                          </div>
                          <div class="mt-2">
                            <button type="button" id="btn_gallery_3" class="btn btn-default" onclick="downloadimage('{{$gallery[2]->image}}')"><i class="fa fa-download"></i> Download</button>
                          </div>
                        @endif
                      </div>
                    </div>
                  </div>

                  <div class="form-group">
                    <label>Status</label>
                    <div>
                      <input type="checkbox" name="status" {{ ($record->status)?'checked':'' }} data-bootstrap-switch>
                    </div>
                  </div>
                  <div class="services">
                    @error('services')
                        <div class="text-danger mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                    <a href="javascript:;" onclick="showPopup('<?php echo url('/admin/salons/services/add/'.$record->id) ?>')" class="btn btn-warning mr-2 btn-sm"><i class="fa fa-plus"></i> Add Services</a>
                    <div id="services" class="mt-2"></div>
                    <!-- <table class="table">
                        <thead>
                        <tr>
                          <th colspan="3">Select Services</th>
                        </tr>
                        <tr>
                          <th>
                            <div class="icheck-primary d-inline">
                              <input type="checkbox" id="checkboxPrimary-all">
                              <label for="checkboxPrimary-all">
                              </label>
                            </div>
                          </th>
                          <th>Services</th>
                          <th>Service Name</th>
                          <th>Description</th>
                          <th>Duration</th>
                          <th>Price</th>
                        </tr>
                        </thead>
                        <tbody>
                          @foreach($services as $key => $service)
                          <tr>
                              <td>
                                <input {{ !isset($saloon_services[$service->id])?'disabled':'' }} type="hidden" name="services_ids[]" value="{{ $service->id }}" class="form-control" required />
                                <div class="icheck-primary d-inline">
                                  <input {{ isset($saloon_services[$service->id])?'checked':'' }} type="checkbox" id="checkboxPrimary-{{ $key }}" value="{{ $service->id }}" class="service_id" name="services[{{ $key }}][service_id]">
                                  <label for="checkboxPrimary-{{ $key }}">
                                  </label>
                                </div>
                              </td>
                              <td>{{$service->name}}</td>
                              <td>
                                <input {{ !isset($saloon_services[$service->id])?'disabled':'' }} type="text" name="services[{{ $key }}][service_name]" value="{{ isset($saloon_services[$service->id])?$saloon_services[$service->id]['service_name']:'' }}" class="form-control" placeholder="Enter Service Name" required  />
                              </td>
                              <td>
                                <input {{ !isset($saloon_services[$service->id])?'disabled':'' }} type="text" name="services[{{ $key }}][service_description]" value="{{ isset($saloon_services[$service->id])?$saloon_services[$service->id]['service_description']:'' }}" class="form-control" placeholder="Enter Service Description" required  />
                              </td>
                              <td>
                                <input {{ !isset($saloon_services[$service->id])?'disabled':'' }} type="text" name="services[{{ $key }}][duration]" value="{{ isset($saloon_services[$service->id])?$saloon_services[$service->id]['duration']:'' }}" class="form-control" placeholder="Enter Duration"  }} type="text" name="services[{{ $key }}][duration]" value="{{ isset($barber_services[$service->id])?$barber_services[$service->id]:'' }}" class="form-control" placeholder="HH:MM" required  data-inputmask='"mask": "99:99:99"' data-mask   />
                              </td>
                              <td>
                                <input {{ !isset($saloon_services[$service->id])?'disabled':'' }} type="text" name="services[{{ $key }}][price]" value="{{ isset($saloon_services[$service->id])?$saloon_services[$service->id]['price']:'' }}" class="form-control" placeholder="Enter Price" required  />
                              </td>
                          </tr>
                          @endforeach
                        </tbody>
                    </table> -->
                  </div>
                </div>
                <!-- /.card-body -->

                <div class="card-footer">
                  <button type="submit" class="btn btn-primary">Submit</button>
                </div>
              </form>
            </div>
            <!-- /.card -->
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
@endsection

@section('javascript')
<link rel="stylesheet" href="assets/plugins/bs-stepper/css/bs-stepper.min.css">
<link rel="stylesheet" href="assets/plugins/daterangepicker/daterangepicker.css">

<script src="assets/plugins/bootstrap-switch/js/bootstrap-switch.min.js"></script>
<script src="assets/plugins/bs-stepper/js/bs-stepper.min.js"></script>
<script src="assets/plugins/moment/moment.min.js"></script>
<script src="assets/plugins/daterangepicker/daterangepicker.js"></script>
<script src="assets/plugins/inputmask/jquery.inputmask.min.js"></script>
<script type="text/javascript">
$(document).ready(function(){
    $("input[data-bootstrap-switch]").each(function(){
      $(this).bootstrapSwitch({
        onText:"Enable",
        offText:"Disable"
      });
    });
    $('#open-timepicker').datetimepicker({
        format: 'HH:mm',
        pickDate: false,
        pickSeconds: false,
        pick12HourFormat: false   
    });
    $('#close-timepicker').datetimepicker({
        format: 'HH:mm',
        pickDate: false,
        pickSeconds: false,
        pick12HourFormat: false   
    });

    $("#checkboxPrimary-all").change(function(){
        if($(this).is(":checked")){
          $(".service_id").prop("checked",true);
          $(".services .form-control").removeAttr("disabled");
        }else{
          $(".service_id").prop("checked",false);
          $(".services .form-control").attr("disabled","disabled");
        }
    });

    $(".service_id").change(function(){
        if($(this).is(":checked")){
          $(this).parents('tr').find(".form-control").removeAttr("disabled");
        }else{
          $(this).parents('tr').find(".form-control").attr("disabled","disabled");
        }
    });
    $('[data-mask]').inputmask();
})

function showPassword(e){
  if($(e).is(":checked")){
    $("#password").attr("type","text");
  }else{
    $("#password").attr("type","password");
  }
}

function fetchStates(id){
  $.ajax({
        url:"{{ url('/fetch-states') }}",
        type:"get",
        data:{
            country_id:id
        },
        beforeSend:function(){
            $("#states").html('');
        },
        success:function(response){
          if(response.status == true){
            $("#states").html(response.options);
          }
        }
    })
}

function fetchCities(id){
  $.ajax({
        url:"{{ url('/fetch-cities') }}",
        type:"get",
        data:{
            state_id:id
        },
        beforeSend:function(){
            $("#cities").html('');
        },
        success:function(response){
          if(response.status == true){
            $("#cities").html(response.options);
          }
        }
    })
}
loadServices("{{ $record->id }}");
function loadServices(saloon_id){
  $.ajax({
        url: "{{ url('admin/salons/services') }}",
        data:{
          saloon_id:saloon_id
        },
        dataType:'json',
        beforeSend:function(){
            $("#services").html("<i class='fa fa-spin fa-spinner'></i>");

        },
        success:function(response){
          if(response.status == true){
              $("#services").html(response.contents);
          }else{
            errorMessage(response.message);
          }
        }
    });
}

function downloadimage(filename)
{
  $("#export_frame").attr("src","{{url('admin/salons/downloadimage')}}/"+filename);
}
function downloadownerimage(filename)
{
  $("#export_frame").attr("src","{{url('admin/salons/downloadownerimage')}}/"+filename);
}
</script>
@endsection