@extends('layouts.master')
@section('content')
<!-- Content Header (Page header) -->
<div class="content-header">
   <div class="container-fluid">
      <div class="row mb-2">
         <div class="col-sm-6">
            <h1 class="m-0 text-dark">{{$pageTitle}}</h1>
         </div>
         <!-- /.col -->
         <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
               <li class="breadcrumb-item"><a href="{{ url('/admin') }}">Dashboard</a></li>
               <li class="breadcrumb-item active">{{$pageTitle}}</li>
            </ol>
         </div>
         <!-- /.col -->
      </div>
      <!-- /.row -->
   </div>
   <!-- /.container-fluid -->
</div>
<!-- /.content-header -->
<!-- Main content -->
<section class="content">
   <div class="container-fluid">
      <!-- Small boxes (Stat box) -->
      <div class="row">
         <div class="col-lg-12 col-12">
            <!-- general form elements -->
            <div class="card card-primary">
               <div class="card-header">
                  <h3 class="card-title float-left">
                     <span class="mt-1 d-block"></span>
                  </h3>
                  <div class="float-right">
                     <a href="{{ url('admin/salons') }}" class="btn btn-secondary btn-sm"><i class="fa fa-angle-left"></i> Back</a>
                  </div>
                  <div  class="clearfix"></div>
               </div>
               <!-- /.card-header -->
               <!-- form start -->
               <div class="card-body">
                  <div class="row">
                     <div class="col-md-6">
                        <div class="form-group">
                           <label>Saloon Name</label>
                           <div class="form-control">{{ $record->saloon_name }}</div>
                           
                        </div>
                     </div>
                     <div class="col-md-6">
                        <div class="form-group">
                           <label>Contact Person Name</label>
                           <div class="form-control">{{ $record->contact_person }}</div>
                        </div>
                     </div>
                     <div class="col-md-6">
                        <div class="form-group">
                           <label>Email</label>
                           <div class="form-control">{{ $record->email }}</div>
                        </div>
                     </div>
                     <div class="col-md-6">
                        <div class="form-group">
                           <label>Mobile</label>
                           <div class="form-control">{{ $record->mobile }}</div>
                        </div>
                     </div>
                     <div class="col-md-6">
                        <div class="form-group">
                           <label>Address</label>
                           <div class="form-control">{{ $record->street_address }}</div>
                           
                        </div>
                     </div>
                     <div class="col-md-6">
                        <div class="form-group">
                           <label>Address Line 2</label>
                           <div class="form-control">{{ $record->address_line_2 }}</div>
                           
                        </div>
                     </div>
                     <div class="col-md-6">
                        <div class="form-group">
                           <label>Country</label>
                           @if(!empty($record->Country))
                           <div class="form-control">{{ $record->Country->name }}</div>
                           @endif
                        </div>
                     </div>
                     <div class="col-md-6">
                        <div class="form-group">
                           <label>State</label>
                           @if(!empty($record->State))
                           <div class="form-control">{{ $record->State->name }}</div>
                           @endif
                        </div>
                     </div>
                     <div class="col-md-6">
                        <div class="form-group">
                           <label>City</label>
                           @if(!empty($record->City))
                           <div class="form-control">{{ $record->City->name }}</div>
                           @endif
                        </div>
                     </div>
                     <div class="col-md-6">
                        <div class="form-group">
                           <label>Zipcode</label>
                           <div class="form-control">{{ $record->zipcode }}</div>
                        </div>
                     </div>
                     <div class="col-md-6">
                        <div class="form-group">
                           <label>Open/Close Time</label>
                           <div class="form-control">
                              {{ $record->open_time }} to {{ $record->close_time }}
                           </div>
                        </div>
                     </div>
                     <div class="col-md-6">
                        <div class="form-group">
                           <label>Bank Name</label>
                           <div class="form-control">{{ $record->bank_name }}</div>
                        </div>
                     </div>
                     <div class="col-md-6">
                        <div class="form-group">
                           <label>Account Number</label>
                           <div class="form-control">{{ $record->account_number }}</div>
                        </div>
                     </div>
                     <div class="col-md-6">
                        <div class="form-group">
                           <label>IFSC Code</label>
                           <div class="form-control">{{ $record->ifsc_code }}</div>
                        </div>
                     </div>
                     <div class="col-md-6">
                        <div class="form-group">
                           <label>UPI ID</label>
                           <div class="form-control">{{ $record->upi_id }}</div>
                        </div>
                     </div>
                     <div class="col-md-6">
                        <div class="form-group">
                           <label>Youtube URL</label>
                           <div class="form-control">{{ $record->youtube_url }}</div>
                        </div>
                     </div>
                     <div class="col-md-6">
                        <div class="form-group">
                           <label>Status</label>
                           <div>
                              @if($record->status == 1)
                                <span class="btn btn-success">Enable</span>
                              @else
                                <span class="btn btn-danger">Disable</span>
                              @endif
                           </div>
                        </div>
                     </div>
                     <div class="col-md-12">
                        <div class="services">
                           <div id="services" class="mt-2">
                              <table class="table">
                                <thead>
                                  <tr>
                                    <th colspan="3">Selected Services</th>
                                  </tr>
                                  <tr>
                                    <th>Services</th>
                                    <th>Service Name</th>
                                    <th>Description</th>
                                    <th>Duration</th>
                                    <th>Price</th>
                                  </tr>
                                </thead>
                                <tbody>
                                    @foreach($services as $key => $service)
                                    <tr>
                                        <td>
                                            @if(!empty($service->Service))
                                            {{$service->Service->name}}
                                            @endif
                                        </td>
                                        <td>
                                          {{$service->service_name}}
                                        </td>
                                        <td>
                                          {{$service->service_description}}
                                        </td>
                                        <td>
                                          {{$service->duration}}
                                        </td>
                                        <td>
                                          {{$service->price}}
                                        </td>
                                    </tr>
                                    @endforeach
                                  </tbody>
                              </table>
                           </div>
                        </div>
                     </div>
                  </div>
               </div>
            </div>
            <!-- /.card -->
         </div>
      </div>
   </div>
   <!-- /.container-fluid -->
</section>
<!-- /.content -->
@endsection
@section('javascript')
@endsection