@extends('layouts.master')

@section('content')
<!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0 text-dark">{{$pageTitle}}</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="{{ url('/admin') }}">Dashboard</a></li>
              <li class="breadcrumb-item active">{{$pageTitle}}</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <!-- Small boxes (Stat box) -->
        <div class="row">
          <div class="col-lg-12 col-12">
             <!-- general form elements -->
            <div class="card card-primary">
              <div class="card-header">
                <h3 class="card-title float-left">
                  <span class="mt-1 d-block">Fill form detail</span>
                </h3>
                <div class="float-right">
                  <a href="{{ url('admin/settings') }}" class="btn btn-secondary btn-sm"><i class="fa fa-angle-left"></i> Back</a>
                </div>
                <div  class="clearfix"></div>
              </div>
              <!-- /.card-header -->
              <!-- form start -->
              <form method="post" action="{{ url('admin/settings/update')}}">
                {{csrf_field()}}
                <div class="card-body">
                  <div class="form-group">
                    <label>Razorpay Key Id</label>
                    <input type="text" class="form-control @error('razorpay_key') is-invalid @enderror" name="razorpay_key" value="{{$settings['razorpay_key']}}" placeholder="Enter Razorpay Key" required>
                    @error('razorpay_key')
                        <div class="text-danger mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>

                  <div class="form-group">
                    <label>Razorpay Secret</label>
                    <input type="text" class="form-control @error('razorpay_secret') is-invalid @enderror" name="razorpay_secret" value="{{$settings['razorpay_secret']}}" placeholder="Enter Razorpay Secret" required>
                    @error('razorpay_secret')
                        <div class="text-danger mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>

                  {{-- <div class="form-group">
                    <label>Phonepay Salt Key</label>
                    <input type="text" class="form-control @error('phonepay_salt_key') is-invalid @enderror" name="phonepay_salt_key" value="{{$settings['phonepay_salt_key']}}" placeholder="Enter Phonepay salt key" required>
                    @error('phonepay_salt_key')
                        <div class="text-danger mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>

                  <div class="form-group">
                    <label>Phonepay Merchant Id</label>
                    <input type="text" class="form-control @error('[phonepay_merchant_id]') is-invalid @enderror" name="phonepay_merchant_id" value="{{$settings['phonepay_merchant_id']}}" placeholder="Enter Phonepay merchant id" required>
                    @error('phonepay_merchant_id')
                        <div class="text-danger mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div> --}}

                  {{-- <div class="form-group">
                    <label>Phonepay Api Url</label>
                    <input type="text" class="form-control @error('phonepay_api_url') is-invalid @enderror" name="phonepay_api_url" value="{{$settings['phonepay_api_url']}}" placeholder="Enter phonepay api url" required>
                    @error('phonepay_api_url')
                        <div class="text-danger mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div> --}}


                   <div class="form-group">
                    <label>Twilio Phone Number</label>
                    <input type="text" class="form-control @error('twilio_phone_number') is-invalid @enderror" name="twilio_phone_number" value="{{$settings['twilio_phone_number']}}" placeholder="Enter Twilio Phone Number" required>
                    @error('twilio_phone_number')
                        <div class="text-danger mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>
                  
                  <div class="form-group">
                    <label>Twilio SID</label>
                    <input type="text" class="form-control @error('twilio_sid') is-invalid @enderror" name="twilio_sid" value="{{$settings['twilio_sid']}}" placeholder="Enter Twilio SID" required>
                    @error('twilio_sid')
                        <div class="text-danger mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>
                  
                  <div class="form-group">
                    <label>Twilio Auth Token</label>
                    <input type="text" class="form-control @error('twilio_auth_token') is-invalid @enderror" name="twilio_auth_token" value="{{$settings['twilio_auth_token']}}" placeholder="Enter Twilio Auth Token" required>
                    @error('twilio_auth_token')
                        <div class="text-danger mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>

                  <div class="form-group">
                    <label>Commission (%)</label>
                    <input type="text" class="form-control @error('commission_percent') is-invalid @enderror" name="commission_percent" value="{{$settings['commission_percent']}}" placeholder="Enter Commission" required>
                    @error('commission_percent')
                        <div class="text-danger mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>

                  <div class="form-group">
                    <label>Customer Charge (%)</label>
                    <input type="text" class="form-control @error('customer_charge') is-invalid @enderror" name="customer_charge" value="{{$settings['customer_charge']}}" placeholder="Enter Customer Charge" required>
                    @error('customer_charge')
                        <div class="text-danger mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>

                  <div class="form-group">
                    <label>Saloon App Version</label>
                    <input type="text" class="form-control @error('app_version') is-invalid @enderror" name="app_version" value="{{$settings['app_version']}}" placeholder="Enter App Version" required>
                    @error('app_version')
                        <div class="text-danger mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>

                  <div class="form-group">
                    <label>Customer App Version</label>
                    <input type="text" class="form-control @error('customer_app_version') is-invalid @enderror" name="customer_app_version" value="{{$settings['customer_app_version']}}" placeholder="Enter Customer App Version" required>
                    @error('customer_app_version')
                        <div class="text-danger mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>

                  {{-- <div class="form-group">
                    <label>Barber App Version</label>
                    <input type="text" class="form-control @error('barber_app_version') is-invalid @enderror" name="barber_app_version" value="{{$settings['barber_app_version']}}" placeholder="Enter Barber App Version" required>
                    @error('barber_app_version')
                        <div class="text-danger mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>  --}}
                  
                  <div class="form-group">
                    <label>Global Pin</label>
                    <input type="number" minlength="4" maxlength="4" class="form-control @error('global_pin') is-invalid @enderror" name="global_pin" value="{{$settings['global_pin']}}" placeholder="Enter Global Pin" required>
                    @error('global_pin')
                        <div class="text-danger mt-2 mb-2" role="alert">
                            <strong>{{ $message }}</strong>
                        </div>
                    @enderror
                  </div>
                  
                </div>
                <!-- /.card-body -->

                <div class="card-footer">
                  <button type="submit" class="btn btn-primary">Submit</button>
                </div>
              </form>
            </div>
            <!-- /.card -->
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
@endsection

@section('javascript')
<link rel="stylesheet" href="assets/plugins/bs-stepper/css/bs-stepper.min.css">
<script src="assets/plugins/bootstrap-switch/js/bootstrap-switch.min.js"></script>
<script src="assets/plugins/bs-stepper/js/bs-stepper.min.js"></script>
<script type="text/javascript">
$(document).ready(function(){
  $("input[data-bootstrap-switch]").each(function(){
      $(this).bootstrapSwitch({
        onText:"Enable",
        offText:"Disable"
      });
    });
})
function showPassword(e){
  if($(e).is(":checked")){
    $("#password").attr("type","text");
  }else{
    $("#password").attr("type","password");
  }
}
function fetchStates(id){
  $.ajax({
        url:"{{ url('/fetch-states') }}",
        type:"get",
        data:{
            country_id:id
        },
        beforeSend:function(){
            $("#states").html('');
        },
        success:function(response){
          if(response.status == true){
            $("#states").html(response.options);
          }
        }
    })
}

function fetchCities(id){
  $.ajax({
        url:"{{ url('/fetch-cities') }}",
        type:"get",
        data:{
            state_id:id
        },
        beforeSend:function(){
            $("#cities").html('');
        },
        success:function(response){
          if(response.status == true){
            $("#cities").html(response.options);
          }
        }
    })
}
</script>
@endsection