<?php

use Illuminate\Http\Request;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/


Route::post('/test-payment', 'Webservices\CustomersController@test_payment');
Route::post('/test_upi_payment','Webservices\CommonController@phonepay_test_api');
Route::post('/phonepay-callback', 'Webservices\CommonController@phonepay_webhook');
Route::post('/test_notification','Webservices\CommonController@test_notification');
Route::any('/booking-cron','Scheduler\ReminderbookingController@index');
Route::any('/clear-booking-cron','Scheduler\ClearBookingController@index');
Route::any('/booking-reminder-cron-unregister-customer','Scheduler\ReminderbookingController@unregister_customer');

//Route::any('/booking-reminder-cron-barber','Scheduler\RemindertenminutebarberController@index');  //this is for testing notification

Route::post('/test-message', 'Webservices\CommonController@test_message');

Route::middleware('auth:api')->get('/user', function (Request $request) {
    return $request->user();
});

Route::group(array('prefix' => 'saloons'), function () {
	Route::post('/login', 'Webservices\SaloonController@loginAsSaloon');
	Route::post('/register', 'Webservices\SaloonController@saloonRegister');
	Route::post('/edit-profile', 'Webservices\SaloonController@editProfile');
	Route::post('/edit-owner', 'Webservices\CommonController@editProfile');
	Route::post('/edit-salon', 'Webservices\CommonController@editSalon');
	Route::post('/update-visibility', 'Webservices\CommonController@update_visibility');
	Route::post('/all-services', 'Webservices\SaloonController@getAllServices');
	Route::post('/fetch-saloons', 'Webservices\SaloonController@getSaloonByService');
	Route::post('/saloon-services', 'Webservices\SaloonController@getSaloonServices');
	Route::post('/fetch-saloon-barbers', 'Webservices\SaloonController@getSaloonBarbers');
	Route::post('/countries', 'Webservices\SaloonController@Countries');
	Route::post('/states', 'Webservices\SaloonController@States');
	Route::post('/cities', 'Webservices\SaloonController@Cities');
	Route::post('/saloon-details', 'Webservices\SaloonController@getSaloonDetails');
	Route::post('/filter-options', 'Webservices\SaloonController@filterOptions');
	Route::post('/booking-list', 'Webservices\SaloonController@bookingList');
	Route::post('/saloon-income', 'Webservices\SaloonController@salooonIncome');
	Route::post('/delete-booking', 'Webservices\SaloonController@deleteBooking');
	Route::post('/edit-service', 'Webservices\SaloonController@editService');
	Route::post('/delete-service', 'Webservices\SaloonController@deleteService');

	Route::post('/get-salon-category', 'Webservices\SaloonController@getSalonCategory');
	Route::post('/add-salon-category', 'Webservices\SaloonController@addSalonCategory');
	Route::post('/edit-salon-category', 'Webservices\SaloonController@editSalonCategory');
	Route::post('/delete-salon-category', 'Webservices\SaloonController@deleteSalonCategory');
	Route::post('/services-by-saloon-category', 'Webservices\SaloonController@getServicesBySaloonCategory');
	
	Route::post('/update-show-earning', 'Webservices\CommonController@update_show_earning');
	Route::post('/update-manage-barber', 'Webservices\CommonController@update_manage_barber');
	
	Route::group(array('prefix' => 'barber'), function () {
		Route::post('/fetch', 'Webservices\SaloonController@fetchBarber');
		Route::post('/save', 'Webservices\SaloonController@saveBarber');
		Route::post('/update', 'Webservices\SaloonController@updateBarber');
		Route::post('/delete', 'Webservices\SaloonController@deleteBarber');
	});
	// Route::group(array('middleware' => 'saloonauth'), function () {
	// 	Route::post('/services', 'Webservices\SaloonController@getSaloonServices');
	// 	Route::post('/add-service', 'Webservices\SaloonController@addService');
	// 	Route::post('/delete-service', 'Webservices\SaloonController@deleteService');

	// 	Route::group(array('prefix' => 'barbers'), function () {
	// 		Route::post('/', 'Webservices\SaloonController@barbersList');
	// 		Route::post('/save', 'Webservices\SaloonController@saveBarber');
	// 		Route::post('/update', 'Webservices\SaloonController@updateBarber');
	// 		Route::post('/delete', 'Webservices\SaloonController@deleteBarber');
	// 	});
	// });
	Route::post('/myfav-saloon', 'Webservices\SaloonController@getMyFavouriteSaloon');
	Route::post('/check-saloon-number', 'Webservices\SaloonController@checkSaloonNumber');
	Route::post('/services-by-saloon', 'Webservices\SaloonController@getServicesBySaloon');

	Route::post('/delete-booking-emergency', 'Webservices\SaloonController@deleteBookingEmergency');
	Route::post('/get-saloonmonthlyincome', 'Webservices\SaloonController@getSaloonMonthlyIncome');
	Route::post('/get-saloonweeklyincome', 'Webservices\CommonController@getSaloonWeeklyIncome');
	Route::post('/add-saloonservice', 'Webservices\SaloonController@addSaloonService');
	Route::post('/add-multiple-saloonservice', 'Webservices\CommonController@addMultipleSaloonService');
	Route::post('/add-saloonloginpin', 'Webservices\SaloonController@addSaloonLoginPin');
	Route::post('/saloonpinlogin', 'Webservices\SaloonController@saloonPinLogin');
	Route::post('/forgotsaloonpin', 'Webservices\SaloonController@forgotsaloonLoginPin');
	Route::post('/update-socialmedialink', 'Webservices\SaloonController@updateSocialMediaLink');
	Route::post('/checkappversion', 'Webservices\SaloonController@checkAppVersion');
	// default service new

	Route::post('/default-services', 'Webservices\CommonController@getDefaultServices');
	Route::post('/add-defaultservice', 'Webservices\CommonController@addDefaultService');
});

Route::group(array('prefix' => 'barbers'), function () {
	Route::post('/login', 'Webservices\BarbersController@loginAsBarber');
	Route::post('/logout', 'Webservices\CommonController@logoutBarber');
	
	
	Route::post('/edit-profile', 'Webservices\BarbersController@editProfile');
	Route::post('/booking-list', 'Webservices\BarbersController@bookingList');

	Route::post('/barber-income', 'Webservices\BarbersController@barberIncome');
	Route::post('/list-schedule', 'Webservices\BarbersController@scheduleList');
	Route::post('/delete-schedule', 'Webservices\BarbersController@scheduleDelete');
	
	Route::post('/add-schedule', 'Webservices\BarbersController@addSchedule');
	Route::post('/update-schedule', 'Webservices\BarbersController@updateSchedule');
	// Route::post('/delete-schedule', 'Webservices\BarbersController@deleteSchedule');
	Route::post('/list-break', 'Webservices\BarbersController@breakList');
	Route::post('/add-break', 'Webservices\BarbersController@addBreak');
	Route::post('/update-break', 'Webservices\BarbersController@updateBreak');
	Route::post('/delete-break', 'Webservices\BarbersController@deleteBreak');

	Route::post('/update-notification-setting', 'Webservices\CommonController@update_barber_notification_setting');
	Route::post('/edit-mobile', 'Webservices\CommonController@edit_mobile');

	Route::group(array('middleware' => 'barberauth'), function () {
	Route::post('/saloon-services', 'Webservices\BarbersController@getSaloonServices');
	Route::post('/services', 'Webservices\BarbersController@getBarberServices');
	Route::post('/add-service', 'Webservices\BarbersController@addService');
	Route::post('/delete-service', 'Webservices\BarbersController@deleteService');

	});
	Route::post('/add-barber-service', 'Webservices\BarbersController@addBarberService');
	Route::post('/remove-barber-service', 'Webservices\BarbersController@removeBarberService');
	
	Route::post('/edit-barber-service', 'Webservices\BarbersController@editBarberService');
	Route::post('/get-barber-service', 'Webservices\BarbersController@getBarberService');
	Route::post('/get-barbernotification', 'Webservices\BarbersController@getBarberNotification');
	Route::post('/read-barbernotification', 'Webservices\BarbersController@readBarberNotification');
	Route::post('/delete-barbernotification', 'Webservices\BarbersController@deleteBarberNotification');
	Route::post('/get-notificationsettingbarber', 'Webservices\BarbersController@getNotificationSetting');
	Route::post('/edit-notificationsettingbarber', 'Webservices\BarbersController@editNotificationSetting');
	Route::post('/get-barberslotbydate', 'Webservices\BarbersController@getBarberSlotByDate');
	Route::post('/get-barbermonthlyincome', 'Webservices\BarbersController@getBarberMonthlyIncome');
	Route::post('/get-barberweeklyincome', 'Webservices\CommonController@getBarberWeeklyIncome');
	Route::post('/add-barberloginpin', 'Webservices\BarbersController@addBarberLoginPin');
	Route::post('/barberpinlogin', 'Webservices\BarbersController@barberPinLogin');
	Route::post('/forgotbarberpin', 'Webservices\BarbersController@forgotBarberLoginPin');
	Route::post('/cancel-barberbookingbyid', 'Webservices\BarbersController@cancelBarberBookingById');
	Route::post('/get-barberreviews', 'Webservices\BarbersController@getBarberReviews');
	Route::post('/checkbarberappversion', 'Webservices\BarbersController@checkBarberAppVersion');
});

Route::group(array('prefix' => 'customers'), function () {
	Route::post('/login', 'Webservices\CustomersController@loginAsCustomer');
	Route::post('/edit-profile', 'Webservices\CustomersController@editProfile');
	Route::post('/edit-location', 'Webservices\CustomersController@editLocation');
	Route::post('/register', 'Webservices\CustomersController@customerRegister');
	Route::post('/fetch-time-slot', 'Webservices\CustomersController@getTimeSlot');
	Route::post('/book-service', 'Webservices\CustomersController@bookService');
	Route::post('/booking-list', 'Webservices\CustomersController@customerBookings');
	Route::post('/booking-details', 'Webservices\CustomersController@customerBookingDetails');
	Route::post('/check-payment-status', 'Webservices\CustomersController@checkpaymentstatus');
	Route::post('/rate-barber', 'Webservices\CustomersController@barberRating');
	Route::post('/customersocialregister', 'Webservices\CustomersController@customerSocialRegister');
	Route::post('/customerchecklogin', 'Webservices\CustomersController@customerChecklogin');
	Route::post('/edit-mobile', 'Webservices\CustomersController@editMobile');
	Route::post('/edit-notification', 'Webservices\CustomersController@editNotificationSetting');
	Route::post('/get-notification', 'Webservices\CustomersController@getNotificationSetting');
	Route::post('/get-customernotification', 'Webservices\CustomersController@getCustomerNotification');
	Route::post('/read-customernotification', 'Webservices\CustomersController@readCustomerNotification');
	Route::post('/delete-customernotification', 'Webservices\CustomersController@deleteCustomerNotification');
	Route::post('/get-settings', 'Webservices\CustomersController@getSettings');
	Route::post('/update-payment-status', 'Webservices\CustomersController@updatePaymentStatus');
	Route::post('/fav-saloon', 'Webservices\CustomersController@favSaloon');
	Route::post('/create-booking', 'Webservices\CustomersController@createBooking');
	Route::post('/request-refund', 'Webservices\CustomersController@requestRefund');
	Route::post('/add-customerloginpin', 'Webservices\CustomersController@addCustomerLoginPin');
	Route::post('/customerpinlogin', 'Webservices\CustomersController@customerPinLogin');
	Route::post('/forgotcustomerpin', 'Webservices\CustomersController@forgotCustomerLoginPin');
	Route::post('/update-bookingaction', 'Webservices\CustomersController@updateBookingAction');
	Route::post('/iscustomerexist', 'Webservices\CustomersController@isCustomerExist');
	Route::post('/cancel-customerbookingbyid', 'Webservices\CustomersController@cancelCustomerBookingById');
	Route::post('/checkcustomerappversion', 'Webservices\CustomersController@checkCustomerAppVersion');

	Route::post('/checkAppVersionCustomer', 'Webservices\CustomersController@checkAppVersionCustomer');


	Route::post('/contactus', 'Webservices\CommonController@update_contact');
	Route::post('/update-notification-setting', 'Webservices\CommonController@update_notification_setting');


});