<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::any('/payment_done','HomeController@payment_done');

Auth::routes();

Route::get('/', 'HomeController@index');
Route::get('/logout', 'HomeController@logout');
Route::get('/home', 'HomeController@index')->name('home');
Route::get('/fetch-states', 'HomeController@fetchStates');
Route::get('/fetch-cities', 'HomeController@fetchCities');
// Route::get('/saloon/login', 'HomeController@saloonLogin');
// Route::post('/saloon/login', 'Auth\LoginController@loginAsSaloon');

Route::group(array('prefix' => 'admin', 'middleware' => 'auth'), function () {
	Route::get('/', 'DashboardController@index');
	Route::get('/profile', 'DashboardController@editProfile');
	Route::post('/profile', 'DashboardController@updateProfile');
	Route::get('/contact-us', 'ContactUsController@list');
	Route::group(array('prefix' => 'users'), function () {
		Route::get('/', 'UsersController@list');
		Route::get('/add', 'UsersController@addNew');
		Route::post('/add', 'UsersController@save');
		Route::get('/edit/{id}', 'UsersController@edit');
		Route::post('/edit/{id}', 'UsersController@update');
		Route::get('/delete/{id}', 'UsersController@deleteRecord');
	});
	Route::group(array('prefix' => 'services'), function () {
		Route::get('/', 'ServicesController@list');
		Route::get('/add', 'ServicesController@addNew');
		Route::post('/add', 'ServicesController@save');
		Route::get('/edit/{id}', 'ServicesController@edit');
		Route::post('/edit/{id}', 'ServicesController@update');
		Route::get('/delete/{id}', 'ServicesController@deleteRecord');
	});
	Route::group(array('prefix' => 'customers'), function () {
		Route::get('/', 'CustomersController@list');
		Route::get('/add', 'CustomersController@addNew');
		Route::post('/add', 'CustomersController@save');
		Route::get('/edit/{id}', 'CustomersController@edit');
		Route::post('/edit/{id}', 'CustomersController@update');
		Route::get('/delete/{id}', 'CustomersController@deleteRecord');
		Route::post('/deleteall', 'CustomersController@deleteAllRecord');
	});

	Route::group(array('prefix' => 'salons'), function () {
		Route::get('/', 'SaloonsController@list');
		Route::get('/add', 'SaloonsController@addNew');
		Route::post('/add', 'SaloonsController@save');
		Route::get('/view/{id}', 'SaloonsController@view');
		Route::get('/edit/{id}', 'SaloonsController@edit');
		Route::post('/edit/{id}', 'SaloonsController@update');
		Route::get('/delete/{id}', 'SaloonsController@deleteRecord');
		Route::post('/deleteall', 'SaloonsController@deleteAllRecord');
		Route::get('/downloadimage/{filename}', 'SaloonsController@downloadimage');
		Route::get('/downloadownerimage/{filename}', 'SaloonsController@downloadownerimage');

		Route::group(array('prefix' => 'services'), function () {
			Route::get('/', 'SaloonsController@servicesList');
			Route::get('/add/{saloon_id}', 'SaloonsController@addService');
			Route::post('/add/{saloon_id}', 'SaloonsController@saveService');
			Route::get('/edit/{id}', 'SaloonsController@editService');
			Route::post('/edit/{id}', 'SaloonsController@updateService');
			Route::get('/delete/{id}', 'SaloonsController@deleteService');
		});
	});

	Route::group(array('prefix' => 'barbers'), function () {
		Route::get('/', 'BarbersController@list');
		Route::get('/saloon-services', 'BarbersController@getSaloonService');
		Route::get('/add', 'BarbersController@addNew');
		Route::post('/add', 'BarbersController@save');
		Route::get('/edit/{id}', 'BarbersController@edit');
		Route::post('/edit/{id}', 'BarbersController@update');
		Route::get('/delete/{id}', 'BarbersController@deleteRecord');
		Route::post('/deleteall', 'BarbersController@deleteAllRecord');
		Route::get('/downloadimage/{filename}', 'BarbersController@downloadimage');
		Route::get('/schedulelist', 'BarbersController@schedulelist');
		Route::get('/addschedule/{id}', 'BarbersController@addSchedule');
		Route::post('/saveschedule/{id}', 'BarbersController@saveSchedule');
		Route::get('/editschedule/{id}', 'BarbersController@editSchedule');
		Route::post('/updateschedule/{id}', 'BarbersController@updateSchedule');
		Route::post('/deleteschedule/{id}', 'BarbersController@deleteSchedule');
	});

	Route::group(array('prefix' => 'bookings'), function () {
		Route::get('/', 'BookingsController@list');
		Route::get('/view/{id}', 'BookingsController@viewBooking');
		Route::get('/saloon/{id}', 'BookingsController@saloonBooking');
		Route::post('/deleteall', 'BookingsController@deleteAllRecord');
	});
	Route::get('/reports', 'BookingsController@reports');

	Route::group(array('prefix' => 'settings'), function () {
		// Route::get('/', 'CustomersController@list');
		Route::get('/', 'SettingsController@edit');
		Route::post('/update', 'SettingsController@update');
		// Route::get('/edit/{id}', 'CustomersController@edit');
		// Route::post('/edit/{id}', 'CustomersController@update');
		// Route::get('/delete/{id}', 'CustomersController@deleteRecord');
	});

	Route::group(array('prefix' => 'payments'), function () {
		Route::get('/', 'PaymentsController@list');
		Route::get('/add', 'PaymentsController@addNew');
		Route::post('/add', 'PaymentsController@save');
		Route::get('/edit/{id}', 'PaymentsController@edit');
		Route::post('/edit/{id}', 'PaymentsController@update');
		Route::get('/delete/{id}', 'PaymentsController@deleteRecord');
		Route::post('/checkpayment', 'PaymentsController@checkpayment');
	});

	Route::group(array('prefix' => 'refunds'), function () {
		Route::get('/', 'RefundrequestController@list');
		Route::get('/view/{id}', 'RefundrequestController@viewBooking');
		Route::get('/saloon/{id}', 'RefundrequestController@saloonBooking');
	});

	Route::get('/paymentsreport', 'PaymentsreportController@reports');
	
	
	Route::group(array('prefix' => 'defaultservices'), function () {
		Route::get('/', 'DefaultservicesController@list');
		Route::get('/add', 'DefaultservicesController@addNew');
		Route::post('/add', 'DefaultservicesController@save');
		Route::get('/edit/{id}', 'DefaultservicesController@edit');
		Route::post('/edit/{id}', 'DefaultservicesController@update');
		Route::get('/delete/{id}', 'DefaultservicesController@deleteRecord');
	});
});

Route::group(array('prefix' => 'saloon', 'middleware' => 'auth:saloon'), function () {
	Route::get('/dashboard', 'Dashboard2Controller@index');
});

Route::group(array('prefix' => 'scheduler'), function () {
	Route::get('/reminder-customeronehour', 'Scheduler\ReminderonehourController@index');
	Route::get('/reminder-customertenminute', 'Scheduler\RemindertenminuteController@index');
	Route::get('/reminder-customerthirtyminute', 'Scheduler\ReminderthirtyminuteController@index');

	Route::get('/reminder-barberonehour', 'Scheduler\ReminderonehourbarberController@index');
	Route::get('/reminder-barbertenminute', 'Scheduler\RemindertenminutebarberController@index');
	Route::get('/reminder-barberthirtyminute', 'Scheduler\ReminderthirtyminutebarberController@index');
});