<?php $__env->startSection('content'); ?>
<style type="text/css">
.dropdown-menu
{
  margin: 0px;
  padding: .0rem 0;
}
.dropdown-menu li
{
  display: block;
  padding: 2px;
}
.dropdown-menu li a.userAction
{
  text-decoration: none;
  color: #000;
  padding: 5px;
  display: block;
}
</style>
<!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0 text-dark"><?php echo e($pageTitle); ?></h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="<?php echo e(url('/admin')); ?>">Dashboard</a></li>
              <li class="breadcrumb-item active"><?php echo e($pageTitle); ?></li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <!-- Small boxes (Stat box) -->
        <div class="row">
          <div class="col-lg-12 col-12">
             <div class="card">
              <div class="card-header">
                <h3 class="card-title float-left">Barbers List</h3>
                <div class="float-right">
                  <a href="<?php echo e(url('admin/barbers/add')); ?>" class="btn btn-primary btn-sm"><i class="fa fa-plus"></i> Add New</a>
                  <div class="clearfix"></div>
                </div>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
                <table class="table table-bordered">
                  <thead>
                    <tr>
                      <th style="width: 10px">
                        <div class="form-group clearfix">
                          <div class="icheck-primary d-inline">
                            <input type="checkbox" id="checkboxPrimary1">
                            <label for="checkboxPrimary1">
                              <span class="caret dropdown-toggle" id="dataTableAction" data-toggle="dropdown" aria-expanded="false" style="height: 8px;"></span>
                              <ul class="dropdown-menu" aria-labelledby="dataTableAction" role="menu">
                                <li role="presentation">
                                  <a href="javascript:void(0)" role="menuitem" class="text-danger userAction deleteAll">
                                    <i class="fa fa-trash" aria-hidden="true"></i> Delete
                                  </a>
                                </li>
                              </ul>
                            </label>
                          </div>
                        </div>
                      </th>
                      <th style="width: 10px">#</th>
                      <th>Image</th>
                      <th>Salon Name</th>
                      <th>Name</th>
                      <th>Email</th>
                      <th>Mobile</th>
                      <th>Status</th>
                      <th style="width: 40px">Action</th>
                    </tr>
                  </thead>
                  <tbody>
                    <?php if(count($records) > 0): ?>
                    <?php $__currentLoopData = $records; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $record): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                    <tr>
                      <td>
                        <div class="form-group clearfix">
                          <div class="icheck-primary d-inline">
                            <input type="checkbox" id="checkboxPrimary<?php echo e($record->id); ?>" class="checkbox_record" value="<?php echo e($record->id); ?>">
                            <label for="checkboxPrimary<?php echo e($record->id); ?>">
                            </label>
                          </div>
                        </div>
                      </td>
                      <td><?php echo e($record->id); ?></td>
                      <td>
                        <div class="profile_image">
                        <?php if($record->profile_image != '' && file_exists(public_path('uploads/profile_images/'.$record->profile_image))): ?>
                          <img src="<?php echo e(asset('public/uploads/profile_images/'.$record->profile_image)); ?>" class="img-circle elevation-2" width="80" height="80" />
                        <?php else: ?>
                        <div class="btn btn-secondary img-circle elevation-3" style="width:80px;height:80px;padding-top:13px">
                          <i class="fa fa-user fa-3x"></i>
                        </div>
                        <?php endif; ?>
                        </div>
                      </td>
                      <td><?php echo e($record->Saloon->saloon_name); ?></td>
                      <td><?php echo e($record->name); ?></td>
                      <td><?php echo e($record->email); ?></td>
                      <td><?php echo e($record->mobile); ?></td>
                      <td>
                        <?php if($record->status == '1'): ?>
                          <span class="badge badge-success">Enable</span>
                        <?php else: ?>
                          <span class="badge badge-danger">Disable</span>
                        <?php endif; ?>
                      </td>
                      <td>
                        <div class="btn-group">
                          <a href="<?php echo e(url('admin/barbers/edit/'.$record->id)); ?>" class="btn btn-warning mr-2 btn-sm"><i class="fa fa-edit"></i></a>
                          <a href="javascript:;" onclick="confirmDelete('<?php echo e($record->id); ?>')" class="btn btn-danger btn-sm"><i class="fa fa-trash"></i></a>
                        </div>
                      </td>
                    </tr>
                    <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                    <?php endif; ?>
                  </tbody>
                </table>
                <?php if(count($records) <= 0): ?>
                  <div class="text-danger text-center mt-1">No records available</div>
                <?php endif; ?>
              </div>
              <!-- /.card-body -->
              <div class="card-footer clearfix">
                <div class="pagination pagination-sm m-0 float-right">
                  <?php echo e($records->links()); ?>

                </div>
              </div>
            </div>
          </div>
         
        </div>
      </div><!-- /.container-fluid -->
    </section>
    <div class="modal fade" id="delete-confirmation">
        <div class="modal-dialog">
          <div class="modal-content">
            
            <div class="modal-header">
              <h4 class="modal-title">Confirm Delete</h4>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <p>Are you sure to delete the record?</p>
            </div>
            <div class="modal-footer justify-content-between">
              <button type="button" class="btn btn-default" data-dismiss="modal">Cancel</button>
              <button onclick="deleteUser()" type="button" class="btn btn-danger">Delete</button>
            </div>
          </div>
          <!-- /.modal-content -->
        </div>
        <!-- /.modal-dialog -->
      </div>
    <!-- /.content -->
    <div class="modal fade" id="deleteall-confirmation">
      <div class="modal-dialog">
        <div class="modal-content">
          
          <div class="modal-header">
            <h4 class="modal-title">Confirm Delete</h4>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <div class="modal-body">
            <p>Are you sure to delete the selected record?</p>
          </div>
          <div class="modal-footer justify-content-between">
            <button type="button" class="btn btn-default" data-dismiss="modal">Cancel</button>
            <button onclick="deleteAllSelected()" type="button" class="btn btn-danger">Delete</button>
          </div>
        </div>
        <!-- /.modal-content -->
      </div>
      <!-- /.modal-dialog -->
    </div>
<?php $__env->stopSection(); ?>

<?php $__env->startSection("javascript"); ?>
<script>
var delete_user ='';
var idStr = [];
function confirmDelete(id){
  delete_user = id;
  $("#delete-confirmation").modal("show");
}
function deleteUser(){
  if(delete_user != ''){
    var url = "<?php echo e(url('admin/barbers/delete')); ?>/"+delete_user;
    redirect(url);
  }else{
    errorMessage("Invalid record selected");
  }
}

function deleteAllSelected(){
  if(idStr.length > 0)
  {
    $.ajax({
      url:"<?php echo e(url('admin/barbers/deleteall')); ?>",
      type:"POST",
      data:{_token:"<?php echo e(csrf_token()); ?>", id:idStr},
      success:function(result){
        $("#deleteall-confirmation").modal("hide");
        toastr.success('All selected records deleted successfully', '', {
            iconClass: 'toast-just-text toast-success',
            positionClass: 'toast-bottom-right',
            containertId: 'toast-bottom-right'
        });
        setTimeout(function(){
          window.location.href = "<?php echo e(url('admin/barbers')); ?>";
        }, 3000);
      }
    });
    return false;
  }
  else
  {
    errorMessage("Invalid record selected");
  }
}

$("#checkboxPrimary1").on("change", function(){
  $("input:checkbox.checkbox_record").prop('checked', $(this).prop("checked"));
  if ($(this).prop("checked"))
  {
      $('#dataTableAction').click();
  }
});

$('body').on('click', '.userAction', function(){
  idStr = [];
  $("input:checkbox").each(function () {
      if ($(this).is(":checked"))
      {
          if ($.isNumeric($(this).val()))
          {
              idStr.push($(this).val());
          }
      }
  });

  if (idStr.length > 0)
  {
      var msgStr = '';
      var isUserRemove = 0;
      if ($(this).hasClass('deleteAll'))
      {
          msgStr = 'remove'
          isUserRemove = 1;
      }
      $("#deleteall-confirmation").modal("show");
  } 
  else
  {
      toastr.success('Please select atleast one record.', '', {
          iconClass: 'toast-just-text toast-danger',
          positionClass: 'toast-bottom-right',
          containertId: 'toast-bottom-right'
      });
  }
});
</script>
<?php $__env->stopSection(); ?>
<?php echo $__env->make('layouts.master', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH /home/blacourdb/public_html/salon/resources/views/barbers/list.blade.php ENDPATH**/ ?>