<?php $__env->startSection('content'); ?>
<!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0 text-dark"><?php echo e($pageTitle); ?></h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="<?php echo e(url('/admin')); ?>">Dashboard</a></li>
              <li class="breadcrumb-item active"><?php echo e($pageTitle); ?></li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <!-- Small boxes (Stat box) -->
        <div class="row">
          <div class="col-lg-12 col-12">
             <div class="card">
              <div class="card-header">
                <h3 class="card-title float-left">Customers List</h3>
                <div class="float-right">
                  <a href="<?php echo e(url('admin/customers/add')); ?>" class="btn btn-primary btn-sm"><i class="fa fa-plus"></i> Add New</a>
                  <div class="clearfix"></div>
                </div>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
                <table class="table table-bordered">
                  <thead>
                    <tr>
                      <th style="width: 10px">#</th>
                      <th>Name</th>
                      <th>Email</th>
                      <th>Mobile</th>
                      <th>City</th>
                      <th>Status</th>
                      <th>Action</th>
                    </tr>
                  </thead>
                  <tbody>
                    <?php if(count($records) > 0): ?>
                      <?php $__currentLoopData = $records; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $record): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                      <tr>
                        <td><?php echo e($record->id); ?></td>
                        <td><?php echo e($record->name); ?></td>
                        <td><?php echo e($record->email); ?></td>
                        <td><?php echo e($record->mobile); ?></td>
                        <td>
                          <?php if(!empty($record->City)): ?>
                          <?php echo e($record->City->name); ?></td>
                          <?php endif; ?>
                        <td>
                          <?php if($record->status == '1'): ?>
                            <span class="badge badge-success">Enable</span>
                          <?php else: ?>
                            <span class="badge badge-danger">Disable</span>
                          <?php endif; ?>

                        </td>
                        <td>
                          <div class="btn-group">
                            <a href="<?php echo e(url('admin/customers/edit/'.$record->id)); ?>" class="btn btn-warning mr-2 btn-sm"><i class="fa fa-edit"></i></a>
                            <a href="javascript:;" onclick="confirmDelete('<?php echo e($record->id); ?>')" class="btn btn-danger btn-sm"><i class="fa fa-trash"></i></a>
                            <?php if(count($record->Bookings) > 0): ?>
                              <a href="<?php echo e(url('admin/bookings?customer='.$record->id)); ?>" class="btn btn-info ml-2 btn-sm"><i class="fa fa-calendar"></i></a>
                            <?php endif; ?>
                          </div>
                        </td>
                      </tr>
                      <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                    <?php endif; ?>
                  </tbody>
                </table>
                <?php if(count($records) <= 0): ?>
                  <div class="text-danger text-center mt-1">No records available</div>
                <?php endif; ?>
              </div>
              <!-- /.card-body -->
              <div class="card-footer clearfix">
                <div class="pagination pagination-sm m-0 float-right">
                  <?php echo e($records->links()); ?>

                  
                </div>
              </div>
            </div>
          </div>
         
        </div>
      </div><!-- /.container-fluid -->
    </section>
    <div class="modal fade" id="delete-confirmation">
        <div class="modal-dialog">
          <div class="modal-content">
            
            <div class="modal-header">
              <h4 class="modal-title">Confirm Delete</h4>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <p>Are you sure to delete the record?</p>
            </div>
            <div class="modal-footer justify-content-between">
              <button type="button" class="btn btn-default" data-dismiss="modal">Cancel</button>
              <button onclick="deleteUser()" type="button" class="btn btn-danger">Delete</button>
            </div>
          </div>
          <!-- /.modal-content -->
        </div>
        <!-- /.modal-dialog -->
      </div>
    <!-- /.content -->
<?php $__env->stopSection(); ?>

<?php $__env->startSection("javascript"); ?>
<script>
var delete_user ='';
function confirmDelete(id){
  delete_user = id;
  $("#delete-confirmation").modal("show");
}
function deleteUser(){
  if(delete_user != ''){
    var url = "<?php echo e(url('admin/customers/delete')); ?>/"+delete_user;
    redirect(url);
  }else{
    errorMessage("Invalid record selected");
  }
}
</script>
<?php $__env->stopSection(); ?>
<?php echo $__env->make('layouts.master', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH /home/anarasalons.com/public_html/admin/resources/views/customers/list.blade.php ENDPATH**/ ?>