<?php $__env->startSection('content'); ?>
<!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0 text-dark"><?php echo e($pageTitle); ?></h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="<?php echo e(url('/admin')); ?>">Dashboard</a></li>
              <li class="breadcrumb-item active"><?php echo e($pageTitle); ?></li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <!-- Small boxes (Stat box) -->
        <div class="row">
          <div class="col-lg-12 col-12">
             <div class="card">
              <div class="card-header">
                <h3 class="card-title float-left">Refund Request List <?php echo e(($saloon_name != '')?"of Salon ".$saloon_name:'of All Saloons'); ?></h3>
                <div class="float-right">
                  <form id="search">
                    <div class="form-group float-left mr-2">
                      <label>Filter by Salon</label>
                      <div>
                        <select class="select2" name="saloon" onchange="return $('#search').submit()">
                          <option value="">All</option>
                          <?php $__currentLoopData = $saloons; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $saloon): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                          <option <?php echo e(($saloon->id == $selected_saloon)?'selected':''); ?> value="<?php echo e($saloon->id); ?>"><?php echo e($saloon->saloon_name); ?></option>
                          <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                        </select>
                      </div>
                    </div>
                    <div class="form-group float-left">
                      <label>Filter by Customer</label>
                      <div>
                        <select class="select2" name="customer" onchange="return $('#search').submit()">
                          <option value="">All</option>
                          <?php $__currentLoopData = $customers; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $customer): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                          <option <?php echo e(($customer->id == $selected_customer)?'selected':''); ?> value="<?php echo e($customer->id); ?>"><?php echo e($customer->name); ?></option>
                          <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                        </select>
                      </div>
                    </div>

                    <div class="clearfix"></div>
                </form>
                  <div class="clearfix"></div>
                </div>
                <div class="clearfix"></div>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
                <table class="table table-bordered">
                  <thead>
                    <tr>
                      <th style="width: 10px">#</th>
                      <!-- <th>Image</th> -->
                      <th>Customer</th>
                      <th>Salon</th>
                      <th>Barber</th>
                      <th>Time</th>
                      <th>Book Date</th>
                      <th>Services</th>
                      <th>Total Amount</th>
                      <th>Status</th>
                      <th style="width: 40px">Action</th>
                    </tr>
                  </thead>
                  <tbody>
                    <?php if(count($records) > 0): ?>
                    <?php $__currentLoopData = $records; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $record): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                    <tr>
                      <td><?php echo e($record->id); ?></td>
                      <td><?php echo e($record->Customer->name); ?></td>
                      <td><?php echo e($record->Saloon->saloon_name); ?></td>
                      <td><?php echo e($record->Barber->name); ?></td>
                      <td><?php echo e($record->from_time); ?> to <?php echo e($record->to_time); ?></td>
                      <td><?php echo e(dateFormat($record->book_date)); ?></td>
                      <td>
                        <?php $__currentLoopData = $record->BookingItems; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $item): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                          <span class="badge badge-secondary"><?php echo e($item->SaloonService->service_name); ?></span>
                        <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                      </td>
                      <td>
                        ₹<?php echo e($record->total); ?>

                      </td>
                      <td>
                        <?php if($record->status == 'cancelled'): ?>      
                            <span class="badge badge-warning">Cancelled</span>
                        <?php elseif($record->book_date." ".$record->to_time > date('Y-m-d H:i:s')): ?>
                          <span class="badge badge-success">Upcoming</span>
                        <?php else: ?>
                          <span class="badge badge-danger">Completed</span>
                        <?php endif; ?>
                      </td>
                      <td>
                        <div class="btn-group">
                          <a href="<?php echo e(url('admin/bookings/view/'.$record->id)); ?>" class="btn btn-info mr-2 btn-sm"><i class="fa fa-eye"></i></a>
                        </div>
                      </td>
                    </tr>
                    <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                    <?php endif; ?>
                  </tbody>
                </table>
                <?php if(count($records) <= 0): ?>
                  <div class="text-danger text-center mt-1">No records available</div>
                <?php endif; ?>
              </div>
              <!-- /.card-body -->
              <div class="card-footer clearfix">
                <div class="pagination pagination-sm m-0 float-right">
                  <?php echo e($records->appends(Request::except('page'))->links()); ?>

                </div>
              </div>
            </div>
          </div>
         
        </div>
      </div><!-- /.container-fluid -->
    </section>
    <div class="modal fade" id="delete-confirmation">
        <div class="modal-dialog">
          <div class="modal-content">
            
            <div class="modal-header">
              <h4 class="modal-title">Confirm Delete</h4>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <p>Are you sure to delete the record?</p>
            </div>
            <div class="modal-footer justify-content-between">
              <button type="button" class="btn btn-default" data-dismiss="modal">Cancel</button>
              <button onclick="deleteUser()" type="button" class="btn btn-danger">Delete</button>
            </div>
          </div>
          <!-- /.modal-content -->
        </div>
        <!-- /.modal-dialog -->
      </div>
    <!-- /.content -->
<?php $__env->stopSection(); ?>

<?php $__env->startSection("javascript"); ?>
<script>
var delete_user ='';
function confirmDelete(id){
  delete_user = id;
  $("#delete-confirmation").modal("show");
}
function deleteUser(){
  if(delete_user != ''){
    var url = "<?php echo e(url('admin/barbers/delete')); ?>/"+delete_user;
    redirect(url);
  }else{
    errorMessage("Invalid record selected");
  }
}
</script>
<?php $__env->stopSection(); ?>
<?php echo $__env->make('layouts.master', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH C:\xampp\htdocs\officework\anarasaloon\resources\views/refund_request/bookings.blade.php ENDPATH**/ ?>