<?php $__env->startSection('content'); ?>
<!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0 text-dark"><?php echo e($pageTitle); ?></h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="<?php echo e(url('/admin')); ?>">Dashboard</a></li>
              <li class="breadcrumb-item active"><?php echo e($pageTitle); ?></li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <!-- Small boxes (Stat box) -->
        <div class="row">
          <div class="col-lg-12 col-12">
             <div class="card">
              <div class="card-header">

                <div class="float-left">
                  <form id="search">
                  	<input type="hidden" name="filter" value="1" />
                  	<div class="form-group float-left mr-2">
	                  <label>Start Date:</label>
	                    <div class="input-group date">
                        <?php if($start_date == ""): ?>
                        <?php $start_date = date("d-m-Y") ?>
                        <?php endif; ?>
	                        <input type="text" name="start_date" id="start_date" value="<?php echo e($start_date); ?>" class="form-control datetimepicker-input" />
	                        <div class="input-group-append">
	                            <div class="input-group-text"><i class="fa fa-calendar"></i></div>
	                        </div>
	                    </div>
	                </div>
                    <div class="form-group float-left mr-2">
                      <label>Filter by Salon</label>
                      <div>
                        <select class="select2" name="saloon">
                          <option value="">All</option>
                          <?php $__currentLoopData = $saloons; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $saloon): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                          <option <?php echo e(($saloon->id == $selected_saloon)?'selected':''); ?> value="<?php echo e($saloon->id); ?>"><?php echo e($saloon->saloon_name); ?></option>
                          <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                        </select>
                      </div>
                    </div>
                    
                    <button class="btn btn-primary" style="margin-top:29px"><i class="fa fa-search"></i></button>
                    <div class="clearfix"></div>
                </form>
                  <div class="clearfix"></div>
                </div>
                <div class="clearfix"></div>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
                <table class="table table-bordered">
                  <thead>
                    <tr>
                      <th style="width: 10px">#</th>
                      <th>Salon</th>
                      <th>Owner Name</th>
                      <th>Book Date</th>
                      <th>Total</th>
                    </tr>
                  </thead>
                  <tbody>
                    <?php if(count($records) > 0): ?>
                    <?php $__currentLoopData = $records; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $record): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                    <tr>
                      <td><?php echo e($record->id); ?></td>
                      <td><?php echo e($record->Saloon->saloon_name); ?></td>
                      <td><?php echo e($record->Saloon->contact_person); ?></td>
                      <td><?php echo e(dateFormat($record->book_date)); ?></td>
                      <td>₹<?php echo e($record->total); ?></td>
                      
                    </tr>
                    <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                    <?php endif; ?>
                  </tbody>
                </table>
                <?php if(count($records) <= 0): ?>
                  <div class="text-danger text-center mt-1">No records available</div>
                <?php endif; ?>
              </div>
              <!-- /.card-body -->
              <?php if(count($records) > 0): ?>
              <div class="card-footer clearfix">
                <div class="pagination pagination-sm m-0 float-right">
                  <?php echo e($records->appends(Request::except('page'))->links()); ?>

                </div>
              </div>
              <?php endif; ?>
            </div>
          </div>
         
        </div>
      </div><!-- /.container-fluid -->
    </section>
    
<?php $__env->stopSection(); ?>

<?php $__env->startSection("javascript"); ?>
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.9.0/css/bootstrap-datepicker.css" />
<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.9.0/js/bootstrap-datepicker.min.js"></script>
<script>
$('#start_date').datepicker({
      format: "dd-mm-yyyy",
      defaultViewDate:"today",
      todayHighlight:true
});
var delete_user ='';
function confirmDelete(id){
  delete_user = id;
  $("#delete-confirmation").modal("show");
}
function deleteUser(){
  if(delete_user != ''){
    var url = "<?php echo e(url('admin/barbers/delete')); ?>/"+delete_user;
    redirect(url);
  }else{
    errorMessage("Invalid record selected");
  }
}
</script>
<?php $__env->stopSection(); ?>
<?php echo $__env->make('layouts.master', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH C:\xampp\htdocs\officework\anarasaloon\resources\views/paymentsreport/reports.blade.php ENDPATH**/ ?>