@extends('layouts.master')

@section('content')
<!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0 text-dark">{{$pageTitle}}</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="{{ url('/admin') }}">Dashboard</a></li>
              <li class="breadcrumb-item active">{{$pageTitle}}</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <!-- Small boxes (Stat box) -->
        <div class="row">
          <div class="col-lg-12 col-12">
             <div class="card">
              <div class="card-header">
                <h3 class="card-title float-left">Customers List</h3>
                <div class="float-right">
                  <a href="{{ url('admin/users/add') }}" class="btn btn-primary btn-sm"><i class="fa fa-plus"></i> Add New</a>
                  <div class="clearfix"></div>
                </div>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
                <table class="table table-bordered">
                  <thead>
                    <tr>
                      <th style="width: 10px">#</th>
                      <th>Name</th>
                      <th>Email</th>
                      <th>Mobile</th>
                      <th>Status</th>
                      <th>Action</th>
                    </tr>
                  </thead>
                  <tbody>
                    @if(count($records) > 0)
                      @foreach($records as $record)
                      <tr>
                        <td>{{ $record->id }}</td>
                        <td>{{ $record->name }}</td>
                        <td>{{ $record->email }}</td>
                        <td>{{ $record->phone_no }}</td>
                        <td>
                          @if($record->status == '1')
                            <span class="badge badge-success">Enable</span>
                          @else
                            <span class="badge badge-danger">Disable</span>
                          @endif

                        </td>
                        <td width="30%">
                          <div class="btn-group">
                            <a href="{{ url('admin/users/edit/'.$record->id) }}" class="btn btn-warning mr-2 btn-sm"><i class="fa fa-edit"></i></a>
                            <a href="javascript:;" onclick="confirmDelete('{{ $record->id }}')" class="btn btn-danger btn-sm"><i class="fa fa-trash"></i></a>
                          </div>
                        </td>
                      </tr>
                      @endforeach
                    @endif
                  </tbody>
                </table>
                @if(count($records) <= 0)
                  <div class="text-danger text-center mt-1">No records available</div>
                @endif
              </div>
              <!-- /.card-body -->
              <div class="card-footer clearfix">
                <div class="pagination pagination-sm m-0 float-right">
                  {{$records->links()}}
                  
                </div>
              </div>
            </div>
          </div>
         
        </div>
      </div><!-- /.container-fluid -->
    </section>
    <div class="modal fade" id="delete-confirmation">
        <div class="modal-dialog">
          <div class="modal-content">
            
            <div class="modal-header">
              <h4 class="modal-title">Confirm Delete</h4>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <p>Are you sure to delete the record?</p>
            </div>
            <div class="modal-footer justify-content-between">
              <button type="button" class="btn btn-default" data-dismiss="modal">Cancel</button>
              <button onclick="deleteUser()" type="button" class="btn btn-danger">Delete</button>
            </div>
          </div>
          <!-- /.modal-content -->
        </div>
        <!-- /.modal-dialog -->
      </div>
    <!-- /.content -->
@endsection

@section("javascript")
<script>
var delete_user ='';
function confirmDelete(id){
  delete_user = id;
  $("#delete-confirmation").modal("show");
}
function deleteUser(){
  if(delete_user != ''){
    var url = "{{ url('admin/users/delete') }}/"+delete_user;
    redirect(url);
  }else{
    errorMessage("Invalid record selected");
  }
}
</script>
@endsection